note

	description:

		"Eiffel parsers"

	library: "Gobo Eiffel Tools Library"
	copyright: "Copyright (c) 1999-2019, Eric Bezault and others"
	license: "MIT License"
	date: "$Date: 2020-01-08 10:24:11 +0000 (Wed, 08 Jan 2020) $"
	revision: "$Revision: 103831 $"

class ET_EIFFEL_PARSER

inherit

	ET_EIFFEL_PARSER_SKELETON
		undefine
			read_token
		redefine
			system_processor
		end

	ET_EIFFEL_SCANNER
		rename
			make as make_eiffel_scanner
		undefine
			reset, set_syntax_error
		redefine
			system_processor
		end

create

	make


feature {NONE} -- Implementation

	yy_build_parser_tables
			-- Build parser tables.
		do
			yytranslate := yytranslate_template
			yyr1 := yyr1_template
			yytypes1 := yytypes1_template
			yytypes2 := yytypes2_template
			yydefact := yydefact_template
			yydefgoto := yydefgoto_template
			yypact := yypact_template
			yypgoto := yypgoto_template
			yytable := yytable_template
			yycheck := yycheck_template
		end

	yy_create_value_stacks
			-- Create value stacks.
		do
			create yyspecial_routines1
			yyvsc1 := yyInitial_yyvs_size
			yyvs1 := yyspecial_routines1.make (yyvsc1)
			create yyspecial_routines2
			yyvsc2 := yyInitial_yyvs_size
			yyvs2 := yyspecial_routines2.make (yyvsc2)
			create yyspecial_routines3
			yyvsc3 := yyInitial_yyvs_size
			yyvs3 := yyspecial_routines3.make (yyvsc3)
			create yyspecial_routines4
			yyvsc4 := yyInitial_yyvs_size
			yyvs4 := yyspecial_routines4.make (yyvsc4)
			create yyspecial_routines5
			yyvsc5 := yyInitial_yyvs_size
			yyvs5 := yyspecial_routines5.make (yyvsc5)
			create yyspecial_routines6
			yyvsc6 := yyInitial_yyvs_size
			yyvs6 := yyspecial_routines6.make (yyvsc6)
			create yyspecial_routines7
			yyvsc7 := yyInitial_yyvs_size
			yyvs7 := yyspecial_routines7.make (yyvsc7)
			create yyspecial_routines8
			yyvsc8 := yyInitial_yyvs_size
			yyvs8 := yyspecial_routines8.make (yyvsc8)
			create yyspecial_routines9
			yyvsc9 := yyInitial_yyvs_size
			yyvs9 := yyspecial_routines9.make (yyvsc9)
			create yyspecial_routines10
			yyvsc10 := yyInitial_yyvs_size
			yyvs10 := yyspecial_routines10.make (yyvsc10)
			create yyspecial_routines11
			yyvsc11 := yyInitial_yyvs_size
			yyvs11 := yyspecial_routines11.make (yyvsc11)
			create yyspecial_routines12
			yyvsc12 := yyInitial_yyvs_size
			yyvs12 := yyspecial_routines12.make (yyvsc12)
			create yyspecial_routines13
			yyvsc13 := yyInitial_yyvs_size
			yyvs13 := yyspecial_routines13.make (yyvsc13)
			create yyspecial_routines14
			yyvsc14 := yyInitial_yyvs_size
			yyvs14 := yyspecial_routines14.make (yyvsc14)
			create yyspecial_routines15
			yyvsc15 := yyInitial_yyvs_size
			yyvs15 := yyspecial_routines15.make (yyvsc15)
			create yyspecial_routines16
			yyvsc16 := yyInitial_yyvs_size
			yyvs16 := yyspecial_routines16.make (yyvsc16)
			create yyspecial_routines17
			yyvsc17 := yyInitial_yyvs_size
			yyvs17 := yyspecial_routines17.make (yyvsc17)
			create yyspecial_routines18
			yyvsc18 := yyInitial_yyvs_size
			yyvs18 := yyspecial_routines18.make (yyvsc18)
			create yyspecial_routines19
			yyvsc19 := yyInitial_yyvs_size
			yyvs19 := yyspecial_routines19.make (yyvsc19)
			create yyspecial_routines20
			yyvsc20 := yyInitial_yyvs_size
			yyvs20 := yyspecial_routines20.make (yyvsc20)
			create yyspecial_routines21
			yyvsc21 := yyInitial_yyvs_size
			yyvs21 := yyspecial_routines21.make (yyvsc21)
			create yyspecial_routines22
			yyvsc22 := yyInitial_yyvs_size
			yyvs22 := yyspecial_routines22.make (yyvsc22)
			create yyspecial_routines23
			yyvsc23 := yyInitial_yyvs_size
			yyvs23 := yyspecial_routines23.make (yyvsc23)
			create yyspecial_routines24
			yyvsc24 := yyInitial_yyvs_size
			yyvs24 := yyspecial_routines24.make (yyvsc24)
			create yyspecial_routines25
			yyvsc25 := yyInitial_yyvs_size
			yyvs25 := yyspecial_routines25.make (yyvsc25)
			create yyspecial_routines26
			yyvsc26 := yyInitial_yyvs_size
			yyvs26 := yyspecial_routines26.make (yyvsc26)
			create yyspecial_routines27
			yyvsc27 := yyInitial_yyvs_size
			yyvs27 := yyspecial_routines27.make (yyvsc27)
			create yyspecial_routines28
			yyvsc28 := yyInitial_yyvs_size
			yyvs28 := yyspecial_routines28.make (yyvsc28)
			create yyspecial_routines29
			yyvsc29 := yyInitial_yyvs_size
			yyvs29 := yyspecial_routines29.make (yyvsc29)
			create yyspecial_routines30
			yyvsc30 := yyInitial_yyvs_size
			yyvs30 := yyspecial_routines30.make (yyvsc30)
			create yyspecial_routines31
			yyvsc31 := yyInitial_yyvs_size
			yyvs31 := yyspecial_routines31.make (yyvsc31)
			create yyspecial_routines32
			yyvsc32 := yyInitial_yyvs_size
			yyvs32 := yyspecial_routines32.make (yyvsc32)
			create yyspecial_routines33
			yyvsc33 := yyInitial_yyvs_size
			yyvs33 := yyspecial_routines33.make (yyvsc33)
			create yyspecial_routines34
			yyvsc34 := yyInitial_yyvs_size
			yyvs34 := yyspecial_routines34.make (yyvsc34)
			create yyspecial_routines35
			yyvsc35 := yyInitial_yyvs_size
			yyvs35 := yyspecial_routines35.make (yyvsc35)
			create yyspecial_routines36
			yyvsc36 := yyInitial_yyvs_size
			yyvs36 := yyspecial_routines36.make (yyvsc36)
			create yyspecial_routines37
			yyvsc37 := yyInitial_yyvs_size
			yyvs37 := yyspecial_routines37.make (yyvsc37)
			create yyspecial_routines38
			yyvsc38 := yyInitial_yyvs_size
			yyvs38 := yyspecial_routines38.make (yyvsc38)
			create yyspecial_routines39
			yyvsc39 := yyInitial_yyvs_size
			yyvs39 := yyspecial_routines39.make (yyvsc39)
			create yyspecial_routines40
			yyvsc40 := yyInitial_yyvs_size
			yyvs40 := yyspecial_routines40.make (yyvsc40)
			create yyspecial_routines41
			yyvsc41 := yyInitial_yyvs_size
			yyvs41 := yyspecial_routines41.make (yyvsc41)
			create yyspecial_routines42
			yyvsc42 := yyInitial_yyvs_size
			yyvs42 := yyspecial_routines42.make (yyvsc42)
			create yyspecial_routines43
			yyvsc43 := yyInitial_yyvs_size
			yyvs43 := yyspecial_routines43.make (yyvsc43)
			create yyspecial_routines44
			yyvsc44 := yyInitial_yyvs_size
			yyvs44 := yyspecial_routines44.make (yyvsc44)
			create yyspecial_routines45
			yyvsc45 := yyInitial_yyvs_size
			yyvs45 := yyspecial_routines45.make (yyvsc45)
			create yyspecial_routines46
			yyvsc46 := yyInitial_yyvs_size
			yyvs46 := yyspecial_routines46.make (yyvsc46)
			create yyspecial_routines47
			yyvsc47 := yyInitial_yyvs_size
			yyvs47 := yyspecial_routines47.make (yyvsc47)
			create yyspecial_routines48
			yyvsc48 := yyInitial_yyvs_size
			yyvs48 := yyspecial_routines48.make (yyvsc48)
			create yyspecial_routines49
			yyvsc49 := yyInitial_yyvs_size
			yyvs49 := yyspecial_routines49.make (yyvsc49)
			create yyspecial_routines50
			yyvsc50 := yyInitial_yyvs_size
			yyvs50 := yyspecial_routines50.make (yyvsc50)
			create yyspecial_routines51
			yyvsc51 := yyInitial_yyvs_size
			yyvs51 := yyspecial_routines51.make (yyvsc51)
			create yyspecial_routines52
			yyvsc52 := yyInitial_yyvs_size
			yyvs52 := yyspecial_routines52.make (yyvsc52)
			create yyspecial_routines53
			yyvsc53 := yyInitial_yyvs_size
			yyvs53 := yyspecial_routines53.make (yyvsc53)
			create yyspecial_routines54
			yyvsc54 := yyInitial_yyvs_size
			yyvs54 := yyspecial_routines54.make (yyvsc54)
			create yyspecial_routines55
			yyvsc55 := yyInitial_yyvs_size
			yyvs55 := yyspecial_routines55.make (yyvsc55)
			create yyspecial_routines56
			yyvsc56 := yyInitial_yyvs_size
			yyvs56 := yyspecial_routines56.make (yyvsc56)
			create yyspecial_routines57
			yyvsc57 := yyInitial_yyvs_size
			yyvs57 := yyspecial_routines57.make (yyvsc57)
			create yyspecial_routines58
			yyvsc58 := yyInitial_yyvs_size
			yyvs58 := yyspecial_routines58.make (yyvsc58)
			create yyspecial_routines59
			yyvsc59 := yyInitial_yyvs_size
			yyvs59 := yyspecial_routines59.make (yyvsc59)
			create yyspecial_routines60
			yyvsc60 := yyInitial_yyvs_size
			yyvs60 := yyspecial_routines60.make (yyvsc60)
			create yyspecial_routines61
			yyvsc61 := yyInitial_yyvs_size
			yyvs61 := yyspecial_routines61.make (yyvsc61)
			create yyspecial_routines62
			yyvsc62 := yyInitial_yyvs_size
			yyvs62 := yyspecial_routines62.make (yyvsc62)
			create yyspecial_routines63
			yyvsc63 := yyInitial_yyvs_size
			yyvs63 := yyspecial_routines63.make (yyvsc63)
			create yyspecial_routines64
			yyvsc64 := yyInitial_yyvs_size
			yyvs64 := yyspecial_routines64.make (yyvsc64)
			create yyspecial_routines65
			yyvsc65 := yyInitial_yyvs_size
			yyvs65 := yyspecial_routines65.make (yyvsc65)
			create yyspecial_routines66
			yyvsc66 := yyInitial_yyvs_size
			yyvs66 := yyspecial_routines66.make (yyvsc66)
			create yyspecial_routines67
			yyvsc67 := yyInitial_yyvs_size
			yyvs67 := yyspecial_routines67.make (yyvsc67)
			create yyspecial_routines68
			yyvsc68 := yyInitial_yyvs_size
			yyvs68 := yyspecial_routines68.make (yyvsc68)
			create yyspecial_routines69
			yyvsc69 := yyInitial_yyvs_size
			yyvs69 := yyspecial_routines69.make (yyvsc69)
			create yyspecial_routines70
			yyvsc70 := yyInitial_yyvs_size
			yyvs70 := yyspecial_routines70.make (yyvsc70)
			create yyspecial_routines71
			yyvsc71 := yyInitial_yyvs_size
			yyvs71 := yyspecial_routines71.make (yyvsc71)
			create yyspecial_routines72
			yyvsc72 := yyInitial_yyvs_size
			yyvs72 := yyspecial_routines72.make (yyvsc72)
			create yyspecial_routines73
			yyvsc73 := yyInitial_yyvs_size
			yyvs73 := yyspecial_routines73.make (yyvsc73)
			create yyspecial_routines74
			yyvsc74 := yyInitial_yyvs_size
			yyvs74 := yyspecial_routines74.make (yyvsc74)
			create yyspecial_routines75
			yyvsc75 := yyInitial_yyvs_size
			yyvs75 := yyspecial_routines75.make (yyvsc75)
			create yyspecial_routines76
			yyvsc76 := yyInitial_yyvs_size
			yyvs76 := yyspecial_routines76.make (yyvsc76)
			create yyspecial_routines77
			yyvsc77 := yyInitial_yyvs_size
			yyvs77 := yyspecial_routines77.make (yyvsc77)
			create yyspecial_routines78
			yyvsc78 := yyInitial_yyvs_size
			yyvs78 := yyspecial_routines78.make (yyvsc78)
			create yyspecial_routines79
			yyvsc79 := yyInitial_yyvs_size
			yyvs79 := yyspecial_routines79.make (yyvsc79)
			create yyspecial_routines80
			yyvsc80 := yyInitial_yyvs_size
			yyvs80 := yyspecial_routines80.make (yyvsc80)
			create yyspecial_routines81
			yyvsc81 := yyInitial_yyvs_size
			yyvs81 := yyspecial_routines81.make (yyvsc81)
			create yyspecial_routines82
			yyvsc82 := yyInitial_yyvs_size
			yyvs82 := yyspecial_routines82.make (yyvsc82)
			create yyspecial_routines83
			yyvsc83 := yyInitial_yyvs_size
			yyvs83 := yyspecial_routines83.make (yyvsc83)
			create yyspecial_routines84
			yyvsc84 := yyInitial_yyvs_size
			yyvs84 := yyspecial_routines84.make (yyvsc84)
			create yyspecial_routines85
			yyvsc85 := yyInitial_yyvs_size
			yyvs85 := yyspecial_routines85.make (yyvsc85)
			create yyspecial_routines86
			yyvsc86 := yyInitial_yyvs_size
			yyvs86 := yyspecial_routines86.make (yyvsc86)
			create yyspecial_routines87
			yyvsc87 := yyInitial_yyvs_size
			yyvs87 := yyspecial_routines87.make (yyvsc87)
			create yyspecial_routines88
			yyvsc88 := yyInitial_yyvs_size
			yyvs88 := yyspecial_routines88.make (yyvsc88)
			create yyspecial_routines89
			yyvsc89 := yyInitial_yyvs_size
			yyvs89 := yyspecial_routines89.make (yyvsc89)
			create yyspecial_routines90
			yyvsc90 := yyInitial_yyvs_size
			yyvs90 := yyspecial_routines90.make (yyvsc90)
			create yyspecial_routines91
			yyvsc91 := yyInitial_yyvs_size
			yyvs91 := yyspecial_routines91.make (yyvsc91)
			create yyspecial_routines92
			yyvsc92 := yyInitial_yyvs_size
			yyvs92 := yyspecial_routines92.make (yyvsc92)
			create yyspecial_routines93
			yyvsc93 := yyInitial_yyvs_size
			yyvs93 := yyspecial_routines93.make (yyvsc93)
			create yyspecial_routines94
			yyvsc94 := yyInitial_yyvs_size
			yyvs94 := yyspecial_routines94.make (yyvsc94)
			create yyspecial_routines95
			yyvsc95 := yyInitial_yyvs_size
			yyvs95 := yyspecial_routines95.make (yyvsc95)
			create yyspecial_routines96
			yyvsc96 := yyInitial_yyvs_size
			yyvs96 := yyspecial_routines96.make (yyvsc96)
			create yyspecial_routines97
			yyvsc97 := yyInitial_yyvs_size
			yyvs97 := yyspecial_routines97.make (yyvsc97)
			create yyspecial_routines98
			yyvsc98 := yyInitial_yyvs_size
			yyvs98 := yyspecial_routines98.make (yyvsc98)
			create yyspecial_routines99
			yyvsc99 := yyInitial_yyvs_size
			yyvs99 := yyspecial_routines99.make (yyvsc99)
			create yyspecial_routines100
			yyvsc100 := yyInitial_yyvs_size
			yyvs100 := yyspecial_routines100.make (yyvsc100)
			create yyspecial_routines101
			yyvsc101 := yyInitial_yyvs_size
			yyvs101 := yyspecial_routines101.make (yyvsc101)
			create yyspecial_routines102
			yyvsc102 := yyInitial_yyvs_size
			yyvs102 := yyspecial_routines102.make (yyvsc102)
			create yyspecial_routines103
			yyvsc103 := yyInitial_yyvs_size
			yyvs103 := yyspecial_routines103.make (yyvsc103)
			create yyspecial_routines104
			yyvsc104 := yyInitial_yyvs_size
			yyvs104 := yyspecial_routines104.make (yyvsc104)
			create yyspecial_routines105
			yyvsc105 := yyInitial_yyvs_size
			yyvs105 := yyspecial_routines105.make (yyvsc105)
			create yyspecial_routines106
			yyvsc106 := yyInitial_yyvs_size
			yyvs106 := yyspecial_routines106.make (yyvsc106)
			create yyspecial_routines107
			yyvsc107 := yyInitial_yyvs_size
			yyvs107 := yyspecial_routines107.make (yyvsc107)
			create yyspecial_routines108
			yyvsc108 := yyInitial_yyvs_size
			yyvs108 := yyspecial_routines108.make (yyvsc108)
			create yyspecial_routines109
			yyvsc109 := yyInitial_yyvs_size
			yyvs109 := yyspecial_routines109.make (yyvsc109)
			create yyspecial_routines110
			yyvsc110 := yyInitial_yyvs_size
			yyvs110 := yyspecial_routines110.make (yyvsc110)
			create yyspecial_routines111
			yyvsc111 := yyInitial_yyvs_size
			yyvs111 := yyspecial_routines111.make (yyvsc111)
			create yyspecial_routines112
			yyvsc112 := yyInitial_yyvs_size
			yyvs112 := yyspecial_routines112.make (yyvsc112)
			create yyspecial_routines113
			yyvsc113 := yyInitial_yyvs_size
			yyvs113 := yyspecial_routines113.make (yyvsc113)
			create yyspecial_routines114
			yyvsc114 := yyInitial_yyvs_size
			yyvs114 := yyspecial_routines114.make (yyvsc114)
			create yyspecial_routines115
			yyvsc115 := yyInitial_yyvs_size
			yyvs115 := yyspecial_routines115.make (yyvsc115)
			create yyspecial_routines116
			yyvsc116 := yyInitial_yyvs_size
			yyvs116 := yyspecial_routines116.make (yyvsc116)
			create yyspecial_routines117
			yyvsc117 := yyInitial_yyvs_size
			yyvs117 := yyspecial_routines117.make (yyvsc117)
			create yyspecial_routines118
			yyvsc118 := yyInitial_yyvs_size
			yyvs118 := yyspecial_routines118.make (yyvsc118)
			create yyspecial_routines119
			yyvsc119 := yyInitial_yyvs_size
			yyvs119 := yyspecial_routines119.make (yyvsc119)
			create yyspecial_routines120
			yyvsc120 := yyInitial_yyvs_size
			yyvs120 := yyspecial_routines120.make (yyvsc120)
			create yyspecial_routines121
			yyvsc121 := yyInitial_yyvs_size
			yyvs121 := yyspecial_routines121.make (yyvsc121)
			create yyspecial_routines122
			yyvsc122 := yyInitial_yyvs_size
			yyvs122 := yyspecial_routines122.make (yyvsc122)
			create yyspecial_routines123
			yyvsc123 := yyInitial_yyvs_size
			yyvs123 := yyspecial_routines123.make (yyvsc123)
			create yyspecial_routines124
			yyvsc124 := yyInitial_yyvs_size
			yyvs124 := yyspecial_routines124.make (yyvsc124)
			create yyspecial_routines125
			yyvsc125 := yyInitial_yyvs_size
			yyvs125 := yyspecial_routines125.make (yyvsc125)
			create yyspecial_routines126
			yyvsc126 := yyInitial_yyvs_size
			yyvs126 := yyspecial_routines126.make (yyvsc126)
			create yyspecial_routines127
			yyvsc127 := yyInitial_yyvs_size
			yyvs127 := yyspecial_routines127.make (yyvsc127)
			create yyspecial_routines128
			yyvsc128 := yyInitial_yyvs_size
			yyvs128 := yyspecial_routines128.make (yyvsc128)
			create yyspecial_routines129
			yyvsc129 := yyInitial_yyvs_size
			yyvs129 := yyspecial_routines129.make (yyvsc129)
			create yyspecial_routines130
			yyvsc130 := yyInitial_yyvs_size
			yyvs130 := yyspecial_routines130.make (yyvsc130)
			create yyspecial_routines131
			yyvsc131 := yyInitial_yyvs_size
			yyvs131 := yyspecial_routines131.make (yyvsc131)
		end

	yy_init_value_stacks
			-- Initialize value stacks.
		do
			yyvsp1 := -1
			yyvsp2 := -1
			yyvsp3 := -1
			yyvsp4 := -1
			yyvsp5 := -1
			yyvsp6 := -1
			yyvsp7 := -1
			yyvsp8 := -1
			yyvsp9 := -1
			yyvsp10 := -1
			yyvsp11 := -1
			yyvsp12 := -1
			yyvsp13 := -1
			yyvsp14 := -1
			yyvsp15 := -1
			yyvsp16 := -1
			yyvsp17 := -1
			yyvsp18 := -1
			yyvsp19 := -1
			yyvsp20 := -1
			yyvsp21 := -1
			yyvsp22 := -1
			yyvsp23 := -1
			yyvsp24 := -1
			yyvsp25 := -1
			yyvsp26 := -1
			yyvsp27 := -1
			yyvsp28 := -1
			yyvsp29 := -1
			yyvsp30 := -1
			yyvsp31 := -1
			yyvsp32 := -1
			yyvsp33 := -1
			yyvsp34 := -1
			yyvsp35 := -1
			yyvsp36 := -1
			yyvsp37 := -1
			yyvsp38 := -1
			yyvsp39 := -1
			yyvsp40 := -1
			yyvsp41 := -1
			yyvsp42 := -1
			yyvsp43 := -1
			yyvsp44 := -1
			yyvsp45 := -1
			yyvsp46 := -1
			yyvsp47 := -1
			yyvsp48 := -1
			yyvsp49 := -1
			yyvsp50 := -1
			yyvsp51 := -1
			yyvsp52 := -1
			yyvsp53 := -1
			yyvsp54 := -1
			yyvsp55 := -1
			yyvsp56 := -1
			yyvsp57 := -1
			yyvsp58 := -1
			yyvsp59 := -1
			yyvsp60 := -1
			yyvsp61 := -1
			yyvsp62 := -1
			yyvsp63 := -1
			yyvsp64 := -1
			yyvsp65 := -1
			yyvsp66 := -1
			yyvsp67 := -1
			yyvsp68 := -1
			yyvsp69 := -1
			yyvsp70 := -1
			yyvsp71 := -1
			yyvsp72 := -1
			yyvsp73 := -1
			yyvsp74 := -1
			yyvsp75 := -1
			yyvsp76 := -1
			yyvsp77 := -1
			yyvsp78 := -1
			yyvsp79 := -1
			yyvsp80 := -1
			yyvsp81 := -1
			yyvsp82 := -1
			yyvsp83 := -1
			yyvsp84 := -1
			yyvsp85 := -1
			yyvsp86 := -1
			yyvsp87 := -1
			yyvsp88 := -1
			yyvsp89 := -1
			yyvsp90 := -1
			yyvsp91 := -1
			yyvsp92 := -1
			yyvsp93 := -1
			yyvsp94 := -1
			yyvsp95 := -1
			yyvsp96 := -1
			yyvsp97 := -1
			yyvsp98 := -1
			yyvsp99 := -1
			yyvsp100 := -1
			yyvsp101 := -1
			yyvsp102 := -1
			yyvsp103 := -1
			yyvsp104 := -1
			yyvsp105 := -1
			yyvsp106 := -1
			yyvsp107 := -1
			yyvsp108 := -1
			yyvsp109 := -1
			yyvsp110 := -1
			yyvsp111 := -1
			yyvsp112 := -1
			yyvsp113 := -1
			yyvsp114 := -1
			yyvsp115 := -1
			yyvsp116 := -1
			yyvsp117 := -1
			yyvsp118 := -1
			yyvsp119 := -1
			yyvsp120 := -1
			yyvsp121 := -1
			yyvsp122 := -1
			yyvsp123 := -1
			yyvsp124 := -1
			yyvsp125 := -1
			yyvsp126 := -1
			yyvsp127 := -1
			yyvsp128 := -1
			yyvsp129 := -1
			yyvsp130 := -1
			yyvsp131 := -1
		end

	yy_clear_value_stacks
			-- Clear objects in semantic value stacks so that
			-- they can be collected by the garbage collector.
		do
			yyvs1.keep_head (0)
			yyvs2.keep_head (0)
			yyvs3.keep_head (0)
			yyvs4.keep_head (0)
			yyvs5.keep_head (0)
			yyvs6.keep_head (0)
			yyvs7.keep_head (0)
			yyvs8.keep_head (0)
			yyvs9.keep_head (0)
			yyvs10.keep_head (0)
			yyvs11.keep_head (0)
			yyvs12.keep_head (0)
			yyvs13.keep_head (0)
			yyvs14.keep_head (0)
			yyvs15.keep_head (0)
			yyvs16.keep_head (0)
			yyvs17.keep_head (0)
			yyvs18.keep_head (0)
			yyvs19.keep_head (0)
			yyvs20.keep_head (0)
			yyvs21.keep_head (0)
			yyvs22.keep_head (0)
			yyvs23.keep_head (0)
			yyvs24.keep_head (0)
			yyvs25.keep_head (0)
			yyvs26.keep_head (0)
			yyvs27.keep_head (0)
			yyvs28.keep_head (0)
			yyvs29.keep_head (0)
			yyvs30.keep_head (0)
			yyvs31.keep_head (0)
			yyvs32.keep_head (0)
			yyvs33.keep_head (0)
			yyvs34.keep_head (0)
			yyvs35.keep_head (0)
			yyvs36.keep_head (0)
			yyvs37.keep_head (0)
			yyvs38.keep_head (0)
			yyvs39.keep_head (0)
			yyvs40.keep_head (0)
			yyvs41.keep_head (0)
			yyvs42.keep_head (0)
			yyvs43.keep_head (0)
			yyvs44.keep_head (0)
			yyvs45.keep_head (0)
			yyvs46.keep_head (0)
			yyvs47.keep_head (0)
			yyvs48.keep_head (0)
			yyvs49.keep_head (0)
			yyvs50.keep_head (0)
			yyvs51.keep_head (0)
			yyvs52.keep_head (0)
			yyvs53.keep_head (0)
			yyvs54.keep_head (0)
			yyvs55.keep_head (0)
			yyvs56.keep_head (0)
			yyvs57.keep_head (0)
			yyvs58.keep_head (0)
			yyvs59.keep_head (0)
			yyvs60.keep_head (0)
			yyvs61.keep_head (0)
			yyvs62.keep_head (0)
			yyvs63.keep_head (0)
			yyvs64.keep_head (0)
			yyvs65.keep_head (0)
			yyvs66.keep_head (0)
			yyvs67.keep_head (0)
			yyvs68.keep_head (0)
			yyvs69.keep_head (0)
			yyvs70.keep_head (0)
			yyvs71.keep_head (0)
			yyvs72.keep_head (0)
			yyvs73.keep_head (0)
			yyvs74.keep_head (0)
			yyvs75.keep_head (0)
			yyvs76.keep_head (0)
			yyvs77.keep_head (0)
			yyvs78.keep_head (0)
			yyvs79.keep_head (0)
			yyvs80.keep_head (0)
			yyvs81.keep_head (0)
			yyvs82.keep_head (0)
			yyvs83.keep_head (0)
			yyvs84.keep_head (0)
			yyvs85.keep_head (0)
			yyvs86.keep_head (0)
			yyvs87.keep_head (0)
			yyvs88.keep_head (0)
			yyvs89.keep_head (0)
			yyvs90.keep_head (0)
			yyvs91.keep_head (0)
			yyvs92.keep_head (0)
			yyvs93.keep_head (0)
			yyvs94.keep_head (0)
			yyvs95.keep_head (0)
			yyvs96.keep_head (0)
			yyvs97.keep_head (0)
			yyvs98.keep_head (0)
			yyvs99.keep_head (0)
			yyvs100.keep_head (0)
			yyvs101.keep_head (0)
			yyvs102.keep_head (0)
			yyvs103.keep_head (0)
			yyvs104.keep_head (0)
			yyvs105.keep_head (0)
			yyvs106.keep_head (0)
			yyvs107.keep_head (0)
			yyvs108.keep_head (0)
			yyvs109.keep_head (0)
			yyvs110.keep_head (0)
			yyvs111.keep_head (0)
			yyvs112.keep_head (0)
			yyvs113.keep_head (0)
			yyvs114.keep_head (0)
			yyvs115.keep_head (0)
			yyvs116.keep_head (0)
			yyvs117.keep_head (0)
			yyvs118.keep_head (0)
			yyvs119.keep_head (0)
			yyvs120.keep_head (0)
			yyvs121.keep_head (0)
			yyvs122.keep_head (0)
			yyvs123.keep_head (0)
			yyvs124.keep_head (0)
			yyvs125.keep_head (0)
			yyvs126.keep_head (0)
			yyvs127.keep_head (0)
			yyvs128.keep_head (0)
			yyvs129.keep_head (0)
			yyvs130.keep_head (0)
			yyvs131.keep_head (0)
		end

	yy_push_last_value (yychar1: INTEGER)
			-- Push semantic value associated with token `last_token'
			-- (with internal id `yychar1') on top of corresponding
			-- value stack.
		do
			inspect yytypes2.item (yychar1)
			when 1 then
				yyvsp1 := yyvsp1 + 1
				if yyvsp1 >= yyvsc1 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs1")
					end
					yyvsc1 := yyvsc1 + yyInitial_yyvs_size
					yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
				end
				yyspecial_routines1.force (yyvs1, last_detachable_any_value, yyvsp1)
			when 2 then
				yyvsp2 := yyvsp2 + 1
				if yyvsp2 >= yyvsc2 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs2")
					end
					yyvsc2 := yyvsc2 + yyInitial_yyvs_size
					yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
				end
				yyspecial_routines2.force (yyvs2, last_detachable_et_keyword_value, yyvsp2)
			when 3 then
				yyvsp3 := yyvsp3 + 1
				if yyvsp3 >= yyvsc3 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs3")
					end
					yyvsc3 := yyvsc3 + yyInitial_yyvs_size
					yyvs3 := yyspecial_routines3.aliased_resized_area (yyvs3, yyvsc3)
				end
				yyspecial_routines3.force (yyvs3, last_detachable_et_agent_keyword_value, yyvsp3)
			when 4 then
				yyvsp4 := yyvsp4 + 1
				if yyvsp4 >= yyvsc4 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs4")
					end
					yyvsc4 := yyvsc4 + yyInitial_yyvs_size
					yyvs4 := yyspecial_routines4.aliased_resized_area (yyvs4, yyvsc4)
				end
				yyspecial_routines4.force (yyvs4, last_detachable_et_precursor_keyword_value, yyvsp4)
			when 5 then
				yyvsp5 := yyvsp5 + 1
				if yyvsp5 >= yyvsc5 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs5")
					end
					yyvsc5 := yyvsc5 + yyInitial_yyvs_size
					yyvs5 := yyspecial_routines5.aliased_resized_area (yyvs5, yyvsc5)
				end
				yyspecial_routines5.force (yyvs5, last_detachable_et_symbol_value, yyvsp5)
			when 6 then
				yyvsp6 := yyvsp6 + 1
				if yyvsp6 >= yyvsc6 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs6")
					end
					yyvsc6 := yyvsc6 + yyInitial_yyvs_size
					yyvs6 := yyspecial_routines6.aliased_resized_area (yyvs6, yyvsc6)
				end
				yyspecial_routines6.force (yyvs6, last_detachable_et_position_value, yyvsp6)
			when 7 then
				yyvsp7 := yyvsp7 + 1
				if yyvsp7 >= yyvsc7 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs7")
					end
					yyvsc7 := yyvsc7 + yyInitial_yyvs_size
					yyvs7 := yyspecial_routines7.aliased_resized_area (yyvs7, yyvsc7)
				end
				yyspecial_routines7.force (yyvs7, last_detachable_et_boolean_constant_value, yyvsp7)
			when 8 then
				yyvsp8 := yyvsp8 + 1
				if yyvsp8 >= yyvsc8 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs8")
					end
					yyvsc8 := yyvsc8 + yyInitial_yyvs_size
					yyvs8 := yyspecial_routines8.aliased_resized_area (yyvs8, yyvsc8)
				end
				yyspecial_routines8.force (yyvs8, last_detachable_et_break_value, yyvsp8)
			when 9 then
				yyvsp9 := yyvsp9 + 1
				if yyvsp9 >= yyvsc9 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs9")
					end
					yyvsc9 := yyvsc9 + yyInitial_yyvs_size
					yyvs9 := yyspecial_routines9.aliased_resized_area (yyvs9, yyvsc9)
				end
				yyspecial_routines9.force (yyvs9, last_detachable_et_character_constant_value, yyvsp9)
			when 10 then
				yyvsp10 := yyvsp10 + 1
				if yyvsp10 >= yyvsc10 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs10")
					end
					yyvsc10 := yyvsc10 + yyInitial_yyvs_size
					yyvs10 := yyspecial_routines10.aliased_resized_area (yyvs10, yyvsc10)
				end
				yyspecial_routines10.force (yyvs10, last_detachable_et_current_value, yyvsp10)
			when 11 then
				yyvsp11 := yyvsp11 + 1
				if yyvsp11 >= yyvsc11 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs11")
					end
					yyvsc11 := yyvsc11 + yyInitial_yyvs_size
					yyvs11 := yyspecial_routines11.aliased_resized_area (yyvs11, yyvsc11)
				end
				yyspecial_routines11.force (yyvs11, last_detachable_et_free_operator_value, yyvsp11)
			when 12 then
				yyvsp12 := yyvsp12 + 1
				if yyvsp12 >= yyvsc12 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs12")
					end
					yyvsc12 := yyvsc12 + yyInitial_yyvs_size
					yyvs12 := yyspecial_routines12.aliased_resized_area (yyvs12, yyvsc12)
				end
				yyspecial_routines12.force (yyvs12, last_detachable_et_identifier_value, yyvsp12)
			when 13 then
				yyvsp13 := yyvsp13 + 1
				if yyvsp13 >= yyvsc13 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs13")
					end
					yyvsc13 := yyvsc13 + yyInitial_yyvs_size
					yyvs13 := yyspecial_routines13.aliased_resized_area (yyvs13, yyvsc13)
				end
				yyspecial_routines13.force (yyvs13, last_detachable_et_integer_constant_value, yyvsp13)
			when 14 then
				yyvsp14 := yyvsp14 + 1
				if yyvsp14 >= yyvsc14 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs14")
					end
					yyvsc14 := yyvsc14 + yyInitial_yyvs_size
					yyvs14 := yyspecial_routines14.aliased_resized_area (yyvs14, yyvsc14)
				end
				yyspecial_routines14.force (yyvs14, last_detachable_et_keyword_operator_value, yyvsp14)
			when 15 then
				yyvsp15 := yyvsp15 + 1
				if yyvsp15 >= yyvsc15 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs15")
					end
					yyvsc15 := yyvsc15 + yyInitial_yyvs_size
					yyvs15 := yyspecial_routines15.aliased_resized_area (yyvs15, yyvsc15)
				end
				yyspecial_routines15.force (yyvs15, last_detachable_et_manifest_string_value, yyvsp15)
			when 16 then
				yyvsp16 := yyvsp16 + 1
				if yyvsp16 >= yyvsc16 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs16")
					end
					yyvsc16 := yyvsc16 + yyInitial_yyvs_size
					yyvs16 := yyspecial_routines16.aliased_resized_area (yyvs16, yyvsc16)
				end
				yyspecial_routines16.force (yyvs16, last_detachable_et_real_constant_value, yyvsp16)
			when 17 then
				yyvsp17 := yyvsp17 + 1
				if yyvsp17 >= yyvsc17 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs17")
					end
					yyvsc17 := yyvsc17 + yyInitial_yyvs_size
					yyvs17 := yyspecial_routines17.aliased_resized_area (yyvs17, yyvsc17)
				end
				yyspecial_routines17.force (yyvs17, last_detachable_et_result_value, yyvsp17)
			when 18 then
				yyvsp18 := yyvsp18 + 1
				if yyvsp18 >= yyvsc18 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs18")
					end
					yyvsc18 := yyvsc18 + yyInitial_yyvs_size
					yyvs18 := yyspecial_routines18.aliased_resized_area (yyvs18, yyvsc18)
				end
				yyspecial_routines18.force (yyvs18, last_detachable_et_retry_instruction_value, yyvsp18)
			when 19 then
				yyvsp19 := yyvsp19 + 1
				if yyvsp19 >= yyvsc19 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs19")
					end
					yyvsc19 := yyvsc19 + yyInitial_yyvs_size
					yyvs19 := yyspecial_routines19.aliased_resized_area (yyvs19, yyvsc19)
				end
				yyspecial_routines19.force (yyvs19, last_detachable_et_symbol_operator_value, yyvsp19)
			when 20 then
				yyvsp20 := yyvsp20 + 1
				if yyvsp20 >= yyvsc20 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs20")
					end
					yyvsc20 := yyvsc20 + yyInitial_yyvs_size
					yyvs20 := yyspecial_routines20.aliased_resized_area (yyvs20, yyvsc20)
				end
				yyspecial_routines20.force (yyvs20, last_detachable_et_void_value, yyvsp20)
			when 21 then
				yyvsp21 := yyvsp21 + 1
				if yyvsp21 >= yyvsc21 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs21")
					end
					yyvsc21 := yyvsc21 + yyInitial_yyvs_size
					yyvs21 := yyspecial_routines21.aliased_resized_area (yyvs21, yyvsc21)
				end
				yyspecial_routines21.force (yyvs21, last_detachable_et_semicolon_symbol_value, yyvsp21)
			when 22 then
				yyvsp22 := yyvsp22 + 1
				if yyvsp22 >= yyvsc22 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs22")
					end
					yyvsc22 := yyvsc22 + yyInitial_yyvs_size
					yyvs22 := yyspecial_routines22.aliased_resized_area (yyvs22, yyvsc22)
				end
				yyspecial_routines22.force (yyvs22, last_detachable_et_bracket_symbol_value, yyvsp22)
			when 23 then
				yyvsp23 := yyvsp23 + 1
				if yyvsp23 >= yyvsc23 then
					debug ("GEYACC")
						std.error.put_line ("Resize yyvs23")
					end
					yyvsc23 := yyvsc23 + yyInitial_yyvs_size
					yyvs23 := yyspecial_routines23.aliased_resized_area (yyvs23, yyvsc23)
				end
				yyspecial_routines23.force (yyvs23, last_detachable_et_question_mark_symbol_value, yyvsp23)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: not a token type: ")
					std.error.put_integer (yytypes2.item (yychar1))
					std.error.put_new_line
				end
				abort
			end
		end

	yy_push_error_value
			-- Push semantic value associated with token 'error'
			-- on top of corresponding value stack.
		local
			yyval1: detachable ANY
		do
			yyvsp1 := yyvsp1 + 1
			if yyvsp1 >= yyvsc1 then
				debug ("GEYACC")
					std.error.put_line ("Resize yyvs1")
				end
				yyvsc1 := yyvsc1 + yyInitial_yyvs_size
				yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
			end
			yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
		end

	yy_pop_last_value (yystate: INTEGER)
			-- Pop semantic value from stack when in state `yystate'.
		local
			yy_type_id: INTEGER
		do
			yy_type_id := yytypes1.item (yystate)
			inspect yy_type_id
			when 1 then
				yyvsp1 := yyvsp1 - 1
			when 2 then
				yyvsp2 := yyvsp2 - 1
			when 3 then
				yyvsp3 := yyvsp3 - 1
			when 4 then
				yyvsp4 := yyvsp4 - 1
			when 5 then
				yyvsp5 := yyvsp5 - 1
			when 6 then
				yyvsp6 := yyvsp6 - 1
			when 7 then
				yyvsp7 := yyvsp7 - 1
			when 8 then
				yyvsp8 := yyvsp8 - 1
			when 9 then
				yyvsp9 := yyvsp9 - 1
			when 10 then
				yyvsp10 := yyvsp10 - 1
			when 11 then
				yyvsp11 := yyvsp11 - 1
			when 12 then
				yyvsp12 := yyvsp12 - 1
			when 13 then
				yyvsp13 := yyvsp13 - 1
			when 14 then
				yyvsp14 := yyvsp14 - 1
			when 15 then
				yyvsp15 := yyvsp15 - 1
			when 16 then
				yyvsp16 := yyvsp16 - 1
			when 17 then
				yyvsp17 := yyvsp17 - 1
			when 18 then
				yyvsp18 := yyvsp18 - 1
			when 19 then
				yyvsp19 := yyvsp19 - 1
			when 20 then
				yyvsp20 := yyvsp20 - 1
			when 21 then
				yyvsp21 := yyvsp21 - 1
			when 22 then
				yyvsp22 := yyvsp22 - 1
			when 23 then
				yyvsp23 := yyvsp23 - 1
			when 24 then
				yyvsp24 := yyvsp24 - 1
			when 25 then
				yyvsp25 := yyvsp25 - 1
			when 26 then
				yyvsp26 := yyvsp26 - 1
			when 27 then
				yyvsp27 := yyvsp27 - 1
			when 28 then
				yyvsp28 := yyvsp28 - 1
			when 29 then
				yyvsp29 := yyvsp29 - 1
			when 30 then
				yyvsp30 := yyvsp30 - 1
			when 31 then
				yyvsp31 := yyvsp31 - 1
			when 32 then
				yyvsp32 := yyvsp32 - 1
			when 33 then
				yyvsp33 := yyvsp33 - 1
			when 34 then
				yyvsp34 := yyvsp34 - 1
			when 35 then
				yyvsp35 := yyvsp35 - 1
			when 36 then
				yyvsp36 := yyvsp36 - 1
			when 37 then
				yyvsp37 := yyvsp37 - 1
			when 38 then
				yyvsp38 := yyvsp38 - 1
			when 39 then
				yyvsp39 := yyvsp39 - 1
			when 40 then
				yyvsp40 := yyvsp40 - 1
			when 41 then
				yyvsp41 := yyvsp41 - 1
			when 42 then
				yyvsp42 := yyvsp42 - 1
			when 43 then
				yyvsp43 := yyvsp43 - 1
			when 44 then
				yyvsp44 := yyvsp44 - 1
			when 45 then
				yyvsp45 := yyvsp45 - 1
			when 46 then
				yyvsp46 := yyvsp46 - 1
			when 47 then
				yyvsp47 := yyvsp47 - 1
			when 48 then
				yyvsp48 := yyvsp48 - 1
			when 49 then
				yyvsp49 := yyvsp49 - 1
			when 50 then
				yyvsp50 := yyvsp50 - 1
			when 51 then
				yyvsp51 := yyvsp51 - 1
			when 52 then
				yyvsp52 := yyvsp52 - 1
			when 53 then
				yyvsp53 := yyvsp53 - 1
			when 54 then
				yyvsp54 := yyvsp54 - 1
			when 55 then
				yyvsp55 := yyvsp55 - 1
			when 56 then
				yyvsp56 := yyvsp56 - 1
			when 57 then
				yyvsp57 := yyvsp57 - 1
			when 58 then
				yyvsp58 := yyvsp58 - 1
			when 59 then
				yyvsp59 := yyvsp59 - 1
			when 60 then
				yyvsp60 := yyvsp60 - 1
			when 61 then
				yyvsp61 := yyvsp61 - 1
			when 62 then
				yyvsp62 := yyvsp62 - 1
			when 63 then
				yyvsp63 := yyvsp63 - 1
			when 64 then
				yyvsp64 := yyvsp64 - 1
			when 65 then
				yyvsp65 := yyvsp65 - 1
			when 66 then
				yyvsp66 := yyvsp66 - 1
			when 67 then
				yyvsp67 := yyvsp67 - 1
			when 68 then
				yyvsp68 := yyvsp68 - 1
			when 69 then
				yyvsp69 := yyvsp69 - 1
			when 70 then
				yyvsp70 := yyvsp70 - 1
			when 71 then
				yyvsp71 := yyvsp71 - 1
			when 72 then
				yyvsp72 := yyvsp72 - 1
			when 73 then
				yyvsp73 := yyvsp73 - 1
			when 74 then
				yyvsp74 := yyvsp74 - 1
			when 75 then
				yyvsp75 := yyvsp75 - 1
			when 76 then
				yyvsp76 := yyvsp76 - 1
			when 77 then
				yyvsp77 := yyvsp77 - 1
			when 78 then
				yyvsp78 := yyvsp78 - 1
			when 79 then
				yyvsp79 := yyvsp79 - 1
			when 80 then
				yyvsp80 := yyvsp80 - 1
			when 81 then
				yyvsp81 := yyvsp81 - 1
			when 82 then
				yyvsp82 := yyvsp82 - 1
			when 83 then
				yyvsp83 := yyvsp83 - 1
			when 84 then
				yyvsp84 := yyvsp84 - 1
			when 85 then
				yyvsp85 := yyvsp85 - 1
			when 86 then
				yyvsp86 := yyvsp86 - 1
			when 87 then
				yyvsp87 := yyvsp87 - 1
			when 88 then
				yyvsp88 := yyvsp88 - 1
			when 89 then
				yyvsp89 := yyvsp89 - 1
			when 90 then
				yyvsp90 := yyvsp90 - 1
			when 91 then
				yyvsp91 := yyvsp91 - 1
			when 92 then
				yyvsp92 := yyvsp92 - 1
			when 93 then
				yyvsp93 := yyvsp93 - 1
			when 94 then
				yyvsp94 := yyvsp94 - 1
			when 95 then
				yyvsp95 := yyvsp95 - 1
			when 96 then
				yyvsp96 := yyvsp96 - 1
			when 97 then
				yyvsp97 := yyvsp97 - 1
			when 98 then
				yyvsp98 := yyvsp98 - 1
			when 99 then
				yyvsp99 := yyvsp99 - 1
			when 100 then
				yyvsp100 := yyvsp100 - 1
			when 101 then
				yyvsp101 := yyvsp101 - 1
			when 102 then
				yyvsp102 := yyvsp102 - 1
			when 103 then
				yyvsp103 := yyvsp103 - 1
			when 104 then
				yyvsp104 := yyvsp104 - 1
			when 105 then
				yyvsp105 := yyvsp105 - 1
			when 106 then
				yyvsp106 := yyvsp106 - 1
			when 107 then
				yyvsp107 := yyvsp107 - 1
			when 108 then
				yyvsp108 := yyvsp108 - 1
			when 109 then
				yyvsp109 := yyvsp109 - 1
			when 110 then
				yyvsp110 := yyvsp110 - 1
			when 111 then
				yyvsp111 := yyvsp111 - 1
			when 112 then
				yyvsp112 := yyvsp112 - 1
			when 113 then
				yyvsp113 := yyvsp113 - 1
			when 114 then
				yyvsp114 := yyvsp114 - 1
			when 115 then
				yyvsp115 := yyvsp115 - 1
			when 116 then
				yyvsp116 := yyvsp116 - 1
			when 117 then
				yyvsp117 := yyvsp117 - 1
			when 118 then
				yyvsp118 := yyvsp118 - 1
			when 119 then
				yyvsp119 := yyvsp119 - 1
			when 120 then
				yyvsp120 := yyvsp120 - 1
			when 121 then
				yyvsp121 := yyvsp121 - 1
			when 122 then
				yyvsp122 := yyvsp122 - 1
			when 123 then
				yyvsp123 := yyvsp123 - 1
			when 124 then
				yyvsp124 := yyvsp124 - 1
			when 125 then
				yyvsp125 := yyvsp125 - 1
			when 126 then
				yyvsp126 := yyvsp126 - 1
			when 127 then
				yyvsp127 := yyvsp127 - 1
			when 128 then
				yyvsp128 := yyvsp128 - 1
			when 129 then
				yyvsp129 := yyvsp129 - 1
			when 130 then
				yyvsp130 := yyvsp130 - 1
			when 131 then
				yyvsp131 := yyvsp131 - 1
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown type id: ")
					std.error.put_integer (yy_type_id)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_run_geyacc
			-- You must run geyacc to regenerate this class.
		do
		end

feature {NONE} -- Semantic actions

	yy_do_action (yy_act: INTEGER)
			-- Execute semantic action.
		do
			if yy_act <= 200 then
				yy_do_action_1_200 (yy_act)
			elseif yy_act <= 400 then
				yy_do_action_201_400 (yy_act)
			elseif yy_act <= 600 then
				yy_do_action_401_600 (yy_act)
			elseif yy_act <= 800 then
				yy_do_action_601_800 (yy_act)
			elseif yy_act <= 1000 then
				yy_do_action_801_1000 (yy_act)
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_1_200 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 1 then
					--|#line 244 "et_eiffel_parser.y"
				yy_do_action_1
			when 2 then
					--|#line 248 "et_eiffel_parser.y"
				yy_do_action_2
			when 3 then
					--|#line 256 "et_eiffel_parser.y"
				yy_do_action_3
			when 4 then
					--|#line 265 "et_eiffel_parser.y"
				yy_do_action_4
			when 5 then
					--|#line 266 "et_eiffel_parser.y"
				yy_do_action_5
			when 6 then
					--|#line 266 "et_eiffel_parser.y"
				yy_do_action_6
			when 7 then
					--|#line 277 "et_eiffel_parser.y"
				yy_do_action_7
			when 8 then
					--|#line 285 "et_eiffel_parser.y"
				yy_do_action_8
			when 9 then
					--|#line 290 "et_eiffel_parser.y"
				yy_do_action_9
			when 10 then
					--|#line 292 "et_eiffel_parser.y"
				yy_do_action_10
			when 11 then
					--|#line 292 "et_eiffel_parser.y"
				yy_do_action_11
			when 12 then
					--|#line 303 "et_eiffel_parser.y"
				yy_do_action_12
			when 13 then
					--|#line 305 "et_eiffel_parser.y"
				yy_do_action_13
			when 14 then
					--|#line 305 "et_eiffel_parser.y"
				yy_do_action_14
			when 15 then
					--|#line 318 "et_eiffel_parser.y"
				yy_do_action_15
			when 16 then
					--|#line 320 "et_eiffel_parser.y"
				yy_do_action_16
			when 17 then
					--|#line 324 "et_eiffel_parser.y"
				yy_do_action_17
			when 18 then
					--|#line 335 "et_eiffel_parser.y"
				yy_do_action_18
			when 19 then
					--|#line 335 "et_eiffel_parser.y"
				yy_do_action_19
			when 20 then
					--|#line 344 "et_eiffel_parser.y"
				yy_do_action_20
			when 21 then
					--|#line 344 "et_eiffel_parser.y"
				yy_do_action_21
			when 22 then
					--|#line 355 "et_eiffel_parser.y"
				yy_do_action_22
			when 23 then
					--|#line 362 "et_eiffel_parser.y"
				yy_do_action_23
			when 24 then
					--|#line 368 "et_eiffel_parser.y"
				yy_do_action_24
			when 25 then
					--|#line 372 "et_eiffel_parser.y"
				yy_do_action_25
			when 26 then
					--|#line 383 "et_eiffel_parser.y"
				yy_do_action_26
			when 27 then
					--|#line 395 "et_eiffel_parser.y"
				yy_do_action_27
			when 28 then
					--|#line 395 "et_eiffel_parser.y"
				yy_do_action_28
			when 29 then
					--|#line 404 "et_eiffel_parser.y"
				yy_do_action_29
			when 30 then
					--|#line 404 "et_eiffel_parser.y"
				yy_do_action_30
			when 31 then
					--|#line 415 "et_eiffel_parser.y"
				yy_do_action_31
			when 32 then
					--|#line 422 "et_eiffel_parser.y"
				yy_do_action_32
			when 33 then
					--|#line 426 "et_eiffel_parser.y"
				yy_do_action_33
			when 34 then
					--|#line 432 "et_eiffel_parser.y"
				yy_do_action_34
			when 35 then
					--|#line 434 "et_eiffel_parser.y"
				yy_do_action_35
			when 36 then
					--|#line 439 "et_eiffel_parser.y"
				yy_do_action_36
			when 37 then
					--|#line 450 "et_eiffel_parser.y"
				yy_do_action_37
			when 38 then
					--|#line 459 "et_eiffel_parser.y"
				yy_do_action_38
			when 39 then
					--|#line 461 "et_eiffel_parser.y"
				yy_do_action_39
			when 40 then
					--|#line 463 "et_eiffel_parser.y"
				yy_do_action_40
			when 41 then
					--|#line 465 "et_eiffel_parser.y"
				yy_do_action_41
			when 42 then
					--|#line 467 "et_eiffel_parser.y"
				yy_do_action_42
			when 43 then
					--|#line 469 "et_eiffel_parser.y"
				yy_do_action_43
			when 44 then
					--|#line 471 "et_eiffel_parser.y"
				yy_do_action_44
			when 45 then
					--|#line 473 "et_eiffel_parser.y"
				yy_do_action_45
			when 46 then
					--|#line 477 "et_eiffel_parser.y"
				yy_do_action_46
			when 47 then
					--|#line 488 "et_eiffel_parser.y"
				yy_do_action_47
			when 48 then
					--|#line 500 "et_eiffel_parser.y"
				yy_do_action_48
			when 49 then
					--|#line 513 "et_eiffel_parser.y"
				yy_do_action_49
			when 50 then
					--|#line 526 "et_eiffel_parser.y"
				yy_do_action_50
			when 51 then
					--|#line 541 "et_eiffel_parser.y"
				yy_do_action_51
			when 52 then
					--|#line 543 "et_eiffel_parser.y"
				yy_do_action_52
			when 53 then
					--|#line 547 "et_eiffel_parser.y"
				yy_do_action_53
			when 54 then
					--|#line 549 "et_eiffel_parser.y"
				yy_do_action_54
			when 55 then
					--|#line 555 "et_eiffel_parser.y"
				yy_do_action_55
			when 56 then
					--|#line 559 "et_eiffel_parser.y"
				yy_do_action_56
			when 57 then
					--|#line 565 "et_eiffel_parser.y"
				yy_do_action_57
			when 58 then
					--|#line 565 "et_eiffel_parser.y"
				yy_do_action_58
			when 59 then
					--|#line 579 "et_eiffel_parser.y"
				yy_do_action_59
			when 60 then
					--|#line 590 "et_eiffel_parser.y"
				yy_do_action_60
			when 61 then
					--|#line 599 "et_eiffel_parser.y"
				yy_do_action_61
			when 62 then
					--|#line 608 "et_eiffel_parser.y"
				yy_do_action_62
			when 63 then
					--|#line 610 "et_eiffel_parser.y"
				yy_do_action_63
			when 64 then
					--|#line 612 "et_eiffel_parser.y"
				yy_do_action_64
			when 65 then
					--|#line 614 "et_eiffel_parser.y"
				yy_do_action_65
			when 66 then
					--|#line 616 "et_eiffel_parser.y"
				yy_do_action_66
			when 67 then
					--|#line 618 "et_eiffel_parser.y"
				yy_do_action_67
			when 68 then
					--|#line 620 "et_eiffel_parser.y"
				yy_do_action_68
			when 69 then
					--|#line 622 "et_eiffel_parser.y"
				yy_do_action_69
			when 70 then
					--|#line 624 "et_eiffel_parser.y"
				yy_do_action_70
			when 71 then
					--|#line 628 "et_eiffel_parser.y"
				yy_do_action_71
			when 72 then
					--|#line 635 "et_eiffel_parser.y"
				yy_do_action_72
			when 73 then
					--|#line 644 "et_eiffel_parser.y"
				yy_do_action_73
			when 74 then
					--|#line 644 "et_eiffel_parser.y"
				yy_do_action_74
			when 75 then
					--|#line 657 "et_eiffel_parser.y"
				yy_do_action_75
			when 76 then
					--|#line 668 "et_eiffel_parser.y"
				yy_do_action_76
			when 77 then
					--|#line 677 "et_eiffel_parser.y"
				yy_do_action_77
			when 78 then
					--|#line 686 "et_eiffel_parser.y"
				yy_do_action_78
			when 79 then
					--|#line 688 "et_eiffel_parser.y"
				yy_do_action_79
			when 80 then
					--|#line 688 "et_eiffel_parser.y"
				yy_do_action_80
			when 81 then
					--|#line 701 "et_eiffel_parser.y"
				yy_do_action_81
			when 82 then
					--|#line 712 "et_eiffel_parser.y"
				yy_do_action_82
			when 83 then
					--|#line 721 "et_eiffel_parser.y"
				yy_do_action_83
			when 84 then
					--|#line 730 "et_eiffel_parser.y"
				yy_do_action_84
			when 85 then
					--|#line 732 "et_eiffel_parser.y"
				yy_do_action_85
			when 86 then
					--|#line 736 "et_eiffel_parser.y"
				yy_do_action_86
			when 87 then
					--|#line 738 "et_eiffel_parser.y"
				yy_do_action_87
			when 88 then
					--|#line 738 "et_eiffel_parser.y"
				yy_do_action_88
			when 89 then
					--|#line 751 "et_eiffel_parser.y"
				yy_do_action_89
			when 90 then
					--|#line 763 "et_eiffel_parser.y"
				yy_do_action_90
			when 91 then
					--|#line 771 "et_eiffel_parser.y"
				yy_do_action_91
			when 92 then
					--|#line 780 "et_eiffel_parser.y"
				yy_do_action_92
			when 93 then
					--|#line 782 "et_eiffel_parser.y"
				yy_do_action_93
			when 94 then
					--|#line 784 "et_eiffel_parser.y"
				yy_do_action_94
			when 95 then
					--|#line 786 "et_eiffel_parser.y"
				yy_do_action_95
			when 96 then
					--|#line 788 "et_eiffel_parser.y"
				yy_do_action_96
			when 97 then
					--|#line 790 "et_eiffel_parser.y"
				yy_do_action_97
			when 98 then
					--|#line 792 "et_eiffel_parser.y"
				yy_do_action_98
			when 99 then
					--|#line 794 "et_eiffel_parser.y"
				yy_do_action_99
			when 100 then
					--|#line 796 "et_eiffel_parser.y"
				yy_do_action_100
			when 101 then
					--|#line 798 "et_eiffel_parser.y"
				yy_do_action_101
			when 102 then
					--|#line 800 "et_eiffel_parser.y"
				yy_do_action_102
			when 103 then
					--|#line 802 "et_eiffel_parser.y"
				yy_do_action_103
			when 104 then
					--|#line 804 "et_eiffel_parser.y"
				yy_do_action_104
			when 105 then
					--|#line 806 "et_eiffel_parser.y"
				yy_do_action_105
			when 106 then
					--|#line 808 "et_eiffel_parser.y"
				yy_do_action_106
			when 107 then
					--|#line 810 "et_eiffel_parser.y"
				yy_do_action_107
			when 108 then
					--|#line 812 "et_eiffel_parser.y"
				yy_do_action_108
			when 109 then
					--|#line 814 "et_eiffel_parser.y"
				yy_do_action_109
			when 110 then
					--|#line 816 "et_eiffel_parser.y"
				yy_do_action_110
			when 111 then
					--|#line 818 "et_eiffel_parser.y"
				yy_do_action_111
			when 112 then
					--|#line 820 "et_eiffel_parser.y"
				yy_do_action_112
			when 113 then
					--|#line 822 "et_eiffel_parser.y"
				yy_do_action_113
			when 114 then
					--|#line 826 "et_eiffel_parser.y"
				yy_do_action_114
			when 115 then
					--|#line 828 "et_eiffel_parser.y"
				yy_do_action_115
			when 116 then
					--|#line 830 "et_eiffel_parser.y"
				yy_do_action_116
			when 117 then
					--|#line 832 "et_eiffel_parser.y"
				yy_do_action_117
			when 118 then
					--|#line 834 "et_eiffel_parser.y"
				yy_do_action_118
			when 119 then
					--|#line 836 "et_eiffel_parser.y"
				yy_do_action_119
			when 120 then
					--|#line 838 "et_eiffel_parser.y"
				yy_do_action_120
			when 121 then
					--|#line 840 "et_eiffel_parser.y"
				yy_do_action_121
			when 122 then
					--|#line 842 "et_eiffel_parser.y"
				yy_do_action_122
			when 123 then
					--|#line 844 "et_eiffel_parser.y"
				yy_do_action_123
			when 124 then
					--|#line 846 "et_eiffel_parser.y"
				yy_do_action_124
			when 125 then
					--|#line 848 "et_eiffel_parser.y"
				yy_do_action_125
			when 126 then
					--|#line 850 "et_eiffel_parser.y"
				yy_do_action_126
			when 127 then
					--|#line 852 "et_eiffel_parser.y"
				yy_do_action_127
			when 128 then
					--|#line 854 "et_eiffel_parser.y"
				yy_do_action_128
			when 129 then
					--|#line 856 "et_eiffel_parser.y"
				yy_do_action_129
			when 130 then
					--|#line 858 "et_eiffel_parser.y"
				yy_do_action_130
			when 131 then
					--|#line 860 "et_eiffel_parser.y"
				yy_do_action_131
			when 132 then
					--|#line 862 "et_eiffel_parser.y"
				yy_do_action_132
			when 133 then
					--|#line 864 "et_eiffel_parser.y"
				yy_do_action_133
			when 134 then
					--|#line 866 "et_eiffel_parser.y"
				yy_do_action_134
			when 135 then
					--|#line 868 "et_eiffel_parser.y"
				yy_do_action_135
			when 136 then
					--|#line 872 "et_eiffel_parser.y"
				yy_do_action_136
			when 137 then
					--|#line 874 "et_eiffel_parser.y"
				yy_do_action_137
			when 138 then
					--|#line 878 "et_eiffel_parser.y"
				yy_do_action_138
			when 139 then
					--|#line 881 "et_eiffel_parser.y"
				yy_do_action_139
			when 140 then
					--|#line 889 "et_eiffel_parser.y"
				yy_do_action_140
			when 141 then
					--|#line 900 "et_eiffel_parser.y"
				yy_do_action_141
			when 142 then
					--|#line 905 "et_eiffel_parser.y"
				yy_do_action_142
			when 143 then
					--|#line 912 "et_eiffel_parser.y"
				yy_do_action_143
			when 144 then
					--|#line 921 "et_eiffel_parser.y"
				yy_do_action_144
			when 145 then
					--|#line 923 "et_eiffel_parser.y"
				yy_do_action_145
			when 146 then
					--|#line 927 "et_eiffel_parser.y"
				yy_do_action_146
			when 147 then
					--|#line 930 "et_eiffel_parser.y"
				yy_do_action_147
			when 148 then
					--|#line 936 "et_eiffel_parser.y"
				yy_do_action_148
			when 149 then
					--|#line 944 "et_eiffel_parser.y"
				yy_do_action_149
			when 150 then
					--|#line 949 "et_eiffel_parser.y"
				yy_do_action_150
			when 151 then
					--|#line 954 "et_eiffel_parser.y"
				yy_do_action_151
			when 152 then
					--|#line 959 "et_eiffel_parser.y"
				yy_do_action_152
			when 153 then
					--|#line 972 "et_eiffel_parser.y"
				yy_do_action_153
			when 154 then
					--|#line 981 "et_eiffel_parser.y"
				yy_do_action_154
			when 155 then
					--|#line 992 "et_eiffel_parser.y"
				yy_do_action_155
			when 156 then
					--|#line 994 "et_eiffel_parser.y"
				yy_do_action_156
			when 157 then
					--|#line 1000 "et_eiffel_parser.y"
				yy_do_action_157
			when 158 then
					--|#line 1002 "et_eiffel_parser.y"
				yy_do_action_158
			when 159 then
					--|#line 1009 "et_eiffel_parser.y"
				yy_do_action_159
			when 160 then
					--|#line 1020 "et_eiffel_parser.y"
				yy_do_action_160
			when 161 then
					--|#line 1020 "et_eiffel_parser.y"
				yy_do_action_161
			when 162 then
					--|#line 1035 "et_eiffel_parser.y"
				yy_do_action_162
			when 163 then
					--|#line 1042 "et_eiffel_parser.y"
				yy_do_action_163
			when 164 then
					--|#line 1042 "et_eiffel_parser.y"
				yy_do_action_164
			when 165 then
					--|#line 1058 "et_eiffel_parser.y"
				yy_do_action_165
			when 166 then
					--|#line 1065 "et_eiffel_parser.y"
				yy_do_action_166
			when 167 then
					--|#line 1073 "et_eiffel_parser.y"
				yy_do_action_167
			when 168 then
					--|#line 1080 "et_eiffel_parser.y"
				yy_do_action_168
			when 169 then
					--|#line 1087 "et_eiffel_parser.y"
				yy_do_action_169
			when 170 then
					--|#line 1094 "et_eiffel_parser.y"
				yy_do_action_170
			when 171 then
					--|#line 1103 "et_eiffel_parser.y"
				yy_do_action_171
			when 172 then
					--|#line 1110 "et_eiffel_parser.y"
				yy_do_action_172
			when 173 then
					--|#line 1117 "et_eiffel_parser.y"
				yy_do_action_173
			when 174 then
					--|#line 1124 "et_eiffel_parser.y"
				yy_do_action_174
			when 175 then
					--|#line 1133 "et_eiffel_parser.y"
				yy_do_action_175
			when 176 then
					--|#line 1144 "et_eiffel_parser.y"
				yy_do_action_176
			when 177 then
					--|#line 1146 "et_eiffel_parser.y"
				yy_do_action_177
			when 178 then
					--|#line 1146 "et_eiffel_parser.y"
				yy_do_action_178
			when 179 then
					--|#line 1159 "et_eiffel_parser.y"
				yy_do_action_179
			when 180 then
					--|#line 1166 "et_eiffel_parser.y"
				yy_do_action_180
			when 181 then
					--|#line 1175 "et_eiffel_parser.y"
				yy_do_action_181
			when 182 then
					--|#line 1184 "et_eiffel_parser.y"
				yy_do_action_182
			when 183 then
					--|#line 1193 "et_eiffel_parser.y"
				yy_do_action_183
			when 184 then
					--|#line 1204 "et_eiffel_parser.y"
				yy_do_action_184
			when 185 then
					--|#line 1206 "et_eiffel_parser.y"
				yy_do_action_185
			when 186 then
					--|#line 1206 "et_eiffel_parser.y"
				yy_do_action_186
			when 187 then
					--|#line 1219 "et_eiffel_parser.y"
				yy_do_action_187
			when 188 then
					--|#line 1221 "et_eiffel_parser.y"
				yy_do_action_188
			when 189 then
					--|#line 1225 "et_eiffel_parser.y"
				yy_do_action_189
			when 190 then
					--|#line 1236 "et_eiffel_parser.y"
				yy_do_action_190
			when 191 then
					--|#line 1236 "et_eiffel_parser.y"
				yy_do_action_191
			when 192 then
					--|#line 1251 "et_eiffel_parser.y"
				yy_do_action_192
			when 193 then
					--|#line 1255 "et_eiffel_parser.y"
				yy_do_action_193
			when 194 then
					--|#line 1260 "et_eiffel_parser.y"
				yy_do_action_194
			when 195 then
					--|#line 1260 "et_eiffel_parser.y"
				yy_do_action_195
			when 196 then
					--|#line 1270 "et_eiffel_parser.y"
				yy_do_action_196
			when 197 then
					--|#line 1274 "et_eiffel_parser.y"
				yy_do_action_197
			when 198 then
					--|#line 1285 "et_eiffel_parser.y"
				yy_do_action_198
			when 199 then
					--|#line 1293 "et_eiffel_parser.y"
				yy_do_action_199
			when 200 then
					--|#line 1304 "et_eiffel_parser.y"
				yy_do_action_200
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_201_400 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 201 then
					--|#line 1304 "et_eiffel_parser.y"
				yy_do_action_201
			when 202 then
					--|#line 1315 "et_eiffel_parser.y"
				yy_do_action_202
			when 203 then
					--|#line 1319 "et_eiffel_parser.y"
				yy_do_action_203
			when 204 then
					--|#line 1326 "et_eiffel_parser.y"
				yy_do_action_204
			when 205 then
					--|#line 1334 "et_eiffel_parser.y"
				yy_do_action_205
			when 206 then
					--|#line 1341 "et_eiffel_parser.y"
				yy_do_action_206
			when 207 then
					--|#line 1351 "et_eiffel_parser.y"
				yy_do_action_207
			when 208 then
					--|#line 1360 "et_eiffel_parser.y"
				yy_do_action_208
			when 209 then
					--|#line 1370 "et_eiffel_parser.y"
				yy_do_action_209
			when 210 then
					--|#line 1372 "et_eiffel_parser.y"
				yy_do_action_210
			when 211 then
					--|#line 1376 "et_eiffel_parser.y"
				yy_do_action_211
			when 212 then
					--|#line 1387 "et_eiffel_parser.y"
				yy_do_action_212
			when 213 then
					--|#line 1389 "et_eiffel_parser.y"
				yy_do_action_213
			when 214 then
					--|#line 1389 "et_eiffel_parser.y"
				yy_do_action_214
			when 215 then
					--|#line 1402 "et_eiffel_parser.y"
				yy_do_action_215
			when 216 then
					--|#line 1404 "et_eiffel_parser.y"
				yy_do_action_216
			when 217 then
					--|#line 1408 "et_eiffel_parser.y"
				yy_do_action_217
			when 218 then
					--|#line 1410 "et_eiffel_parser.y"
				yy_do_action_218
			when 219 then
					--|#line 1410 "et_eiffel_parser.y"
				yy_do_action_219
			when 220 then
					--|#line 1423 "et_eiffel_parser.y"
				yy_do_action_220
			when 221 then
					--|#line 1425 "et_eiffel_parser.y"
				yy_do_action_221
			when 222 then
					--|#line 1429 "et_eiffel_parser.y"
				yy_do_action_222
			when 223 then
					--|#line 1431 "et_eiffel_parser.y"
				yy_do_action_223
			when 224 then
					--|#line 1431 "et_eiffel_parser.y"
				yy_do_action_224
			when 225 then
					--|#line 1444 "et_eiffel_parser.y"
				yy_do_action_225
			when 226 then
					--|#line 1446 "et_eiffel_parser.y"
				yy_do_action_226
			when 227 then
					--|#line 1450 "et_eiffel_parser.y"
				yy_do_action_227
			when 228 then
					--|#line 1461 "et_eiffel_parser.y"
				yy_do_action_228
			when 229 then
					--|#line 1469 "et_eiffel_parser.y"
				yy_do_action_229
			when 230 then
					--|#line 1478 "et_eiffel_parser.y"
				yy_do_action_230
			when 231 then
					--|#line 1489 "et_eiffel_parser.y"
				yy_do_action_231
			when 232 then
					--|#line 1491 "et_eiffel_parser.y"
				yy_do_action_232
			when 233 then
					--|#line 1498 "et_eiffel_parser.y"
				yy_do_action_233
			when 234 then
					--|#line 1509 "et_eiffel_parser.y"
				yy_do_action_234
			when 235 then
					--|#line 1509 "et_eiffel_parser.y"
				yy_do_action_235
			when 236 then
					--|#line 1524 "et_eiffel_parser.y"
				yy_do_action_236
			when 237 then
					--|#line 1526 "et_eiffel_parser.y"
				yy_do_action_237
			when 238 then
					--|#line 1528 "et_eiffel_parser.y"
				yy_do_action_238
			when 239 then
					--|#line 1528 "et_eiffel_parser.y"
				yy_do_action_239
			when 240 then
					--|#line 1540 "et_eiffel_parser.y"
				yy_do_action_240
			when 241 then
					--|#line 1540 "et_eiffel_parser.y"
				yy_do_action_241
			when 242 then
					--|#line 1552 "et_eiffel_parser.y"
				yy_do_action_242
			when 243 then
					--|#line 1554 "et_eiffel_parser.y"
				yy_do_action_243
			when 244 then
					--|#line 1556 "et_eiffel_parser.y"
				yy_do_action_244
			when 245 then
					--|#line 1556 "et_eiffel_parser.y"
				yy_do_action_245
			when 246 then
					--|#line 1568 "et_eiffel_parser.y"
				yy_do_action_246
			when 247 then
					--|#line 1568 "et_eiffel_parser.y"
				yy_do_action_247
			when 248 then
					--|#line 1582 "et_eiffel_parser.y"
				yy_do_action_248
			when 249 then
					--|#line 1594 "et_eiffel_parser.y"
				yy_do_action_249
			when 250 then
					--|#line 1606 "et_eiffel_parser.y"
				yy_do_action_250
			when 251 then
					--|#line 1615 "et_eiffel_parser.y"
				yy_do_action_251
			when 252 then
					--|#line 1631 "et_eiffel_parser.y"
				yy_do_action_252
			when 253 then
					--|#line 1633 "et_eiffel_parser.y"
				yy_do_action_253
			when 254 then
					--|#line 1637 "et_eiffel_parser.y"
				yy_do_action_254
			when 255 then
					--|#line 1637 "et_eiffel_parser.y"
				yy_do_action_255
			when 256 then
					--|#line 1650 "et_eiffel_parser.y"
				yy_do_action_256
			when 257 then
					--|#line 1657 "et_eiffel_parser.y"
				yy_do_action_257
			when 258 then
					--|#line 1664 "et_eiffel_parser.y"
				yy_do_action_258
			when 259 then
					--|#line 1673 "et_eiffel_parser.y"
				yy_do_action_259
			when 260 then
					--|#line 1682 "et_eiffel_parser.y"
				yy_do_action_260
			when 261 then
					--|#line 1686 "et_eiffel_parser.y"
				yy_do_action_261
			when 262 then
					--|#line 1692 "et_eiffel_parser.y"
				yy_do_action_262
			when 263 then
					--|#line 1694 "et_eiffel_parser.y"
				yy_do_action_263
			when 264 then
					--|#line 1694 "et_eiffel_parser.y"
				yy_do_action_264
			when 265 then
					--|#line 1707 "et_eiffel_parser.y"
				yy_do_action_265
			when 266 then
					--|#line 1718 "et_eiffel_parser.y"
				yy_do_action_266
			when 267 then
					--|#line 1727 "et_eiffel_parser.y"
				yy_do_action_267
			when 268 then
					--|#line 1738 "et_eiffel_parser.y"
				yy_do_action_268
			when 269 then
					--|#line 1743 "et_eiffel_parser.y"
				yy_do_action_269
			when 270 then
					--|#line 1747 "et_eiffel_parser.y"
				yy_do_action_270
			when 271 then
					--|#line 1755 "et_eiffel_parser.y"
				yy_do_action_271
			when 272 then
					--|#line 1762 "et_eiffel_parser.y"
				yy_do_action_272
			when 273 then
					--|#line 1771 "et_eiffel_parser.y"
				yy_do_action_273
			when 274 then
					--|#line 1778 "et_eiffel_parser.y"
				yy_do_action_274
			when 275 then
					--|#line 1787 "et_eiffel_parser.y"
				yy_do_action_275
			when 276 then
					--|#line 1792 "et_eiffel_parser.y"
				yy_do_action_276
			when 277 then
					--|#line 1799 "et_eiffel_parser.y"
				yy_do_action_277
			when 278 then
					--|#line 1800 "et_eiffel_parser.y"
				yy_do_action_278
			when 279 then
					--|#line 1801 "et_eiffel_parser.y"
				yy_do_action_279
			when 280 then
					--|#line 1802 "et_eiffel_parser.y"
				yy_do_action_280
			when 281 then
					--|#line 1807 "et_eiffel_parser.y"
				yy_do_action_281
			when 282 then
					--|#line 1812 "et_eiffel_parser.y"
				yy_do_action_282
			when 283 then
					--|#line 1820 "et_eiffel_parser.y"
				yy_do_action_283
			when 284 then
					--|#line 1825 "et_eiffel_parser.y"
				yy_do_action_284
			when 285 then
					--|#line 1831 "et_eiffel_parser.y"
				yy_do_action_285
			when 286 then
					--|#line 1839 "et_eiffel_parser.y"
				yy_do_action_286
			when 287 then
					--|#line 1850 "et_eiffel_parser.y"
				yy_do_action_287
			when 288 then
					--|#line 1855 "et_eiffel_parser.y"
				yy_do_action_288
			when 289 then
					--|#line 1863 "et_eiffel_parser.y"
				yy_do_action_289
			when 290 then
					--|#line 1868 "et_eiffel_parser.y"
				yy_do_action_290
			when 291 then
					--|#line 1874 "et_eiffel_parser.y"
				yy_do_action_291
			when 292 then
					--|#line 1882 "et_eiffel_parser.y"
				yy_do_action_292
			when 293 then
					--|#line 1893 "et_eiffel_parser.y"
				yy_do_action_293
			when 294 then
					--|#line 1895 "et_eiffel_parser.y"
				yy_do_action_294
			when 295 then
					--|#line 1897 "et_eiffel_parser.y"
				yy_do_action_295
			when 296 then
					--|#line 1901 "et_eiffel_parser.y"
				yy_do_action_296
			when 297 then
					--|#line 1903 "et_eiffel_parser.y"
				yy_do_action_297
			when 298 then
					--|#line 1911 "et_eiffel_parser.y"
				yy_do_action_298
			when 299 then
					--|#line 1913 "et_eiffel_parser.y"
				yy_do_action_299
			when 300 then
					--|#line 1921 "et_eiffel_parser.y"
				yy_do_action_300
			when 301 then
					--|#line 1924 "et_eiffel_parser.y"
				yy_do_action_301
			when 302 then
					--|#line 1933 "et_eiffel_parser.y"
				yy_do_action_302
			when 303 then
					--|#line 1937 "et_eiffel_parser.y"
				yy_do_action_303
			when 304 then
					--|#line 1947 "et_eiffel_parser.y"
				yy_do_action_304
			when 305 then
					--|#line 1950 "et_eiffel_parser.y"
				yy_do_action_305
			when 306 then
					--|#line 1959 "et_eiffel_parser.y"
				yy_do_action_306
			when 307 then
					--|#line 1963 "et_eiffel_parser.y"
				yy_do_action_307
			when 308 then
					--|#line 1973 "et_eiffel_parser.y"
				yy_do_action_308
			when 309 then
					--|#line 1975 "et_eiffel_parser.y"
				yy_do_action_309
			when 310 then
					--|#line 1983 "et_eiffel_parser.y"
				yy_do_action_310
			when 311 then
					--|#line 1986 "et_eiffel_parser.y"
				yy_do_action_311
			when 312 then
					--|#line 1995 "et_eiffel_parser.y"
				yy_do_action_312
			when 313 then
					--|#line 1998 "et_eiffel_parser.y"
				yy_do_action_313
			when 314 then
					--|#line 2007 "et_eiffel_parser.y"
				yy_do_action_314
			when 315 then
					--|#line 2011 "et_eiffel_parser.y"
				yy_do_action_315
			when 316 then
					--|#line 2023 "et_eiffel_parser.y"
				yy_do_action_316
			when 317 then
					--|#line 2026 "et_eiffel_parser.y"
				yy_do_action_317
			when 318 then
					--|#line 2030 "et_eiffel_parser.y"
				yy_do_action_318
			when 319 then
					--|#line 2033 "et_eiffel_parser.y"
				yy_do_action_319
			when 320 then
					--|#line 2037 "et_eiffel_parser.y"
				yy_do_action_320
			when 321 then
					--|#line 2039 "et_eiffel_parser.y"
				yy_do_action_321
			when 322 then
					--|#line 2042 "et_eiffel_parser.y"
				yy_do_action_322
			when 323 then
					--|#line 2045 "et_eiffel_parser.y"
				yy_do_action_323
			when 324 then
					--|#line 2051 "et_eiffel_parser.y"
				yy_do_action_324
			when 325 then
					--|#line 2059 "et_eiffel_parser.y"
				yy_do_action_325
			when 326 then
					--|#line 2063 "et_eiffel_parser.y"
				yy_do_action_326
			when 327 then
					--|#line 2065 "et_eiffel_parser.y"
				yy_do_action_327
			when 328 then
					--|#line 2069 "et_eiffel_parser.y"
				yy_do_action_328
			when 329 then
					--|#line 2071 "et_eiffel_parser.y"
				yy_do_action_329
			when 330 then
					--|#line 2075 "et_eiffel_parser.y"
				yy_do_action_330
			when 331 then
					--|#line 2077 "et_eiffel_parser.y"
				yy_do_action_331
			when 332 then
					--|#line 2083 "et_eiffel_parser.y"
				yy_do_action_332
			when 333 then
					--|#line 2092 "et_eiffel_parser.y"
				yy_do_action_333
			when 334 then
					--|#line 2094 "et_eiffel_parser.y"
				yy_do_action_334
			when 335 then
					--|#line 2106 "et_eiffel_parser.y"
				yy_do_action_335
			when 336 then
					--|#line 2117 "et_eiffel_parser.y"
				yy_do_action_336
			when 337 then
					--|#line 2117 "et_eiffel_parser.y"
				yy_do_action_337
			when 338 then
					--|#line 2132 "et_eiffel_parser.y"
				yy_do_action_338
			when 339 then
					--|#line 2134 "et_eiffel_parser.y"
				yy_do_action_339
			when 340 then
					--|#line 2136 "et_eiffel_parser.y"
				yy_do_action_340
			when 341 then
					--|#line 2138 "et_eiffel_parser.y"
				yy_do_action_341
			when 342 then
					--|#line 2140 "et_eiffel_parser.y"
				yy_do_action_342
			when 343 then
					--|#line 2142 "et_eiffel_parser.y"
				yy_do_action_343
			when 344 then
					--|#line 2144 "et_eiffel_parser.y"
				yy_do_action_344
			when 345 then
					--|#line 2146 "et_eiffel_parser.y"
				yy_do_action_345
			when 346 then
					--|#line 2148 "et_eiffel_parser.y"
				yy_do_action_346
			when 347 then
					--|#line 2150 "et_eiffel_parser.y"
				yy_do_action_347
			when 348 then
					--|#line 2152 "et_eiffel_parser.y"
				yy_do_action_348
			when 349 then
					--|#line 2154 "et_eiffel_parser.y"
				yy_do_action_349
			when 350 then
					--|#line 2156 "et_eiffel_parser.y"
				yy_do_action_350
			when 351 then
					--|#line 2158 "et_eiffel_parser.y"
				yy_do_action_351
			when 352 then
					--|#line 2160 "et_eiffel_parser.y"
				yy_do_action_352
			when 353 then
					--|#line 2162 "et_eiffel_parser.y"
				yy_do_action_353
			when 354 then
					--|#line 2164 "et_eiffel_parser.y"
				yy_do_action_354
			when 355 then
					--|#line 2166 "et_eiffel_parser.y"
				yy_do_action_355
			when 356 then
					--|#line 2168 "et_eiffel_parser.y"
				yy_do_action_356
			when 357 then
					--|#line 2170 "et_eiffel_parser.y"
				yy_do_action_357
			when 358 then
					--|#line 2172 "et_eiffel_parser.y"
				yy_do_action_358
			when 359 then
					--|#line 2174 "et_eiffel_parser.y"
				yy_do_action_359
			when 360 then
					--|#line 2176 "et_eiffel_parser.y"
				yy_do_action_360
			when 361 then
					--|#line 2180 "et_eiffel_parser.y"
				yy_do_action_361
			when 362 then
					--|#line 2182 "et_eiffel_parser.y"
				yy_do_action_362
			when 363 then
					--|#line 2188 "et_eiffel_parser.y"
				yy_do_action_363
			when 364 then
					--|#line 2195 "et_eiffel_parser.y"
				yy_do_action_364
			when 365 then
					--|#line 2197 "et_eiffel_parser.y"
				yy_do_action_365
			when 366 then
					--|#line 2205 "et_eiffel_parser.y"
				yy_do_action_366
			when 367 then
					--|#line 2216 "et_eiffel_parser.y"
				yy_do_action_367
			when 368 then
					--|#line 2223 "et_eiffel_parser.y"
				yy_do_action_368
			when 369 then
					--|#line 2230 "et_eiffel_parser.y"
				yy_do_action_369
			when 370 then
					--|#line 2240 "et_eiffel_parser.y"
				yy_do_action_370
			when 371 then
					--|#line 2251 "et_eiffel_parser.y"
				yy_do_action_371
			when 372 then
					--|#line 2258 "et_eiffel_parser.y"
				yy_do_action_372
			when 373 then
					--|#line 2267 "et_eiffel_parser.y"
				yy_do_action_373
			when 374 then
					--|#line 2276 "et_eiffel_parser.y"
				yy_do_action_374
			when 375 then
					--|#line 2285 "et_eiffel_parser.y"
				yy_do_action_375
			when 376 then
					--|#line 2294 "et_eiffel_parser.y"
				yy_do_action_376
			when 377 then
					--|#line 2305 "et_eiffel_parser.y"
				yy_do_action_377
			when 378 then
					--|#line 2307 "et_eiffel_parser.y"
				yy_do_action_378
			when 379 then
					--|#line 2309 "et_eiffel_parser.y"
				yy_do_action_379
			when 380 then
					--|#line 2309 "et_eiffel_parser.y"
				yy_do_action_380
			when 381 then
					--|#line 2322 "et_eiffel_parser.y"
				yy_do_action_381
			when 382 then
					--|#line 2329 "et_eiffel_parser.y"
				yy_do_action_382
			when 383 then
					--|#line 2336 "et_eiffel_parser.y"
				yy_do_action_383
			when 384 then
					--|#line 2346 "et_eiffel_parser.y"
				yy_do_action_384
			when 385 then
					--|#line 2357 "et_eiffel_parser.y"
				yy_do_action_385
			when 386 then
					--|#line 2364 "et_eiffel_parser.y"
				yy_do_action_386
			when 387 then
					--|#line 2373 "et_eiffel_parser.y"
				yy_do_action_387
			when 388 then
					--|#line 2382 "et_eiffel_parser.y"
				yy_do_action_388
			when 389 then
					--|#line 2391 "et_eiffel_parser.y"
				yy_do_action_389
			when 390 then
					--|#line 2400 "et_eiffel_parser.y"
				yy_do_action_390
			when 391 then
					--|#line 2411 "et_eiffel_parser.y"
				yy_do_action_391
			when 392 then
					--|#line 2413 "et_eiffel_parser.y"
				yy_do_action_392
			when 393 then
					--|#line 2415 "et_eiffel_parser.y"
				yy_do_action_393
			when 394 then
					--|#line 2417 "et_eiffel_parser.y"
				yy_do_action_394
			when 395 then
					--|#line 2419 "et_eiffel_parser.y"
				yy_do_action_395
			when 396 then
					--|#line 2428 "et_eiffel_parser.y"
				yy_do_action_396
			when 397 then
					--|#line 2437 "et_eiffel_parser.y"
				yy_do_action_397
			when 398 then
					--|#line 2439 "et_eiffel_parser.y"
				yy_do_action_398
			when 399 then
					--|#line 2441 "et_eiffel_parser.y"
				yy_do_action_399
			when 400 then
					--|#line 2443 "et_eiffel_parser.y"
				yy_do_action_400
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_401_600 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 401 then
					--|#line 2445 "et_eiffel_parser.y"
				yy_do_action_401
			when 402 then
					--|#line 2454 "et_eiffel_parser.y"
				yy_do_action_402
			when 403 then
					--|#line 2465 "et_eiffel_parser.y"
				yy_do_action_403
			when 404 then
					--|#line 2469 "et_eiffel_parser.y"
				yy_do_action_404
			when 405 then
					--|#line 2471 "et_eiffel_parser.y"
				yy_do_action_405
			when 406 then
					--|#line 2473 "et_eiffel_parser.y"
				yy_do_action_406
			when 407 then
					--|#line 2475 "et_eiffel_parser.y"
				yy_do_action_407
			when 408 then
					--|#line 2477 "et_eiffel_parser.y"
				yy_do_action_408
			when 409 then
					--|#line 2481 "et_eiffel_parser.y"
				yy_do_action_409
			when 410 then
					--|#line 2485 "et_eiffel_parser.y"
				yy_do_action_410
			when 411 then
					--|#line 2487 "et_eiffel_parser.y"
				yy_do_action_411
			when 412 then
					--|#line 2489 "et_eiffel_parser.y"
				yy_do_action_412
			when 413 then
					--|#line 2491 "et_eiffel_parser.y"
				yy_do_action_413
			when 414 then
					--|#line 2493 "et_eiffel_parser.y"
				yy_do_action_414
			when 415 then
					--|#line 2497 "et_eiffel_parser.y"
				yy_do_action_415
			when 416 then
					--|#line 2501 "et_eiffel_parser.y"
				yy_do_action_416
			when 417 then
					--|#line 2503 "et_eiffel_parser.y"
				yy_do_action_417
			when 418 then
					--|#line 2507 "et_eiffel_parser.y"
				yy_do_action_418
			when 419 then
					--|#line 2509 "et_eiffel_parser.y"
				yy_do_action_419
			when 420 then
					--|#line 2513 "et_eiffel_parser.y"
				yy_do_action_420
			when 421 then
					--|#line 2517 "et_eiffel_parser.y"
				yy_do_action_421
			when 422 then
					--|#line 2521 "et_eiffel_parser.y"
				yy_do_action_422
			when 423 then
					--|#line 2523 "et_eiffel_parser.y"
				yy_do_action_423
			when 424 then
					--|#line 2527 "et_eiffel_parser.y"
				yy_do_action_424
			when 425 then
					--|#line 2529 "et_eiffel_parser.y"
				yy_do_action_425
			when 426 then
					--|#line 2533 "et_eiffel_parser.y"
				yy_do_action_426
			when 427 then
					--|#line 2535 "et_eiffel_parser.y"
				yy_do_action_427
			when 428 then
					--|#line 2539 "et_eiffel_parser.y"
				yy_do_action_428
			when 429 then
					--|#line 2541 "et_eiffel_parser.y"
				yy_do_action_429
			when 430 then
					--|#line 2547 "et_eiffel_parser.y"
				yy_do_action_430
			when 431 then
					--|#line 2549 "et_eiffel_parser.y"
				yy_do_action_431
			when 432 then
					--|#line 2555 "et_eiffel_parser.y"
				yy_do_action_432
			when 433 then
					--|#line 2557 "et_eiffel_parser.y"
				yy_do_action_433
			when 434 then
					--|#line 2561 "et_eiffel_parser.y"
				yy_do_action_434
			when 435 then
					--|#line 2563 "et_eiffel_parser.y"
				yy_do_action_435
			when 436 then
					--|#line 2565 "et_eiffel_parser.y"
				yy_do_action_436
			when 437 then
					--|#line 2567 "et_eiffel_parser.y"
				yy_do_action_437
			when 438 then
					--|#line 2569 "et_eiffel_parser.y"
				yy_do_action_438
			when 439 then
					--|#line 2571 "et_eiffel_parser.y"
				yy_do_action_439
			when 440 then
					--|#line 2573 "et_eiffel_parser.y"
				yy_do_action_440
			when 441 then
					--|#line 2575 "et_eiffel_parser.y"
				yy_do_action_441
			when 442 then
					--|#line 2577 "et_eiffel_parser.y"
				yy_do_action_442
			when 443 then
					--|#line 2579 "et_eiffel_parser.y"
				yy_do_action_443
			when 444 then
					--|#line 2581 "et_eiffel_parser.y"
				yy_do_action_444
			when 445 then
					--|#line 2583 "et_eiffel_parser.y"
				yy_do_action_445
			when 446 then
					--|#line 2585 "et_eiffel_parser.y"
				yy_do_action_446
			when 447 then
					--|#line 2587 "et_eiffel_parser.y"
				yy_do_action_447
			when 448 then
					--|#line 2589 "et_eiffel_parser.y"
				yy_do_action_448
			when 449 then
					--|#line 2591 "et_eiffel_parser.y"
				yy_do_action_449
			when 450 then
					--|#line 2593 "et_eiffel_parser.y"
				yy_do_action_450
			when 451 then
					--|#line 2595 "et_eiffel_parser.y"
				yy_do_action_451
			when 452 then
					--|#line 2597 "et_eiffel_parser.y"
				yy_do_action_452
			when 453 then
					--|#line 2599 "et_eiffel_parser.y"
				yy_do_action_453
			when 454 then
					--|#line 2601 "et_eiffel_parser.y"
				yy_do_action_454
			when 455 then
					--|#line 2603 "et_eiffel_parser.y"
				yy_do_action_455
			when 456 then
					--|#line 2607 "et_eiffel_parser.y"
				yy_do_action_456
			when 457 then
					--|#line 2609 "et_eiffel_parser.y"
				yy_do_action_457
			when 458 then
					--|#line 2611 "et_eiffel_parser.y"
				yy_do_action_458
			when 459 then
					--|#line 2613 "et_eiffel_parser.y"
				yy_do_action_459
			when 460 then
					--|#line 2615 "et_eiffel_parser.y"
				yy_do_action_460
			when 461 then
					--|#line 2617 "et_eiffel_parser.y"
				yy_do_action_461
			when 462 then
					--|#line 2619 "et_eiffel_parser.y"
				yy_do_action_462
			when 463 then
					--|#line 2621 "et_eiffel_parser.y"
				yy_do_action_463
			when 464 then
					--|#line 2623 "et_eiffel_parser.y"
				yy_do_action_464
			when 465 then
					--|#line 2625 "et_eiffel_parser.y"
				yy_do_action_465
			when 466 then
					--|#line 2627 "et_eiffel_parser.y"
				yy_do_action_466
			when 467 then
					--|#line 2629 "et_eiffel_parser.y"
				yy_do_action_467
			when 468 then
					--|#line 2631 "et_eiffel_parser.y"
				yy_do_action_468
			when 469 then
					--|#line 2633 "et_eiffel_parser.y"
				yy_do_action_469
			when 470 then
					--|#line 2635 "et_eiffel_parser.y"
				yy_do_action_470
			when 471 then
					--|#line 2637 "et_eiffel_parser.y"
				yy_do_action_471
			when 472 then
					--|#line 2639 "et_eiffel_parser.y"
				yy_do_action_472
			when 473 then
					--|#line 2641 "et_eiffel_parser.y"
				yy_do_action_473
			when 474 then
					--|#line 2643 "et_eiffel_parser.y"
				yy_do_action_474
			when 475 then
					--|#line 2645 "et_eiffel_parser.y"
				yy_do_action_475
			when 476 then
					--|#line 2647 "et_eiffel_parser.y"
				yy_do_action_476
			when 477 then
					--|#line 2649 "et_eiffel_parser.y"
				yy_do_action_477
			when 478 then
					--|#line 2653 "et_eiffel_parser.y"
				yy_do_action_478
			when 479 then
					--|#line 2655 "et_eiffel_parser.y"
				yy_do_action_479
			when 480 then
					--|#line 2657 "et_eiffel_parser.y"
				yy_do_action_480
			when 481 then
					--|#line 2659 "et_eiffel_parser.y"
				yy_do_action_481
			when 482 then
					--|#line 2661 "et_eiffel_parser.y"
				yy_do_action_482
			when 483 then
					--|#line 2663 "et_eiffel_parser.y"
				yy_do_action_483
			when 484 then
					--|#line 2665 "et_eiffel_parser.y"
				yy_do_action_484
			when 485 then
					--|#line 2667 "et_eiffel_parser.y"
				yy_do_action_485
			when 486 then
					--|#line 2669 "et_eiffel_parser.y"
				yy_do_action_486
			when 487 then
					--|#line 2671 "et_eiffel_parser.y"
				yy_do_action_487
			when 488 then
					--|#line 2673 "et_eiffel_parser.y"
				yy_do_action_488
			when 489 then
					--|#line 2675 "et_eiffel_parser.y"
				yy_do_action_489
			when 490 then
					--|#line 2677 "et_eiffel_parser.y"
				yy_do_action_490
			when 491 then
					--|#line 2679 "et_eiffel_parser.y"
				yy_do_action_491
			when 492 then
					--|#line 2681 "et_eiffel_parser.y"
				yy_do_action_492
			when 493 then
					--|#line 2683 "et_eiffel_parser.y"
				yy_do_action_493
			when 494 then
					--|#line 2685 "et_eiffel_parser.y"
				yy_do_action_494
			when 495 then
					--|#line 2687 "et_eiffel_parser.y"
				yy_do_action_495
			when 496 then
					--|#line 2689 "et_eiffel_parser.y"
				yy_do_action_496
			when 497 then
					--|#line 2691 "et_eiffel_parser.y"
				yy_do_action_497
			when 498 then
					--|#line 2693 "et_eiffel_parser.y"
				yy_do_action_498
			when 499 then
					--|#line 2695 "et_eiffel_parser.y"
				yy_do_action_499
			when 500 then
					--|#line 2697 "et_eiffel_parser.y"
				yy_do_action_500
			when 501 then
					--|#line 2701 "et_eiffel_parser.y"
				yy_do_action_501
			when 502 then
					--|#line 2703 "et_eiffel_parser.y"
				yy_do_action_502
			when 503 then
					--|#line 2707 "et_eiffel_parser.y"
				yy_do_action_503
			when 504 then
					--|#line 2709 "et_eiffel_parser.y"
				yy_do_action_504
			when 505 then
					--|#line 2713 "et_eiffel_parser.y"
				yy_do_action_505
			when 506 then
					--|#line 2716 "et_eiffel_parser.y"
				yy_do_action_506
			when 507 then
					--|#line 2724 "et_eiffel_parser.y"
				yy_do_action_507
			when 508 then
					--|#line 2731 "et_eiffel_parser.y"
				yy_do_action_508
			when 509 then
					--|#line 2742 "et_eiffel_parser.y"
				yy_do_action_509
			when 510 then
					--|#line 2747 "et_eiffel_parser.y"
				yy_do_action_510
			when 511 then
					--|#line 2752 "et_eiffel_parser.y"
				yy_do_action_511
			when 512 then
					--|#line 2757 "et_eiffel_parser.y"
				yy_do_action_512
			when 513 then
					--|#line 2764 "et_eiffel_parser.y"
				yy_do_action_513
			when 514 then
					--|#line 2770 "et_eiffel_parser.y"
				yy_do_action_514
			when 515 then
					--|#line 2779 "et_eiffel_parser.y"
				yy_do_action_515
			when 516 then
					--|#line 2781 "et_eiffel_parser.y"
				yy_do_action_516
			when 517 then
					--|#line 2785 "et_eiffel_parser.y"
				yy_do_action_517
			when 518 then
					--|#line 2788 "et_eiffel_parser.y"
				yy_do_action_518
			when 519 then
					--|#line 2794 "et_eiffel_parser.y"
				yy_do_action_519
			when 520 then
					--|#line 2802 "et_eiffel_parser.y"
				yy_do_action_520
			when 521 then
					--|#line 2807 "et_eiffel_parser.y"
				yy_do_action_521
			when 522 then
					--|#line 2812 "et_eiffel_parser.y"
				yy_do_action_522
			when 523 then
					--|#line 2817 "et_eiffel_parser.y"
				yy_do_action_523
			when 524 then
					--|#line 2828 "et_eiffel_parser.y"
				yy_do_action_524
			when 525 then
					--|#line 2839 "et_eiffel_parser.y"
				yy_do_action_525
			when 526 then
					--|#line 2852 "et_eiffel_parser.y"
				yy_do_action_526
			when 527 then
					--|#line 2861 "et_eiffel_parser.y"
				yy_do_action_527
			when 528 then
					--|#line 2870 "et_eiffel_parser.y"
				yy_do_action_528
			when 529 then
					--|#line 2872 "et_eiffel_parser.y"
				yy_do_action_529
			when 530 then
					--|#line 2874 "et_eiffel_parser.y"
				yy_do_action_530
			when 531 then
					--|#line 2878 "et_eiffel_parser.y"
				yy_do_action_531
			when 532 then
					--|#line 2880 "et_eiffel_parser.y"
				yy_do_action_532
			when 533 then
					--|#line 2882 "et_eiffel_parser.y"
				yy_do_action_533
			when 534 then
					--|#line 2884 "et_eiffel_parser.y"
				yy_do_action_534
			when 535 then
					--|#line 2886 "et_eiffel_parser.y"
				yy_do_action_535
			when 536 then
					--|#line 2888 "et_eiffel_parser.y"
				yy_do_action_536
			when 537 then
					--|#line 2890 "et_eiffel_parser.y"
				yy_do_action_537
			when 538 then
					--|#line 2892 "et_eiffel_parser.y"
				yy_do_action_538
			when 539 then
					--|#line 2894 "et_eiffel_parser.y"
				yy_do_action_539
			when 540 then
					--|#line 2896 "et_eiffel_parser.y"
				yy_do_action_540
			when 541 then
					--|#line 2898 "et_eiffel_parser.y"
				yy_do_action_541
			when 542 then
					--|#line 2900 "et_eiffel_parser.y"
				yy_do_action_542
			when 543 then
					--|#line 2902 "et_eiffel_parser.y"
				yy_do_action_543
			when 544 then
					--|#line 2904 "et_eiffel_parser.y"
				yy_do_action_544
			when 545 then
					--|#line 2906 "et_eiffel_parser.y"
				yy_do_action_545
			when 546 then
					--|#line 2908 "et_eiffel_parser.y"
				yy_do_action_546
			when 547 then
					--|#line 2910 "et_eiffel_parser.y"
				yy_do_action_547
			when 548 then
					--|#line 2912 "et_eiffel_parser.y"
				yy_do_action_548
			when 549 then
					--|#line 2914 "et_eiffel_parser.y"
				yy_do_action_549
			when 550 then
					--|#line 2916 "et_eiffel_parser.y"
				yy_do_action_550
			when 551 then
					--|#line 2918 "et_eiffel_parser.y"
				yy_do_action_551
			when 552 then
					--|#line 2922 "et_eiffel_parser.y"
				yy_do_action_552
			when 553 then
					--|#line 2924 "et_eiffel_parser.y"
				yy_do_action_553
			when 554 then
					--|#line 2928 "et_eiffel_parser.y"
				yy_do_action_554
			when 555 then
					--|#line 2930 "et_eiffel_parser.y"
				yy_do_action_555
			when 556 then
					--|#line 2932 "et_eiffel_parser.y"
				yy_do_action_556
			when 557 then
					--|#line 2934 "et_eiffel_parser.y"
				yy_do_action_557
			when 558 then
					--|#line 2936 "et_eiffel_parser.y"
				yy_do_action_558
			when 559 then
					--|#line 2938 "et_eiffel_parser.y"
				yy_do_action_559
			when 560 then
					--|#line 2940 "et_eiffel_parser.y"
				yy_do_action_560
			when 561 then
					--|#line 2948 "et_eiffel_parser.y"
				yy_do_action_561
			when 562 then
					--|#line 2956 "et_eiffel_parser.y"
				yy_do_action_562
			when 563 then
					--|#line 2964 "et_eiffel_parser.y"
				yy_do_action_563
			when 564 then
					--|#line 2972 "et_eiffel_parser.y"
				yy_do_action_564
			when 565 then
					--|#line 2974 "et_eiffel_parser.y"
				yy_do_action_565
			when 566 then
					--|#line 2976 "et_eiffel_parser.y"
				yy_do_action_566
			when 567 then
					--|#line 2978 "et_eiffel_parser.y"
				yy_do_action_567
			when 568 then
					--|#line 2980 "et_eiffel_parser.y"
				yy_do_action_568
			when 569 then
					--|#line 2982 "et_eiffel_parser.y"
				yy_do_action_569
			when 570 then
					--|#line 2984 "et_eiffel_parser.y"
				yy_do_action_570
			when 571 then
					--|#line 2986 "et_eiffel_parser.y"
				yy_do_action_571
			when 572 then
					--|#line 2988 "et_eiffel_parser.y"
				yy_do_action_572
			when 573 then
					--|#line 2994 "et_eiffel_parser.y"
				yy_do_action_573
			when 574 then
					--|#line 2998 "et_eiffel_parser.y"
				yy_do_action_574
			when 575 then
					--|#line 3002 "et_eiffel_parser.y"
				yy_do_action_575
			when 576 then
					--|#line 3006 "et_eiffel_parser.y"
				yy_do_action_576
			when 577 then
					--|#line 3010 "et_eiffel_parser.y"
				yy_do_action_577
			when 578 then
					--|#line 3014 "et_eiffel_parser.y"
				yy_do_action_578
			when 579 then
					--|#line 3018 "et_eiffel_parser.y"
				yy_do_action_579
			when 580 then
					--|#line 3022 "et_eiffel_parser.y"
				yy_do_action_580
			when 581 then
					--|#line 3026 "et_eiffel_parser.y"
				yy_do_action_581
			when 582 then
					--|#line 3028 "et_eiffel_parser.y"
				yy_do_action_582
			when 583 then
					--|#line 3032 "et_eiffel_parser.y"
				yy_do_action_583
			when 584 then
					--|#line 3036 "et_eiffel_parser.y"
				yy_do_action_584
			when 585 then
					--|#line 3043 "et_eiffel_parser.y"
				yy_do_action_585
			when 586 then
					--|#line 3045 "et_eiffel_parser.y"
				yy_do_action_586
			when 587 then
					--|#line 3049 "et_eiffel_parser.y"
				yy_do_action_587
			when 588 then
					--|#line 3051 "et_eiffel_parser.y"
				yy_do_action_588
			when 589 then
					--|#line 3055 "et_eiffel_parser.y"
				yy_do_action_589
			when 590 then
					--|#line 3066 "et_eiffel_parser.y"
				yy_do_action_590
			when 591 then
					--|#line 3066 "et_eiffel_parser.y"
				yy_do_action_591
			when 592 then
					--|#line 3087 "et_eiffel_parser.y"
				yy_do_action_592
			when 593 then
					--|#line 3089 "et_eiffel_parser.y"
				yy_do_action_593
			when 594 then
					--|#line 3091 "et_eiffel_parser.y"
				yy_do_action_594
			when 595 then
					--|#line 3093 "et_eiffel_parser.y"
				yy_do_action_595
			when 596 then
					--|#line 3095 "et_eiffel_parser.y"
				yy_do_action_596
			when 597 then
					--|#line 3097 "et_eiffel_parser.y"
				yy_do_action_597
			when 598 then
					--|#line 3099 "et_eiffel_parser.y"
				yy_do_action_598
			when 599 then
					--|#line 3101 "et_eiffel_parser.y"
				yy_do_action_599
			when 600 then
					--|#line 3103 "et_eiffel_parser.y"
				yy_do_action_600
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_601_800 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 601 then
					--|#line 3105 "et_eiffel_parser.y"
				yy_do_action_601
			when 602 then
					--|#line 3107 "et_eiffel_parser.y"
				yy_do_action_602
			when 603 then
					--|#line 3115 "et_eiffel_parser.y"
				yy_do_action_603
			when 604 then
					--|#line 3128 "et_eiffel_parser.y"
				yy_do_action_604
			when 605 then
					--|#line 3130 "et_eiffel_parser.y"
				yy_do_action_605
			when 606 then
					--|#line 3132 "et_eiffel_parser.y"
				yy_do_action_606
			when 607 then
					--|#line 3134 "et_eiffel_parser.y"
				yy_do_action_607
			when 608 then
					--|#line 3136 "et_eiffel_parser.y"
				yy_do_action_608
			when 609 then
					--|#line 3138 "et_eiffel_parser.y"
				yy_do_action_609
			when 610 then
					--|#line 3144 "et_eiffel_parser.y"
				yy_do_action_610
			when 611 then
					--|#line 3148 "et_eiffel_parser.y"
				yy_do_action_611
			when 612 then
					--|#line 3150 "et_eiffel_parser.y"
				yy_do_action_612
			when 613 then
					--|#line 3152 "et_eiffel_parser.y"
				yy_do_action_613
			when 614 then
					--|#line 3154 "et_eiffel_parser.y"
				yy_do_action_614
			when 615 then
					--|#line 3160 "et_eiffel_parser.y"
				yy_do_action_615
			when 616 then
					--|#line 3162 "et_eiffel_parser.y"
				yy_do_action_616
			when 617 then
					--|#line 3164 "et_eiffel_parser.y"
				yy_do_action_617
			when 618 then
					--|#line 3166 "et_eiffel_parser.y"
				yy_do_action_618
			when 619 then
					--|#line 3170 "et_eiffel_parser.y"
				yy_do_action_619
			when 620 then
					--|#line 3172 "et_eiffel_parser.y"
				yy_do_action_620
			when 621 then
					--|#line 3174 "et_eiffel_parser.y"
				yy_do_action_621
			when 622 then
					--|#line 3176 "et_eiffel_parser.y"
				yy_do_action_622
			when 623 then
					--|#line 3180 "et_eiffel_parser.y"
				yy_do_action_623
			when 624 then
					--|#line 3182 "et_eiffel_parser.y"
				yy_do_action_624
			when 625 then
					--|#line 3186 "et_eiffel_parser.y"
				yy_do_action_625
			when 626 then
					--|#line 3187 "et_eiffel_parser.y"
				yy_do_action_626
			when 627 then
					--|#line 3193 "et_eiffel_parser.y"
				yy_do_action_627
			when 628 then
					--|#line 3195 "et_eiffel_parser.y"
				yy_do_action_628
			when 629 then
					--|#line 3197 "et_eiffel_parser.y"
				yy_do_action_629
			when 630 then
					--|#line 3199 "et_eiffel_parser.y"
				yy_do_action_630
			when 631 then
					--|#line 3203 "et_eiffel_parser.y"
				yy_do_action_631
			when 632 then
					--|#line 3210 "et_eiffel_parser.y"
				yy_do_action_632
			when 633 then
					--|#line 3217 "et_eiffel_parser.y"
				yy_do_action_633
			when 634 then
					--|#line 3226 "et_eiffel_parser.y"
				yy_do_action_634
			when 635 then
					--|#line 3237 "et_eiffel_parser.y"
				yy_do_action_635
			when 636 then
					--|#line 3239 "et_eiffel_parser.y"
				yy_do_action_636
			when 637 then
					--|#line 3243 "et_eiffel_parser.y"
				yy_do_action_637
			when 638 then
					--|#line 3250 "et_eiffel_parser.y"
				yy_do_action_638
			when 639 then
					--|#line 3257 "et_eiffel_parser.y"
				yy_do_action_639
			when 640 then
					--|#line 3266 "et_eiffel_parser.y"
				yy_do_action_640
			when 641 then
					--|#line 3277 "et_eiffel_parser.y"
				yy_do_action_641
			when 642 then
					--|#line 3279 "et_eiffel_parser.y"
				yy_do_action_642
			when 643 then
					--|#line 3283 "et_eiffel_parser.y"
				yy_do_action_643
			when 644 then
					--|#line 3285 "et_eiffel_parser.y"
				yy_do_action_644
			when 645 then
					--|#line 3292 "et_eiffel_parser.y"
				yy_do_action_645
			when 646 then
					--|#line 3299 "et_eiffel_parser.y"
				yy_do_action_646
			when 647 then
					--|#line 3308 "et_eiffel_parser.y"
				yy_do_action_647
			when 648 then
					--|#line 3317 "et_eiffel_parser.y"
				yy_do_action_648
			when 649 then
					--|#line 3319 "et_eiffel_parser.y"
				yy_do_action_649
			when 650 then
					--|#line 3319 "et_eiffel_parser.y"
				yy_do_action_650
			when 651 then
					--|#line 3332 "et_eiffel_parser.y"
				yy_do_action_651
			when 652 then
					--|#line 3343 "et_eiffel_parser.y"
				yy_do_action_652
			when 653 then
					--|#line 3351 "et_eiffel_parser.y"
				yy_do_action_653
			when 654 then
					--|#line 3360 "et_eiffel_parser.y"
				yy_do_action_654
			when 655 then
					--|#line 3369 "et_eiffel_parser.y"
				yy_do_action_655
			when 656 then
					--|#line 3371 "et_eiffel_parser.y"
				yy_do_action_656
			when 657 then
					--|#line 3375 "et_eiffel_parser.y"
				yy_do_action_657
			when 658 then
					--|#line 3377 "et_eiffel_parser.y"
				yy_do_action_658
			when 659 then
					--|#line 3379 "et_eiffel_parser.y"
				yy_do_action_659
			when 660 then
					--|#line 3381 "et_eiffel_parser.y"
				yy_do_action_660
			when 661 then
					--|#line 3387 "et_eiffel_parser.y"
				yy_do_action_661
			when 662 then
					--|#line 3389 "et_eiffel_parser.y"
				yy_do_action_662
			when 663 then
					--|#line 3393 "et_eiffel_parser.y"
				yy_do_action_663
			when 664 then
					--|#line 3397 "et_eiffel_parser.y"
				yy_do_action_664
			when 665 then
					--|#line 3399 "et_eiffel_parser.y"
				yy_do_action_665
			when 666 then
					--|#line 3405 "et_eiffel_parser.y"
				yy_do_action_666
			when 667 then
					--|#line 3409 "et_eiffel_parser.y"
				yy_do_action_667
			when 668 then
					--|#line 3411 "et_eiffel_parser.y"
				yy_do_action_668
			when 669 then
					--|#line 3413 "et_eiffel_parser.y"
				yy_do_action_669
			when 670 then
					--|#line 3413 "et_eiffel_parser.y"
				yy_do_action_670
			when 671 then
					--|#line 3426 "et_eiffel_parser.y"
				yy_do_action_671
			when 672 then
					--|#line 3437 "et_eiffel_parser.y"
				yy_do_action_672
			when 673 then
					--|#line 3446 "et_eiffel_parser.y"
				yy_do_action_673
			when 674 then
					--|#line 3457 "et_eiffel_parser.y"
				yy_do_action_674
			when 675 then
					--|#line 3459 "et_eiffel_parser.y"
				yy_do_action_675
			when 676 then
					--|#line 3461 "et_eiffel_parser.y"
				yy_do_action_676
			when 677 then
					--|#line 3463 "et_eiffel_parser.y"
				yy_do_action_677
			when 678 then
					--|#line 3465 "et_eiffel_parser.y"
				yy_do_action_678
			when 679 then
					--|#line 3467 "et_eiffel_parser.y"
				yy_do_action_679
			when 680 then
					--|#line 3469 "et_eiffel_parser.y"
				yy_do_action_680
			when 681 then
					--|#line 3473 "et_eiffel_parser.y"
				yy_do_action_681
			when 682 then
					--|#line 3475 "et_eiffel_parser.y"
				yy_do_action_682
			when 683 then
					--|#line 3479 "et_eiffel_parser.y"
				yy_do_action_683
			when 684 then
					--|#line 3483 "et_eiffel_parser.y"
				yy_do_action_684
			when 685 then
					--|#line 3485 "et_eiffel_parser.y"
				yy_do_action_685
			when 686 then
					--|#line 3489 "et_eiffel_parser.y"
				yy_do_action_686
			when 687 then
					--|#line 3491 "et_eiffel_parser.y"
				yy_do_action_687
			when 688 then
					--|#line 3495 "et_eiffel_parser.y"
				yy_do_action_688
			when 689 then
					--|#line 3497 "et_eiffel_parser.y"
				yy_do_action_689
			when 690 then
					--|#line 3501 "et_eiffel_parser.y"
				yy_do_action_690
			when 691 then
					--|#line 3503 "et_eiffel_parser.y"
				yy_do_action_691
			when 692 then
					--|#line 3505 "et_eiffel_parser.y"
				yy_do_action_692
			when 693 then
					--|#line 3507 "et_eiffel_parser.y"
				yy_do_action_693
			when 694 then
					--|#line 3509 "et_eiffel_parser.y"
				yy_do_action_694
			when 695 then
					--|#line 3511 "et_eiffel_parser.y"
				yy_do_action_695
			when 696 then
					--|#line 3519 "et_eiffel_parser.y"
				yy_do_action_696
			when 697 then
					--|#line 3521 "et_eiffel_parser.y"
				yy_do_action_697
			when 698 then
					--|#line 3525 "et_eiffel_parser.y"
				yy_do_action_698
			when 699 then
					--|#line 3533 "et_eiffel_parser.y"
				yy_do_action_699
			when 700 then
					--|#line 3539 "et_eiffel_parser.y"
				yy_do_action_700
			when 701 then
					--|#line 3541 "et_eiffel_parser.y"
				yy_do_action_701
			when 702 then
					--|#line 3543 "et_eiffel_parser.y"
				yy_do_action_702
			when 703 then
					--|#line 3543 "et_eiffel_parser.y"
				yy_do_action_703
			when 704 then
					--|#line 3556 "et_eiffel_parser.y"
				yy_do_action_704
			when 705 then
					--|#line 3567 "et_eiffel_parser.y"
				yy_do_action_705
			when 706 then
					--|#line 3575 "et_eiffel_parser.y"
				yy_do_action_706
			when 707 then
					--|#line 3584 "et_eiffel_parser.y"
				yy_do_action_707
			when 708 then
					--|#line 3593 "et_eiffel_parser.y"
				yy_do_action_708
			when 709 then
					--|#line 3595 "et_eiffel_parser.y"
				yy_do_action_709
			when 710 then
					--|#line 3597 "et_eiffel_parser.y"
				yy_do_action_710
			when 711 then
					--|#line 3599 "et_eiffel_parser.y"
				yy_do_action_711
			when 712 then
					--|#line 3606 "et_eiffel_parser.y"
				yy_do_action_712
			when 713 then
					--|#line 3608 "et_eiffel_parser.y"
				yy_do_action_713
			when 714 then
					--|#line 3614 "et_eiffel_parser.y"
				yy_do_action_714
			when 715 then
					--|#line 3616 "et_eiffel_parser.y"
				yy_do_action_715
			when 716 then
					--|#line 3620 "et_eiffel_parser.y"
				yy_do_action_716
			when 717 then
					--|#line 3622 "et_eiffel_parser.y"
				yy_do_action_717
			when 718 then
					--|#line 3624 "et_eiffel_parser.y"
				yy_do_action_718
			when 719 then
					--|#line 3626 "et_eiffel_parser.y"
				yy_do_action_719
			when 720 then
					--|#line 3628 "et_eiffel_parser.y"
				yy_do_action_720
			when 721 then
					--|#line 3630 "et_eiffel_parser.y"
				yy_do_action_721
			when 722 then
					--|#line 3632 "et_eiffel_parser.y"
				yy_do_action_722
			when 723 then
					--|#line 3634 "et_eiffel_parser.y"
				yy_do_action_723
			when 724 then
					--|#line 3636 "et_eiffel_parser.y"
				yy_do_action_724
			when 725 then
					--|#line 3638 "et_eiffel_parser.y"
				yy_do_action_725
			when 726 then
					--|#line 3640 "et_eiffel_parser.y"
				yy_do_action_726
			when 727 then
					--|#line 3642 "et_eiffel_parser.y"
				yy_do_action_727
			when 728 then
					--|#line 3644 "et_eiffel_parser.y"
				yy_do_action_728
			when 729 then
					--|#line 3646 "et_eiffel_parser.y"
				yy_do_action_729
			when 730 then
					--|#line 3648 "et_eiffel_parser.y"
				yy_do_action_730
			when 731 then
					--|#line 3650 "et_eiffel_parser.y"
				yy_do_action_731
			when 732 then
					--|#line 3652 "et_eiffel_parser.y"
				yy_do_action_732
			when 733 then
					--|#line 3654 "et_eiffel_parser.y"
				yy_do_action_733
			when 734 then
					--|#line 3656 "et_eiffel_parser.y"
				yy_do_action_734
			when 735 then
					--|#line 3658 "et_eiffel_parser.y"
				yy_do_action_735
			when 736 then
					--|#line 3660 "et_eiffel_parser.y"
				yy_do_action_736
			when 737 then
					--|#line 3662 "et_eiffel_parser.y"
				yy_do_action_737
			when 738 then
					--|#line 3666 "et_eiffel_parser.y"
				yy_do_action_738
			when 739 then
					--|#line 3668 "et_eiffel_parser.y"
				yy_do_action_739
			when 740 then
					--|#line 3670 "et_eiffel_parser.y"
				yy_do_action_740
			when 741 then
					--|#line 3672 "et_eiffel_parser.y"
				yy_do_action_741
			when 742 then
					--|#line 3674 "et_eiffel_parser.y"
				yy_do_action_742
			when 743 then
					--|#line 3676 "et_eiffel_parser.y"
				yy_do_action_743
			when 744 then
					--|#line 3680 "et_eiffel_parser.y"
				yy_do_action_744
			when 745 then
					--|#line 3682 "et_eiffel_parser.y"
				yy_do_action_745
			when 746 then
					--|#line 3684 "et_eiffel_parser.y"
				yy_do_action_746
			when 747 then
					--|#line 3686 "et_eiffel_parser.y"
				yy_do_action_747
			when 748 then
					--|#line 3688 "et_eiffel_parser.y"
				yy_do_action_748
			when 749 then
					--|#line 3690 "et_eiffel_parser.y"
				yy_do_action_749
			when 750 then
					--|#line 3692 "et_eiffel_parser.y"
				yy_do_action_750
			when 751 then
					--|#line 3694 "et_eiffel_parser.y"
				yy_do_action_751
			when 752 then
					--|#line 3696 "et_eiffel_parser.y"
				yy_do_action_752
			when 753 then
					--|#line 3698 "et_eiffel_parser.y"
				yy_do_action_753
			when 754 then
					--|#line 3700 "et_eiffel_parser.y"
				yy_do_action_754
			when 755 then
					--|#line 3702 "et_eiffel_parser.y"
				yy_do_action_755
			when 756 then
					--|#line 3704 "et_eiffel_parser.y"
				yy_do_action_756
			when 757 then
					--|#line 3706 "et_eiffel_parser.y"
				yy_do_action_757
			when 758 then
					--|#line 3708 "et_eiffel_parser.y"
				yy_do_action_758
			when 759 then
					--|#line 3710 "et_eiffel_parser.y"
				yy_do_action_759
			when 760 then
					--|#line 3718 "et_eiffel_parser.y"
				yy_do_action_760
			when 761 then
					--|#line 3720 "et_eiffel_parser.y"
				yy_do_action_761
			when 762 then
					--|#line 3722 "et_eiffel_parser.y"
				yy_do_action_762
			when 763 then
					--|#line 3724 "et_eiffel_parser.y"
				yy_do_action_763
			when 764 then
					--|#line 3728 "et_eiffel_parser.y"
				yy_do_action_764
			when 765 then
					--|#line 3730 "et_eiffel_parser.y"
				yy_do_action_765
			when 766 then
					--|#line 3732 "et_eiffel_parser.y"
				yy_do_action_766
			when 767 then
					--|#line 3734 "et_eiffel_parser.y"
				yy_do_action_767
			when 768 then
					--|#line 3736 "et_eiffel_parser.y"
				yy_do_action_768
			when 769 then
					--|#line 3738 "et_eiffel_parser.y"
				yy_do_action_769
			when 770 then
					--|#line 3740 "et_eiffel_parser.y"
				yy_do_action_770
			when 771 then
					--|#line 3742 "et_eiffel_parser.y"
				yy_do_action_771
			when 772 then
					--|#line 3744 "et_eiffel_parser.y"
				yy_do_action_772
			when 773 then
					--|#line 3746 "et_eiffel_parser.y"
				yy_do_action_773
			when 774 then
					--|#line 3748 "et_eiffel_parser.y"
				yy_do_action_774
			when 775 then
					--|#line 3750 "et_eiffel_parser.y"
				yy_do_action_775
			when 776 then
					--|#line 3752 "et_eiffel_parser.y"
				yy_do_action_776
			when 777 then
					--|#line 3785 "et_eiffel_parser.y"
				yy_do_action_777
			when 778 then
					--|#line 3787 "et_eiffel_parser.y"
				yy_do_action_778
			when 779 then
					--|#line 3789 "et_eiffel_parser.y"
				yy_do_action_779
			when 780 then
					--|#line 3793 "et_eiffel_parser.y"
				yy_do_action_780
			when 781 then
					--|#line 3795 "et_eiffel_parser.y"
				yy_do_action_781
			when 782 then
					--|#line 3797 "et_eiffel_parser.y"
				yy_do_action_782
			when 783 then
					--|#line 3805 "et_eiffel_parser.y"
				yy_do_action_783
			when 784 then
					--|#line 3809 "et_eiffel_parser.y"
				yy_do_action_784
			when 785 then
					--|#line 3811 "et_eiffel_parser.y"
				yy_do_action_785
			when 786 then
					--|#line 3815 "et_eiffel_parser.y"
				yy_do_action_786
			when 787 then
					--|#line 3815 "et_eiffel_parser.y"
				yy_do_action_787
			when 788 then
					--|#line 3826 "et_eiffel_parser.y"
				yy_do_action_788
			when 789 then
					--|#line 3826 "et_eiffel_parser.y"
				yy_do_action_789
			when 790 then
					--|#line 3839 "et_eiffel_parser.y"
				yy_do_action_790
			when 791 then
					--|#line 3839 "et_eiffel_parser.y"
				yy_do_action_791
			when 792 then
					--|#line 3850 "et_eiffel_parser.y"
				yy_do_action_792
			when 793 then
					--|#line 3850 "et_eiffel_parser.y"
				yy_do_action_793
			when 794 then
					--|#line 3863 "et_eiffel_parser.y"
				yy_do_action_794
			when 795 then
					--|#line 3874 "et_eiffel_parser.y"
				yy_do_action_795
			when 796 then
					--|#line 3882 "et_eiffel_parser.y"
				yy_do_action_796
			when 797 then
					--|#line 3891 "et_eiffel_parser.y"
				yy_do_action_797
			when 798 then
					--|#line 3899 "et_eiffel_parser.y"
				yy_do_action_798
			when 799 then
					--|#line 3901 "et_eiffel_parser.y"
				yy_do_action_799
			when 800 then
					--|#line 3901 "et_eiffel_parser.y"
				yy_do_action_800
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_801_1000 (yy_act: INTEGER)
			-- Execute semantic action.
		do
			inspect yy_act
			when 801 then
					--|#line 3914 "et_eiffel_parser.y"
				yy_do_action_801
			when 802 then
					--|#line 3923 "et_eiffel_parser.y"
				yy_do_action_802
			when 803 then
					--|#line 3934 "et_eiffel_parser.y"
				yy_do_action_803
			when 804 then
					--|#line 3942 "et_eiffel_parser.y"
				yy_do_action_804
			when 805 then
					--|#line 3951 "et_eiffel_parser.y"
				yy_do_action_805
			when 806 then
					--|#line 3953 "et_eiffel_parser.y"
				yy_do_action_806
			when 807 then
					--|#line 3953 "et_eiffel_parser.y"
				yy_do_action_807
			when 808 then
					--|#line 3966 "et_eiffel_parser.y"
				yy_do_action_808
			when 809 then
					--|#line 3977 "et_eiffel_parser.y"
				yy_do_action_809
			when 810 then
					--|#line 3985 "et_eiffel_parser.y"
				yy_do_action_810
			when 811 then
					--|#line 3994 "et_eiffel_parser.y"
				yy_do_action_811
			when 812 then
					--|#line 3996 "et_eiffel_parser.y"
				yy_do_action_812
			when 813 then
					--|#line 3996 "et_eiffel_parser.y"
				yy_do_action_813
			when 814 then
					--|#line 4011 "et_eiffel_parser.y"
				yy_do_action_814
			when 815 then
					--|#line 4022 "et_eiffel_parser.y"
				yy_do_action_815
			when 816 then
					--|#line 4030 "et_eiffel_parser.y"
				yy_do_action_816
			when 817 then
					--|#line 4039 "et_eiffel_parser.y"
				yy_do_action_817
			when 818 then
					--|#line 4041 "et_eiffel_parser.y"
				yy_do_action_818
			when 819 then
					--|#line 4043 "et_eiffel_parser.y"
				yy_do_action_819
			when 820 then
					--|#line 4045 "et_eiffel_parser.y"
				yy_do_action_820
			when 821 then
					--|#line 4047 "et_eiffel_parser.y"
				yy_do_action_821
			when 822 then
					--|#line 4051 "et_eiffel_parser.y"
				yy_do_action_822
			when 823 then
					--|#line 4055 "et_eiffel_parser.y"
				yy_do_action_823
			when 824 then
					--|#line 4059 "et_eiffel_parser.y"
				yy_do_action_824
			when 825 then
					--|#line 4061 "et_eiffel_parser.y"
				yy_do_action_825
			when 826 then
					--|#line 4065 "et_eiffel_parser.y"
				yy_do_action_826
			when 827 then
					--|#line 4069 "et_eiffel_parser.y"
				yy_do_action_827
			when 828 then
					--|#line 4071 "et_eiffel_parser.y"
				yy_do_action_828
			when 829 then
					--|#line 4077 "et_eiffel_parser.y"
				yy_do_action_829
			when 830 then
					--|#line 4079 "et_eiffel_parser.y"
				yy_do_action_830
			when 831 then
					--|#line 4083 "et_eiffel_parser.y"
				yy_do_action_831
			when 832 then
					--|#line 4090 "et_eiffel_parser.y"
				yy_do_action_832
			when 833 then
					--|#line 4100 "et_eiffel_parser.y"
				yy_do_action_833
			when 834 then
					--|#line 4106 "et_eiffel_parser.y"
				yy_do_action_834
			when 835 then
					--|#line 4112 "et_eiffel_parser.y"
				yy_do_action_835
			when 836 then
					--|#line 4118 "et_eiffel_parser.y"
				yy_do_action_836
			when 837 then
					--|#line 4124 "et_eiffel_parser.y"
				yy_do_action_837
			when 838 then
					--|#line 4130 "et_eiffel_parser.y"
				yy_do_action_838
			when 839 then
					--|#line 4136 "et_eiffel_parser.y"
				yy_do_action_839
			when 840 then
					--|#line 4142 "et_eiffel_parser.y"
				yy_do_action_840
			when 841 then
					--|#line 4148 "et_eiffel_parser.y"
				yy_do_action_841
			when 842 then
					--|#line 4153 "et_eiffel_parser.y"
				yy_do_action_842
			when 843 then
					--|#line 4159 "et_eiffel_parser.y"
				yy_do_action_843
			when 844 then
					--|#line 4167 "et_eiffel_parser.y"
				yy_do_action_844
			when 845 then
					--|#line 4174 "et_eiffel_parser.y"
				yy_do_action_845
			when 846 then
					--|#line 4178 "et_eiffel_parser.y"
				yy_do_action_846
			when 847 then
					--|#line 4180 "et_eiffel_parser.y"
				yy_do_action_847
			when 848 then
					--|#line 4182 "et_eiffel_parser.y"
				yy_do_action_848
			when 849 then
					--|#line 4184 "et_eiffel_parser.y"
				yy_do_action_849
			when 850 then
					--|#line 4186 "et_eiffel_parser.y"
				yy_do_action_850
			when 851 then
					--|#line 4190 "et_eiffel_parser.y"
				yy_do_action_851
			when 852 then
					--|#line 4192 "et_eiffel_parser.y"
				yy_do_action_852
			when 853 then
					--|#line 4194 "et_eiffel_parser.y"
				yy_do_action_853
			when 854 then
					--|#line 4194 "et_eiffel_parser.y"
				yy_do_action_854
			when 855 then
					--|#line 4207 "et_eiffel_parser.y"
				yy_do_action_855
			when 856 then
					--|#line 4218 "et_eiffel_parser.y"
				yy_do_action_856
			when 857 then
					--|#line 4226 "et_eiffel_parser.y"
				yy_do_action_857
			when 858 then
					--|#line 4235 "et_eiffel_parser.y"
				yy_do_action_858
			when 859 then
					--|#line 4244 "et_eiffel_parser.y"
				yy_do_action_859
			when 860 then
					--|#line 4246 "et_eiffel_parser.y"
				yy_do_action_860
			when 861 then
					--|#line 4248 "et_eiffel_parser.y"
				yy_do_action_861
			when 862 then
					--|#line 4254 "et_eiffel_parser.y"
				yy_do_action_862
			when 863 then
					--|#line 4256 "et_eiffel_parser.y"
				yy_do_action_863
			when 864 then
					--|#line 4260 "et_eiffel_parser.y"
				yy_do_action_864
			when 865 then
					--|#line 4262 "et_eiffel_parser.y"
				yy_do_action_865
			when 866 then
					--|#line 4264 "et_eiffel_parser.y"
				yy_do_action_866
			when 867 then
					--|#line 4266 "et_eiffel_parser.y"
				yy_do_action_867
			when 868 then
					--|#line 4268 "et_eiffel_parser.y"
				yy_do_action_868
			when 869 then
					--|#line 4270 "et_eiffel_parser.y"
				yy_do_action_869
			when 870 then
					--|#line 4272 "et_eiffel_parser.y"
				yy_do_action_870
			when 871 then
					--|#line 4274 "et_eiffel_parser.y"
				yy_do_action_871
			when 872 then
					--|#line 4276 "et_eiffel_parser.y"
				yy_do_action_872
			when 873 then
					--|#line 4278 "et_eiffel_parser.y"
				yy_do_action_873
			when 874 then
					--|#line 4280 "et_eiffel_parser.y"
				yy_do_action_874
			when 875 then
					--|#line 4282 "et_eiffel_parser.y"
				yy_do_action_875
			when 876 then
					--|#line 4284 "et_eiffel_parser.y"
				yy_do_action_876
			when 877 then
					--|#line 4286 "et_eiffel_parser.y"
				yy_do_action_877
			when 878 then
					--|#line 4288 "et_eiffel_parser.y"
				yy_do_action_878
			when 879 then
					--|#line 4290 "et_eiffel_parser.y"
				yy_do_action_879
			when 880 then
					--|#line 4292 "et_eiffel_parser.y"
				yy_do_action_880
			when 881 then
					--|#line 4294 "et_eiffel_parser.y"
				yy_do_action_881
			when 882 then
					--|#line 4296 "et_eiffel_parser.y"
				yy_do_action_882
			when 883 then
					--|#line 4298 "et_eiffel_parser.y"
				yy_do_action_883
			when 884 then
					--|#line 4300 "et_eiffel_parser.y"
				yy_do_action_884
			when 885 then
					--|#line 4302 "et_eiffel_parser.y"
				yy_do_action_885
			when 886 then
					--|#line 4304 "et_eiffel_parser.y"
				yy_do_action_886
			when 887 then
					--|#line 4306 "et_eiffel_parser.y"
				yy_do_action_887
			when 888 then
					--|#line 4310 "et_eiffel_parser.y"
				yy_do_action_888
			when 889 then
					--|#line 4319 "et_eiffel_parser.y"
				yy_do_action_889
			when 890 then
					--|#line 4321 "et_eiffel_parser.y"
				yy_do_action_890
			when 891 then
					--|#line 4325 "et_eiffel_parser.y"
				yy_do_action_891
			when 892 then
					--|#line 4327 "et_eiffel_parser.y"
				yy_do_action_892
			when 893 then
					--|#line 4331 "et_eiffel_parser.y"
				yy_do_action_893
			when 894 then
					--|#line 4340 "et_eiffel_parser.y"
				yy_do_action_894
			when 895 then
					--|#line 4342 "et_eiffel_parser.y"
				yy_do_action_895
			when 896 then
					--|#line 4346 "et_eiffel_parser.y"
				yy_do_action_896
			when 897 then
					--|#line 4348 "et_eiffel_parser.y"
				yy_do_action_897
			when 898 then
					--|#line 4352 "et_eiffel_parser.y"
				yy_do_action_898
			when 899 then
					--|#line 4354 "et_eiffel_parser.y"
				yy_do_action_899
			when 900 then
					--|#line 4358 "et_eiffel_parser.y"
				yy_do_action_900
			when 901 then
					--|#line 4365 "et_eiffel_parser.y"
				yy_do_action_901
			when 902 then
					--|#line 4374 "et_eiffel_parser.y"
				yy_do_action_902
			when 903 then
					--|#line 4383 "et_eiffel_parser.y"
				yy_do_action_903
			when 904 then
					--|#line 4385 "et_eiffel_parser.y"
				yy_do_action_904
			when 905 then
					--|#line 4389 "et_eiffel_parser.y"
				yy_do_action_905
			when 906 then
					--|#line 4391 "et_eiffel_parser.y"
				yy_do_action_906
			when 907 then
					--|#line 4395 "et_eiffel_parser.y"
				yy_do_action_907
			when 908 then
					--|#line 4402 "et_eiffel_parser.y"
				yy_do_action_908
			when 909 then
					--|#line 4411 "et_eiffel_parser.y"
				yy_do_action_909
			when 910 then
					--|#line 4420 "et_eiffel_parser.y"
				yy_do_action_910
			when 911 then
					--|#line 4422 "et_eiffel_parser.y"
				yy_do_action_911
			when 912 then
					--|#line 4424 "et_eiffel_parser.y"
				yy_do_action_912
			when 913 then
					--|#line 4430 "et_eiffel_parser.y"
				yy_do_action_913
			else
				debug ("GEYACC")
					std.error.put_string ("Error in parser: unknown rule id: ")
					std.error.put_integer (yy_act)
					std.error.put_new_line
				end
				abort
			end
		end

	yy_do_action_1
			--|#line 244 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 244 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 244")
end

			-- END
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp44 := yyvsp44 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_2
			--|#line 248 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 248 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 248")
end

			if attached yyvs44.item (yyvsp44) as l_class_declaration then
				l_class_declaration.set_leading_break (yyvs8.item (yyvsp8))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp8 := yyvsp8 -1
	yyvsp44 := yyvsp44 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_3
			--|#line 256 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 256 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 256")
end

			yyval44 := yyvs44.item (yyvsp44)
			if yyval44 /= Void then
				yyval44.set_first_indexing (yyvs86.item (yyvsp86))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp86 := yyvsp86 -1
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_4
			--|#line 265 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 265 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 265")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_5
			--|#line 266 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 266 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 266")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp44 := yyvsp44 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_6
			--|#line 266 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 266 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 266")
end

			if not system_processor.preparse_multiple_mode then
					-- Raise syntax error: it is not valid to have more
					-- than one class text in the same file.
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_7
			--|#line 277 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 277 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 277")
end

			yyval44 := yyvs44.item (yyvsp44)
			set_class_to_end (yyval44, yyvs105.item (yyvsp105), yyvs108.item (yyvsp108), yyvs61.item (yyvsp61), yyvs57.item (yyvsp57), yyvs74.item (yyvsp74), yyvs94.item (yyvsp94), yyvs86.item (yyvsp86), yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp83 := yyvsp83 -1
	yyvsp105 := yyvsp105 -1
	yyvsp108 := yyvsp108 -1
	yyvsp61 := yyvsp61 -1
	yyvsp57 := yyvsp57 -1
	yyvsp74 := yyvsp74 -1
	yyvsp94 := yyvsp94 -1
	yyvsp86 := yyvsp86 -1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_8
			--|#line 285 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 285 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 285")
end

set_class_providers 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_9
			--|#line 290 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 290 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 290")
end

yyval86 := ast_factory.new_indexings (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_10
			--|#line 292 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 292 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 292")
end

			yyval86 := yyvs86.item (yyvsp86)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_11
			--|#line 292 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 292 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 292")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_12
			--|#line 303 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 303 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 303")
end

yyval86 := ast_factory.new_indexings (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_13
			--|#line 305 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 305 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 305")
end

			yyval86 := yyvs86.item (yyvsp86)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_14
			--|#line 305 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 305 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 305")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_15
			--|#line 318 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 318 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 318")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_16
			--|#line 320 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 320 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 320")
end

yyval86 := yyvs86.item (yyvsp86) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_17
			--|#line 324 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 324 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 324")
end

			if attached yyvs87.item (yyvsp87) as l_note then
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value + 1)
				if yyval86 /= Void then
					yyval86.put_first (l_note)
				end
			else
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp87 := yyvsp87 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_18
			--|#line 335 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 335 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 335")
end

			yyval86 := yyvs86.item (yyvsp86)
			if yyval86 /= Void and attached yyvs87.item (yyvsp87) as l_note then
				yyval86.put_first (l_note)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp87 := yyvsp87 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_19
			--|#line 335 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 335 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 335")
end

increment_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_20
			--|#line 344 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 344 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 344")
end

			yyval86 := yyvs86.item (yyvsp86)
			if yyval86 /= Void and attached yyvs87.item (yyvsp87) as l_note then
				yyval86.put_first (l_note)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp87 := yyvsp87 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_21
			--|#line 344 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 344 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 344")
end

increment_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_22
			--|#line 355 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 355 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 355")
end

			yyval87 := yyvs87.item (yyvsp87)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_23
			--|#line 362 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 362 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 362")
end

			yyval87 := ast_factory.new_tagged_indexing (ast_factory.new_tag (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs90.item (yyvsp90))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp87 := yyvsp87 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp90 := yyvsp90 -1
	if yyvsp87 >= yyvsc87 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs87")
		end
		yyvsc87 := yyvsc87 + yyInitial_yyvs_size
		yyvs87 := yyspecial_routines87.aliased_resized_area (yyvs87, yyvsc87)
	end
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_24
			--|#line 368 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 368 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 368")
end

yyval87 := ast_factory.new_indexing_semicolon (yyvs87.item (yyvsp87), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp21 := yyvsp21 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_25
			--|#line 372 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 372 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 372")
end

			if attached yyvs87.item (yyvsp87) as l_indexing_clause then
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value + 1)
				if yyval86 /= Void then
					yyval86.put_first (l_indexing_clause)
				end
			else
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp87 := yyvsp87 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_26
			--|#line 383 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 383 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 383")
end

			if attached yyvs87.item (yyvsp87) as l_indexing_clause then
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value + 1)
				if yyval86 /= Void then
					yyval86.put_first (l_indexing_clause)
				end
			else
				yyval86 := ast_factory.new_indexings (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp86 := yyvsp86 + 1
	yyvsp87 := yyvsp87 -1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_27
			--|#line 395 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 395 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 395")
end

			yyval86 := yyvs86.item (yyvsp86)
			if yyval86 /= Void and attached yyvs87.item (yyvsp87) as l_indexing_clause then
				yyval86.put_first (l_indexing_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp87 := yyvsp87 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_28
			--|#line 395 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 395 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 395")
end

increment_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_29
			--|#line 404 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 404 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 404")
end

			yyval86 := yyvs86.item (yyvsp86)
			if yyval86 /= Void and attached yyvs87.item (yyvsp87) as l_indexing_clause then
				yyval86.put_first (l_indexing_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp86 := yyvsp86 -1
	yyvsp87 := yyvsp87 -1
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_30
			--|#line 404 "et_eiffel_parser.y"
		local
			yyval86: detachable ET_INDEXING_LIST
		do
--|#line 404 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 404")
end

increment_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp86 := yyvsp86 + 1
	if yyvsp86 >= yyvsc86 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs86")
		end
		yyvsc86 := yyvsc86 + yyInitial_yyvs_size
		yyvs86 := yyspecial_routines86.aliased_resized_area (yyvs86, yyvsc86)
	end
	yyspecial_routines86.force (yyvs86, yyval86, yyvsp86)
end
		end

	yy_do_action_31
			--|#line 415 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 415 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 415")
end

			yyval87 := yyvs87.item (yyvsp87)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_32
			--|#line 422 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 422 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 422")
end

			yyval87 := ast_factory.new_indexing (yyvs90.item (yyvsp90))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp87 := yyvsp87 + 1
	yyvsp90 := yyvsp90 -1
	if yyvsp87 >= yyvsc87 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs87")
		end
		yyvsc87 := yyvsc87 + yyInitial_yyvs_size
		yyvs87 := yyspecial_routines87.aliased_resized_area (yyvs87, yyvsc87)
	end
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_33
			--|#line 426 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 426 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 426")
end

			yyval87 := ast_factory.new_tagged_indexing (ast_factory.new_tag (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs90.item (yyvsp90))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp87 := yyvsp87 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp90 := yyvsp90 -1
	if yyvsp87 >= yyvsc87 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs87")
		end
		yyvsc87 := yyvsc87 + yyInitial_yyvs_size
		yyvs87 := yyspecial_routines87.aliased_resized_area (yyvs87, yyvsc87)
	end
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_34
			--|#line 432 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 432 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 432")
end

yyval87 := ast_factory.new_indexing_semicolon (yyvs87.item (yyvsp87), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp21 := yyvsp21 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_35
			--|#line 434 "et_eiffel_parser.y"
		local
			yyval87: detachable ET_INDEXING_ITEM
		do
--|#line 434 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 434")
end

yyval87 := ast_factory.new_indexing_semicolon (yyvs87.item (yyvsp87), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp21 := yyvsp21 -1
	yyspecial_routines87.force (yyvs87, yyval87, yyvsp87)
end
		end

	yy_do_action_36
			--|#line 439 "et_eiffel_parser.y"
		local
			yyval90: detachable ET_INDEXING_TERM_LIST
		do
--|#line 439 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 439")
end

			if attached yyvs88.item (yyvsp88) as l_index_value then
				yyval90 := ast_factory.new_indexing_terms (counter_value + 1)
				if yyval90 /= Void then
					yyval90.put_first (l_index_value)
				end
			else
				yyval90 := ast_factory.new_indexing_terms (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp90 := yyvsp90 + 1
	yyvsp88 := yyvsp88 -1
	if yyvsp90 >= yyvsc90 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs90")
		end
		yyvsc90 := yyvsc90 + yyInitial_yyvs_size
		yyvs90 := yyspecial_routines90.aliased_resized_area (yyvs90, yyvsc90)
	end
	yyspecial_routines90.force (yyvs90, yyval90, yyvsp90)
end
		end

	yy_do_action_37
			--|#line 450 "et_eiffel_parser.y"
		local
			yyval90: detachable ET_INDEXING_TERM_LIST
		do
--|#line 450 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 450")
end

			yyval90 := yyvs90.item (yyvsp90)
			if yyval90 /= Void and attached yyvs89.item (yyvsp89) as l_index_value then
				yyval90.put_first (l_index_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp89 := yyvsp89 -1
	yyspecial_routines90.force (yyvs90, yyval90, yyvsp90)
end
		end

	yy_do_action_38
			--|#line 459 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 459 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 459")
end

yyval88 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_39
			--|#line 461 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 461 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 461")
end

yyval88 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_40
			--|#line 463 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 463 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 463")
end

yyval88 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_41
			--|#line 465 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 465 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 465")
end

yyval88 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_42
			--|#line 467 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 467 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 467")
end

yyval88 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_43
			--|#line 469 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 469 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 469")
end

yyval88 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp88 := yyvsp88 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_44
			--|#line 471 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 471 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 471")
end

yyval88 := ast_factory.new_custom_attribute (yyvs58.item (yyvsp58), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp88 := yyvsp88 + 1
	yyvsp58 := yyvsp58 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_45
			--|#line 473 "et_eiffel_parser.y"
		local
			yyval88: detachable ET_INDEXING_TERM
		do
--|#line 473 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 473")
end

yyval88 := ast_factory.new_custom_attribute (yyvs58.item (yyvsp58), yyvs104.item (yyvsp104), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp88 := yyvsp88 + 1
	yyvsp58 := yyvsp58 -1
	yyvsp104 := yyvsp104 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp88 >= yyvsc88 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs88")
		end
		yyvsc88 := yyvsc88 + yyInitial_yyvs_size
		yyvs88 := yyspecial_routines88.aliased_resized_area (yyvs88, yyvsc88)
	end
	yyspecial_routines88.force (yyvs88, yyval88, yyvsp88)
end
		end

	yy_do_action_46
			--|#line 477 "et_eiffel_parser.y"
		local
			yyval89: detachable ET_INDEXING_TERM_ITEM
		do
--|#line 477 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 477")
end

			yyval89 := ast_factory.new_indexing_term_comma (yyvs88.item (yyvsp88), yyvs5.item (yyvsp5))
			if yyval89 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp89 := yyvsp89 + 1
	yyvsp88 := yyvsp88 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp89 >= yyvsc89 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs89")
		end
		yyvsc89 := yyvsc89 + yyInitial_yyvs_size
		yyvs89 := yyspecial_routines89.aliased_resized_area (yyvs89, yyvsc89)
	end
	yyspecial_routines89.force (yyvs89, yyval89, yyvsp89)
end
		end

	yy_do_action_47
			--|#line 488 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 488 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 488")
end

			yyval44 := new_class (yyvs12.item (yyvsp12))
			if yyval44 /= Void then
				if attached yyvs2.item (yyvsp2) as l_class_keyword then
					yyval44.set_class_keyword (l_class_keyword)
				end
				yyval44.set_frozen_keyword (yyvs2.item (yyvsp2 - 2))
				yyval44.set_external_keyword (yyvs2.item (yyvsp2 - 1))
			end
			last_class := yyval44
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp44 := yyvsp44 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp12 := yyvsp12 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_48
			--|#line 500 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 500 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 500")
end

			yyval44 := new_class (yyvs12.item (yyvsp12))
			if yyval44 /= Void then
				if attached yyvs2.item (yyvsp2) as l_class_keyword then
					yyval44.set_class_keyword (l_class_keyword)
				end
				yyval44.set_class_mark (yyvs2.item (yyvsp2 - 2))
				yyval44.set_frozen_keyword (yyvs2.item (yyvsp2 - 3))
				yyval44.set_external_keyword (yyvs2.item (yyvsp2 - 1))
			end
			last_class := yyval44
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp44 := yyvsp44 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp12 := yyvsp12 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_49
			--|#line 513 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 513 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 513")
end

			yyval44 := new_class (yyvs12.item (yyvsp12))
			if yyval44 /= Void then
				if attached yyvs2.item (yyvsp2) as l_class_keyword then
					yyval44.set_class_keyword (l_class_keyword)
				end
				yyval44.set_class_mark (yyvs2.item (yyvsp2 - 2))
				yyval44.set_frozen_keyword (yyvs2.item (yyvsp2 - 3))
				yyval44.set_external_keyword (yyvs2.item (yyvsp2 - 1))
			end
			last_class := yyval44
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp44 := yyvsp44 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp12 := yyvsp12 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_50
			--|#line 526 "et_eiffel_parser.y"
		local
			yyval44: detachable ET_CLASS
		do
--|#line 526 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 526")
end

			yyval44 := new_class (yyvs12.item (yyvsp12))
			if yyval44 /= Void then
				if attached yyvs2.item (yyvsp2) as l_class_keyword then
					yyval44.set_class_keyword (l_class_keyword)
				end
				yyval44.set_class_mark (yyvs2.item (yyvsp2 - 2))
				yyval44.set_frozen_keyword (yyvs2.item (yyvsp2 - 3))
				yyval44.set_external_keyword (yyvs2.item (yyvsp2 - 1))
			end
			last_class := yyval44
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp44 := yyvsp44 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp12 := yyvsp12 -1
	if yyvsp44 >= yyvsc44 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs44")
		end
		yyvsc44 := yyvsc44 + yyInitial_yyvs_size
		yyvs44 := yyspecial_routines44.aliased_resized_area (yyvs44, yyvsc44)
	end
	yyspecial_routines44.force (yyvs44, yyval44, yyvsp44)
end
		end

	yy_do_action_51
			--|#line 541 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 541 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 541")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_52
			--|#line 543 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 543 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 543")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_53
			--|#line 547 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 547 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 547")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_54
			--|#line 549 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 549 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 549")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_55
			--|#line 555 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 555 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 555")
end

			set_formal_parameters (Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp83 := yyvsp83 + 1
	if yyvsp83 >= yyvsc83 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs83")
		end
		yyvsc83 := yyvsc83 + yyInitial_yyvs_size
		yyvs83 := yyspecial_routines83.aliased_resized_area (yyvs83, yyvsc83)
	end
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_56
			--|#line 559 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 559 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 559")
end

			yyval83 := ast_factory.new_formal_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0)
			set_formal_parameters (yyval83)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp83 := yyvsp83 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp83 >= yyvsc83 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs83")
		end
		yyvsc83 := yyvsc83 + yyInitial_yyvs_size
		yyvs83 := yyspecial_routines83.aliased_resized_area (yyvs83, yyvsc83)
	end
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_57
			--|#line 565 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 565 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 565")
end

			yyval83 := yyvs83.item (yyvsp83)
			set_formal_parameters (yyval83)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp83 := yyvsp83 -1
	yyvsp22 := yyvsp22 -1
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_58
			--|#line 565 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 565 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 565")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp83 := yyvsp83 + 1
	if yyvsp83 >= yyvsc83 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs83")
		end
		yyvsc83 := yyvsc83 + yyInitial_yyvs_size
		yyvs83 := yyspecial_routines83.aliased_resized_area (yyvs83, yyvsc83)
	end
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_59
			--|#line 579 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 579 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 579")
end

			if attached yyvs81.item (yyvsp81) as l_formal_parameter then
				yyval83 := ast_factory.new_formal_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval83 /= Void then
					yyval83.put_first (l_formal_parameter)
				end
			else
				yyval83 := ast_factory.new_formal_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp83 := yyvsp83 + 1
	yyvsp81 := yyvsp81 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp83 >= yyvsc83 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs83")
		end
		yyvsc83 := yyvsc83 + yyInitial_yyvs_size
		yyvs83 := yyspecial_routines83.aliased_resized_area (yyvs83, yyvsc83)
	end
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_60
			--|#line 590 "et_eiffel_parser.y"
		local
			yyval83: detachable ET_FORMAL_PARAMETER_LIST
		do
--|#line 590 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 590")
end

			yyval83 := yyvs83.item (yyvsp83)
			if yyval83 /= Void and attached yyvs82.item (yyvsp82) as l_formal_parameter then
				yyval83.put_first (l_formal_parameter)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp82 := yyvsp82 -1
	yyspecial_routines83.force (yyvs83, yyval83, yyvsp83)
end
		end

	yy_do_action_61
			--|#line 599 "et_eiffel_parser.y"
		local
			yyval82: detachable ET_FORMAL_PARAMETER_ITEM
		do
--|#line 599 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 599")
end

			yyval82 := ast_factory.new_formal_parameter_comma (yyvs81.item (yyvsp81), yyvs5.item (yyvsp5))
			if yyval82 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp82 := yyvsp82 + 1
	yyvsp81 := yyvsp81 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp82 >= yyvsc82 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs82")
		end
		yyvsc82 := yyvsc82 + yyInitial_yyvs_size
		yyvs82 := yyspecial_routines82.aliased_resized_area (yyvs82, yyvsc82)
	end
	yyspecial_routines82.force (yyvs82, yyval82, yyvsp82)
end
		end

	yy_do_action_62
			--|#line 608 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 608 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 608")
end

yyval81 := ast_factory.new_formal_parameter (Void, yyvs12.item (yyvsp12), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp81 := yyvsp81 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_63
			--|#line 610 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 610 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 610")
end

yyval81 := ast_factory.new_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_64
			--|#line 612 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 612 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 612")
end

yyval81 := ast_factory.new_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_65
			--|#line 614 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 614 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 614")
end

yyval81 := ast_factory.new_constrained_formal_parameter (Void, yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs123.item (yyvsp123), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp81 := yyvsp81 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_66
			--|#line 616 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 616 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 616")
end

yyval81 := ast_factory.new_constrained_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs123.item (yyvsp123), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_67
			--|#line 618 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 618 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 618")
end

yyval81 := ast_factory.new_constrained_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs123.item (yyvsp123), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp123 := yyvsp123 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_68
			--|#line 620 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 620 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 620")
end

yyval81 := ast_factory.new_constrained_formal_parameter (Void, yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs125.item (yyvsp125), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp81 := yyvsp81 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp125 := yyvsp125 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_69
			--|#line 622 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 622 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 622")
end

yyval81 := ast_factory.new_constrained_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs125.item (yyvsp125), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp125 := yyvsp125 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_70
			--|#line 624 "et_eiffel_parser.y"
		local
			yyval81: detachable ET_FORMAL_PARAMETER
		do
--|#line 624 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 624")
end

yyval81 := ast_factory.new_constrained_formal_parameter (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs125.item (yyvsp125), yyvs52.item (yyvsp52), last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp81 := yyvsp81 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp125 := yyvsp125 -1
	yyvsp52 := yyvsp52 -1
	if yyvsp81 >= yyvsc81 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs81")
		end
		yyvsc81 := yyvsc81 + yyInitial_yyvs_size
		yyvs81 := yyspecial_routines81.aliased_resized_area (yyvs81, yyvsc81)
	end
	yyspecial_routines81.force (yyvs81, yyval81, yyvsp81)
end
		end

	yy_do_action_71
			--|#line 628 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE_CONSTRAINT
		do
--|#line 628 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 628")
end

			yyval123 := dummy_constraint (yyvs54.item (yyvsp54))
			if yyval123 /= Void then
				register_constraint (yyvs54.item (yyvsp54))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp123 := yyvsp123 + 1
	yyvsp54 := yyvsp54 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_72
			--|#line 635 "et_eiffel_parser.y"
		local
			yyval123: detachable ET_TYPE_CONSTRAINT
		do
--|#line 635 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 635")
end

			yyval123 := ast_factory.new_type_rename_constraint (dummy_constraint (yyvs54.item (yyvsp54)), yyvs53.item (yyvsp53))
			if yyval123 /= Void then
				register_constraint (yyvs54.item (yyvsp54))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp123 := yyvsp123 + 1
	yyvsp54 := yyvsp54 -1
	yyvsp53 := yyvsp53 -1
	if yyvsp123 >= yyvsc123 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs123")
		end
		yyvsc123 := yyvsc123 + yyInitial_yyvs_size
		yyvs123 := yyspecial_routines123.aliased_resized_area (yyvs123, yyvsc123)
	end
	yyspecial_routines123.force (yyvs123, yyval123, yyvsp123)
end
		end

	yy_do_action_73
			--|#line 644 "et_eiffel_parser.y"
		local
			yyval125: detachable ET_TYPE_CONSTRAINT_LIST
		do
--|#line 644 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 644")
end

			yyval125 := yyvs125.item (yyvsp125)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp125 := yyvsp125 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines125.force (yyvs125, yyval125, yyvsp125)
end
		end

	yy_do_action_74
			--|#line 644 "et_eiffel_parser.y"
		local
			yyval125: detachable ET_TYPE_CONSTRAINT_LIST
		do
--|#line 644 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 644")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp125 := yyvsp125 + 1
	if yyvsp125 >= yyvsc125 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs125")
		end
		yyvsc125 := yyvsc125 + yyInitial_yyvs_size
		yyvs125 := yyspecial_routines125.aliased_resized_area (yyvs125, yyvsc125)
	end
	yyspecial_routines125.force (yyvs125, yyval125, yyvsp125)
end
		end

	yy_do_action_75
			--|#line 657 "et_eiffel_parser.y"
		local
			yyval125: detachable ET_TYPE_CONSTRAINT_LIST
		do
--|#line 657 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 657")
end

			if attached yyvs123.item (yyvsp123) as l_type_constraint then
				yyval125 := ast_factory.new_type_constraint_list (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval125 /= Void then
					yyval125.put_first (l_type_constraint)
				end
			else
				yyval125 := ast_factory.new_type_constraint_list (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp125 := yyvsp125 + 1
	yyvsp123 := yyvsp123 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp125 >= yyvsc125 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs125")
		end
		yyvsc125 := yyvsc125 + yyInitial_yyvs_size
		yyvs125 := yyspecial_routines125.aliased_resized_area (yyvs125, yyvsc125)
	end
	yyspecial_routines125.force (yyvs125, yyval125, yyvsp125)
end
		end

	yy_do_action_76
			--|#line 668 "et_eiffel_parser.y"
		local
			yyval125: detachable ET_TYPE_CONSTRAINT_LIST
		do
--|#line 668 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 668")
end

			yyval125 := yyvs125.item (yyvsp125)
			if yyval125 /= Void and attached yyvs124.item (yyvsp124) as l_type_constraint then
				yyval125.put_first (l_type_constraint)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp124 := yyvsp124 -1
	yyspecial_routines125.force (yyvs125, yyval125, yyvsp125)
end
		end

	yy_do_action_77
			--|#line 677 "et_eiffel_parser.y"
		local
			yyval124: detachable ET_TYPE_CONSTRAINT_ITEM
		do
--|#line 677 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 677")
end

			yyval124 := ast_factory.new_type_constraint_comma (yyvs123.item (yyvsp123), yyvs5.item (yyvsp5))
			if yyval124 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp124 := yyvsp124 + 1
	yyvsp123 := yyvsp123 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp124 >= yyvsc124 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs124")
		end
		yyvsc124 := yyvsc124 + yyInitial_yyvs_size
		yyvs124 := yyspecial_routines124.aliased_resized_area (yyvs124, yyvsc124)
	end
	yyspecial_routines124.force (yyvs124, yyval124, yyvsp124)
end
		end

	yy_do_action_78
			--|#line 686 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 686 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 686")
end

yyval53 := ast_factory.new_constraint_renames (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp53 := yyvsp53 + 1
	yyvsp2 := yyvsp2 -2
	if yyvsp53 >= yyvsc53 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs53")
		end
		yyvsc53 := yyvsc53 + yyInitial_yyvs_size
		yyvs53 := yyspecial_routines53.aliased_resized_area (yyvs53, yyvsc53)
	end
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_79
			--|#line 688 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 688 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 688")
end

			yyval53 := yyvs53.item (yyvsp53)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp53 := yyvsp53 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_80
			--|#line 688 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 688 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 688")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp53 := yyvsp53 + 1
	if yyvsp53 >= yyvsc53 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs53")
		end
		yyvsc53 := yyvsc53 + yyInitial_yyvs_size
		yyvs53 := yyspecial_routines53.aliased_resized_area (yyvs53, yyvsc53)
	end
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_81
			--|#line 701 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 701 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 701")
end

			if attached yyvs117.item (yyvsp117) as l_rename then
				yyval53 := ast_factory.new_constraint_renames (last_keyword, yyvs2.item (yyvsp2), counter_value + 1)
				if yyval53 /= Void then
					yyval53.put_first (l_rename)
				end
			else
				yyval53 := ast_factory.new_constraint_renames (last_keyword, yyvs2.item (yyvsp2), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp53 := yyvsp53 + 1
	yyvsp117 := yyvsp117 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp53 >= yyvsc53 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs53")
		end
		yyvsc53 := yyvsc53 + yyInitial_yyvs_size
		yyvs53 := yyspecial_routines53.aliased_resized_area (yyvs53, yyvsc53)
	end
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_82
			--|#line 712 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 712 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 712")
end

			yyval53 := ast_factory.new_constraint_renames (last_keyword, yyvs2.item (yyvsp2), counter_value)
			if yyval53 /= Void and attached yyvs117.item (yyvsp117) as l_rename then
				yyval53.put_first (l_rename)
			end
				-- TODO: syntax error.
			raise_error
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp53 := yyvsp53 + 1
	yyvsp117 := yyvsp117 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp53 >= yyvsc53 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs53")
		end
		yyvsc53 := yyvsc53 + yyInitial_yyvs_size
		yyvs53 := yyspecial_routines53.aliased_resized_area (yyvs53, yyvsc53)
	end
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_83
			--|#line 721 "et_eiffel_parser.y"
		local
			yyval53: detachable ET_CONSTRAINT_RENAME_LIST
		do
--|#line 721 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 721")
end

			yyval53 := yyvs53.item (yyvsp53)
			if yyval53 /= Void and attached yyvs117.item (yyvsp117) as l_rename then
				yyval53.put_first (l_rename)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp117 := yyvsp117 -1
	yyspecial_routines53.force (yyvs53, yyval53, yyvsp53)
end
		end

	yy_do_action_84
			--|#line 730 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 730 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 730")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp52 := yyvsp52 + 1
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_85
			--|#line 732 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 732 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 732")
end

yyval52 := yyvs52.item (yyvsp52) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_86
			--|#line 736 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 736 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 736")
end

yyval52 := ast_factory.new_constraint_creator (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp52 := yyvsp52 + 1
	yyvsp2 := yyvsp2 -2
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_87
			--|#line 738 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 738 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 738")
end

			yyval52 := yyvs52.item (yyvsp52)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp52 := yyvsp52 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_88
			--|#line 738 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 738 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 738")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp52 := yyvsp52 + 1
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_89
			--|#line 751 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 751 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 751")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval52 := ast_factory.new_constraint_creator (last_keyword, yyvs2.item (yyvsp2), counter_value + 1)
				if yyval52 /= Void then
					yyval52.put_first (l_identifier)
				end
			else
				yyval52 := ast_factory.new_constraint_creator (last_keyword, yyvs2.item (yyvsp2), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp52 := yyvsp52 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_90
			--|#line 763 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 763 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 763")
end

			yyval52 := ast_factory.new_constraint_creator (last_keyword, yyvs2.item (yyvsp2), counter_value)
			if yyval52 /= Void and attached yyvs77.item (yyvsp77) as l_creation_procedure then
				yyval52.put_first (l_creation_procedure)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp52 := yyvsp52 + 1
	yyvsp77 := yyvsp77 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp52 >= yyvsc52 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs52")
		end
		yyvsc52 := yyvsc52 + yyInitial_yyvs_size
		yyvs52 := yyspecial_routines52.aliased_resized_area (yyvs52, yyvsc52)
	end
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_91
			--|#line 771 "et_eiffel_parser.y"
		local
			yyval52: detachable ET_CONSTRAINT_CREATOR
		do
--|#line 771 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 771")
end

			yyval52 := yyvs52.item (yyvsp52)
			if yyval52 /= Void and attached yyvs77.item (yyvsp77) as l_creation_procedure then
				yyval52.put_first (l_creation_procedure)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines52.force (yyvs52, yyval52, yyvsp52)
end
		end

	yy_do_action_92
			--|#line 780 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 780 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 780")
end

yyval54 := new_constraint_named_type (Void, yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp54 := yyvsp54 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_93
			--|#line 782 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 782 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 782")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_94
			--|#line 784 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 784 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 784")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_95
			--|#line 786 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 786 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 786")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_96
			--|#line 788 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 788 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 788")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_97
			--|#line 790 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 790 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 790")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_98
			--|#line 792 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 792 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 792")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_99
			--|#line 794 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 794 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 794")
end

yyval54 := new_constraint_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_100
			--|#line 796 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 796 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 796")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_101
			--|#line 798 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 798 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 798")
end

yyval54 := new_constraint_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_102
			--|#line 800 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 800 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 800")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_103
			--|#line 802 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 802 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 802")
end

yyval54 := yyvs96.item (yyvsp96) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp54 := yyvsp54 + 1
	yyvsp96 := yyvsp96 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_104
			--|#line 804 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 804 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 804")
end

yyval54 := new_constraint_named_type (Void, yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp54 := yyvsp54 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_105
			--|#line 806 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 806 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 806")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_106
			--|#line 808 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 808 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 808")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_107
			--|#line 810 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 810 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 810")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_108
			--|#line 812 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 812 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 812")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_109
			--|#line 814 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 814 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 814")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_110
			--|#line 816 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 816 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 816")
end

yyval54 := new_constraint_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_111
			--|#line 818 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 818 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 818")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_112
			--|#line 820 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 820 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 820")
end

yyval54 := new_constraint_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_113
			--|#line 822 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 822 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 822")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_114
			--|#line 826 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 826 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 826")
end

yyval54 := new_constraint_named_type (Void, yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp54 := yyvsp54 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_115
			--|#line 828 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 828 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 828")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_116
			--|#line 830 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 830 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 830")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_117
			--|#line 832 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 832 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 832")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_118
			--|#line 834 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 834 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 834")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_119
			--|#line 836 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 836 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 836")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_120
			--|#line 838 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 838 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 838")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_121
			--|#line 840 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 840 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 840")
end

yyval54 := new_constraint_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_122
			--|#line 842 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 842 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 842")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_123
			--|#line 844 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 844 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 844")
end

yyval54 := new_constraint_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_124
			--|#line 846 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 846 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 846")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_125
			--|#line 848 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 848 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 848")
end

yyval54 := yyvs96.item (yyvsp96) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp54 := yyvsp54 + 1
	yyvsp96 := yyvsp96 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_126
			--|#line 850 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 850 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 850")
end

yyval54 := new_constraint_named_type (Void, yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp54 := yyvsp54 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_127
			--|#line 852 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 852 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 852")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_128
			--|#line 854 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 854 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 854")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_129
			--|#line 856 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 856 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 856")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_130
			--|#line 858 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 858 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 858")
end

yyval54 := new_constraint_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_131
			--|#line 860 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 860 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 860")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_132
			--|#line 862 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 862 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 862")
end

yyval54 := new_constraint_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_133
			--|#line 864 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 864 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 864")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_134
			--|#line 866 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 866 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 866")
end

yyval54 := new_constraint_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_135
			--|#line 868 "et_eiffel_parser.y"
		local
			yyval54: detachable ET_CONSTRAINT_TYPE
		do
--|#line 868 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 868")
end

yyval54 := new_constraint_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs51.item (yyvsp51)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp54 := yyvsp54 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp51 := yyvsp51 -1
	if yyvsp54 >= yyvsc54 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs54")
		end
		yyvsc54 := yyvsc54 + yyInitial_yyvs_size
		yyvs54 := yyspecial_routines54.aliased_resized_area (yyvs54, yyvsc54)
	end
	yyspecial_routines54.force (yyvs54, yyval54, yyvsp54)
end
		end

	yy_do_action_136
			--|#line 872 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 872 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 872")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp51 := yyvsp51 + 1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_137
			--|#line 874 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 874 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 874")
end

yyval51 := yyvs51.item (yyvsp51) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_138
			--|#line 878 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 878 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 878")
end

yyval51 := ast_factory.new_constraint_actual_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp51 := yyvsp51 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_139
			--|#line 881 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 881 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 881")
end

			yyval51 := yyvs51.item (yyvsp51)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_140
			--|#line 889 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 889 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 889")
end

			if attached yyvs54.item (yyvsp54) as l_constraint_type then
				yyval51 := ast_factory.new_constraint_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval51 /= Void then
					yyval51.put_first (l_constraint_type)
				end
			else
				yyval51 := ast_factory.new_constraint_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp51 := yyvsp51 + 1
	yyvsp54 := yyvsp54 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_141
			--|#line 900 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 900 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 900")
end

			yyval51 := yyvs51.item (yyvsp51)
			add_to_constraint_actual_parameter_list (yyvs50.item (yyvsp50), yyval51)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_142
			--|#line 905 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 905 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 905")
end

			yyval51 := yyvs51.item (yyvsp51)
			add_to_constraint_actual_parameter_list (ast_factory.new_constraint_actual_parameter_comma (new_constraint_named_type (Void, yyvs12.item (yyvsp12), Void), yyvs5.item (yyvsp5)), yyval51)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_143
			--|#line 912 "et_eiffel_parser.y"
		local
			yyval50: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM
		do
--|#line 912 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 912")
end

			yyval50 := ast_factory.new_constraint_actual_parameter_comma (yyvs54.item (yyvsp54), yyvs5.item (yyvsp5))
			if yyval50 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 + 1
	yyvsp54 := yyvsp54 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp50 >= yyvsc50 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs50")
		end
		yyvsc50 := yyvsc50 + yyInitial_yyvs_size
		yyvs50 := yyspecial_routines50.aliased_resized_area (yyvs50, yyvsc50)
	end
	yyspecial_routines50.force (yyvs50, yyval50, yyvsp50)
end
		end

	yy_do_action_144
			--|#line 921 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 921 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 921")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp51 := yyvsp51 + 1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_145
			--|#line 923 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 923 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 923")
end

yyval51 := yyvs51.item (yyvsp51) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_146
			--|#line 927 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 927 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 927")
end

yyval51 := ast_factory.new_constraint_actual_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp51 := yyvsp51 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_147
			--|#line 930 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 930 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 930")
end

			yyval51 := yyvs51.item (yyvsp51)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_148
			--|#line 936 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 936 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 936")
end

			yyval51 := yyvs51.item (yyvsp51)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_149
			--|#line 944 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 944 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 944")
end

			yyval51 := ast_factory.new_constraint_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
			add_to_constraint_actual_parameter_list (ast_factory.new_constraint_labeled_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs54.item (yyvsp54)), yyval51)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp51 := yyvsp51 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -2
	yyvsp54 := yyvsp54 -1
	if yyvsp51 >= yyvsc51 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs51")
		end
		yyvsc51 := yyvsc51 + yyInitial_yyvs_size
		yyvs51 := yyspecial_routines51.aliased_resized_area (yyvs51, yyvsc51)
	end
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_150
			--|#line 949 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 949 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 949")
end

			yyval51 := yyvs51.item (yyvsp51)
			add_to_constraint_actual_parameter_list (yyvs50.item (yyvsp50), yyvs51.item (yyvsp51))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_151
			--|#line 954 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 954 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 954")
end

			yyval51 := yyvs51.item (yyvsp51)
			add_to_constraint_actual_parameter_list (yyvs50.item (yyvsp50), yyvs51.item (yyvsp51))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp50 := yyvsp50 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_152
			--|#line 959 "et_eiffel_parser.y"
		local
			yyval51: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST
		do
--|#line 959 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 959")
end

			yyval51 := yyvs51.item (yyvsp51)
			if yyval51 /= Void then
				if not yyval51.is_empty then
					add_to_constraint_actual_parameter_list (ast_factory.new_constraint_labeled_comma_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyval51.first.type), yyval51)
				else
					add_to_constraint_actual_parameter_list (ast_factory.new_constraint_labeled_comma_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), Void), yyval51)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines51.force (yyvs51, yyval51, yyvsp51)
end
		end

	yy_do_action_153
			--|#line 972 "et_eiffel_parser.y"
		local
			yyval50: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM
		do
--|#line 972 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 972")
end

			yyval50 := ast_factory.new_constraint_labeled_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs54.item (yyvsp54))
			if yyval50 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp50 := yyvsp50 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp54 := yyvsp54 -1
	if yyvsp50 >= yyvsc50 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs50")
		end
		yyvsc50 := yyvsc50 + yyInitial_yyvs_size
		yyvs50 := yyspecial_routines50.aliased_resized_area (yyvs50, yyvsc50)
	end
	yyspecial_routines50.force (yyvs50, yyval50, yyvsp50)
end
		end

	yy_do_action_154
			--|#line 981 "et_eiffel_parser.y"
		local
			yyval50: detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM
		do
--|#line 981 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 981")
end

			yyval50 := ast_factory.new_constraint_labeled_actual_parameter_semicolon (ast_factory.new_constraint_labeled_actual_parameter (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs54.item (yyvsp54)), yyvs21.item (yyvsp21))
			if yyval50 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp50 := yyvsp50 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp54 := yyvsp54 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp50 >= yyvsc50 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs50")
		end
		yyvsc50 := yyvsc50 + yyInitial_yyvs_size
		yyvs50 := yyspecial_routines50.aliased_resized_area (yyvs50, yyvsc50)
	end
	yyspecial_routines50.force (yyvs50, yyval50, yyvsp50)
end
		end

	yy_do_action_155
			--|#line 992 "et_eiffel_parser.y"
		local
			yyval105: detachable ET_OBSOLETE
		do
--|#line 992 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 992")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp105 := yyvsp105 + 1
	if yyvsp105 >= yyvsc105 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs105")
		end
		yyvsc105 := yyvsc105 + yyInitial_yyvs_size
		yyvs105 := yyspecial_routines105.aliased_resized_area (yyvs105, yyvsc105)
	end
	yyspecial_routines105.force (yyvs105, yyval105, yyvsp105)
end
		end

	yy_do_action_156
			--|#line 994 "et_eiffel_parser.y"
		local
			yyval105: detachable ET_OBSOLETE
		do
--|#line 994 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 994")
end

yyval105 := ast_factory.new_obsolete_message (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp105 := yyvsp105 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp105 >= yyvsc105 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs105")
		end
		yyvsc105 := yyvsc105 + yyInitial_yyvs_size
		yyvs105 := yyspecial_routines105.aliased_resized_area (yyvs105, yyvsc105)
	end
	yyspecial_routines105.force (yyvs105, yyval105, yyvsp105)
end
		end

	yy_do_action_157
			--|#line 1000 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1000 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1000")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp108 := yyvsp108 + 1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_158
			--|#line 1002 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1002 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1002")
end

			yyval108 := yyvs108.item (yyvsp108)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_159
			--|#line 1009 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1009 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1009")
end

			if attached yyvs110.item (yyvsp110) as l_inheritance_clause then
				yyval108 := ast_factory.new_parent_clauses (counter_value + 1)
				if yyval108 /= Void then
					yyval108.put_first (l_inheritance_clause)
				end
			else
				yyval108 := ast_factory.new_parent_clauses (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp108 := yyvsp108 + 1
	yyvsp110 := yyvsp110 -1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_160
			--|#line 1020 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1020 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1020")
end

			yyval108 := yyvs108.item (yyvsp108)
			if yyval108 /= Void and attached yyvs110.item (yyvsp110) as l_inheritance_clause then
				yyval108.put_first (l_inheritance_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp108 := yyvsp108 -1
	yyvsp110 := yyvsp110 -1
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_161
			--|#line 1020 "et_eiffel_parser.y"
		local
			yyval108: detachable ET_PARENT_CLAUSE_LIST
		do
--|#line 1020 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1020")
end

			if yyvs110.item (yyvsp110) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp108 := yyvsp108 + 1
	if yyvsp108 >= yyvsc108 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs108")
		end
		yyvsc108 := yyvsc108 + yyInitial_yyvs_size
		yyvs108 := yyspecial_routines108.aliased_resized_area (yyvs108, yyvsc108)
	end
	yyspecial_routines108.force (yyvs108, yyval108, yyvsp108)
end
		end

	yy_do_action_162
			--|#line 1035 "et_eiffel_parser.y"
		local
			yyval110: detachable ET_PARENT_LIST
		do
--|#line 1035 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1035")
end

			yyval110 := ast_factory.new_parents (yyvs2.item (yyvsp2), 0)
			if yyval110 /= Void then
				yyval110.set_clients_clause (yyvs46.item (yyvsp46))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp110 := yyvsp110 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	if yyvsp110 >= yyvsc110 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs110")
		end
		yyvsc110 := yyvsc110 + yyInitial_yyvs_size
		yyvs110 := yyspecial_routines110.aliased_resized_area (yyvs110, yyvsc110)
	end
	yyspecial_routines110.force (yyvs110, yyval110, yyvsp110)
end
		end

	yy_do_action_163
			--|#line 1042 "et_eiffel_parser.y"
		local
			yyval110: detachable ET_PARENT_LIST
		do
--|#line 1042 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1042")
end

			yyval110 := yyvs110.item (yyvsp110)
			if yyval110 /= Void then
				yyval110.set_clients_clause (yyvs46.item (yyvsp46))
			end
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp110 := yyvsp110 -1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	yyspecial_routines110.force (yyvs110, yyval110, yyvsp110)
end
		end

	yy_do_action_164
			--|#line 1042 "et_eiffel_parser.y"
		local
			yyval110: detachable ET_PARENT_LIST
		do
--|#line 1042 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1042")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp110 := yyvsp110 + 1
	if yyvsp110 >= yyvsc110 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs110")
		end
		yyvsc110 := yyvsc110 + yyInitial_yyvs_size
		yyvs110 := yyspecial_routines110.aliased_resized_area (yyvs110, yyvsc110)
	end
	yyspecial_routines110.force (yyvs110, yyval110, yyvsp110)
end
		end

	yy_do_action_165
			--|#line 1058 "et_eiffel_parser.y"
		local
			yyval107: detachable ET_PARENT
		do
--|#line 1058 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1058")
end

			yyval107 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, Void, Void, Void, Void, Void)
			if yyval107 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp107 := yyvsp107 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp107 >= yyvsc107 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs107")
		end
		yyvsc107 := yyvsc107 + yyInitial_yyvs_size
		yyvs107 := yyspecial_routines107.aliased_resized_area (yyvs107, yyvsc107)
	end
	yyspecial_routines107.force (yyvs107, yyval107, yyvsp107)
end
		end

	yy_do_action_166
			--|#line 1065 "et_eiffel_parser.y"
		local
			yyval107: detachable ET_PARENT
		do
--|#line 1065 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1065")
end

			yyval107 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), yyvs118.item (yyvsp118), yyvs68.item (yyvsp68), yyvs95.item (yyvsp95 - 2), yyvs95.item (yyvsp95 - 1), yyvs95.item (yyvsp95), yyvs2.item (yyvsp2))
			if yyval107 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp107 := yyvsp107 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp118 := yyvsp118 -1
	yyvsp68 := yyvsp68 -1
	yyvsp95 := yyvsp95 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp107 >= yyvsc107 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs107")
		end
		yyvsc107 := yyvsc107 + yyInitial_yyvs_size
		yyvs107 := yyspecial_routines107.aliased_resized_area (yyvs107, yyvsc107)
	end
	yyspecial_routines107.force (yyvs107, yyval107, yyvsp107)
end
		end

	yy_do_action_167
			--|#line 1073 "et_eiffel_parser.y"
		local
			yyval107: detachable ET_PARENT
		do
--|#line 1073 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1073")
end

			yyval107 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, yyvs68.item (yyvsp68), yyvs95.item (yyvsp95 - 2), yyvs95.item (yyvsp95 - 1), yyvs95.item (yyvsp95), yyvs2.item (yyvsp2))
			if yyval107 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp107 := yyvsp107 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp68 := yyvsp68 -1
	yyvsp95 := yyvsp95 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp107 >= yyvsc107 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs107")
		end
		yyvsc107 := yyvsc107 + yyInitial_yyvs_size
		yyvs107 := yyspecial_routines107.aliased_resized_area (yyvs107, yyvsc107)
	end
	yyspecial_routines107.force (yyvs107, yyval107, yyvsp107)
end
		end

	yy_do_action_168
			--|#line 1080 "et_eiffel_parser.y"
		local
			yyval107: detachable ET_PARENT
		do
--|#line 1080 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1080")
end

			yyval107 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, Void, yyvs95.item (yyvsp95 - 2), yyvs95.item (yyvsp95 - 1), yyvs95.item (yyvsp95), yyvs2.item (yyvsp2))
			if yyval107 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp107 := yyvsp107 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp95 := yyvsp95 -3
	yyvsp2 := yyvsp2 -1
	if yyvsp107 >= yyvsc107 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs107")
		end
		yyvsc107 := yyvsc107 + yyInitial_yyvs_size
		yyvs107 := yyspecial_routines107.aliased_resized_area (yyvs107, yyvsc107)
	end
	yyspecial_routines107.force (yyvs107, yyval107, yyvsp107)
end
		end

	yy_do_action_169
			--|#line 1087 "et_eiffel_parser.y"
		local
			yyval107: detachable ET_PARENT
		do
--|#line 1087 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1087")
end

			yyval107 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, Void, Void, yyvs95.item (yyvsp95 - 1), yyvs95.item (yyvsp95), yyvs2.item (yyvsp2))
			if yyval107 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp107 := yyvsp107 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp95 := yyvsp95 -2
	yyvsp2 := yyvsp2 -1
	if yyvsp107 >= yyvsc107 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs107")
		end
		yyvsc107 := yyvsc107 + yyInitial_yyvs_size
		yyvs107 := yyspecial_routines107.aliased_resized_area (yyvs107, yyvsc107)
	end
	yyspecial_routines107.force (yyvs107, yyval107, yyvsp107)
end
		end

	yy_do_action_170
			--|#line 1094 "et_eiffel_parser.y"
		local
			yyval107: detachable ET_PARENT
		do
--|#line 1094 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1094")
end

			yyval107 := new_parent (yyvs12.item (yyvsp12), yyvs28.item (yyvsp28), Void, Void, Void, Void, yyvs95.item (yyvsp95), yyvs2.item (yyvsp2))
			if yyval107 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp107 := yyvsp107 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	yyvsp95 := yyvsp95 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp107 >= yyvsc107 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs107")
		end
		yyvsc107 := yyvsc107 + yyInitial_yyvs_size
		yyvs107 := yyspecial_routines107.aliased_resized_area (yyvs107, yyvsc107)
	end
	yyspecial_routines107.force (yyvs107, yyval107, yyvsp107)
end
		end

	yy_do_action_171
			--|#line 1103 "et_eiffel_parser.y"
		local
			yyval110: detachable ET_PARENT_LIST
		do
--|#line 1103 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1103")
end

			yyval110 := ast_factory.new_parents (last_keyword, counter_value)
			if yyval110 /= Void and attached yyvs107.item (yyvsp107) as l_parent then
				yyval110.put_first (l_parent)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp110 := yyvsp110 + 1
	yyvsp107 := yyvsp107 -1
	if yyvsp110 >= yyvsc110 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs110")
		end
		yyvsc110 := yyvsc110 + yyInitial_yyvs_size
		yyvs110 := yyspecial_routines110.aliased_resized_area (yyvs110, yyvsc110)
	end
	yyspecial_routines110.force (yyvs110, yyval110, yyvsp110)
end
		end

	yy_do_action_172
			--|#line 1110 "et_eiffel_parser.y"
		local
			yyval110: detachable ET_PARENT_LIST
		do
--|#line 1110 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1110")
end

			yyval110 := ast_factory.new_parents (last_keyword, counter_value)
			if yyval110 /= Void and attached yyvs109.item (yyvsp109) as l_parent then
				yyval110.put_first (l_parent)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp110 := yyvsp110 + 1
	yyvsp109 := yyvsp109 -1
	if yyvsp110 >= yyvsc110 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs110")
		end
		yyvsc110 := yyvsc110 + yyInitial_yyvs_size
		yyvs110 := yyspecial_routines110.aliased_resized_area (yyvs110, yyvsc110)
	end
	yyspecial_routines110.force (yyvs110, yyval110, yyvsp110)
end
		end

	yy_do_action_173
			--|#line 1117 "et_eiffel_parser.y"
		local
			yyval110: detachable ET_PARENT_LIST
		do
--|#line 1117 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1117")
end

			yyval110 := yyvs110.item (yyvsp110)
			if yyval110 /= Void and attached yyvs107.item (yyvsp107) as l_parent then
				yyval110.put_first (l_parent)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp107 := yyvsp107 -1
	yyspecial_routines110.force (yyvs110, yyval110, yyvsp110)
end
		end

	yy_do_action_174
			--|#line 1124 "et_eiffel_parser.y"
		local
			yyval110: detachable ET_PARENT_LIST
		do
--|#line 1124 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1124")
end

			yyval110 := yyvs110.item (yyvsp110)
			if yyval110 /= Void and attached yyvs109.item (yyvsp109) as l_parent then
				yyval110.put_first (l_parent)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp109 := yyvsp109 -1
	yyspecial_routines110.force (yyvs110, yyval110, yyvsp110)
end
		end

	yy_do_action_175
			--|#line 1133 "et_eiffel_parser.y"
		local
			yyval109: detachable ET_PARENT_ITEM
		do
--|#line 1133 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1133")
end

			yyval109 := ast_factory.new_parent_semicolon (yyvs107.item (yyvsp107), yyvs21.item (yyvsp21))
			if yyval109 /= Void and yyvs107.item (yyvsp107) = Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp109 := yyvsp109 + 1
	yyvsp107 := yyvsp107 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp109 >= yyvsc109 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs109")
		end
		yyvsc109 := yyvsc109 + yyInitial_yyvs_size
		yyvs109 := yyspecial_routines109.aliased_resized_area (yyvs109, yyvsc109)
	end
	yyspecial_routines109.force (yyvs109, yyval109, yyvsp109)
end
		end

	yy_do_action_176
			--|#line 1144 "et_eiffel_parser.y"
		local
			yyval118: detachable ET_RENAME_LIST
		do
--|#line 1144 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1144")
end

yyval118 := ast_factory.new_renames (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp118 := yyvsp118 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp118 >= yyvsc118 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs118")
		end
		yyvsc118 := yyvsc118 + yyInitial_yyvs_size
		yyvs118 := yyspecial_routines118.aliased_resized_area (yyvs118, yyvsc118)
	end
	yyspecial_routines118.force (yyvs118, yyval118, yyvsp118)
end
		end

	yy_do_action_177
			--|#line 1146 "et_eiffel_parser.y"
		local
			yyval118: detachable ET_RENAME_LIST
		do
--|#line 1146 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1146")
end

			yyval118 := yyvs118.item (yyvsp118)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp118 := yyvsp118 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines118.force (yyvs118, yyval118, yyvsp118)
end
		end

	yy_do_action_178
			--|#line 1146 "et_eiffel_parser.y"
		local
			yyval118: detachable ET_RENAME_LIST
		do
--|#line 1146 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1146")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp118 := yyvsp118 + 1
	if yyvsp118 >= yyvsc118 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs118")
		end
		yyvsc118 := yyvsc118 + yyInitial_yyvs_size
		yyvs118 := yyspecial_routines118.aliased_resized_area (yyvs118, yyvsc118)
	end
	yyspecial_routines118.force (yyvs118, yyval118, yyvsp118)
end
		end

	yy_do_action_179
			--|#line 1159 "et_eiffel_parser.y"
		local
			yyval118: detachable ET_RENAME_LIST
		do
--|#line 1159 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1159")
end

			yyval118 := ast_factory.new_renames (last_keyword, counter_value)
			if yyval118 /= Void and attached yyvs117.item (yyvsp117) as l_rename then
				yyval118.put_first (l_rename)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp118 := yyvsp118 + 1
	yyvsp117 := yyvsp117 -1
	if yyvsp118 >= yyvsc118 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs118")
		end
		yyvsc118 := yyvsc118 + yyInitial_yyvs_size
		yyvs118 := yyspecial_routines118.aliased_resized_area (yyvs118, yyvsc118)
	end
	yyspecial_routines118.force (yyvs118, yyval118, yyvsp118)
end
		end

	yy_do_action_180
			--|#line 1166 "et_eiffel_parser.y"
		local
			yyval118: detachable ET_RENAME_LIST
		do
--|#line 1166 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1166")
end

			yyval118 := ast_factory.new_renames (last_keyword, counter_value)
			if yyval118 /= Void and attached yyvs117.item (yyvsp117) as l_rename then
				yyval118.put_first (l_rename)
			end
				-- TODO: syntax error.
			raise_error
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp118 := yyvsp118 + 1
	yyvsp117 := yyvsp117 -1
	if yyvsp118 >= yyvsc118 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs118")
		end
		yyvsc118 := yyvsc118 + yyInitial_yyvs_size
		yyvs118 := yyspecial_routines118.aliased_resized_area (yyvs118, yyvsc118)
	end
	yyspecial_routines118.force (yyvs118, yyval118, yyvsp118)
end
		end

	yy_do_action_181
			--|#line 1175 "et_eiffel_parser.y"
		local
			yyval118: detachable ET_RENAME_LIST
		do
--|#line 1175 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1175")
end

			yyval118 := yyvs118.item (yyvsp118)
			if yyval118 /= Void and attached yyvs117.item (yyvsp117) as l_rename then
				yyval118.put_first (l_rename)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp117 := yyvsp117 -1
	yyspecial_routines118.force (yyvs118, yyval118, yyvsp118)
end
		end

	yy_do_action_182
			--|#line 1184 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_RENAME_ITEM
		do
--|#line 1184 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1184")
end

			yyval117 := ast_factory.new_rename (yyvs76.item (yyvsp76), yyvs2.item (yyvsp2), yyvs71.item (yyvsp71))
			if yyval117 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp117 := yyvsp117 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_183
			--|#line 1193 "et_eiffel_parser.y"
		local
			yyval117: detachable ET_RENAME_ITEM
		do
--|#line 1193 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1193")
end

			yyval117 := ast_factory.new_rename_comma (yyvs76.item (yyvsp76), yyvs2.item (yyvsp2), yyvs71.item (yyvsp71), yyvs5.item (yyvsp5))
			if yyval117 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp117 := yyvsp117 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp117 >= yyvsc117 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs117")
		end
		yyvsc117 := yyvsc117 + yyInitial_yyvs_size
		yyvs117 := yyspecial_routines117.aliased_resized_area (yyvs117, yyvsc117)
	end
	yyspecial_routines117.force (yyvs117, yyval117, yyvsp117)
end
		end

	yy_do_action_184
			--|#line 1204 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1204 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1204")
end

yyval68 := ast_factory.new_exports (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp68 := yyvsp68 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_185
			--|#line 1206 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1206 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1206")
end

			yyval68 := yyvs68.item (yyvsp68)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp68 := yyvsp68 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_186
			--|#line 1206 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1206 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1206")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp68 := yyvsp68 + 1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_187
			--|#line 1219 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1219 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1219")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp68 := yyvsp68 + 1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_188
			--|#line 1221 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1221 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1221")
end

yyval68 := yyvs68.item (yyvsp68) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_189
			--|#line 1225 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1225 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1225")
end

			if attached yyvs67.item (yyvsp67) as l_new_export then
				yyval68 := ast_factory.new_exports (last_keyword, counter_value + 1)
				if yyval68 /= Void then
					yyval68.put_first (l_new_export)
				end
			else
				yyval68 := ast_factory.new_exports (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp68 := yyvsp68 + 1
	yyvsp67 := yyvsp67 -1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_190
			--|#line 1236 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1236 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1236")
end

			yyval68 := yyvs68.item (yyvsp68)
			if yyval68 /= Void and attached yyvs67.item (yyvsp67) as l_new_export then
				yyval68.put_first (l_new_export)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp68 := yyvsp68 -1
	yyvsp67 := yyvsp67 -1
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_191
			--|#line 1236 "et_eiffel_parser.y"
		local
			yyval68: detachable ET_EXPORT_LIST
		do
--|#line 1236 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1236")
end

			if yyvs67.item (yyvsp67) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp68 := yyvsp68 + 1
	if yyvsp68 >= yyvsc68 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs68")
		end
		yyvsc68 := yyvsc68 + yyInitial_yyvs_size
		yyvs68 := yyspecial_routines68.aliased_resized_area (yyvs68, yyvsc68)
	end
	yyspecial_routines68.force (yyvs68, yyval68, yyvsp68)
end
		end

	yy_do_action_192
			--|#line 1251 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1251 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1251")
end

			yyval67 := ast_factory.new_all_export (yyvs46.item (yyvsp46), yyvs2.item (yyvsp2))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp67 := yyvsp67 + 1
	yyvsp46 := yyvsp46 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp67 >= yyvsc67 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs67")
		end
		yyvsc67 := yyvsc67 + yyInitial_yyvs_size
		yyvs67 := yyspecial_routines67.aliased_resized_area (yyvs67, yyvsc67)
	end
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_193
			--|#line 1255 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1255 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1255")
end

			last_export_clients := yyvs46.item (yyvsp46)
			yyval67 := ast_factory.new_feature_export (last_export_clients, 0)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp67 := yyvsp67 + 1
	yyvsp46 := yyvsp46 -1
	if yyvsp67 >= yyvsc67 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs67")
		end
		yyvsc67 := yyvsc67 + yyInitial_yyvs_size
		yyvs67 := yyspecial_routines67.aliased_resized_area (yyvs67, yyvsc67)
	end
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_194
			--|#line 1260 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1260 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1260")
end

			yyval67 := yyvs75.item (yyvsp75)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp46 := yyvsp46 -1
	yyvsp75 := yyvsp75 -1
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_195
			--|#line 1260 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1260 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1260")
end

			last_export_clients := yyvs46.item (yyvsp46)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp67 := yyvsp67 + 1
	if yyvsp67 >= yyvsc67 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs67")
		end
		yyvsc67 := yyvsc67 + yyInitial_yyvs_size
		yyvs67 := yyspecial_routines67.aliased_resized_area (yyvs67, yyvsc67)
	end
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_196
			--|#line 1270 "et_eiffel_parser.y"
		local
			yyval67: detachable ET_EXPORT
		do
--|#line 1270 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1270")
end

yyval67 := ast_factory.new_null_export (yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp67 := yyvsp67 + 1
	yyvsp21 := yyvsp21 -1
	if yyvsp67 >= yyvsc67 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs67")
		end
		yyvsc67 := yyvsc67 + yyInitial_yyvs_size
		yyvs67 := yyspecial_routines67.aliased_resized_area (yyvs67, yyvsc67)
	end
	yyspecial_routines67.force (yyvs67, yyval67, yyvsp67)
end
		end

	yy_do_action_197
			--|#line 1274 "et_eiffel_parser.y"
		local
			yyval75: detachable ET_FEATURE_EXPORT
		do
--|#line 1274 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1274")
end

			if attached yyvs76.item (yyvsp76) as l_feature_name then
				yyval75 := ast_factory.new_feature_export (last_export_clients, counter_value + 1)
				if yyval75 /= Void then
					yyval75.put_first (l_feature_name)
				end
			else
				yyval75 := ast_factory.new_feature_export (last_export_clients, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp75 := yyvsp75 + 1
	yyvsp76 := yyvsp76 -1
	if yyvsp75 >= yyvsc75 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs75")
		end
		yyvsc75 := yyvsc75 + yyInitial_yyvs_size
		yyvs75 := yyspecial_routines75.aliased_resized_area (yyvs75, yyvsc75)
	end
	yyspecial_routines75.force (yyvs75, yyval75, yyvsp75)
end
		end

	yy_do_action_198
			--|#line 1285 "et_eiffel_parser.y"
		local
			yyval75: detachable ET_FEATURE_EXPORT
		do
--|#line 1285 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1285")
end

			yyval75 := ast_factory.new_feature_export (last_export_clients, counter_value)
			if yyval75 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval75.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp75 := yyvsp75 + 1
	yyvsp77 := yyvsp77 -1
	if yyvsp75 >= yyvsc75 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs75")
		end
		yyvsc75 := yyvsc75 + yyInitial_yyvs_size
		yyvs75 := yyspecial_routines75.aliased_resized_area (yyvs75, yyvsc75)
	end
	yyspecial_routines75.force (yyvs75, yyval75, yyvsp75)
end
		end

	yy_do_action_199
			--|#line 1293 "et_eiffel_parser.y"
		local
			yyval75: detachable ET_FEATURE_EXPORT
		do
--|#line 1293 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1293")
end

			yyval75 := yyvs75.item (yyvsp75)
			if yyval75 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval75.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines75.force (yyvs75, yyval75, yyvsp75)
end
		end

	yy_do_action_200
			--|#line 1304 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1304 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1304")
end

			yyval46 := yyvs46.item (yyvsp46)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp46 := yyvsp46 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_201
			--|#line 1304 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1304 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1304")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp46 := yyvsp46 + 1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_202
			--|#line 1315 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1315 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1315")
end

yyval46 := ast_factory.new_none_clients (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp46 := yyvsp46 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_203
			--|#line 1319 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1319 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1319")
end

			yyval46 := ast_factory.new_clients (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval46 /= Void and attached yyvs45.item (yyvsp45) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp46 := yyvsp46 + 1
	yyvsp45 := yyvsp45 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_204
			--|#line 1326 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1326 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1326")
end

			yyval46 := ast_factory.new_clients (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval46 /= Void and attached yyvs45.item (yyvsp45) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp46 := yyvsp46 + 1
	yyvsp45 := yyvsp45 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_205
			--|#line 1334 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1334 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1334")
end

			yyval46 := yyvs46.item (yyvsp46)
			if yyval46 /= Void and attached yyvs45.item (yyvsp45) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp45 := yyvsp45 -1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_206
			--|#line 1341 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1341 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1341")
end

			yyval46 := yyvs46.item (yyvsp46)
			if yyval46 /= Void and attached yyvs45.item (yyvsp45) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp45 := yyvsp45 -1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_207
			--|#line 1351 "et_eiffel_parser.y"
		local
			yyval45: detachable ET_CLIENT_ITEM
		do
--|#line 1351 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1351")
end

			yyval45 := new_client (yyvs12.item (yyvsp12))
			if yyval45 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp45 := yyvsp45 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp45 >= yyvsc45 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs45")
		end
		yyvsc45 := yyvsc45 + yyInitial_yyvs_size
		yyvs45 := yyspecial_routines45.aliased_resized_area (yyvs45, yyvsc45)
	end
	yyspecial_routines45.force (yyvs45, yyval45, yyvsp45)
end
		end

	yy_do_action_208
			--|#line 1360 "et_eiffel_parser.y"
		local
			yyval45: detachable ET_CLIENT_ITEM
		do
--|#line 1360 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1360")
end

			yyval45 := new_client_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5))
			if yyval45 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp45 := yyvsp45 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp45 >= yyvsc45 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs45")
		end
		yyvsc45 := yyvsc45 + yyInitial_yyvs_size
		yyvs45 := yyspecial_routines45.aliased_resized_area (yyvs45, yyvsc45)
	end
	yyspecial_routines45.force (yyvs45, yyval45, yyvsp45)
end
		end

	yy_do_action_209
			--|#line 1370 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1370 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1370")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp46 := yyvsp46 + 1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_210
			--|#line 1372 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1372 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1372")
end

yyval46 := yyvs46.item (yyvsp46) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_211
			--|#line 1376 "et_eiffel_parser.y"
		local
			yyval46: detachable ET_CLIENTS
		do
--|#line 1376 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1376")
end

			yyval46 := ast_factory.new_clients (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 1)
			if yyval46 /= Void and attached new_client (yyvs12.item (yyvsp12)) as l_client then
				yyval46.put_first (l_client)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp46 := yyvsp46 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp46 >= yyvsc46 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs46")
		end
		yyvsc46 := yyvsc46 + yyInitial_yyvs_size
		yyvs46 := yyspecial_routines46.aliased_resized_area (yyvs46, yyvsc46)
	end
	yyspecial_routines46.force (yyvs46, yyval46, yyvsp46)
end
		end

	yy_do_action_212
			--|#line 1387 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1387 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1387")
end

yyval95 := ast_factory.new_keyword_feature_name_list (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp95 := yyvsp95 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_213
			--|#line 1389 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1389 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1389")
end

			yyval95 := yyvs95.item (yyvsp95)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp95 := yyvsp95 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_214
			--|#line 1389 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1389 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1389")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp95 := yyvsp95 + 1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_215
			--|#line 1402 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1402 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1402")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp95 := yyvsp95 + 1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_216
			--|#line 1404 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1404 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1404")
end

yyval95 := yyvs95.item (yyvsp95) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_217
			--|#line 1408 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1408 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1408")
end

yyval95 := ast_factory.new_keyword_feature_name_list (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp95 := yyvsp95 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_218
			--|#line 1410 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1410 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1410")
end

			yyval95 := yyvs95.item (yyvsp95)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp95 := yyvsp95 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_219
			--|#line 1410 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1410 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1410")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp95 := yyvsp95 + 1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_220
			--|#line 1423 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1423 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1423")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp95 := yyvsp95 + 1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_221
			--|#line 1425 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1425 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1425")
end

yyval95 := yyvs95.item (yyvsp95) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_222
			--|#line 1429 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1429 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1429")
end

yyval95 := ast_factory.new_keyword_feature_name_list (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp95 := yyvsp95 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_223
			--|#line 1431 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1431 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1431")
end

			yyval95 := yyvs95.item (yyvsp95)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp95 := yyvsp95 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_224
			--|#line 1431 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1431 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1431")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp95 := yyvsp95 + 1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_225
			--|#line 1444 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1444 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1444")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp95 := yyvsp95 + 1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_226
			--|#line 1446 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1446 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1446")
end

yyval95 := yyvs95.item (yyvsp95) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_227
			--|#line 1450 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1450 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1450")
end

			if attached yyvs76.item (yyvsp76) as l_feature_name then
				yyval95 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value + 1)
				if yyval95 /= Void then
					yyval95.put_first (l_feature_name)
				end
			else
				yyval95 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp95 := yyvsp95 + 1
	yyvsp76 := yyvsp76 -1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_228
			--|#line 1461 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1461 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1461")
end

			yyval95 := ast_factory.new_keyword_feature_name_list (last_keyword, counter_value)
			if yyval95 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval95.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp95 := yyvsp95 + 1
	yyvsp77 := yyvsp77 -1
	if yyvsp95 >= yyvsc95 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs95")
		end
		yyvsc95 := yyvsc95 + yyInitial_yyvs_size
		yyvs95 := yyspecial_routines95.aliased_resized_area (yyvs95, yyvsc95)
	end
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_229
			--|#line 1469 "et_eiffel_parser.y"
		local
			yyval95: detachable ET_KEYWORD_FEATURE_NAME_LIST
		do
--|#line 1469 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1469")
end

			yyval95 := yyvs95.item (yyvsp95)
			if yyval95 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval95.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines95.force (yyvs95, yyval95, yyvsp95)
end
		end

	yy_do_action_230
			--|#line 1478 "et_eiffel_parser.y"
		local
			yyval77: detachable ET_FEATURE_NAME_ITEM
		do
--|#line 1478 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1478")
end

			yyval77 := ast_factory.new_feature_name_comma (yyvs76.item (yyvsp76), yyvs5.item (yyvsp5))
			if yyval77 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp77 >= yyvsc77 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs77")
		end
		yyvsc77 := yyvsc77 + yyInitial_yyvs_size
		yyvs77 := yyspecial_routines77.aliased_resized_area (yyvs77, yyvsc77)
	end
	yyspecial_routines77.force (yyvs77, yyval77, yyvsp77)
end
		end

	yy_do_action_231
			--|#line 1489 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1489 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1489")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp61 := yyvsp61 + 1
	if yyvsp61 >= yyvsc61 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs61")
		end
		yyvsc61 := yyvsc61 + yyInitial_yyvs_size
		yyvs61 := yyspecial_routines61.aliased_resized_area (yyvs61, yyvsc61)
	end
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_232
			--|#line 1491 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1491 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1491")
end

			yyval61 := yyvs61.item (yyvsp61)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_233
			--|#line 1498 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1498 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1498")
end

			if attached yyvs60.item (yyvsp60) as l_creation_clause then
				yyval61 := ast_factory.new_creators (counter_value + 1)
				if yyval61 /= Void then
					yyval61.put_first (l_creation_clause)
				end
			else
				yyval61 := ast_factory.new_creators (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp61 := yyvsp61 + 1
	yyvsp60 := yyvsp60 -1
	if yyvsp61 >= yyvsc61 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs61")
		end
		yyvsc61 := yyvsc61 + yyInitial_yyvs_size
		yyvs61 := yyspecial_routines61.aliased_resized_area (yyvs61, yyvsc61)
	end
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_234
			--|#line 1509 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1509 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1509")
end

			yyval61 := yyvs61.item (yyvsp61)
			if yyval61 /= Void and attached yyvs60.item (yyvsp60) as l_creation_clause then
				yyval61.put_first (l_creation_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp61 := yyvsp61 -1
	yyvsp60 := yyvsp60 -1
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_235
			--|#line 1509 "et_eiffel_parser.y"
		local
			yyval61: detachable ET_CREATOR_LIST
		do
--|#line 1509 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1509")
end

			if yyvs60.item (yyvsp60) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp61 := yyvsp61 + 1
	if yyvsp61 >= yyvsc61 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs61")
		end
		yyvsc61 := yyvsc61 + yyInitial_yyvs_size
		yyvs61 := yyspecial_routines61.aliased_resized_area (yyvs61, yyvsc61)
	end
	yyspecial_routines61.force (yyvs61, yyval61, yyvsp61)
end
		end

	yy_do_action_236
			--|#line 1524 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1524 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1524")
end

yyval60 := ast_factory.new_creator (yyvs2.item (yyvsp2), yyvs46.item (yyvsp46), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp60 := yyvsp60 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_237
			--|#line 1526 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1526 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1526")
end

yyval60 := ast_factory.new_creator (yyvs2.item (yyvsp2), new_any_clients (yyvs2.item (yyvsp2)), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp60 := yyvsp60 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_238
			--|#line 1528 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1528 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1528")
end

			yyval60 := yyvs60.item (yyvsp60)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp60 := yyvsp60 -1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_239
			--|#line 1528 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1528 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1528")
end

			add_keyword (yyvs2.item (yyvsp2))
			last_clients := yyvs46.item (yyvsp46)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp60 := yyvsp60 + 1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_240
			--|#line 1540 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1540 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1540")
end

			yyval60 := yyvs60.item (yyvsp60)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp60 := yyvsp60 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_241
			--|#line 1540 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1540 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1540")
end

			add_keyword (yyvs2.item (yyvsp2))
			last_clients := new_any_clients (last_keyword)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp60 := yyvsp60 + 1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_242
			--|#line 1552 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1552 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1552")
end

yyval60 := ast_factory.new_creator (yyvs2.item (yyvsp2), yyvs46.item (yyvsp46), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp60 := yyvsp60 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_243
			--|#line 1554 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1554 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1554")
end

yyval60 := ast_factory.new_creator (yyvs2.item (yyvsp2), new_any_clients (yyvs2.item (yyvsp2)), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp60 := yyvsp60 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_244
			--|#line 1556 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1556 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1556")
end

			yyval60 := yyvs60.item (yyvsp60)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp60 := yyvsp60 -1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_245
			--|#line 1556 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1556 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1556")
end

			add_keyword (yyvs2.item (yyvsp2))
			last_clients := yyvs46.item (yyvsp46)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp60 := yyvsp60 + 1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_246
			--|#line 1568 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1568 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1568")
end

			yyval60 := yyvs60.item (yyvsp60)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp60 := yyvsp60 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_247
			--|#line 1568 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1568 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1568")
end

			add_keyword (yyvs2.item (yyvsp2))
			last_clients := new_any_clients (last_keyword)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp60 := yyvsp60 + 1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_248
			--|#line 1582 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1582 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1582")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval60 := ast_factory.new_creator (last_keyword, last_clients, counter_value + 1)
				if yyval60 /= Void then
					yyval60.put_first (l_identifier)
				end
			else
				yyval60 := ast_factory.new_creator (last_keyword, last_clients, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp60 := yyvsp60 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_249
			--|#line 1594 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1594 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1594")
end

			if system_processor.is_ise then
				raise_error
			else
				yyval60 := ast_factory.new_creator (last_keyword, last_clients, counter_value)
				if yyval60 /= Void and attached yyvs77.item (yyvsp77) as l_creation_procedure then
					yyval60.put_first (l_creation_procedure)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp60 := yyvsp60 + 1
	yyvsp77 := yyvsp77 -1
	if yyvsp60 >= yyvsc60 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs60")
		end
		yyvsc60 := yyvsc60 + yyInitial_yyvs_size
		yyvs60 := yyspecial_routines60.aliased_resized_area (yyvs60, yyvsc60)
	end
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_250
			--|#line 1606 "et_eiffel_parser.y"
		local
			yyval60: detachable ET_CREATOR
		do
--|#line 1606 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1606")
end

			yyval60 := yyvs60.item (yyvsp60)
			if yyval60 /= Void and attached yyvs77.item (yyvsp77) as l_creation_procedure then
				yyval60.put_first (l_creation_procedure)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines60.force (yyvs60, yyval60, yyvsp60)
end
		end

	yy_do_action_251
			--|#line 1615 "et_eiffel_parser.y"
		local
			yyval77: detachable ET_FEATURE_NAME_ITEM
		do
--|#line 1615 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1615")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval77 := ast_factory.new_feature_name_comma (l_identifier, yyvs5.item (yyvsp5))
			else
				yyval77 := ast_factory.new_feature_name_comma (Void, yyvs5.item (yyvsp5))
			end
			if yyval77 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp77 >= yyvsc77 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs77")
		end
		yyvsc77 := yyvsc77 + yyInitial_yyvs_size
		yyvs77 := yyspecial_routines77.aliased_resized_area (yyvs77, yyvsc77)
	end
	yyspecial_routines77.force (yyvs77, yyval77, yyvsp77)
end
		end

	yy_do_action_252
			--|#line 1631 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1631 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1631")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp57 := yyvsp57 + 1
	if yyvsp57 >= yyvsc57 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs57")
		end
		yyvsc57 := yyvsc57 + yyInitial_yyvs_size
		yyvs57 := yyspecial_routines57.aliased_resized_area (yyvs57, yyvsc57)
	end
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_253
			--|#line 1633 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1633 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1633")
end

yyval57 := yyvs57.item (yyvsp57) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_254
			--|#line 1637 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1637 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1637")
end

			yyval57 := yyvs57.item (yyvsp57)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp57 := yyvsp57 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_255
			--|#line 1637 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1637 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1637")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp57 := yyvsp57 + 1
	if yyvsp57 >= yyvsc57 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs57")
		end
		yyvsc57 := yyvsc57 + yyInitial_yyvs_size
		yyvs57 := yyspecial_routines57.aliased_resized_area (yyvs57, yyvsc57)
	end
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_256
			--|#line 1650 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1650 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1650")
end

			yyval57 := ast_factory.new_convert_features (last_keyword, counter_value + 1)
			if yyval57 /= Void and attached yyvs55.item (yyvsp55) as l_convert_feature then
				yyval57.put_first (l_convert_feature)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp57 := yyvsp57 + 1
	yyvsp55 := yyvsp55 -1
	if yyvsp57 >= yyvsc57 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs57")
		end
		yyvsc57 := yyvsc57 + yyInitial_yyvs_size
		yyvs57 := yyspecial_routines57.aliased_resized_area (yyvs57, yyvsc57)
	end
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_257
			--|#line 1657 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1657 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1657")
end

			yyval57 := ast_factory.new_convert_features (last_keyword, counter_value)
			if yyval57 /= Void and attached yyvs56.item (yyvsp56) as l_convert_feature then
				yyval57.put_first (l_convert_feature)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp57 := yyvsp57 + 1
	yyvsp56 := yyvsp56 -1
	if yyvsp57 >= yyvsc57 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs57")
		end
		yyvsc57 := yyvsc57 + yyInitial_yyvs_size
		yyvs57 := yyspecial_routines57.aliased_resized_area (yyvs57, yyvsc57)
	end
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_258
			--|#line 1664 "et_eiffel_parser.y"
		local
			yyval57: detachable ET_CONVERT_FEATURE_LIST
		do
--|#line 1664 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1664")
end

			yyval57 := yyvs57.item (yyvsp57)
			if yyval57 /= Void and attached yyvs56.item (yyvsp56) as l_convert_feature then
				yyval57.put_first (l_convert_feature)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp56 := yyvsp56 -1
	yyspecial_routines57.force (yyvs57, yyval57, yyvsp57)
end
		end

	yy_do_action_259
			--|#line 1673 "et_eiffel_parser.y"
		local
			yyval56: detachable ET_CONVERT_FEATURE_ITEM
		do
--|#line 1673 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1673")
end

			yyval56 := ast_factory.new_convert_feature_comma (yyvs55.item (yyvsp55), yyvs5.item (yyvsp5))
			if yyval56 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp56 := yyvsp56 + 1
	yyvsp55 := yyvsp55 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp56 >= yyvsc56 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs56")
		end
		yyvsc56 := yyvsc56 + yyInitial_yyvs_size
		yyvs56 := yyspecial_routines56.aliased_resized_area (yyvs56, yyvsc56)
	end
	yyspecial_routines56.force (yyvs56, yyval56, yyvsp56)
end
		end

	yy_do_action_260
			--|#line 1682 "et_eiffel_parser.y"
		local
			yyval55: detachable ET_CONVERT_FEATURE
		do
--|#line 1682 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1682")
end

			yyval55 := ast_factory.new_convert_function (yyvs76.item (yyvsp76), yyvs5.item (yyvsp5), yyvs127.item (yyvsp127))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp55 := yyvsp55 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp5 := yyvsp5 -1
	yyvsp127 := yyvsp127 -1
	if yyvsp55 >= yyvsc55 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs55")
		end
		yyvsc55 := yyvsc55 + yyInitial_yyvs_size
		yyvs55 := yyspecial_routines55.aliased_resized_area (yyvs55, yyvsc55)
	end
	yyspecial_routines55.force (yyvs55, yyval55, yyvsp55)
end
		end

	yy_do_action_261
			--|#line 1686 "et_eiffel_parser.y"
		local
			yyval55: detachable ET_CONVERT_FEATURE
		do
--|#line 1686 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1686")
end

			yyval55 := ast_factory.new_convert_procedure (yyvs76.item (yyvsp76), yyvs5.item (yyvsp5 - 1), yyvs127.item (yyvsp127), yyvs5.item (yyvsp5))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp55 := yyvsp55 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp5 := yyvsp5 -2
	yyvsp127 := yyvsp127 -1
	if yyvsp55 >= yyvsc55 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs55")
		end
		yyvsc55 := yyvsc55 + yyInitial_yyvs_size
		yyvs55 := yyspecial_routines55.aliased_resized_area (yyvs55, yyvsc55)
	end
	yyspecial_routines55.force (yyvs55, yyval55, yyvsp55)
end
		end

	yy_do_action_262
			--|#line 1692 "et_eiffel_parser.y"
		local
			yyval127: detachable ET_TYPE_LIST
		do
--|#line 1692 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1692")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp127 := yyvsp127 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp127 >= yyvsc127 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs127")
		end
		yyvsc127 := yyvsc127 + yyInitial_yyvs_size
		yyvs127 := yyspecial_routines127.aliased_resized_area (yyvs127, yyvsc127)
	end
	yyspecial_routines127.force (yyvs127, yyval127, yyvsp127)
end
		end

	yy_do_action_263
			--|#line 1694 "et_eiffel_parser.y"
		local
			yyval127: detachable ET_TYPE_LIST
		do
--|#line 1694 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1694")
end

			yyval127 := yyvs127.item (yyvsp127)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp127 := yyvsp127 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines127.force (yyvs127, yyval127, yyvsp127)
end
		end

	yy_do_action_264
			--|#line 1694 "et_eiffel_parser.y"
		local
			yyval127: detachable ET_TYPE_LIST
		do
--|#line 1694 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1694")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp127 := yyvsp127 + 1
	if yyvsp127 >= yyvsc127 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs127")
		end
		yyvsc127 := yyvsc127 + yyInitial_yyvs_size
		yyvs127 := yyspecial_routines127.aliased_resized_area (yyvs127, yyvsc127)
	end
	yyspecial_routines127.force (yyvs127, yyval127, yyvsp127)
end
		end

	yy_do_action_265
			--|#line 1707 "et_eiffel_parser.y"
		local
			yyval127: detachable ET_TYPE_LIST
		do
--|#line 1707 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1707")
end

			if attached yyvs122.item (yyvsp122) as l_convert_type then
				yyval127 := ast_factory.new_convert_types (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval127 /= Void then
					yyval127.put_first (l_convert_type)
				end
			else
				yyval127 := ast_factory.new_convert_types (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp127 := yyvsp127 + 1
	yyvsp122 := yyvsp122 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp127 >= yyvsc127 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs127")
		end
		yyvsc127 := yyvsc127 + yyInitial_yyvs_size
		yyvs127 := yyspecial_routines127.aliased_resized_area (yyvs127, yyvsc127)
	end
	yyspecial_routines127.force (yyvs127, yyval127, yyvsp127)
end
		end

	yy_do_action_266
			--|#line 1718 "et_eiffel_parser.y"
		local
			yyval127: detachable ET_TYPE_LIST
		do
--|#line 1718 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1718")
end

			yyval127 := yyvs127.item (yyvsp127)
			if yyval127 /= Void and attached yyvs126.item (yyvsp126) as l_convert_type then
				yyval127.put_first (l_convert_type)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp126 := yyvsp126 -1
	yyspecial_routines127.force (yyvs127, yyval127, yyvsp127)
end
		end

	yy_do_action_267
			--|#line 1727 "et_eiffel_parser.y"
		local
			yyval126: detachable ET_TYPE_ITEM
		do
--|#line 1727 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1727")
end

			yyval126 := ast_factory.new_type_comma (yyvs122.item (yyvsp122), yyvs5.item (yyvsp5))
			if yyval126 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp126 := yyvsp126 + 1
	yyvsp122 := yyvsp122 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp126 >= yyvsc126 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs126")
		end
		yyvsc126 := yyvsc126 + yyInitial_yyvs_size
		yyvs126 := yyspecial_routines126.aliased_resized_area (yyvs126, yyvsc126)
	end
	yyspecial_routines126.force (yyvs126, yyval126, yyvsp126)
end
		end

	yy_do_action_268
			--|#line 1738 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1738 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1738")
end

			-- $$ := Void
			set_class_features
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp74 := yyvsp74 + 1
	if yyvsp74 >= yyvsc74 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs74")
		end
		yyvsc74 := yyvsc74 + yyInitial_yyvs_size
		yyvs74 := yyspecial_routines74.aliased_resized_area (yyvs74, yyvsc74)
	end
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_269
			--|#line 1743 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1743 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1743")
end

yyval74 := yyvs74.item (yyvsp74) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_270
			--|#line 1747 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1747 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1747")
end

			yyval74 := yyvs74.item (yyvsp74)
			set_class_features
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_271
			--|#line 1755 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1755 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1755")
end

			yyval74 := ast_factory.new_feature_clauses (counter_value)
			if yyval74 /= Void and attached yyvs73.item (yyvsp73) as l_feature_clause then
				yyval74.put_first (l_feature_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp74 := yyvsp74 + 1
	yyvsp73 := yyvsp73 -1
	if yyvsp74 >= yyvsc74 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs74")
		end
		yyvsc74 := yyvsc74 + yyInitial_yyvs_size
		yyvs74 := yyspecial_routines74.aliased_resized_area (yyvs74, yyvsc74)
	end
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_272
			--|#line 1762 "et_eiffel_parser.y"
		local
			yyval74: detachable ET_FEATURE_CLAUSE_LIST
		do
--|#line 1762 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1762")
end

			yyval74 := yyvs74.item (yyvsp74)
			if yyval74 /= Void and attached yyvs73.item (yyvsp73) as l_feature_clause then
				yyval74.put_first (l_feature_clause)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp73 := yyvsp73 -1
	yyspecial_routines74.force (yyvs74, yyval74, yyvsp74)
end
		end

	yy_do_action_273
			--|#line 1771 "et_eiffel_parser.y"
		local
			yyval73: detachable ET_FEATURE_CLAUSE
		do
--|#line 1771 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1771")
end

			yyval73 := last_feature_clause
			if yyval73 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines73.force (yyvs73, yyval73, yyvsp73)
end
		end

	yy_do_action_274
			--|#line 1778 "et_eiffel_parser.y"
		local
			yyval73: detachable ET_FEATURE_CLAUSE
		do
--|#line 1778 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1778")
end

			yyval73 := last_feature_clause
			if yyval73 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines73.force (yyvs73, yyval73, yyvsp73)
end
		end

	yy_do_action_275
			--|#line 1787 "et_eiffel_parser.y"
		local
			yyval73: detachable ET_FEATURE_CLAUSE
		do
--|#line 1787 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1787")
end

			last_clients := yyvs46.item (yyvsp46)
			last_feature_clause := ast_factory.new_feature_clause (yyvs2.item (yyvsp2), last_clients)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp73 := yyvsp73 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp46 := yyvsp46 -1
	if yyvsp73 >= yyvsc73 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs73")
		end
		yyvsc73 := yyvsc73 + yyInitial_yyvs_size
		yyvs73 := yyspecial_routines73.aliased_resized_area (yyvs73, yyvsc73)
	end
	yyspecial_routines73.force (yyvs73, yyval73, yyvsp73)
end
		end

	yy_do_action_276
			--|#line 1792 "et_eiffel_parser.y"
		local
			yyval73: detachable ET_FEATURE_CLAUSE
		do
--|#line 1792 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1792")
end

			last_clients := new_any_clients (yyvs2.item (yyvsp2))
			last_feature_clause := ast_factory.new_feature_clause (yyvs2.item (yyvsp2), last_clients)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp73 := yyvsp73 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp73 >= yyvsc73 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs73")
		end
		yyvsc73 := yyvsc73 + yyInitial_yyvs_size
		yyvs73 := yyspecial_routines73.aliased_resized_area (yyvs73, yyvsc73)
	end
	yyspecial_routines73.force (yyvs73, yyval73, yyvsp73)
end
		end

	yy_do_action_277
			--|#line 1799 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 1799 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1799")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp116 := yyvsp116 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_278
			--|#line 1800 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 1800 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1800")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp113 := yyvsp113 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_279
			--|#line 1801 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 1801 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1801")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp116 := yyvsp116 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_280
			--|#line 1802 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 1802 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1802")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp113 := yyvsp113 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_281
			--|#line 1807 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1807 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1807")
end

			yyval116 := yyvs116.item (yyvsp116)
			register_query (yyval116)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_282
			--|#line 1812 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1812 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1812")
end

			yyval116 := yyvs116.item (yyvsp116)
			if yyval116 /= Void then
				yyval116.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_query (yyval116)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_283
			--|#line 1820 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1820 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1820")
end

			yyval116 := new_query_synonym (ast_factory.new_extended_feature_name_comma (yyvs71.item (yyvsp71), yyvs5.item (yyvsp5)), yyvs116.item (yyvsp116))
			register_query_synonym (yyval116)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_284
			--|#line 1825 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1825 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1825")
end

			yyval116 := new_query_synonym (yyvs71.item (yyvsp71), yyvs116.item (yyvsp116))
			register_query_synonym (yyval116)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp71 := yyvsp71 -1
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_285
			--|#line 1831 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1831 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1831")
end

			yyval116 := new_query_synonym (ast_factory.new_extended_feature_name_comma (yyvs71.item (yyvsp71), yyvs5.item (yyvsp5)), yyvs116.item (yyvsp116))
			if yyval116 /= Void then
				yyval116.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_query_synonym (yyval116)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_286
			--|#line 1839 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1839 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1839")
end

			yyval116 := new_query_synonym (yyvs71.item (yyvsp71), yyvs116.item (yyvsp116))
			if yyval116 /= Void then
				yyval116.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_query_synonym (yyval116)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_287
			--|#line 1850 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 1850 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1850")
end

			yyval113 := yyvs113.item (yyvsp113)
			register_procedure (yyval113)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_288
			--|#line 1855 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 1855 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1855")
end

			yyval113 := yyvs113.item (yyvsp113)
			if yyval113 /= Void then
				yyval113.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_procedure (yyval113)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_289
			--|#line 1863 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 1863 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1863")
end

			yyval113 := new_procedure_synonym (ast_factory.new_extended_feature_name_comma (yyvs71.item (yyvsp71), yyvs5.item (yyvsp5)), yyvs113.item (yyvsp113))
			register_procedure_synonym (yyval113)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_290
			--|#line 1868 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 1868 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1868")
end

			yyval113 := new_procedure_synonym (yyvs71.item (yyvsp71), yyvs113.item (yyvsp113))
			register_procedure_synonym (yyval113)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp71 := yyvsp71 -1
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_291
			--|#line 1874 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 1874 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1874")
end

			yyval113 := new_procedure_synonym (ast_factory.new_extended_feature_name_comma (yyvs71.item (yyvsp71), yyvs5.item (yyvsp5)), yyvs113.item (yyvsp113))
			if yyval113 /= Void then
				yyval113.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_procedure_synonym (yyval113)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_292
			--|#line 1882 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 1882 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1882")
end

			yyval113 := new_procedure_synonym (yyvs71.item (yyvsp71), yyvs113.item (yyvsp113))
			if yyval113 /= Void then
				yyval113.set_frozen_keyword (yyvs2.item (yyvsp2))
				register_procedure_synonym (yyval113)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp71 := yyvsp71 -1
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_293
			--|#line 1893 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1893 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1893")
end

yyval116 := ast_factory.new_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_294
			--|#line 1895 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1895 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1895")
end

yyval116 := ast_factory.new_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_295
			--|#line 1897 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1897 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1897")
end

			yyval116 := ast_factory.new_extended_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_296
			--|#line 1901 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1901 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1901")
end

yyval116 := ast_factory.new_constant_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2), yyvs49.item (yyvsp49), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -1
	yyvsp49 := yyvsp49 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_297
			--|#line 1903 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1903 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1903")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := ast_factory.new_constant_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs5.item (yyvsp5), yyvs49.item (yyvsp49), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp49 := yyvsp49 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_298
			--|#line 1911 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1911 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1911")
end

yyval116 := ast_factory.new_unique_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -2
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_299
			--|#line 1913 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1913 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1913")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := ast_factory.new_unique_attribute (yyvs71.item (yyvsp71), ast_factory.new_colon_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs5.item (yyvsp5), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_300
			--|#line 1921 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1921 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1921")
end

yyval116 := ast_factory.new_do_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 1), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -2
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_301
			--|#line 1924 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1924 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1924")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := ast_factory.new_do_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_302
			--|#line 1933 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1933 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1933")
end

yyval116 := ast_factory.new_do_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 1), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 15
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -2
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_303
			--|#line 1937 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1937 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1937")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := ast_factory.new_do_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_304
			--|#line 1947 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1947 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1947")
end

yyval116 := ast_factory.new_once_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 16
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_305
			--|#line 1950 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1950 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1950")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := ast_factory.new_once_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 15
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp2 := yyvsp2 -2
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_306
			--|#line 1959 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1959 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1959")
end

yyval116 := ast_factory.new_once_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 17
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_307
			--|#line 1963 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1963 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1963")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := ast_factory.new_once_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 16
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp2 := yyvsp2 -2
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_308
			--|#line 1973 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1973 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1973")
end

yyval116 := ast_factory.new_deferred_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2 - 1), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_309
			--|#line 1975 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1975 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1975")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := ast_factory.new_deferred_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2 - 1), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 11
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_310
			--|#line 1983 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1983 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1983")
end

yyval116 := ast_factory.new_deferred_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2 - 1), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_311
			--|#line 1986 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1986 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1986")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := ast_factory.new_deferred_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2 - 1), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_312
			--|#line 1995 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1995 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1995")
end

yyval116 := new_external_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_313
			--|#line 1998 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 1998 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 1998")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := new_external_function (yyvs71.item (yyvsp71), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_314
			--|#line 2007 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 2007 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2007")
end

yyval116 := new_external_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 15
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_315
			--|#line 2011 "et_eiffel_parser.y"
		local
			yyval116: detachable ET_QUERY
		do
--|#line 2011 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2011")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval116 := new_external_function (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs35.item (yyvsp35), Void, yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp116 := yyvsp116 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp35 := yyvsp35 -1
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp116 >= yyvsc116 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs116")
		end
		yyvsc116 := yyvsc116 + yyInitial_yyvs_size
		yyvs116 := yyspecial_routines116.aliased_resized_area (yyvs116, yyvsc116)
	end
	yyspecial_routines116.force (yyvs116, yyval116, yyvsp116)
end
		end

	yy_do_action_316
			--|#line 2023 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 2023 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2023")
end

yyval113 := ast_factory.new_do_procedure (yyvs71.item (yyvsp71), Void, yyvs2.item (yyvsp2 - 1), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 11
	yyvsp113 := yyvsp113 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp2 := yyvsp2 -2
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_317
			--|#line 2026 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 2026 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2026")
end

yyval113 := ast_factory.new_do_procedure (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), yyvs2.item (yyvsp2 - 1), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp113 := yyvsp113 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp2 := yyvsp2 -2
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_318
			--|#line 2030 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 2030 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2030")
end

yyval113 := ast_factory.new_once_procedure (yyvs71.item (yyvsp71), Void, yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 13
	yyvsp113 := yyvsp113 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_319
			--|#line 2033 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 2033 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2033")
end

yyval113 := ast_factory.new_once_procedure (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 14
	yyvsp113 := yyvsp113 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_320
			--|#line 2037 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 2037 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2037")
end

yyval113 := ast_factory.new_deferred_procedure (yyvs71.item (yyvsp71), Void, yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2 - 1), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 9
	yyvsp113 := yyvsp113 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_321
			--|#line 2039 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 2039 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2039")
end

yyval113 := ast_factory.new_deferred_procedure (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), yyvs2.item (yyvsp2 - 1), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp113 := yyvsp113 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_322
			--|#line 2042 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 2042 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2042")
end

yyval113 := new_external_procedure (yyvs71.item (yyvsp71), Void, yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 11
	yyvsp113 := yyvsp113 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_323
			--|#line 2045 "et_eiffel_parser.y"
		local
			yyval113: detachable ET_PROCEDURE
		do
--|#line 2045 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2045")
end

yyval113 := new_external_procedure (yyvs71.item (yyvsp71), yyvs80.item (yyvsp80), yyvs2.item (yyvsp2 - 2), yyvs86.item (yyvsp86), yyvs105.item (yyvsp105), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), yyvs21.item (yyvsp21), last_clients, last_feature_clause, last_class) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp113 := yyvsp113 + 1
	yyvsp71 := yyvsp71 -1
	yyvsp80 := yyvsp80 -1
	yyvsp2 := yyvsp2 -3
	yyvsp86 := yyvsp86 -1
	yyvsp105 := yyvsp105 -1
	yyvsp112 := yyvsp112 -1
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp113 >= yyvsc113 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs113")
		end
		yyvsc113 := yyvsc113 + yyInitial_yyvs_size
		yyvs113 := yyspecial_routines113.aliased_resized_area (yyvs113, yyvsc113)
	end
	yyspecial_routines113.force (yyvs113, yyval113, yyvsp113)
end
		end

	yy_do_action_324
			--|#line 2051 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 2051 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2051")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval2 := Void
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_325
			--|#line 2059 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 2059 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2059")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_326
			--|#line 2063 "et_eiffel_parser.y"
		local
			yyval21: detachable ET_SEMICOLON_SYMBOL
		do
--|#line 2063 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2063")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp21 := yyvsp21 + 1
	if yyvsp21 >= yyvsc21 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs21")
		end
		yyvsc21 := yyvsc21 + yyInitial_yyvs_size
		yyvs21 := yyspecial_routines21.aliased_resized_area (yyvs21, yyvsc21)
	end
	yyspecial_routines21.force (yyvs21, yyval21, yyvsp21)
end
		end

	yy_do_action_327
			--|#line 2065 "et_eiffel_parser.y"
		local
			yyval21: detachable ET_SEMICOLON_SYMBOL
		do
--|#line 2065 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2065")
end

yyval21 := yyvs21.item (yyvsp21) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines21.force (yyvs21, yyval21, yyvsp21)
end
		end

	yy_do_action_328
			--|#line 2069 "et_eiffel_parser.y"
		local
			yyval72: detachable ET_EXTERNAL_ALIAS
		do
--|#line 2069 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2069")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp72 := yyvsp72 + 1
	if yyvsp72 >= yyvsc72 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs72")
		end
		yyvsc72 := yyvsc72 + yyInitial_yyvs_size
		yyvs72 := yyspecial_routines72.aliased_resized_area (yyvs72, yyvsc72)
	end
	yyspecial_routines72.force (yyvs72, yyval72, yyvsp72)
end
		end

	yy_do_action_329
			--|#line 2071 "et_eiffel_parser.y"
		local
			yyval72: detachable ET_EXTERNAL_ALIAS
		do
--|#line 2071 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2071")
end

yyval72 := ast_factory.new_external_alias (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp72 := yyvsp72 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp72 >= yyvsc72 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs72")
		end
		yyvsc72 := yyvsc72 + yyInitial_yyvs_size
		yyvs72 := yyspecial_routines72.aliased_resized_area (yyvs72, yyvsc72)
	end
	yyspecial_routines72.force (yyvs72, yyval72, yyvsp72)
end
		end

	yy_do_action_330
			--|#line 2075 "et_eiffel_parser.y"
		local
			yyval35: detachable ET_ASSIGNER
		do
--|#line 2075 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2075")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp35 := yyvsp35 + 1
	if yyvsp35 >= yyvsc35 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs35")
		end
		yyvsc35 := yyvsc35 + yyInitial_yyvs_size
		yyvs35 := yyspecial_routines35.aliased_resized_area (yyvs35, yyvsc35)
	end
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
		end

	yy_do_action_331
			--|#line 2077 "et_eiffel_parser.y"
		local
			yyval35: detachable ET_ASSIGNER
		do
--|#line 2077 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2077")
end

yyval35 := ast_factory.new_assigner (yyvs2.item (yyvsp2), yyvs76.item (yyvsp76)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp35 := yyvsp35 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp76 := yyvsp76 -1
	if yyvsp35 >= yyvsc35 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs35")
		end
		yyvsc35 := yyvsc35 + yyInitial_yyvs_size
		yyvs35 := yyspecial_routines35.aliased_resized_area (yyvs35, yyvsc35)
	end
	yyspecial_routines35.force (yyvs35, yyval35, yyvsp35)
end
		end

	yy_do_action_332
			--|#line 2083 "et_eiffel_parser.y"
		local
			yyval76: detachable ET_FEATURE_NAME
		do
--|#line 2083 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2083")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval76 := l_identifier 
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp76 := yyvsp76 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp76 >= yyvsc76 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs76")
		end
		yyvsc76 := yyvsc76 + yyInitial_yyvs_size
		yyvs76 := yyspecial_routines76.aliased_resized_area (yyvs76, yyvsc76)
	end
	yyspecial_routines76.force (yyvs76, yyval76, yyvsp76)
end
		end

	yy_do_action_333
			--|#line 2092 "et_eiffel_parser.y"
		local
			yyval71: detachable ET_EXTENDED_FEATURE_NAME
		do
--|#line 2092 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2092")
end

yyval71 := yyvs76.item (yyvsp76) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp71 := yyvsp71 + 1
	yyvsp76 := yyvsp76 -1
	if yyvsp71 >= yyvsc71 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs71")
		end
		yyvsc71 := yyvsc71 + yyInitial_yyvs_size
		yyvs71 := yyspecial_routines71.aliased_resized_area (yyvs71, yyvsc71)
	end
	yyspecial_routines71.force (yyvs71, yyval71, yyvsp71)
end
		end

	yy_do_action_334
			--|#line 2094 "et_eiffel_parser.y"
		local
			yyval71: detachable ET_EXTENDED_FEATURE_NAME
		do
--|#line 2094 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2094")
end

			if attached yyvs12.item (yyvsp12) as l_identifier then
				l_identifier.set_feature_name (True)
				yyval71 := ast_factory.new_aliased_feature_name (l_identifier, yyvs34.item (yyvsp34))
			else
				yyval71 := ast_factory.new_aliased_feature_name (Void, yyvs34.item (yyvsp34))
			end
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp71 := yyvsp71 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp1 := yyvsp1 -1
	yyvsp34 := yyvsp34 -1
	if yyvsp71 >= yyvsc71 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs71")
		end
		yyvsc71 := yyvsc71 + yyInitial_yyvs_size
		yyvs71 := yyspecial_routines71.aliased_resized_area (yyvs71, yyvsc71)
	end
	yyspecial_routines71.force (yyvs71, yyval71, yyvsp71)
end
		end

	yy_do_action_335
			--|#line 2106 "et_eiffel_parser.y"
		local
			yyval34: detachable ET_ALIAS_NAME_LIST
		do
--|#line 2106 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2106")
end

			if attached yyvs33.item (yyvsp33) as l_alias_name then
				yyval34 := ast_factory.new_alias_name_list (counter_value + 1)
				if yyval34 /= Void then
					yyval34.put_first (l_alias_name)
				end
			else
				yyval34 := ast_factory.new_alias_name_list (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp34 := yyvsp34 + 1
	yyvsp33 := yyvsp33 -1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
		end

	yy_do_action_336
			--|#line 2117 "et_eiffel_parser.y"
		local
			yyval34: detachable ET_ALIAS_NAME_LIST
		do
--|#line 2117 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2117")
end

			yyval34 := yyvs34.item (yyvsp34)
			if yyval34 /= Void and attached yyvs33.item (yyvsp33) as l_alias_name then
				yyval34.put_first (l_alias_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp34 := yyvsp34 -1
	yyvsp33 := yyvsp33 -1
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
		end

	yy_do_action_337
			--|#line 2117 "et_eiffel_parser.y"
		local
			yyval34: detachable ET_ALIAS_NAME_LIST
		do
--|#line 2117 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2117")
end

			if yyvs33.item (yyvsp33) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp34 := yyvsp34 + 1
	if yyvsp34 >= yyvsc34 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs34")
		end
		yyvsc34 := yyvsc34 + yyInitial_yyvs_size
		yyvs34 := yyspecial_routines34.aliased_resized_area (yyvs34, yyvsc34)
	end
	yyspecial_routines34.force (yyvs34, yyval34, yyvsp34)
end
		end

	yy_do_action_338
			--|#line 2132 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2132 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2132")
end

yyval33 := ast_factory.new_alias_not_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_339
			--|#line 2134 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2134 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2134")
end

yyval33 := ast_factory.new_alias_plus_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_340
			--|#line 2136 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2136 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2136")
end

yyval33 := ast_factory.new_alias_minus_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_341
			--|#line 2138 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2138 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2138")
end

yyval33 := ast_factory.new_alias_times_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_342
			--|#line 2140 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2140 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2140")
end

yyval33 := ast_factory.new_alias_divide_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_343
			--|#line 2142 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2142 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2142")
end

yyval33 := ast_factory.new_alias_div_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_344
			--|#line 2144 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2144 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2144")
end

yyval33 := ast_factory.new_alias_mod_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_345
			--|#line 2146 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2146 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2146")
end

yyval33 := ast_factory.new_alias_power_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_346
			--|#line 2148 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2148 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2148")
end

yyval33 := ast_factory.new_alias_lt_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_347
			--|#line 2150 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2150 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2150")
end

yyval33 := ast_factory.new_alias_le_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_348
			--|#line 2152 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2152 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2152")
end

yyval33 := ast_factory.new_alias_gt_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_349
			--|#line 2154 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2154 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2154")
end

yyval33 := ast_factory.new_alias_ge_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_350
			--|#line 2156 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2156 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2156")
end

yyval33 := ast_factory.new_alias_and_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_351
			--|#line 2158 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2158 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2158")
end

yyval33 := ast_factory.new_alias_and_then_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_352
			--|#line 2160 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2160 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2160")
end

yyval33 := ast_factory.new_alias_or_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_353
			--|#line 2162 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2162 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2162")
end

yyval33 := ast_factory.new_alias_or_else_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_354
			--|#line 2164 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2164 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2164")
end

yyval33 := ast_factory.new_alias_implies_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_355
			--|#line 2166 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2166 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2166")
end

yyval33 := ast_factory.new_alias_xor_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_356
			--|#line 2168 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2168 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2168")
end

yyval33 := ast_factory.new_alias_dotdot_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_357
			--|#line 2170 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2170 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2170")
end

yyval33 := ast_factory.new_alias_free_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_358
			--|#line 2172 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2172 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2172")
end

yyval33 := ast_factory.new_alias_bracket_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_359
			--|#line 2174 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2174 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2174")
end

yyval33 := ast_factory.new_alias_parenthesis_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_360
			--|#line 2176 "et_eiffel_parser.y"
		local
			yyval33: detachable ET_ALIAS_NAME
		do
--|#line 2176 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2176")
end

yyval33 := new_invalid_alias_name (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp33 := yyvsp33 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	if yyvsp33 >= yyvsc33 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs33")
		end
		yyvsc33 := yyvsc33 + yyInitial_yyvs_size
		yyvs33 := yyspecial_routines33.aliased_resized_area (yyvs33, yyvsc33)
	end
	yyspecial_routines33.force (yyvs33, yyval33, yyvsp33)
end
		end

	yy_do_action_361
			--|#line 2180 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 2180 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2180")
end

yyval2 := Void 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp2 := yyvsp2 + 1
	if yyvsp2 >= yyvsc2 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs2")
		end
		yyvsc2 := yyvsc2 + yyInitial_yyvs_size
		yyvs2 := yyspecial_routines2.aliased_resized_area (yyvs2, yyvsc2)
	end
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_362
			--|#line 2182 "et_eiffel_parser.y"
		local
			yyval2: detachable ET_KEYWORD
		do
--|#line 2182 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2182")
end

yyval2 := yyvs2.item (yyvsp2) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines2.force (yyvs2, yyval2, yyvsp2)
end
		end

	yy_do_action_363
			--|#line 2188 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2188 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2188")
end

			yyval80 := yyvs80.item (yyvsp80)
			set_start_closure (yyval80)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_364
			--|#line 2195 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2195 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2195")
end

yyval80 := new_formal_arguments (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp80 := yyvsp80 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp80 >= yyvsc80 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs80")
		end
		yyvsc80 := yyvsc80 + yyInitial_yyvs_size
		yyvs80 := yyspecial_routines80.aliased_resized_area (yyvs80, yyvsc80)
	end
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_365
			--|#line 2197 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2197 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2197")
end

			yyval80 := yyvs80.item (yyvsp80)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp5 := yyvsp5 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_366
			--|#line 2205 "et_eiffel_parser.y"
		local
			yyval5: detachable ET_SYMBOL
		do
--|#line 2205 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2205")
end

			-- Needed to solve ambiguity when parsing:
			--   agent (a).f
			--   agent (a: A) do ... end
			yyval5 := yyvs5.item (yyvsp5)
			add_symbol (yyval5)
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines5.force (yyvs5, yyval5, yyvsp5)
end
		end

	yy_do_action_367
			--|#line 2216 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2216 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2216")
end

			yyval80 := new_formal_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval80 /= Void and attached yyvs79.item (yyvsp79) as l_formal_argument then
				yyval80.put_first (l_formal_argument)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp80 := yyvsp80 + 1
	yyvsp79 := yyvsp79 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp80 >= yyvsc80 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs80")
		end
		yyvsc80 := yyvsc80 + yyInitial_yyvs_size
		yyvs80 := yyspecial_routines80.aliased_resized_area (yyvs80, yyvsc80)
	end
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_368
			--|#line 2223 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2223 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2223")
end

			yyval80 := new_formal_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval80 /= Void and attached yyvs79.item (yyvsp79) as l_formal_argument then
				yyval80.put_first (l_formal_argument)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp80 := yyvsp80 + 1
	yyvsp79 := yyvsp79 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp80 >= yyvsc80 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs80")
		end
		yyvsc80 := yyvsc80 + yyInitial_yyvs_size
		yyvs80 := yyspecial_routines80.aliased_resized_area (yyvs80, yyvsc80)
	end
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_369
			--|#line 2230 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2230 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2230")
end

			yyval80 := yyvs80.item (yyvsp80)
			if yyval80 /= Void and attached yyvs78.item (yyvsp78) as l_formal_argument then
				if not yyval80.is_empty then
					l_formal_argument.set_declared_type (yyval80.first.type)
					yyval80.put_first (l_formal_argument)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp78 := yyvsp78 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_370
			--|#line 2240 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2240 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2240")
end

			-- TODO: Syntax error
			yyval80 := yyvs80.item (yyvsp80)
			if yyval80 /= Void and attached yyvs78.item (yyvsp78) as l_formal_argument then
				if not yyval80.is_empty then
					l_formal_argument.set_declared_type (yyval80.first.type)
					yyval80.put_first (l_formal_argument)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp78 := yyvsp78 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_371
			--|#line 2251 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2251 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2251")
end

			yyval80 := yyvs80.item (yyvsp80)
			if yyval80 /= Void and attached yyvs79.item (yyvsp79) as l_formal_argument then
				yyval80.put_first (l_formal_argument)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp79 := yyvsp79 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_372
			--|#line 2258 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 2258 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2258")
end

			yyval80 := yyvs80.item (yyvsp80)
			if yyval80 /= Void and attached yyvs79.item (yyvsp79) as l_formal_argument then
				yyval80.put_first (l_formal_argument)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp79 := yyvsp79 -1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_373
			--|#line 2267 "et_eiffel_parser.y"
		local
			yyval78: detachable ET_FORMAL_ARGUMENT
		do
--|#line 2267 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2267")
end

			yyval78 := ast_factory.new_formal_comma_argument (ast_factory.new_argument_name_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), dummy_type)
			if yyval78 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp78 := yyvsp78 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp78 >= yyvsc78 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs78")
		end
		yyvsc78 := yyvsc78 + yyInitial_yyvs_size
		yyvs78 := yyspecial_routines78.aliased_resized_area (yyvs78, yyvsc78)
	end
	yyspecial_routines78.force (yyvs78, yyval78, yyvsp78)
end
		end

	yy_do_action_374
			--|#line 2276 "et_eiffel_parser.y"
		local
			yyval78: detachable ET_FORMAL_ARGUMENT
		do
--|#line 2276 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2276")
end

			yyval78 := ast_factory.new_formal_comma_argument (yyvs12.item (yyvsp12), dummy_type)
			if yyval78 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp78 := yyvsp78 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp78 >= yyvsc78 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs78")
		end
		yyvsc78 := yyvsc78 + yyInitial_yyvs_size
		yyvs78 := yyspecial_routines78.aliased_resized_area (yyvs78, yyvsc78)
	end
	yyspecial_routines78.force (yyvs78, yyval78, yyvsp78)
end
		end

	yy_do_action_375
			--|#line 2285 "et_eiffel_parser.y"
		local
			yyval79: detachable ET_FORMAL_ARGUMENT_ITEM
		do
--|#line 2285 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2285")
end

			yyval79 := ast_factory.new_formal_argument (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)))
			if yyval79 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp79 := yyvsp79 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	if yyvsp79 >= yyvsc79 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs79")
		end
		yyvsc79 := yyvsc79 + yyInitial_yyvs_size
		yyvs79 := yyspecial_routines79.aliased_resized_area (yyvs79, yyvsc79)
	end
	yyspecial_routines79.force (yyvs79, yyval79, yyvsp79)
end
		end

	yy_do_action_376
			--|#line 2294 "et_eiffel_parser.y"
		local
			yyval79: detachable ET_FORMAL_ARGUMENT_ITEM
		do
--|#line 2294 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2294")
end

			yyval79 := ast_factory.new_formal_argument_semicolon (ast_factory.new_formal_argument (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122))), yyvs21.item (yyvsp21))
			if yyval79 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp79 := yyvsp79 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp79 >= yyvsc79 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs79")
		end
		yyvsc79 := yyvsc79 + yyInitial_yyvs_size
		yyvs79 := yyspecial_routines79.aliased_resized_area (yyvs79, yyvsc79)
	end
	yyspecial_routines79.force (yyvs79, yyval79, yyvsp79)
end
		end

	yy_do_action_377
			--|#line 2305 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2305 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2305")
end

yyval99 := Void 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp99 := yyvsp99 + 1
	if yyvsp99 >= yyvsc99 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs99")
		end
		yyvsc99 := yyvsc99 + yyInitial_yyvs_size
		yyvs99 := yyspecial_routines99.aliased_resized_area (yyvs99, yyvsc99)
	end
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_378
			--|#line 2307 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2307 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2307")
end

yyval99 := new_local_variables (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp99 := yyvsp99 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp99 >= yyvsc99 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs99")
		end
		yyvsc99 := yyvsc99 + yyInitial_yyvs_size
		yyvs99 := yyspecial_routines99.aliased_resized_area (yyvs99, yyvsc99)
	end
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_379
			--|#line 2309 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2309 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2309")
end

			yyval99 := yyvs99.item (yyvsp99)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp99 := yyvsp99 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_380
			--|#line 2309 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2309 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2309")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp99 := yyvsp99 + 1
	if yyvsp99 >= yyvsc99 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs99")
		end
		yyvsc99 := yyvsc99 + yyInitial_yyvs_size
		yyvs99 := yyspecial_routines99.aliased_resized_area (yyvs99, yyvsc99)
	end
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_381
			--|#line 2322 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2322 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2322")
end

			yyval99 := new_local_variables (last_keyword, counter_value)
			if yyval99 /= Void and attached yyvs98.item (yyvsp98) as l_local_variable then
				yyval99.put_first (l_local_variable)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp99 := yyvsp99 + 1
	yyvsp98 := yyvsp98 -1
	if yyvsp99 >= yyvsc99 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs99")
		end
		yyvsc99 := yyvsc99 + yyInitial_yyvs_size
		yyvs99 := yyspecial_routines99.aliased_resized_area (yyvs99, yyvsc99)
	end
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_382
			--|#line 2329 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2329 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2329")
end

			yyval99 := new_local_variables (last_keyword, counter_value)
			if yyval99 /= Void and attached yyvs98.item (yyvsp98) as l_local_variable then
				yyval99.put_first (l_local_variable)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp99 := yyvsp99 + 1
	yyvsp98 := yyvsp98 -1
	if yyvsp99 >= yyvsc99 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs99")
		end
		yyvsc99 := yyvsc99 + yyInitial_yyvs_size
		yyvs99 := yyspecial_routines99.aliased_resized_area (yyvs99, yyvsc99)
	end
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_383
			--|#line 2336 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2336 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2336")
end

			yyval99 := yyvs99.item (yyvsp99)
			if yyval99 /= Void and attached yyvs97.item (yyvsp97) as l_local_variable then
				if not yyval99.is_empty then
					l_local_variable.set_declared_type (yyval99.first.type)
					yyval99.put_first (l_local_variable)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp97 := yyvsp97 -1
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_384
			--|#line 2346 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2346 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2346")
end

			-- TODO: Syntax error
			yyval99 := yyvs99.item (yyvsp99)
			if yyval99 /= Void and attached yyvs97.item (yyvsp97) as l_local_variable then
				if not yyval99.is_empty then
					l_local_variable.set_declared_type (yyval99.first.type)
					yyval99.put_first (l_local_variable)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp97 := yyvsp97 -1
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_385
			--|#line 2357 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2357 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2357")
end

			yyval99 := yyvs99.item (yyvsp99)
			if yyval99 /= Void and attached yyvs98.item (yyvsp98) as l_local_variable then
				yyval99.put_first (l_local_variable)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp98 := yyvsp98 -1
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_386
			--|#line 2364 "et_eiffel_parser.y"
		local
			yyval99: detachable ET_LOCAL_VARIABLE_LIST
		do
--|#line 2364 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2364")
end

			yyval99 := yyvs99.item (yyvsp99)
			if yyval99 /= Void and attached yyvs98.item (yyvsp98) as l_local_variable then
				yyval99.put_first (l_local_variable)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp98 := yyvsp98 -1
	yyspecial_routines99.force (yyvs99, yyval99, yyvsp99)
end
		end

	yy_do_action_387
			--|#line 2373 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LOCAL_VARIABLE
		do
--|#line 2373 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2373")
end

			yyval97 := ast_factory.new_local_comma_variable (ast_factory.new_local_name_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), dummy_type)
			if yyval97 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp97 := yyvsp97 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_388
			--|#line 2382 "et_eiffel_parser.y"
		local
			yyval97: detachable ET_LOCAL_VARIABLE
		do
--|#line 2382 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2382")
end

			yyval97 := ast_factory.new_local_comma_variable (yyvs12.item (yyvsp12), dummy_type)
			if yyval97 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp97 := yyvsp97 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp97 >= yyvsc97 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs97")
		end
		yyvsc97 := yyvsc97 + yyInitial_yyvs_size
		yyvs97 := yyspecial_routines97.aliased_resized_area (yyvs97, yyvsc97)
	end
	yyspecial_routines97.force (yyvs97, yyval97, yyvsp97)
end
		end

	yy_do_action_389
			--|#line 2391 "et_eiffel_parser.y"
		local
			yyval98: detachable ET_LOCAL_VARIABLE_ITEM
		do
--|#line 2391 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2391")
end

			yyval98 := ast_factory.new_local_variable (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)))
			if yyval98 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp98 := yyvsp98 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	if yyvsp98 >= yyvsc98 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs98")
		end
		yyvsc98 := yyvsc98 + yyInitial_yyvs_size
		yyvs98 := yyspecial_routines98.aliased_resized_area (yyvs98, yyvsc98)
	end
	yyspecial_routines98.force (yyvs98, yyval98, yyvsp98)
end
		end

	yy_do_action_390
			--|#line 2400 "et_eiffel_parser.y"
		local
			yyval98: detachable ET_LOCAL_VARIABLE_ITEM
		do
--|#line 2400 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2400")
end

			yyval98 := ast_factory.new_local_variable_semicolon (ast_factory.new_local_variable (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122))), yyvs21.item (yyvsp21))
			if yyval98 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp98 := yyvsp98 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp98 >= yyvsc98 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs98")
		end
		yyvsc98 := yyvsc98 + yyInitial_yyvs_size
		yyvs98 := yyspecial_routines98.aliased_resized_area (yyvs98, yyvsc98)
	end
	yyspecial_routines98.force (yyvs98, yyval98, yyvsp98)
end
		end

	yy_do_action_391
			--|#line 2411 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2411 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2411")
end

add_expression_assertion (yyvs69.item (yyvsp69), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp69 := yyvsp69 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_392
			--|#line 2413 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2413 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2413")
end

add_expression_assertion (yyvs69.item (yyvsp69), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_393
			--|#line 2415 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2415 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2415")
end

add_tagged_assertion (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_394
			--|#line 2417 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2417 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2417")
end

add_tagged_assertion (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp1 := yyvsp1 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_395
			--|#line 2419 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2419 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2419")
end

			if assertion_kind = assertion_kind_postcondition then
					-- 'class' assertions only allowed in postconditions.
				add_class_assertion (ast_factory.new_class_assertion (yyvs2.item (yyvsp2)), Void)
			else
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_396
			--|#line 2428 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2428 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2428")
end

			if assertion_kind = assertion_kind_postcondition then
					-- 'class' assertions only allowed in postconditions.
				add_class_assertion (ast_factory.new_class_assertion (yyvs2.item (yyvsp2)), yyvs21.item (yyvsp21))
			else
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_397
			--|#line 2437 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2437 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2437")
end

add_expression_assertion (yyvs69.item (yyvsp69), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_398
			--|#line 2439 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2439 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2439")
end

add_expression_assertion (yyvs69.item (yyvsp69), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp21 := yyvsp21 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_399
			--|#line 2441 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2441 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2441")
end

add_tagged_assertion (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_400
			--|#line 2443 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2443 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2443")
end

add_tagged_assertion (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5), yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp21 := yyvsp21 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_401
			--|#line 2445 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2445 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2445")
end

			if assertion_kind = assertion_kind_postcondition then
					-- 'class' assertions only allowed in postconditions.
				add_class_assertion (ast_factory.new_class_assertion (yyvs2.item (yyvsp2)), Void)
			else
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_402
			--|#line 2454 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2454 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2454")
end

			if assertion_kind = assertion_kind_postcondition then
					-- 'class' assertions only allowed in postconditions.
				add_class_assertion (ast_factory.new_class_assertion (yyvs2.item (yyvsp2)), yyvs21.item (yyvsp21))
			else
				raise_error
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp2 := yyvsp2 -1
	yyvsp21 := yyvsp21 -1
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_403
			--|#line 2465 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2465 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2465")
end

start_precondition 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_404
			--|#line 2469 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_PRECONDITIONS
		do
--|#line 2469 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2469")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp112 := yyvsp112 + 1
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_405
			--|#line 2471 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_PRECONDITIONS
		do
--|#line 2471 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2471")
end

yyval112 := new_preconditions (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp112 := yyvsp112 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_406
			--|#line 2473 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_PRECONDITIONS
		do
--|#line 2473 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2473")
end

yyval112 := new_preconditions (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp112 := yyvsp112 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_407
			--|#line 2475 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_PRECONDITIONS
		do
--|#line 2475 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2475")
end

yyval112 := new_preconditions (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp112 := yyvsp112 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_408
			--|#line 2477 "et_eiffel_parser.y"
		local
			yyval112: detachable ET_PRECONDITIONS
		do
--|#line 2477 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2477")
end

yyval112 := new_preconditions (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp112 := yyvsp112 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -2
	if yyvsp112 >= yyvsc112 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs112")
		end
		yyvsc112 := yyvsc112 + yyInitial_yyvs_size
		yyvs112 := yyspecial_routines112.aliased_resized_area (yyvs112, yyvsc112)
	end
	yyspecial_routines112.force (yyvs112, yyval112, yyvsp112)
end
		end

	yy_do_action_409
			--|#line 2481 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2481 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2481")
end

start_postcondition 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_410
			--|#line 2485 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_POSTCONDITIONS
		do
--|#line 2485 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2485")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp111 := yyvsp111 + 1
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_411
			--|#line 2487 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_POSTCONDITIONS
		do
--|#line 2487 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2487")
end

yyval111 := new_postconditions (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp111 := yyvsp111 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_412
			--|#line 2489 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_POSTCONDITIONS
		do
--|#line 2489 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2489")
end

yyval111 := new_postconditions (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp111 := yyvsp111 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_413
			--|#line 2491 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_POSTCONDITIONS
		do
--|#line 2491 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2491")
end

yyval111 := new_postconditions (yyvs2.item (yyvsp2), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp111 := yyvsp111 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_414
			--|#line 2493 "et_eiffel_parser.y"
		local
			yyval111: detachable ET_POSTCONDITIONS
		do
--|#line 2493 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2493")
end

yyval111 := new_postconditions (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp111 := yyvsp111 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -2
	if yyvsp111 >= yyvsc111 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs111")
		end
		yyvsc111 := yyvsc111 + yyInitial_yyvs_size
		yyvs111 := yyspecial_routines111.aliased_resized_area (yyvs111, yyvsc111)
	end
	yyspecial_routines111.force (yyvs111, yyval111, yyvsp111)
end
		end

	yy_do_action_415
			--|#line 2497 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2497 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2497")
end

start_invariant 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_416
			--|#line 2501 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INVARIANTS
		do
--|#line 2501 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2501")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp94 := yyvsp94 + 1
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_417
			--|#line 2503 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INVARIANTS
		do
--|#line 2503 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2503")
end

yyval94 := yyvs94.item (yyvsp94) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_418
			--|#line 2507 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INVARIANTS
		do
--|#line 2507 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2507")
end

yyval94 := new_invariants (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp94 := yyvsp94 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_419
			--|#line 2509 "et_eiffel_parser.y"
		local
			yyval94: detachable ET_INVARIANTS
		do
--|#line 2509 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2509")
end

yyval94 := new_invariants (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp94 := yyvsp94 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -3
	if yyvsp94 >= yyvsc94 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs94")
		end
		yyvsc94 := yyvsc94 + yyInitial_yyvs_size
		yyvs94 := yyspecial_routines94.aliased_resized_area (yyvs94, yyvsc94)
	end
	yyspecial_routines94.force (yyvs94, yyval94, yyvsp94)
end
		end

	yy_do_action_420
			--|#line 2513 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2513 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2513")
end

set_start_closure (Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_421
			--|#line 2517 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2517 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2517")
end

start_loop_invariant 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_422
			--|#line 2521 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOOP_INVARIANTS
		do
--|#line 2521 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2521")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp100 := yyvsp100 + 1
	if yyvsp100 >= yyvsc100 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs100")
		end
		yyvsc100 := yyvsc100 + yyInitial_yyvs_size
		yyvs100 := yyspecial_routines100.aliased_resized_area (yyvs100, yyvsc100)
	end
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_423
			--|#line 2523 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOOP_INVARIANTS
		do
--|#line 2523 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2523")
end

yyval100 := yyvs100.item (yyvsp100) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_424
			--|#line 2527 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOOP_INVARIANTS
		do
--|#line 2527 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2527")
end

yyval100 := new_loop_invariants (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp100 := yyvsp100 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -1
	if yyvsp100 >= yyvsc100 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs100")
		end
		yyvsc100 := yyvsc100 + yyInitial_yyvs_size
		yyvs100 := yyspecial_routines100.aliased_resized_area (yyvs100, yyvsc100)
	end
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_425
			--|#line 2529 "et_eiffel_parser.y"
		local
			yyval100: detachable ET_LOOP_INVARIANTS
		do
--|#line 2529 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2529")
end

yyval100 := new_loop_invariants (yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp100 := yyvsp100 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp1 := yyvsp1 -2
	if yyvsp100 >= yyvsc100 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs100")
		end
		yyvsc100 := yyvsc100 + yyInitial_yyvs_size
		yyvs100 := yyspecial_routines100.aliased_resized_area (yyvs100, yyvsc100)
	end
	yyspecial_routines100.force (yyvs100, yyval100, yyvsp100)
end
		end

	yy_do_action_426
			--|#line 2533 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_VARIANT
		do
--|#line 2533 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2533")
end

yyval128 := ast_factory.new_variant (yyvs2.item (yyvsp2), Void, yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp128 := yyvsp128 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp128 >= yyvsc128 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs128")
		end
		yyvsc128 := yyvsc128 + yyInitial_yyvs_size
		yyvs128 := yyspecial_routines128.aliased_resized_area (yyvs128, yyvsc128)
	end
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_427
			--|#line 2535 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_VARIANT
		do
--|#line 2535 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2535")
end

yyval128 := ast_factory.new_variant (yyvs2.item (yyvsp2), ast_factory.new_tag (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp128 := yyvsp128 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp128 >= yyvsc128 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs128")
		end
		yyvsc128 := yyvsc128 + yyInitial_yyvs_size
		yyvs128 := yyspecial_routines128.aliased_resized_area (yyvs128, yyvsc128)
	end
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_428
			--|#line 2539 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_VARIANT
		do
--|#line 2539 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2539")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp128 := yyvsp128 + 1
	if yyvsp128 >= yyvsc128 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs128")
		end
		yyvsc128 := yyvsc128 + yyInitial_yyvs_size
		yyvs128 := yyspecial_routines128.aliased_resized_area (yyvs128, yyvsc128)
	end
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_429
			--|#line 2541 "et_eiffel_parser.y"
		local
			yyval128: detachable ET_VARIANT
		do
--|#line 2541 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2541")
end

yyval128 := yyvs128.item (yyvsp128) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines128.force (yyvs128, yyval128, yyvsp128)
end
		end

	yy_do_action_430
			--|#line 2547 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 2547 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2547")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_431
			--|#line 2549 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 2549 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2549")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_432
			--|#line 2555 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2555 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2555")
end

yyval122 := new_named_type (Void, yyvs12.item (yyvsp12), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp122 := yyvsp122 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_433
			--|#line 2557 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2557 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2557")
end

yyval122 := yyvs122.item (yyvsp122) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_434
			--|#line 2561 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2561 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2561")
end

yyval122 := new_named_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp122 := yyvsp122 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_435
			--|#line 2563 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2563 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2563")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_436
			--|#line 2565 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2565 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2565")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_437
			--|#line 2567 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2567 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2567")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_438
			--|#line 2569 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2569 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2569")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_439
			--|#line 2571 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2571 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2571")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_440
			--|#line 2573 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2573 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2573")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_441
			--|#line 2575 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2575 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2575")
end

yyval122 := new_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_442
			--|#line 2577 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2577 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2577")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_443
			--|#line 2579 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2579 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2579")
end

yyval122 := new_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_444
			--|#line 2581 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2581 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2581")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_445
			--|#line 2583 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2583 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2583")
end

yyval122 := yyvs96.item (yyvsp96) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp122 := yyvsp122 + 1
	yyvsp96 := yyvsp96 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_446
			--|#line 2585 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2585 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2585")
end

yyval122 := new_tuple_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp122 := yyvsp122 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_447
			--|#line 2587 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2587 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2587")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_448
			--|#line 2589 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2589 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2589")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_449
			--|#line 2591 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2591 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2591")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_450
			--|#line 2593 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2593 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2593")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_451
			--|#line 2595 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2595 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2595")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_452
			--|#line 2597 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2597 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2597")
end

yyval122 := new_tuple_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_453
			--|#line 2599 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2599 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2599")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_454
			--|#line 2601 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2601 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2601")
end

yyval122 := new_tuple_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_455
			--|#line 2603 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2603 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2603")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_456
			--|#line 2607 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2607 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2607")
end

yyval122 := new_named_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp122 := yyvsp122 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_457
			--|#line 2609 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2609 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2609")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_458
			--|#line 2611 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2611 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2611")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_459
			--|#line 2613 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2613 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2613")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_460
			--|#line 2615 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2615 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2615")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_461
			--|#line 2617 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2617 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2617")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_462
			--|#line 2619 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2619 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2619")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_463
			--|#line 2621 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2621 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2621")
end

yyval122 := new_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_464
			--|#line 2623 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2623 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2623")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_465
			--|#line 2625 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2625 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2625")
end

yyval122 := new_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_466
			--|#line 2627 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2627 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2627")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_467
			--|#line 2629 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2629 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2629")
end

yyval122 := yyvs96.item (yyvsp96) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp122 := yyvsp122 + 1
	yyvsp96 := yyvsp96 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_468
			--|#line 2631 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2631 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2631")
end

yyval122 := new_tuple_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp122 := yyvsp122 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_469
			--|#line 2633 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2633 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2633")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_470
			--|#line 2635 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2635 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2635")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_471
			--|#line 2637 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2637 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2637")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_472
			--|#line 2639 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2639 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2639")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_473
			--|#line 2641 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2641 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2641")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_474
			--|#line 2643 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2643 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2643")
end

yyval122 := new_tuple_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_475
			--|#line 2645 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2645 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2645")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_476
			--|#line 2647 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2647 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2647")
end

yyval122 := new_tuple_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_477
			--|#line 2649 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2649 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2649")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_478
			--|#line 2653 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2653 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2653")
end

yyval122 := new_named_type (Void, yyvs12.item (yyvsp12), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp122 := yyvsp122 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_479
			--|#line 2655 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2655 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2655")
end

yyval122 := new_named_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp122 := yyvsp122 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_480
			--|#line 2657 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2657 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2657")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_481
			--|#line 2659 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2659 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2659")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_482
			--|#line 2661 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2661 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2661")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_483
			--|#line 2663 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2663 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2663")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_484
			--|#line 2665 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2665 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2665")
end

yyval122 := new_named_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_485
			--|#line 2667 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2667 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2667")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_486
			--|#line 2669 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2669 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2669")
end

yyval122 := new_named_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_487
			--|#line 2671 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2671 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2671")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_488
			--|#line 2673 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2673 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2673")
end

yyval122 := new_named_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_489
			--|#line 2675 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2675 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2675")
end

yyval122 := new_named_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_490
			--|#line 2677 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2677 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2677")
end

yyval122 := yyvs96.item (yyvsp96) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp122 := yyvsp122 + 1
	yyvsp96 := yyvsp96 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_491
			--|#line 2679 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2679 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2679")
end

yyval122 := new_tuple_type (Void, yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp122 := yyvsp122 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_492
			--|#line 2681 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2681 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2681")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_493
			--|#line 2683 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2683 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2683")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_494
			--|#line 2685 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2685 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2685")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_495
			--|#line 2687 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2687 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2687")
end

yyval122 := new_tuple_type (yyvs2.item (yyvsp2), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_496
			--|#line 2689 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2689 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2689")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_497
			--|#line 2691 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2691 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2691")
end

yyval122 := new_tuple_type (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_498
			--|#line 2693 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2693 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2693")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_499
			--|#line 2695 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2695 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2695")
end

yyval122 := new_tuple_type (yyvs23.item (yyvsp23), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_500
			--|#line 2697 "et_eiffel_parser.y"
		local
			yyval122: detachable ET_TYPE
		do
--|#line 2697 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2697")
end

yyval122 := new_tuple_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs12.item (yyvsp12), yyvs28.item (yyvsp28)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp122 := yyvsp122 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	yyvsp28 := yyvsp28 -1
	if yyvsp122 >= yyvsc122 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs122")
		end
		yyvsc122 := yyvsc122 + yyInitial_yyvs_size
		yyvs122 := yyspecial_routines122.aliased_resized_area (yyvs122, yyvsc122)
	end
	yyspecial_routines122.force (yyvs122, yyval122, yyvsp122)
end
		end

	yy_do_action_501
			--|#line 2701 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 2701 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2701")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_502
			--|#line 2703 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 2703 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2703")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_503
			--|#line 2707 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2707 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2707")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp28 := yyvsp28 + 1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_504
			--|#line 2709 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2709 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2709")
end

yyval28 := yyvs28.item (yyvsp28) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_505
			--|#line 2713 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2713 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2713")
end

yyval28 := ast_factory.new_actual_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp28 := yyvsp28 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_506
			--|#line 2716 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2716 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2716")
end

			yyval28 := yyvs28.item (yyvsp28)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_507
			--|#line 2724 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2724 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2724")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp1 := yyvsp1 + 1
	yyvsp22 := yyvsp22 -1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_508
			--|#line 2731 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2731 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2731")
end

			if attached yyvs122.item (yyvsp122) as l_type then
				yyval28 := ast_factory.new_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval28 /= Void then
					yyval28.put_first (l_type)
				end
			else
				yyval28 := ast_factory.new_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp28 := yyvsp28 + 1
	yyvsp122 := yyvsp122 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_509
			--|#line 2742 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2742 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2742")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (yyvs27.item (yyvsp27), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp27 := yyvsp27 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_510
			--|#line 2747 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2747 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2747")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (ast_factory.new_actual_parameter_comma (new_named_type (Void, yyvs12.item (yyvsp12), Void), yyvs5.item (yyvsp5)), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_511
			--|#line 2752 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2752 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2752")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (ast_factory.new_actual_parameter_comma (new_named_type (Void, yyvs12.item (yyvsp12), Void), yyvs5.item (yyvsp5)), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_512
			--|#line 2757 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2757 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2757")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (ast_factory.new_actual_parameter_comma (new_tuple_type (Void, yyvs12.item (yyvsp12), Void), yyvs5.item (yyvsp5)), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_513
			--|#line 2764 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 2764 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2764")
end

			increment_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_514
			--|#line 2770 "et_eiffel_parser.y"
		local
			yyval27: detachable ET_ACTUAL_PARAMETER_ITEM
		do
--|#line 2770 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2770")
end

			yyval27 := ast_factory.new_actual_parameter_comma (yyvs122.item (yyvsp122), yyvs5.item (yyvsp5))
			if yyval27 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp27 := yyvsp27 + 1
	yyvsp122 := yyvsp122 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp27 >= yyvsc27 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs27")
		end
		yyvsc27 := yyvsc27 + yyInitial_yyvs_size
		yyvs27 := yyspecial_routines27.aliased_resized_area (yyvs27, yyvsc27)
	end
	yyspecial_routines27.force (yyvs27, yyval27, yyvsp27)
end
		end

	yy_do_action_515
			--|#line 2779 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2779 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2779")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp28 := yyvsp28 + 1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_516
			--|#line 2781 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2781 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2781")
end

yyval28 := yyvs28.item (yyvsp28) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_517
			--|#line 2785 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2785 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2785")
end

yyval28 := ast_factory.new_actual_parameters (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp28 := yyvsp28 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_518
			--|#line 2788 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2788 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2788")
end

			yyval28 := yyvs28.item (yyvsp28)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_519
			--|#line 2794 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2794 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2794")
end

			yyval28 := yyvs28.item (yyvsp28)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_520
			--|#line 2802 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2802 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2802")
end

			yyval28 := ast_factory.new_actual_parameters (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
			add_to_actual_parameter_list (ast_factory.new_labeled_actual_parameter (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122))), yyval28)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp28 := yyvsp28 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	if yyvsp28 >= yyvsc28 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs28")
		end
		yyvsc28 := yyvsc28 + yyInitial_yyvs_size
		yyvs28 := yyspecial_routines28.aliased_resized_area (yyvs28, yyvsc28)
	end
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_521
			--|#line 2807 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2807 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2807")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (yyvs27.item (yyvsp27), yyvs28.item (yyvsp28))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp27 := yyvsp27 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_522
			--|#line 2812 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2812 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2812")
end

			yyval28 := yyvs28.item (yyvsp28)
			add_to_actual_parameter_list (yyvs27.item (yyvsp27), yyvs28.item (yyvsp28))
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp27 := yyvsp27 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_523
			--|#line 2817 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2817 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2817")
end

			yyval28 := yyvs28.item (yyvsp28)
			if yyval28 /= Void then
				if not yyval28.is_empty then
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyval28.first.type), yyval28)
				else
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), Void), yyval28)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_524
			--|#line 2828 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2828 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2828")
end

			yyval28 := yyvs28.item (yyvsp28)
			if yyval28 /= Void then
				if not yyval28.is_empty then
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyval28.first.type), yyval28)
				else
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), Void), yyval28)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_525
			--|#line 2839 "et_eiffel_parser.y"
		local
			yyval28: detachable ET_ACTUAL_PARAMETER_LIST
		do
--|#line 2839 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2839")
end

			yyval28 := yyvs28.item (yyvsp28)
			if yyval28 /= Void then
				if not yyval28.is_empty then
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyval28.first.type), yyval28)
				else
					add_to_actual_parameter_list (ast_factory.new_labeled_comma_actual_parameter (ast_factory.new_label_comma (yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), Void), yyval28)
				end
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp1 := yyvsp1 -1
	yyspecial_routines28.force (yyvs28, yyval28, yyvsp28)
end
		end

	yy_do_action_526
			--|#line 2852 "et_eiffel_parser.y"
		local
			yyval27: detachable ET_ACTUAL_PARAMETER_ITEM
		do
--|#line 2852 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2852")
end

			yyval27 := ast_factory.new_labeled_actual_parameter (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)))
			if yyval27 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp27 := yyvsp27 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	if yyvsp27 >= yyvsc27 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs27")
		end
		yyvsc27 := yyvsc27 + yyInitial_yyvs_size
		yyvs27 := yyspecial_routines27.aliased_resized_area (yyvs27, yyvsc27)
	end
	yyspecial_routines27.force (yyvs27, yyval27, yyvsp27)
end
		end

	yy_do_action_527
			--|#line 2861 "et_eiffel_parser.y"
		local
			yyval27: detachable ET_ACTUAL_PARAMETER_ITEM
		do
--|#line 2861 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2861")
end

			yyval27 := ast_factory.new_labeled_actual_parameter_semicolon (ast_factory.new_labeled_actual_parameter (yyvs12.item (yyvsp12), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122))), yyvs21.item (yyvsp21))
			if yyval27 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp27 := yyvsp27 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp21 := yyvsp21 -1
	if yyvsp27 >= yyvsc27 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs27")
		end
		yyvsc27 := yyvsc27 + yyInitial_yyvs_size
		yyvs27 := yyspecial_routines27.aliased_resized_area (yyvs27, yyvsc27)
	end
	yyspecial_routines27.force (yyvs27, yyval27, yyvsp27)
end
		end

	yy_do_action_528
			--|#line 2870 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2870 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2870")
end

yyval96 := new_like_feature (Void, yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_529
			--|#line 2872 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2872 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2872")
end

yyval96 := ast_factory.new_like_current (tokens.implicit_attached_type_mark, yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_530
			--|#line 2874 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2874 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2874")
end

yyval96 := yyvs114.item (yyvsp114) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp96 := yyvsp96 + 1
	yyvsp114 := yyvsp114 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_531
			--|#line 2878 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2878 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2878")
end

yyval96 := new_like_feature (Void, yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_532
			--|#line 2880 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2880 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2880")
end

yyval96 := new_like_feature (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_533
			--|#line 2882 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2882 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2882")
end

yyval96 := new_like_feature (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_534
			--|#line 2884 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2884 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2884")
end

yyval96 := new_like_feature (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_535
			--|#line 2886 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2886 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2886")
end

yyval96 := new_like_feature (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_536
			--|#line 2888 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2888 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2888")
end

yyval96 := new_like_feature (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_537
			--|#line 2890 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2890 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2890")
end

yyval96 := new_like_feature (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_538
			--|#line 2892 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2892 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2892")
end

yyval96 := new_like_feature (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp96 := yyvsp96 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_539
			--|#line 2894 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2894 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2894")
end

yyval96 := new_like_feature (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_540
			--|#line 2896 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2896 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2896")
end

yyval96 := new_like_feature (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp96 := yyvsp96 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_541
			--|#line 2898 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2898 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2898")
end

yyval96 := ast_factory.new_like_current (tokens.implicit_attached_type_mark, yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_542
			--|#line 2900 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2900 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2900")
end

yyval96 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (tokens.implicit_attached_type_mark, yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_543
			--|#line 2902 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2902 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2902")
end

yyval96 := ast_factory.new_like_current (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_544
			--|#line 2904 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2904 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2904")
end

yyval96 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_545
			--|#line 2906 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2906 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2906")
end

yyval96 := ast_factory.new_like_current (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_546
			--|#line 2908 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2908 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2908")
end

yyval96 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp96 := yyvsp96 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_547
			--|#line 2910 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2910 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2910")
end

yyval96 := ast_factory.new_like_current (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_548
			--|#line 2912 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2912 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2912")
end

yyval96 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp96 := yyvsp96 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_549
			--|#line 2914 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2914 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2914")
end

yyval96 := ast_factory.new_like_current (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp96 := yyvsp96 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_550
			--|#line 2916 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2916 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2916")
end

yyval96 := ast_factory.new_like_current (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp96 := yyvsp96 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -2
	yyvsp10 := yyvsp10 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_551
			--|#line 2918 "et_eiffel_parser.y"
		local
			yyval96: detachable ET_LIKE_TYPE
		do
--|#line 2918 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2918")
end

yyval96 := yyvs114.item (yyvsp114) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp96 := yyvsp96 + 1
	yyvsp114 := yyvsp114 -1
	if yyvsp96 >= yyvsc96 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs96")
		end
		yyvsc96 := yyvsc96 + yyInitial_yyvs_size
		yyvs96 := yyspecial_routines96.aliased_resized_area (yyvs96, yyvsc96)
	end
	yyspecial_routines96.force (yyvs96, yyval96, yyvsp96)
end
		end

	yy_do_action_552
			--|#line 2922 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2922 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2922")
end

yyval114 := ast_factory.new_qualified_like_braced_type (Void, yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_553
			--|#line 2924 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2924 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2924")
end

yyval114 := ast_factory.new_qualified_like_type (Void, yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp114 := yyvsp114 + 1
	yyvsp96 := yyvsp96 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_554
			--|#line 2928 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2928 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2928")
end

yyval114 := yyvs114.item (yyvsp114) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_555
			--|#line 2930 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2930 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2930")
end

yyval114 := ast_factory.new_qualified_like_braced_type (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_556
			--|#line 2932 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2932 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2932")
end

yyval114 := ast_factory.new_qualified_like_braced_type (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_557
			--|#line 2934 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2934 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2934")
end

yyval114 := ast_factory.new_qualified_like_braced_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_558
			--|#line 2936 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2936 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2936")
end

yyval114 := ast_factory.new_qualified_like_braced_type (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_559
			--|#line 2938 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2938 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2938")
end

yyval114 := ast_factory.new_qualified_like_braced_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 2), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -3
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_560
			--|#line 2940 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2940 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2940")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval114 := ast_factory.new_qualified_like_braced_type (yyvs5.item (yyvsp5 - 3), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp114 := yyvsp114 + 1
	yyvsp5 := yyvsp5 -4
	yyvsp2 := yyvsp2 -1
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_561
			--|#line 2948 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2948 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2948")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval114 := ast_factory.new_qualified_like_braced_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5 - 3), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp114 := yyvsp114 + 1
	yyvsp5 := yyvsp5 -4
	yyvsp2 := yyvsp2 -2
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_562
			--|#line 2956 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2956 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2956")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval114 := ast_factory.new_qualified_like_braced_type (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp114 := yyvsp114 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_563
			--|#line 2964 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2964 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2964")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval114 := ast_factory.new_qualified_like_braced_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2 - 1)), yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp114 := yyvsp114 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_564
			--|#line 2972 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2972 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2972")
end

yyval114 := ast_factory.new_qualified_like_type (yyvs2.item (yyvsp2), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp96 := yyvsp96 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_565
			--|#line 2974 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2974 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2974")
end

yyval114 := ast_factory.new_qualified_like_type (yyvs2.item (yyvsp2), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp96 := yyvsp96 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_566
			--|#line 2976 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2976 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2976")
end

yyval114 := ast_factory.new_qualified_like_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp96 := yyvsp96 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_567
			--|#line 2978 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2978 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2978")
end

yyval114 := ast_factory.new_qualified_like_type (yyvs2.item (yyvsp2), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp96 := yyvsp96 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_568
			--|#line 2980 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2980 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2980")
end

yyval114 := ast_factory.new_qualified_like_type (ast_factory.new_attachment_mark_separate_keyword (yyvs2.item (yyvsp2 - 1), yyvs2.item (yyvsp2)), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp114 := yyvsp114 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp96 := yyvsp96 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_569
			--|#line 2982 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2982 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2982")
end

yyval114 := ast_factory.new_qualified_like_type (yyvs5.item (yyvsp5 - 1), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp114 := yyvsp114 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp96 := yyvsp96 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_570
			--|#line 2984 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2984 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2984")
end

yyval114 := ast_factory.new_qualified_like_type (ast_factory.new_attachment_mark_separate_keyword (yyvs5.item (yyvsp5 - 1), yyvs2.item (yyvsp2)), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp114 := yyvsp114 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp2 := yyvsp2 -1
	yyvsp96 := yyvsp96 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_571
			--|#line 2986 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2986 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2986")
end

yyval114 := ast_factory.new_qualified_like_type (yyvs23.item (yyvsp23), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp114 := yyvsp114 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp96 := yyvsp96 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_572
			--|#line 2988 "et_eiffel_parser.y"
		local
			yyval114: detachable ET_QUALIFIED_LIKE_IDENTIFIER
		do
--|#line 2988 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2988")
end

yyval114 := ast_factory.new_qualified_like_type (ast_factory.new_attachment_mark_separate_keyword (yyvs23.item (yyvsp23), yyvs2.item (yyvsp2)), yyvs96.item (yyvsp96), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), last_class)
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp114 := yyvsp114 + 1
	yyvsp23 := yyvsp23 -1
	yyvsp2 := yyvsp2 -1
	yyvsp96 := yyvsp96 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp114 >= yyvsc114 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs114")
		end
		yyvsc114 := yyvsc114 + yyInitial_yyvs_size
		yyvs114 := yyspecial_routines114.aliased_resized_area (yyvs114, yyvsc114)
	end
	yyspecial_routines114.force (yyvs114, yyval114, yyvsp114)
end
		end

	yy_do_action_573
			--|#line 2994 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 2994 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2994")
end

yyval47 := ast_factory.new_do_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_574
			--|#line 2998 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 2998 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 2998")
end

yyval47 := ast_factory.new_attribute_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_575
			--|#line 3002 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3002 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3002")
end

yyval47 := ast_factory.new_then_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_576
			--|#line 3006 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3006 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3006")
end

yyval47 := ast_factory.new_then_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_577
			--|#line 3010 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3010 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3010")
end

yyval47 := ast_factory.new_else_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_578
			--|#line 3014 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3014 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3014")
end

yyval47 := ast_factory.new_else_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_579
			--|#line 3018 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3018 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3018")
end

yyval47 := ast_factory.new_rescue_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_580
			--|#line 3022 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3022 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3022")
end

yyval47 := ast_factory.new_from_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_581
			--|#line 3026 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3026 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3026")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_582
			--|#line 3028 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3028 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3028")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_583
			--|#line 3032 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3032 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3032")
end

yyval47 := ast_factory.new_loop_compound (yyvs2.item (yyvsp2), yyvs47.item (yyvsp47)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_584
			--|#line 3036 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3036 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3036")
end

			yyval47 := yyvs47.item (yyvsp47)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_585
			--|#line 3043 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3043 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3043")
end

yyval47 := ast_factory.new_empty_compound 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_586
			--|#line 3045 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3045 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3045")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_587
			--|#line 3049 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3049 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3049")
end

yyval47 := ast_factory.new_compound (0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_588
			--|#line 3051 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3051 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3051")
end

yyval47 := yyvs47.item (yyvsp47) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_589
			--|#line 3055 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3055 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3055")
end

			if attached yyvs93.item (yyvsp93) as l_instruction then
				yyval47 := ast_factory.new_compound (counter_value + 1)
				if yyval47 /= Void then
					yyval47.put_first (l_instruction)
				end
			else
				yyval47 := ast_factory.new_compound (counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp47 := yyvsp47 + 1
	yyvsp93 := yyvsp93 -1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_590
			--|#line 3066 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3066 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3066")
end

			yyval47 := yyvs47.item (yyvsp47)
			if yyval47 /= Void and attached yyvs93.item (yyvsp93) as l_instruction then
				yyval47.put_first (l_instruction)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp47 := yyvsp47 -1
	yyvsp93 := yyvsp93 -1
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_591
			--|#line 3066 "et_eiffel_parser.y"
		local
			yyval47: detachable ET_COMPOUND
		do
--|#line 3066 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3066")
end

			if yyvs93.item (yyvsp93) /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp47 := yyvsp47 + 1
	if yyvsp47 >= yyvsc47 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs47")
		end
		yyvsc47 := yyvsc47 + yyInitial_yyvs_size
		yyvs47 := yyspecial_routines47.aliased_resized_area (yyvs47, yyvsc47)
	end
	yyspecial_routines47.force (yyvs47, yyval47, yyvsp47)
end
		end

	yy_do_action_592
			--|#line 3087 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3087 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3087")
end

yyval93 := yyvs93.item (yyvsp93) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_593
			--|#line 3089 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3089 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3089")
end

yyval93 := yyvs93.item (yyvsp93) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_594
			--|#line 3091 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3091 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3091")
end

yyval93 := yyvs93.item (yyvsp93) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_595
			--|#line 3093 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3093 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3093")
end

yyval93 := ast_factory.new_assigner_instruction (yyvs38.item (yyvsp38), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp93 := yyvsp93 + 1
	yyvsp38 := yyvsp38 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_596
			--|#line 3095 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3095 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3095")
end

yyval93 := ast_factory.new_assigner_instruction (yyvs36.item (yyvsp36), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp93 := yyvsp93 + 1
	yyvsp36 := yyvsp36 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_597
			--|#line 3097 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3097 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3097")
end

yyval93 := ast_factory.new_assignment (yyvs131.item (yyvsp131), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp93 := yyvsp93 + 1
	yyvsp131 := yyvsp131 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_598
			--|#line 3099 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3099 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3099")
end

yyval93 := ast_factory.new_assignment_attempt (yyvs131.item (yyvsp131), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp93 := yyvsp93 + 1
	yyvsp131 := yyvsp131 -1
	yyvsp5 := yyvsp5 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_599
			--|#line 3101 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3101 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3101")
end

yyval93 := yyvs85.item (yyvsp85) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp93 := yyvsp93 + 1
	yyvsp85 := yyvsp85 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_600
			--|#line 3103 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3103 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3103")
end

yyval93 := yyvs92.item (yyvsp92) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp93 := yyvsp93 + 1
	yyvsp92 := yyvsp92 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_601
			--|#line 3105 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3105 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3105")
end

yyval93 := ast_factory.new_loop_instruction_old_syntax (yyvs47.item (yyvsp47 - 1), yyvs100.item (yyvsp100), yyvs128.item (yyvsp128), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp93 := yyvsp93 + 1
	yyvsp47 := yyvsp47 -2
	yyvsp100 := yyvsp100 -1
	yyvsp128 := yyvsp128 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_602
			--|#line 3107 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3107 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3107")
end

			if system_processor.older_ise_version (ise_6_3_7_4554) then
				yyval93 := ast_factory.new_loop_instruction_old_syntax (yyvs47.item (yyvsp47 - 1), yyvs100.item (yyvsp100), Void, ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2))
			else
				yyval93 := ast_factory.new_loop_instruction (yyvs47.item (yyvsp47 - 1), yyvs100.item (yyvsp100), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), Void, yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp93 := yyvsp93 + 1
	yyvsp47 := yyvsp47 -2
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_603
			--|#line 3115 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3115 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3115")
end

			if system_processor.older_ise_version (ise_6_3_7_4554) then
				raise_error
			else
				yyval93 := ast_factory.new_loop_instruction (yyvs47.item (yyvsp47 - 1), yyvs100.item (yyvsp100), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), yyvs128.item (yyvsp128), yyvs2.item (yyvsp2))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp93 := yyvsp93 + 1
	yyvsp47 := yyvsp47 -2
	yyvsp100 := yyvsp100 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp128 := yyvsp128 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_604
			--|#line 3128 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3128 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3128")
end

yyval93 := new_across_instruction (yyvs25.item (yyvsp25), yyvs47.item (yyvsp47 - 1), yyvs100.item (yyvsp100), yyvs48.item (yyvsp48), yyvs47.item (yyvsp47), yyvs128.item (yyvsp128), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp93 := yyvsp93 + 1
	yyvsp25 := yyvsp25 -1
	yyvsp47 := yyvsp47 -2
	yyvsp100 := yyvsp100 -1
	yyvsp48 := yyvsp48 -1
	yyvsp128 := yyvsp128 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_605
			--|#line 3130 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3130 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3130")
end

yyval93 := new_repeat_instruction (yyvs119.item (yyvsp119), yyvs47.item (yyvsp47), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp93 := yyvsp93 + 1
	yyvsp119 := yyvsp119 -1
	yyvsp47 := yyvsp47 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_606
			--|#line 3132 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3132 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3132")
end

yyval93 := yyvs62.item (yyvsp62) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp93 := yyvsp93 + 1
	yyvsp62 := yyvsp62 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_607
			--|#line 3134 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3134 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3134")
end

yyval93 := yyvs39.item (yyvsp39) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp93 := yyvsp93 + 1
	yyvsp39 := yyvsp39 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_608
			--|#line 3136 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3136 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3136")
end

yyval93 := yyvs18.item (yyvsp18) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp93 := yyvsp93 + 1
	yyvsp18 := yyvsp18 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_609
			--|#line 3138 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3138 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3138")
end

yyval93 := ast_factory.new_null_instruction (yyvs21.item (yyvsp21)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp93 := yyvsp93 + 1
	yyvsp21 := yyvsp21 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_610
			--|#line 3144 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 3144 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3144")
end

start_check_instruction 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_611
			--|#line 3148 "et_eiffel_parser.y"
		local
			yyval39: detachable ET_CHECK_INSTRUCTION
		do
--|#line 3148 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3148")
end

yyval39 := new_check_instruction (yyvs2.item (yyvsp2 - 1), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp39 := yyvsp39 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
		end

	yy_do_action_612
			--|#line 3150 "et_eiffel_parser.y"
		local
			yyval39: detachable ET_CHECK_INSTRUCTION
		do
--|#line 3150 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3150")
end

yyval39 := new_check_instruction (yyvs2.item (yyvsp2 - 1), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp39 := yyvsp39 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -2
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
		end

	yy_do_action_613
			--|#line 3152 "et_eiffel_parser.y"
		local
			yyval39: detachable ET_CHECK_INSTRUCTION
		do
--|#line 3152 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3152")
end

yyval39 := new_check_instruction (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp39 := yyvsp39 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
		end

	yy_do_action_614
			--|#line 3154 "et_eiffel_parser.y"
		local
			yyval39: detachable ET_CHECK_INSTRUCTION
		do
--|#line 3154 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3154")
end

yyval39 := new_check_instruction (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp39 := yyvsp39 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp1 := yyvsp1 -2
	yyvsp47 := yyvsp47 -1
	if yyvsp39 >= yyvsc39 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs39")
		end
		yyvsc39 := yyvsc39 + yyInitial_yyvs_size
		yyvs39 := yyspecial_routines39.aliased_resized_area (yyvs39, yyvsc39)
	end
	yyspecial_routines39.force (yyvs39, yyval39, yyvsp39)
end
		end

	yy_do_action_615
			--|#line 3160 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3160 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3160")
end

yyval93 := ast_factory.new_bang_instruction (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5), yyvs131.item (yyvsp131), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp93 := yyvsp93 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyvsp131 := yyvsp131 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_616
			--|#line 3162 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3162 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3162")
end

yyval93 := ast_factory.new_bang_instruction (yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1), yyvs131.item (yyvsp131), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp93 := yyvsp93 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp131 := yyvsp131 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_617
			--|#line 3164 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3164 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3164")
end

yyval93 := ast_factory.new_bang_instruction (yyvs5.item (yyvsp5 - 1), Void, yyvs5.item (yyvsp5), yyvs131.item (yyvsp131), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp93 := yyvsp93 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp131 := yyvsp131 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_618
			--|#line 3166 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3166 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3166")
end

yyval93 := ast_factory.new_bang_instruction (yyvs5.item (yyvsp5 - 2), Void, yyvs5.item (yyvsp5 - 1), yyvs131.item (yyvsp131), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp93 := yyvsp93 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp131 := yyvsp131 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_619
			--|#line 3170 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3170 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3170")
end

yyval93 := ast_factory.new_create_instruction (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)), yyvs131.item (yyvsp131), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp93 := yyvsp93 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyvsp131 := yyvsp131 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_620
			--|#line 3172 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3172 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3172")
end

yyval93 := ast_factory.new_create_instruction (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1)), yyvs131.item (yyvsp131), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 9
	yyvsp93 := yyvsp93 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp131 := yyvsp131 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_621
			--|#line 3174 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3174 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3174")
end

yyval93 := ast_factory.new_create_instruction (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), Void, yyvs131.item (yyvsp131), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp93 := yyvsp93 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp131 := yyvsp131 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_622
			--|#line 3176 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3176 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3176")
end

yyval93 := ast_factory.new_create_instruction (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), Void, yyvs131.item (yyvsp131), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp93 := yyvsp93 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp131 := yyvsp131 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_623
			--|#line 3180 "et_eiffel_parser.y"
		local
			yyval58: detachable ET_CREATE_EXPRESSION
		do
--|#line 3180 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3180")
end

yyval58 := ast_factory.new_create_expression (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)), Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp58 := yyvsp58 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	if yyvsp58 >= yyvsc58 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs58")
		end
		yyvsc58 := yyvsc58 + yyInitial_yyvs_size
		yyvs58 := yyspecial_routines58.aliased_resized_area (yyvs58, yyvsc58)
	end
	yyspecial_routines58.force (yyvs58, yyval58, yyvsp58)
end
		end

	yy_do_action_624
			--|#line 3182 "et_eiffel_parser.y"
		local
			yyval58: detachable ET_CREATE_EXPRESSION
		do
--|#line 3182 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3182")
end

yyval58 := ast_factory.new_create_expression (yyvs2.item (yyvsp2), yyvs59.item (yyvsp59), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1)), ast_factory.new_qualified_call (new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26))) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp58 := yyvsp58 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp59 := yyvsp59 -1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp58 >= yyvsc58 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs58")
		end
		yyvsc58 := yyvsc58 + yyInitial_yyvs_size
		yyvs58 := yyspecial_routines58.aliased_resized_area (yyvs58, yyvsc58)
	end
	yyspecial_routines58.force (yyvs58, yyval58, yyvsp58)
end
		end

	yy_do_action_625
			--|#line 3186 "et_eiffel_parser.y"
		local
			yyval59: detachable ET_CREATION_REGION
		do
--|#line 3186 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3186")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp59 := yyvsp59 + 1
	if yyvsp59 >= yyvsc59 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs59")
		end
		yyvsc59 := yyvsc59 + yyInitial_yyvs_size
		yyvs59 := yyspecial_routines59.aliased_resized_area (yyvs59, yyvsc59)
	end
	yyspecial_routines59.force (yyvs59, yyval59, yyvsp59)
end
		end

	yy_do_action_626
			--|#line 3187 "et_eiffel_parser.y"
		local
			yyval59: detachable ET_CREATION_REGION
		do
--|#line 3187 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3187")
end

yyval59 := ast_factory.new_creation_region (yyvs19.item (yyvsp19 - 1), yyvs12.item (yyvsp12), yyvs19.item (yyvsp19)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp59 := yyvsp59 + 1
	yyvsp19 := yyvsp19 -2
	yyvsp12 := yyvsp12 -1
	if yyvsp59 >= yyvsc59 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs59")
		end
		yyvsc59 := yyvsc59 + yyInitial_yyvs_size
		yyvs59 := yyspecial_routines59.aliased_resized_area (yyvs59, yyvsc59)
	end
	yyspecial_routines59.force (yyvs59, yyval59, yyvsp59)
end
		end

	yy_do_action_627
			--|#line 3193 "et_eiffel_parser.y"
		local
			yyval85: detachable ET_IF_INSTRUCTION
		do
--|#line 3193 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3193")
end

yyval85 := ast_factory.new_if_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), Void, Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp85 := yyvsp85 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp85 >= yyvsc85 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs85")
		end
		yyvsc85 := yyvsc85 + yyInitial_yyvs_size
		yyvs85 := yyspecial_routines85.aliased_resized_area (yyvs85, yyvsc85)
	end
	yyspecial_routines85.force (yyvs85, yyval85, yyvsp85)
end
		end

	yy_do_action_628
			--|#line 3195 "et_eiffel_parser.y"
		local
			yyval85: detachable ET_IF_INSTRUCTION
		do
--|#line 3195 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3195")
end

yyval85 := ast_factory.new_if_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47 - 1), Void, yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp85 := yyvsp85 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -2
	if yyvsp85 >= yyvsc85 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs85")
		end
		yyvsc85 := yyvsc85 + yyInitial_yyvs_size
		yyvs85 := yyspecial_routines85.aliased_resized_area (yyvs85, yyvsc85)
	end
	yyspecial_routines85.force (yyvs85, yyval85, yyvsp85)
end
		end

	yy_do_action_629
			--|#line 3197 "et_eiffel_parser.y"
		local
			yyval85: detachable ET_IF_INSTRUCTION
		do
--|#line 3197 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3197")
end

yyval85 := ast_factory.new_if_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47), yyvs66.item (yyvsp66), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp85 := yyvsp85 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -1
	yyvsp66 := yyvsp66 -1
	if yyvsp85 >= yyvsc85 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs85")
		end
		yyvsc85 := yyvsc85 + yyInitial_yyvs_size
		yyvs85 := yyspecial_routines85.aliased_resized_area (yyvs85, yyvsc85)
	end
	yyspecial_routines85.force (yyvs85, yyval85, yyvsp85)
end
		end

	yy_do_action_630
			--|#line 3199 "et_eiffel_parser.y"
		local
			yyval85: detachable ET_IF_INSTRUCTION
		do
--|#line 3199 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3199")
end

yyval85 := ast_factory.new_if_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47 - 1), yyvs66.item (yyvsp66), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp85 := yyvsp85 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -2
	yyvsp66 := yyvsp66 -1
	if yyvsp85 >= yyvsc85 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs85")
		end
		yyvsc85 := yyvsc85 + yyInitial_yyvs_size
		yyvs85 := yyspecial_routines85.aliased_resized_area (yyvs85, yyvsc85)
	end
	yyspecial_routines85.force (yyvs85, yyval85, yyvsp85)
end
		end

	yy_do_action_631
			--|#line 3203 "et_eiffel_parser.y"
		local
			yyval66: detachable ET_ELSEIF_PART_LIST
		do
--|#line 3203 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3203")
end

			yyval66 := yyvs66.item (yyvsp66)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines66.force (yyvs66, yyval66, yyvsp66)
end
		end

	yy_do_action_632
			--|#line 3210 "et_eiffel_parser.y"
		local
			yyval66: detachable ET_ELSEIF_PART_LIST
		do
--|#line 3210 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3210")
end

			yyval66 := ast_factory.new_elseif_part_list (counter_value)
			if yyval66 /= Void and attached yyvs65.item (yyvsp65) as l_elseif_part then
				yyval66.put_first (l_elseif_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp66 := yyvsp66 + 1
	yyvsp65 := yyvsp65 -1
	if yyvsp66 >= yyvsc66 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs66")
		end
		yyvsc66 := yyvsc66 + yyInitial_yyvs_size
		yyvs66 := yyspecial_routines66.aliased_resized_area (yyvs66, yyvsc66)
	end
	yyspecial_routines66.force (yyvs66, yyval66, yyvsp66)
end
		end

	yy_do_action_633
			--|#line 3217 "et_eiffel_parser.y"
		local
			yyval66: detachable ET_ELSEIF_PART_LIST
		do
--|#line 3217 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3217")
end

			yyval66 := yyvs66.item (yyvsp66)
			if yyval66 /= Void and attached yyvs65.item (yyvsp65) as l_elseif_part then
				yyval66.put_first (l_elseif_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp65 := yyvsp65 -1
	yyspecial_routines66.force (yyvs66, yyval66, yyvsp66)
end
		end

	yy_do_action_634
			--|#line 3226 "et_eiffel_parser.y"
		local
			yyval65: detachable ET_ELSEIF_PART
		do
--|#line 3226 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3226")
end

			yyval65 := ast_factory.new_elseif_part (ast_factory.new_conditional (yyvs2.item (yyvsp2), yyvs69.item (yyvsp69)), yyvs47.item (yyvsp47))
			if yyval65 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp65 := yyvsp65 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp69 := yyvsp69 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp65 >= yyvsc65 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs65")
		end
		yyvsc65 := yyvsc65 + yyInitial_yyvs_size
		yyvs65 := yyspecial_routines65.aliased_resized_area (yyvs65, yyvsc65)
	end
	yyspecial_routines65.force (yyvs65, yyval65, yyvsp65)
end
		end

	yy_do_action_635
			--|#line 3237 "et_eiffel_parser.y"
		local
			yyval84: detachable ET_IF_EXPRESSION
		do
--|#line 3237 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3237")
end

yyval84 := ast_factory.new_if_expression (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 3), yyvs69.item (yyvsp69 - 2)), yyvs2.item (yyvsp2 - 2), yyvs69.item (yyvsp69 - 1), Void, yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp84 := yyvsp84 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp69 := yyvsp69 -3
	if yyvsp84 >= yyvsc84 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs84")
		end
		yyvsc84 := yyvsc84 + yyInitial_yyvs_size
		yyvs84 := yyspecial_routines84.aliased_resized_area (yyvs84, yyvsc84)
	end
	yyspecial_routines84.force (yyvs84, yyval84, yyvsp84)
end
		end

	yy_do_action_636
			--|#line 3239 "et_eiffel_parser.y"
		local
			yyval84: detachable ET_IF_EXPRESSION
		do
--|#line 3239 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3239")
end

yyval84 := ast_factory.new_if_expression (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 3), yyvs69.item (yyvsp69 - 2)), yyvs2.item (yyvsp2 - 2), yyvs69.item (yyvsp69 - 1), yyvs64.item (yyvsp64), yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp84 := yyvsp84 + 1
	yyvsp2 := yyvsp2 -4
	yyvsp69 := yyvsp69 -3
	yyvsp64 := yyvsp64 -1
	if yyvsp84 >= yyvsc84 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs84")
		end
		yyvsc84 := yyvsc84 + yyInitial_yyvs_size
		yyvs84 := yyspecial_routines84.aliased_resized_area (yyvs84, yyvsc84)
	end
	yyspecial_routines84.force (yyvs84, yyval84, yyvsp84)
end
		end

	yy_do_action_637
			--|#line 3243 "et_eiffel_parser.y"
		local
			yyval64: detachable ET_ELSEIF_EXPRESSION_LIST
		do
--|#line 3243 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3243")
end

			yyval64 := yyvs64.item (yyvsp64)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines64.force (yyvs64, yyval64, yyvsp64)
end
		end

	yy_do_action_638
			--|#line 3250 "et_eiffel_parser.y"
		local
			yyval64: detachable ET_ELSEIF_EXPRESSION_LIST
		do
--|#line 3250 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3250")
end

			yyval64 := ast_factory.new_elseif_expression_list (counter_value)
			if yyval64 /= Void and attached yyvs63.item (yyvsp63) as l_elseif_part then
				yyval64.put_first (l_elseif_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp64 := yyvsp64 + 1
	yyvsp63 := yyvsp63 -1
	if yyvsp64 >= yyvsc64 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs64")
		end
		yyvsc64 := yyvsc64 + yyInitial_yyvs_size
		yyvs64 := yyspecial_routines64.aliased_resized_area (yyvs64, yyvsc64)
	end
	yyspecial_routines64.force (yyvs64, yyval64, yyvsp64)
end
		end

	yy_do_action_639
			--|#line 3257 "et_eiffel_parser.y"
		local
			yyval64: detachable ET_ELSEIF_EXPRESSION_LIST
		do
--|#line 3257 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3257")
end

			yyval64 := yyvs64.item (yyvsp64)
			if yyval64 /= Void and attached yyvs63.item (yyvsp63) as l_elseif_part then
				yyval64.put_first (l_elseif_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp63 := yyvsp63 -1
	yyspecial_routines64.force (yyvs64, yyval64, yyvsp64)
end
		end

	yy_do_action_640
			--|#line 3266 "et_eiffel_parser.y"
		local
			yyval63: detachable ET_ELSEIF_EXPRESSION
		do
--|#line 3266 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3266")
end

			yyval63 := ast_factory.new_elseif_expression (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69 - 1)), yyvs2.item (yyvsp2), yyvs69.item (yyvsp69))
			if yyval63 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp63 := yyvsp63 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -2
	if yyvsp63 >= yyvsc63 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs63")
		end
		yyvsc63 := yyvsc63 + yyInitial_yyvs_size
		yyvs63 := yyspecial_routines63.aliased_resized_area (yyvs63, yyvsc63)
	end
	yyspecial_routines63.force (yyvs63, yyval63, yyvsp63)
end
		end

	yy_do_action_641
			--|#line 3277 "et_eiffel_parser.y"
		local
			yyval92: detachable ET_INSPECT_INSTRUCTION
		do
--|#line 3277 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3277")
end

yyval92 := ast_factory.new_inspect_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs130.item (yyvsp130), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp92 := yyvsp92 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp130 := yyvsp130 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp92 >= yyvsc92 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs92")
		end
		yyvsc92 := yyvsc92 + yyInitial_yyvs_size
		yyvs92 := yyspecial_routines92.aliased_resized_area (yyvs92, yyvsc92)
	end
	yyspecial_routines92.force (yyvs92, yyval92, yyvsp92)
end
		end

	yy_do_action_642
			--|#line 3279 "et_eiffel_parser.y"
		local
			yyval92: detachable ET_INSPECT_INSTRUCTION
		do
--|#line 3279 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3279")
end

yyval92 := ast_factory.new_inspect_instruction (ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs130.item (yyvsp130), Void, yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp92 := yyvsp92 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp130 := yyvsp130 -1
	if yyvsp92 >= yyvsc92 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs92")
		end
		yyvsc92 := yyvsc92 + yyInitial_yyvs_size
		yyvs92 := yyspecial_routines92.aliased_resized_area (yyvs92, yyvsc92)
	end
	yyspecial_routines92.force (yyvs92, yyval92, yyvsp92)
end
		end

	yy_do_action_643
			--|#line 3283 "et_eiffel_parser.y"
		local
			yyval130: detachable ET_WHEN_PART_LIST
		do
--|#line 3283 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3283")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp130 := yyvsp130 + 1
	if yyvsp130 >= yyvsc130 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs130")
		end
		yyvsc130 := yyvsc130 + yyInitial_yyvs_size
		yyvs130 := yyspecial_routines130.aliased_resized_area (yyvs130, yyvsc130)
	end
	yyspecial_routines130.force (yyvs130, yyval130, yyvsp130)
end
		end

	yy_do_action_644
			--|#line 3285 "et_eiffel_parser.y"
		local
			yyval130: detachable ET_WHEN_PART_LIST
		do
--|#line 3285 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3285")
end

			yyval130 := yyvs130.item (yyvsp130)
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp1 := yyvsp1 -1
	yyspecial_routines130.force (yyvs130, yyval130, yyvsp130)
end
		end

	yy_do_action_645
			--|#line 3292 "et_eiffel_parser.y"
		local
			yyval130: detachable ET_WHEN_PART_LIST
		do
--|#line 3292 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3292")
end

			yyval130 := ast_factory.new_when_part_list (counter_value)
			if yyval130 /= Void and attached yyvs129.item (yyvsp129) as l_when_part then
				yyval130.put_first (l_when_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp130 := yyvsp130 + 1
	yyvsp129 := yyvsp129 -1
	if yyvsp130 >= yyvsc130 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs130")
		end
		yyvsc130 := yyvsc130 + yyInitial_yyvs_size
		yyvs130 := yyspecial_routines130.aliased_resized_area (yyvs130, yyvsc130)
	end
	yyspecial_routines130.force (yyvs130, yyval130, yyvsp130)
end
		end

	yy_do_action_646
			--|#line 3299 "et_eiffel_parser.y"
		local
			yyval130: detachable ET_WHEN_PART_LIST
		do
--|#line 3299 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3299")
end

			yyval130 := yyvs130.item (yyvsp130)
			if yyval130 /= Void and attached yyvs129.item (yyvsp129) as l_when_part then
				yyval130.put_first (l_when_part)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp129 := yyvsp129 -1
	yyspecial_routines130.force (yyvs130, yyval130, yyvsp130)
end
		end

	yy_do_action_647
			--|#line 3308 "et_eiffel_parser.y"
		local
			yyval129: detachable ET_WHEN_PART
		do
--|#line 3308 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3308")
end

			yyval129 := ast_factory.new_when_part (yyvs43.item (yyvsp43), yyvs47.item (yyvsp47))
			if yyval129 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp129 := yyvsp129 + 1
	yyvsp43 := yyvsp43 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp129 >= yyvsc129 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs129")
		end
		yyvsc129 := yyvsc129 + yyInitial_yyvs_size
		yyvs129 := yyspecial_routines129.aliased_resized_area (yyvs129, yyvsc129)
	end
	yyspecial_routines129.force (yyvs129, yyval129, yyvsp129)
end
		end

	yy_do_action_648
			--|#line 3317 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3317 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3317")
end

yyval43 := ast_factory.new_choice_list (yyvs2.item (yyvsp2), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp43 := yyvsp43 + 1
	yyvsp2 := yyvsp2 -1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_649
			--|#line 3319 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3319 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3319")
end

			yyval43 := yyvs43.item (yyvsp43)
			remove_keyword
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp43 := yyvsp43 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_650
			--|#line 3319 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3319 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3319")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp43 := yyvsp43 + 1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_651
			--|#line 3332 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3332 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3332")
end

			if attached yyvs40.item (yyvsp40) as l_choice then
				yyval43 := ast_factory.new_choice_list (last_keyword, counter_value + 1)
				if yyval43 /= Void then
					yyval43.put_first (l_choice)
				end
			else
				yyval43 := ast_factory.new_choice_list (last_keyword, counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp43 := yyvsp43 + 1
	yyvsp40 := yyvsp40 -1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_652
			--|#line 3343 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3343 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3343")
end

			yyval43 := ast_factory.new_choice_list (last_keyword, counter_value)
			if yyval43 /= Void and attached yyvs42.item (yyvsp42) as l_choice then
				yyval43.put_first (l_choice)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp43 := yyvsp43 + 1
	yyvsp42 := yyvsp42 -1
	if yyvsp43 >= yyvsc43 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs43")
		end
		yyvsc43 := yyvsc43 + yyInitial_yyvs_size
		yyvs43 := yyspecial_routines43.aliased_resized_area (yyvs43, yyvsc43)
	end
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_653
			--|#line 3351 "et_eiffel_parser.y"
		local
			yyval43: detachable ET_CHOICE_LIST
		do
--|#line 3351 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3351")
end

			yyval43 := yyvs43.item (yyvsp43)
			if yyval43 /= Void and attached yyvs42.item (yyvsp42) as l_choice then
				yyval43.put_first (l_choice)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp42 := yyvsp42 -1
	yyspecial_routines43.force (yyvs43, yyval43, yyvsp43)
end
		end

	yy_do_action_654
			--|#line 3360 "et_eiffel_parser.y"
		local
			yyval42: detachable ET_CHOICE_ITEM
		do
--|#line 3360 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3360")
end

			yyval42 := ast_factory.new_choice_comma (yyvs40.item (yyvsp40), yyvs5.item (yyvsp5))
			if yyval42 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp42 := yyvsp42 + 1
	yyvsp40 := yyvsp40 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp42 >= yyvsc42 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs42")
		end
		yyvsc42 := yyvsc42 + yyInitial_yyvs_size
		yyvs42 := yyspecial_routines42.aliased_resized_area (yyvs42, yyvsc42)
	end
	yyspecial_routines42.force (yyvs42, yyval42, yyvsp42)
end
		end

	yy_do_action_655
			--|#line 3369 "et_eiffel_parser.y"
		local
			yyval40: detachable ET_CHOICE
		do
--|#line 3369 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3369")
end

yyval40 := yyvs41.item (yyvsp41) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp40 := yyvsp40 + 1
	yyvsp41 := yyvsp41 -1
	if yyvsp40 >= yyvsc40 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs40")
		end
		yyvsc40 := yyvsc40 + yyInitial_yyvs_size
		yyvs40 := yyspecial_routines40.aliased_resized_area (yyvs40, yyvsc40)
	end
	yyspecial_routines40.force (yyvs40, yyval40, yyvsp40)
end
		end

	yy_do_action_656
			--|#line 3371 "et_eiffel_parser.y"
		local
			yyval40: detachable ET_CHOICE
		do
--|#line 3371 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3371")
end

yyval40 := ast_factory.new_choice_range (yyvs41.item (yyvsp41 - 1), yyvs5.item (yyvsp5), yyvs41.item (yyvsp41)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp40 := yyvsp40 + 1
	yyvsp41 := yyvsp41 -2
	yyvsp5 := yyvsp5 -1
	if yyvsp40 >= yyvsc40 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs40")
		end
		yyvsc40 := yyvsc40 + yyInitial_yyvs_size
		yyvs40 := yyspecial_routines40.aliased_resized_area (yyvs40, yyvsc40)
	end
	yyspecial_routines40.force (yyvs40, yyval40, yyvsp40)
end
		end

	yy_do_action_657
			--|#line 3375 "et_eiffel_parser.y"
		local
			yyval41: detachable ET_CHOICE_CONSTANT
		do
--|#line 3375 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3375")
end

yyval41 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp41 := yyvsp41 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
		end

	yy_do_action_658
			--|#line 3377 "et_eiffel_parser.y"
		local
			yyval41: detachable ET_CHOICE_CONSTANT
		do
--|#line 3377 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3377")
end

yyval41 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp41 := yyvsp41 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
		end

	yy_do_action_659
			--|#line 3379 "et_eiffel_parser.y"
		local
			yyval41: detachable ET_CHOICE_CONSTANT
		do
--|#line 3379 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3379")
end

yyval41 := new_choice_attribute_constant (yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp41 := yyvsp41 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
		end

	yy_do_action_660
			--|#line 3381 "et_eiffel_parser.y"
		local
			yyval41: detachable ET_CHOICE_CONSTANT
		do
--|#line 3381 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3381")
end

yyval41 := yyvs120.item (yyvsp120) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp41 := yyvsp41 + 1
	yyvsp120 := yyvsp120 -1
	if yyvsp41 >= yyvsc41 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs41")
		end
		yyvsc41 := yyvsc41 + yyInitial_yyvs_size
		yyvs41 := yyspecial_routines41.aliased_resized_area (yyvs41, yyvsc41)
	end
	yyspecial_routines41.force (yyvs41, yyval41, yyvsp41)
end
		end

	yy_do_action_661
			--|#line 3387 "et_eiffel_parser.y"
		local
			yyval25: detachable ET_ACROSS_INSTRUCTION
		do
--|#line 3387 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3387")
end

yyval25 := new_across_instruction_header (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp25 := yyvsp25 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp25 >= yyvsc25 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs25")
		end
		yyvsc25 := yyvsc25 + yyInitial_yyvs_size
		yyvs25 := yyspecial_routines25.aliased_resized_area (yyvs25, yyvsc25)
	end
	yyspecial_routines25.force (yyvs25, yyval25, yyvsp25)
end
		end

	yy_do_action_662
			--|#line 3389 "et_eiffel_parser.y"
		local
			yyval25: detachable ET_ACROSS_INSTRUCTION
		do
--|#line 3389 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3389")
end

yyval25 := new_across_instruction_header (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp25 := yyvsp25 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp25 >= yyvsc25 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs25")
		end
		yyvsc25 := yyvsc25 + yyInitial_yyvs_size
		yyvs25 := yyspecial_routines25.aliased_resized_area (yyvs25, yyvsc25)
	end
	yyspecial_routines25.force (yyvs25, yyval25, yyvsp25)
end
		end

	yy_do_action_663
			--|#line 3393 "et_eiffel_parser.y"
		local
			yyval119: detachable ET_REPEAT_INSTRUCTION
		do
--|#line 3393 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3393")
end

yyval119 := new_repeat_instruction_header (yyvs5.item (yyvsp5 - 2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs69.item (yyvsp69), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp119 := yyvsp119 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp12 := yyvsp12 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp119 >= yyvsc119 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs119")
		end
		yyvsc119 := yyvsc119 + yyInitial_yyvs_size
		yyvs119 := yyspecial_routines119.aliased_resized_area (yyvs119, yyvsc119)
	end
	yyspecial_routines119.force (yyvs119, yyval119, yyvsp119)
end
		end

	yy_do_action_664
			--|#line 3397 "et_eiffel_parser.y"
		local
			yyval48: detachable ET_CONDITIONAL
		do
--|#line 3397 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3397")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp48 := yyvsp48 + 1
	if yyvsp48 >= yyvsc48 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs48")
		end
		yyvsc48 := yyvsc48 + yyInitial_yyvs_size
		yyvs48 := yyspecial_routines48.aliased_resized_area (yyvs48, yyvsc48)
	end
	yyspecial_routines48.force (yyvs48, yyval48, yyvsp48)
end
		end

	yy_do_action_665
			--|#line 3399 "et_eiffel_parser.y"
		local
			yyval48: detachable ET_CONDITIONAL
		do
--|#line 3399 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3399")
end

yyval48 := ast_factory.new_conditional (yyvs2.item (yyvsp2), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp48 := yyvsp48 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp48 >= yyvsc48 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs48")
		end
		yyvsc48 := yyvsc48 + yyInitial_yyvs_size
		yyvs48 := yyspecial_routines48.aliased_resized_area (yyvs48, yyvsc48)
	end
	yyspecial_routines48.force (yyvs48, yyval48, yyvsp48)
end
		end

	yy_do_action_666
			--|#line 3405 "et_eiffel_parser.y"
		local
			yyval62: detachable ET_DEBUG_INSTRUCTION
		do
--|#line 3405 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3405")
end

yyval62 := ast_factory.new_debug_instruction (yyvs103.item (yyvsp103), ast_factory.new_debug_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47)), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp62 := yyvsp62 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -1
	if yyvsp62 >= yyvsc62 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs62")
		end
		yyvsc62 := yyvsc62 + yyInitial_yyvs_size
		yyvs62 := yyspecial_routines62.aliased_resized_area (yyvs62, yyvsc62)
	end
	yyspecial_routines62.force (yyvs62, yyval62, yyvsp62)
end
		end

	yy_do_action_667
			--|#line 3409 "et_eiffel_parser.y"
		local
			yyval103: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3409 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3409")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp103 := yyvsp103 + 1
	if yyvsp103 >= yyvsc103 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs103")
		end
		yyvsc103 := yyvsc103 + yyInitial_yyvs_size
		yyvs103 := yyspecial_routines103.aliased_resized_area (yyvs103, yyvsc103)
	end
	yyspecial_routines103.force (yyvs103, yyval103, yyvsp103)
end
		end

	yy_do_action_668
			--|#line 3411 "et_eiffel_parser.y"
		local
			yyval103: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3411 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3411")
end

yyval103 := ast_factory.new_manifest_string_list (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp103 := yyvsp103 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp103 >= yyvsc103 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs103")
		end
		yyvsc103 := yyvsc103 + yyInitial_yyvs_size
		yyvs103 := yyspecial_routines103.aliased_resized_area (yyvs103, yyvsc103)
	end
	yyspecial_routines103.force (yyvs103, yyval103, yyvsp103)
end
		end

	yy_do_action_669
			--|#line 3413 "et_eiffel_parser.y"
		local
			yyval103: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3413 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3413")
end

			yyval103 := yyvs103.item (yyvsp103)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp103 := yyvsp103 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines103.force (yyvs103, yyval103, yyvsp103)
end
		end

	yy_do_action_670
			--|#line 3413 "et_eiffel_parser.y"
		local
			yyval103: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3413 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3413")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp103 := yyvsp103 + 1
	if yyvsp103 >= yyvsc103 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs103")
		end
		yyvsc103 := yyvsc103 + yyInitial_yyvs_size
		yyvs103 := yyspecial_routines103.aliased_resized_area (yyvs103, yyvsc103)
	end
	yyspecial_routines103.force (yyvs103, yyval103, yyvsp103)
end
		end

	yy_do_action_671
			--|#line 3426 "et_eiffel_parser.y"
		local
			yyval103: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3426 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3426")
end

			if attached yyvs15.item (yyvsp15) as l_manifest_string then
				yyval103 := ast_factory.new_manifest_string_list (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval103 /= Void then
					yyval103.put_first (l_manifest_string)
				end
			else
				yyval103 := ast_factory.new_manifest_string_list (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp103 := yyvsp103 + 1
	yyvsp15 := yyvsp15 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp103 >= yyvsc103 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs103")
		end
		yyvsc103 := yyvsc103 + yyInitial_yyvs_size
		yyvs103 := yyspecial_routines103.aliased_resized_area (yyvs103, yyvsc103)
	end
	yyspecial_routines103.force (yyvs103, yyval103, yyvsp103)
end
		end

	yy_do_action_672
			--|#line 3437 "et_eiffel_parser.y"
		local
			yyval103: detachable ET_MANIFEST_STRING_LIST
		do
--|#line 3437 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3437")
end

			yyval103 := yyvs103.item (yyvsp103)
			if yyval103 /= Void and attached yyvs102.item (yyvsp102) as l_manifest_string then
				yyval103.put_first (l_manifest_string)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp102 := yyvsp102 -1
	yyspecial_routines103.force (yyvs103, yyval103, yyvsp103)
end
		end

	yy_do_action_673
			--|#line 3446 "et_eiffel_parser.y"
		local
			yyval102: detachable ET_MANIFEST_STRING_ITEM
		do
--|#line 3446 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3446")
end

			yyval102 := ast_factory.new_manifest_string_comma (yyvs15.item (yyvsp15), yyvs5.item (yyvsp5))
			if yyval102 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp102 := yyvsp102 + 1
	yyvsp15 := yyvsp15 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp102 >= yyvsc102 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs102")
		end
		yyvsc102 := yyvsc102 + yyInitial_yyvs_size
		yyvs102 := yyspecial_routines102.aliased_resized_area (yyvs102, yyvsc102)
	end
	yyspecial_routines102.force (yyvs102, yyval102, yyvsp102)
end
		end

	yy_do_action_674
			--|#line 3457 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3457 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3457")
end

yyval93 := new_unqualified_call_instruction (yyvs12.item (yyvsp12), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp93 := yyvsp93 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_675
			--|#line 3459 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3459 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3459")
end

yyval93 := ast_factory.new_qualified_call_instruction (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp93 := yyvsp93 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_676
			--|#line 3461 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3461 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3461")
end

yyval93 := ast_factory.new_qualified_call_instruction (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp93 := yyvsp93 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_677
			--|#line 3463 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3463 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3463")
end

yyval93 := ast_factory.new_precursor_instruction (False, yyvs4.item (yyvsp4), Void, yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp93 := yyvsp93 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_678
			--|#line 3465 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3465 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3465")
end

yyval93 := ast_factory.new_precursor_instruction (False, yyvs4.item (yyvsp4), ast_factory.new_precursor_class_name (yyvs5.item (yyvsp5 - 1), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp93 := yyvsp93 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp5 := yyvsp5 -2
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_679
			--|#line 3467 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3467 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3467")
end

yyval93 := ast_factory.new_static_call_instruction (yyvs2.item (yyvsp2), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1)), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp93 := yyvsp93 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_680
			--|#line 3469 "et_eiffel_parser.y"
		local
			yyval93: detachable ET_INSTRUCTION
		do
--|#line 3469 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3469")
end

yyval93 := ast_factory.new_static_call_instruction (Void, ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1)), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp93 := yyvsp93 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp93 >= yyvsc93 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs93")
		end
		yyvsc93 := yyvsc93 + yyInitial_yyvs_size
		yyvs93 := yyspecial_routines93.aliased_resized_area (yyvs93, yyvsc93)
	end
	yyspecial_routines93.force (yyvs93, yyval93, yyvsp93)
end
		end

	yy_do_action_681
			--|#line 3473 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3473 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3473")
end

yyval69 := new_unqualified_call_expression (yyvs12.item (yyvsp12), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_682
			--|#line 3475 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3475 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3475")
end

yyval69 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_683
			--|#line 3479 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3479 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3479")
end

yyval69 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_684
			--|#line 3483 "et_eiffel_parser.y"
		local
			yyval38: detachable ET_QUALIFIED_CALL_EXPRESSION
		do
--|#line 3483 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3483")
end

yyval38 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp38 := yyvsp38 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
		end

	yy_do_action_685
			--|#line 3485 "et_eiffel_parser.y"
		local
			yyval38: detachable ET_QUALIFIED_CALL_EXPRESSION
		do
--|#line 3485 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3485")
end

yyval38 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp38 := yyvsp38 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp38 >= yyvsc38 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs38")
		end
		yyvsc38 := yyvsc38 + yyInitial_yyvs_size
		yyvs38 := yyspecial_routines38.aliased_resized_area (yyvs38, yyvsc38)
	end
	yyspecial_routines38.force (yyvs38, yyval38, yyvsp38)
end
		end

	yy_do_action_686
			--|#line 3489 "et_eiffel_parser.y"
		local
			yyval120: detachable ET_STATIC_CALL_EXPRESSION
		do
--|#line 3489 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3489")
end

yyval120 := ast_factory.new_static_call_expression (yyvs2.item (yyvsp2), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1)), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp120 := yyvsp120 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp120 >= yyvsc120 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs120")
		end
		yyvsc120 := yyvsc120 + yyInitial_yyvs_size
		yyvs120 := yyspecial_routines120.aliased_resized_area (yyvs120, yyvsc120)
	end
	yyspecial_routines120.force (yyvs120, yyval120, yyvsp120)
end
		end

	yy_do_action_687
			--|#line 3491 "et_eiffel_parser.y"
		local
			yyval120: detachable ET_STATIC_CALL_EXPRESSION
		do
--|#line 3491 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3491")
end

yyval120 := ast_factory.new_static_call_expression (Void, ast_factory.new_target_type (yyvs5.item (yyvsp5 - 2), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5 - 1)), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp120 := yyvsp120 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp120 >= yyvsc120 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs120")
		end
		yyvsc120 := yyvsc120 + yyInitial_yyvs_size
		yyvs120 := yyspecial_routines120.aliased_resized_area (yyvs120, yyvsc120)
	end
	yyspecial_routines120.force (yyvs120, yyval120, yyvsp120)
end
		end

	yy_do_action_688
			--|#line 3495 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3495 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3495")
end

yyval69 := ast_factory.new_precursor_expression (False, yyvs4.item (yyvsp4), Void, yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_689
			--|#line 3497 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3497 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3497")
end

yyval69 := ast_factory.new_precursor_expression (False, yyvs4.item (yyvsp4), ast_factory.new_precursor_class_name (yyvs5.item (yyvsp5 - 1), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp69 := yyvsp69 + 1
	yyvsp4 := yyvsp4 -1
	yyvsp5 := yyvsp5 -2
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_690
			--|#line 3501 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3501 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3501")
end

yyval69 := new_unqualified_call_expression (yyvs12.item (yyvsp12), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_691
			--|#line 3503 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3503 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3503")
end

yyval69 := yyvs17.item (yyvsp17) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp17 := yyvsp17 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_692
			--|#line 3505 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3505 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3505")
end

yyval69 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_693
			--|#line 3507 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3507 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3507")
end

yyval69 := yyvs106.item (yyvsp106) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp106 := yyvsp106 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_694
			--|#line 3509 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3509 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3509")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_695
			--|#line 3511 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3511 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3511")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval69 := yyvs36.item (yyvsp36)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_696
			--|#line 3519 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3519 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3519")
end

yyval69 := yyvs120.item (yyvsp120) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp120 := yyvsp120 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_697
			--|#line 3521 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3521 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3521")
end

yyval69 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_698
			--|#line 3525 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3525 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3525")
end

			if system_processor.older_ise_version (ise_5_7_59914) then
				raise_error
			else
				yyval69 := yyvs36.item (yyvsp36)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_699
			--|#line 3533 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3533 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3533")
end

yyval69 := ast_factory.new_qualified_call_expression (yyvs69.item (yyvsp69), new_dot_feature_name (yyvs5.item (yyvsp5), yyvs12.item (yyvsp12)), yyvs26.item (yyvsp26)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -1
	yyvsp12 := yyvsp12 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_700
			--|#line 3539 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3539 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3539")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp26 := yyvsp26 + 1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_701
			--|#line 3541 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3541 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3541")
end

yyval26 := ast_factory.new_actual_arguments (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_702
			--|#line 3543 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3543 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3543")
end

			yyval26 := yyvs26.item (yyvsp26)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp26 := yyvsp26 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_703
			--|#line 3543 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3543 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3543")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp26 := yyvsp26 + 1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_704
			--|#line 3556 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3556 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3556")
end

			if attached yyvs69.item (yyvsp69) as l_expression then
				yyval26 := ast_factory.new_actual_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval26 /= Void then
					yyval26.put_first (l_expression)
				end
			else
				yyval26 := ast_factory.new_actual_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_705
			--|#line 3567 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3567 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3567")
end

			yyval26 := ast_factory.new_actual_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval26 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval26.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp70 := yyvsp70 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_706
			--|#line 3575 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3575 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3575")
end

			yyval26 := yyvs26.item (yyvsp26)
			if yyval26 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval26.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 -1
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_707
			--|#line 3584 "et_eiffel_parser.y"
		local
			yyval70: detachable ET_EXPRESSION_ITEM
		do
--|#line 3584 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3584")
end

			yyval70 := ast_factory.new_expression_comma (yyvs69.item (yyvsp69), yyvs5.item (yyvsp5))
			if yyval70 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp70 >= yyvsc70 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs70")
		end
		yyvsc70 := yyvsc70 + yyInitial_yyvs_size
		yyvs70 := yyspecial_routines70.aliased_resized_area (yyvs70, yyvsc70)
	end
	yyspecial_routines70.force (yyvs70, yyval70, yyvsp70)
end
		end

	yy_do_action_708
			--|#line 3593 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3593 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3593")
end

yyval69 := new_feature_address (yyvs5.item (yyvsp5), yyvs76.item (yyvsp76)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp76 := yyvsp76 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_709
			--|#line 3595 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3595 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3595")
end

yyval69 := ast_factory.new_current_address (yyvs5.item (yyvsp5), yyvs10.item (yyvsp10)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp10 := yyvsp10 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_710
			--|#line 3597 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3597 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3597")
end

yyval69 := ast_factory.new_result_address (yyvs5.item (yyvsp5), yyvs17.item (yyvsp17)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp17 := yyvsp17 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_711
			--|#line 3599 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3599 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3599")
end

yyval69 := ast_factory.new_expression_address (yyvs5.item (yyvsp5), yyvs106.item (yyvsp106)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -1
	yyvsp106 := yyvsp106 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_712
			--|#line 3606 "et_eiffel_parser.y"
		local
			yyval131: detachable ET_WRITABLE
		do
--|#line 3606 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3606")
end

yyval131 := new_writable (yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp131 := yyvsp131 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp131 >= yyvsc131 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs131")
		end
		yyvsc131 := yyvsc131 + yyInitial_yyvs_size
		yyvs131 := yyspecial_routines131.aliased_resized_area (yyvs131, yyvsc131)
	end
	yyspecial_routines131.force (yyvs131, yyval131, yyvsp131)
end
		end

	yy_do_action_713
			--|#line 3608 "et_eiffel_parser.y"
		local
			yyval131: detachable ET_WRITABLE
		do
--|#line 3608 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3608")
end

yyval131 := yyvs17.item (yyvsp17) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp131 := yyvsp131 + 1
	yyvsp17 := yyvsp17 -1
	if yyvsp131 >= yyvsc131 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs131")
		end
		yyvsc131 := yyvsc131 + yyInitial_yyvs_size
		yyvs131 := yyspecial_routines131.aliased_resized_area (yyvs131, yyvsc131)
	end
	yyspecial_routines131.force (yyvs131, yyval131, yyvsp131)
end
		end

	yy_do_action_714
			--|#line 3614 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3614 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3614")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_715
			--|#line 3616 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3616 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3616")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_716
			--|#line 3620 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3620 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3620")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_free_operator (yyvs11.item (yyvsp11)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp11 := yyvsp11 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_717
			--|#line 3622 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3622 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3622")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_plus_operator (yyvs19.item (yyvsp19)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_718
			--|#line 3624 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3624 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3624")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_minus_operator (yyvs19.item (yyvsp19)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_719
			--|#line 3626 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3626 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3626")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_720
			--|#line 3628 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3628 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3628")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_721
			--|#line 3630 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3630 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3630")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_722
			--|#line 3632 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3632 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3632")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_723
			--|#line 3634 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3634 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3634")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_724
			--|#line 3636 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3636 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3636")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_725
			--|#line 3638 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3638 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3638")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_726
			--|#line 3640 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3640 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3640")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_727
			--|#line 3642 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3642 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3642")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_728
			--|#line 3644 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3644 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3644")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_729
			--|#line 3646 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3646 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3646")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_730
			--|#line 3648 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3648 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3648")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_731
			--|#line 3650 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3650 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3650")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_and_then_operator (yyvs14.item (yyvsp14), yyvs2.item (yyvsp2)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_732
			--|#line 3652 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3652 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3652")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), ast_factory.new_infix_or_else_operator (yyvs14.item (yyvsp14), yyvs2.item (yyvsp2)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyvsp2 := yyvsp2 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_733
			--|#line 3654 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3654 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3654")
end

yyval69 := ast_factory.new_infix_expression (yyvs69.item (yyvsp69 - 1), yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_734
			--|#line 3656 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3656 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3656")
end

yyval69 := ast_factory.new_equality_expression (yyvs69.item (yyvsp69 - 1), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_735
			--|#line 3658 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3658 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3658")
end

yyval69 := ast_factory.new_equality_expression (yyvs69.item (yyvsp69 - 1), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_736
			--|#line 3660 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3660 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3660")
end

yyval69 := ast_factory.new_object_equality_expression (yyvs69.item (yyvsp69 - 1), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_737
			--|#line 3662 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3662 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3662")
end

yyval69 := ast_factory.new_object_equality_expression (yyvs69.item (yyvsp69 - 1), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_738
			--|#line 3666 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3666 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3666")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_739
			--|#line 3668 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3668 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3668")
end

yyval69 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_740
			--|#line 3670 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3670 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3670")
end

yyval69 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_741
			--|#line 3672 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3672 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3672")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_742
			--|#line 3674 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3674 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3674")
end

yyval69 := yyvs36.item (yyvsp36) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_743
			--|#line 3676 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3676 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3676")
end

yyval69 := ast_factory.new_manifest_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp69 := yyvsp69 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_744
			--|#line 3680 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3680 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3680")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_745
			--|#line 3682 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3682 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3682")
end

yyval69 := yyvs36.item (yyvsp36) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp36 := yyvsp36 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_746
			--|#line 3684 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3684 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3684")
end

yyval69 := yyvs58.item (yyvsp58) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp58 := yyvsp58 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_747
			--|#line 3686 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3686 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3686")
end

yyval69 := yyvs24.item (yyvsp24) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp24 := yyvsp24 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_748
			--|#line 3688 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3688 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3688")
end

yyval69 := yyvs24.item (yyvsp24) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp24 := yyvsp24 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_749
			--|#line 3690 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3690 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3690")
end

yyval69 := yyvs115.item (yyvsp115) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp115 := yyvsp115 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_750
			--|#line 3692 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3692 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3692")
end

yyval69 := yyvs84.item (yyvsp84) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp84 := yyvsp84 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_751
			--|#line 3694 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3694 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3694")
end

yyval69 := yyvs104.item (yyvsp104) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp104 := yyvsp104 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_752
			--|#line 3696 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3696 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3696")
end

yyval69 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_753
			--|#line 3698 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3698 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3698")
end

yyval69 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_754
			--|#line 3700 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3700 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3700")
end

yyval69 := new_prefix_plus_expression (yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_755
			--|#line 3702 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3702 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3702")
end

yyval69 := new_prefix_minus_expression (yyvs19.item (yyvsp19), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_756
			--|#line 3704 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3704 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3704")
end

yyval69 := ast_factory.new_prefix_expression (yyvs14.item (yyvsp14), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp14 := yyvsp14 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_757
			--|#line 3706 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3706 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3706")
end

yyval69 := ast_factory.new_prefix_expression (ast_factory.new_prefix_free_operator (yyvs11.item (yyvsp11)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp11 := yyvsp11 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_758
			--|#line 3708 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3708 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3708")
end

yyval69 := ast_factory.new_old_expression (yyvs2.item (yyvsp2), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_759
			--|#line 3710 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3710 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3710")
end

			if system_processor.older_ise_version (ise_6_1_0) then
				raise_error
			else
				yyval69 := new_old_object_test (yyvs5.item (yyvsp5 - 2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5), yyvs69.item (yyvsp69))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 6
	yyvsp5 := yyvsp5 -3
	yyvsp12 := yyvsp12 -1
	yyvsp122 := yyvsp122 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_760
			--|#line 3718 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3718 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3718")
end

yyval69 := ast_factory.new_object_test (yyvs2.item (yyvsp2), Void, yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp2 := yyvsp2 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_761
			--|#line 3720 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3720 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3720")
end

yyval69 := ast_factory.new_object_test (yyvs2.item (yyvsp2), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_762
			--|#line 3722 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3722 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3722")
end

yyval69 := new_named_object_test (yyvs2.item (yyvsp2 - 1), Void, yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp2 := yyvsp2 -2
	yyvsp12 := yyvsp12 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_763
			--|#line 3724 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3724 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3724")
end

yyval69 := new_named_object_test (yyvs2.item (yyvsp2 - 1), ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp2 := yyvsp2 -2
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyvsp12 := yyvsp12 -1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_764
			--|#line 3728 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3728 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3728")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_765
			--|#line 3730 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3730 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3730")
end

yyval69 := yyvs120.item (yyvsp120) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp120 := yyvsp120 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_766
			--|#line 3732 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3732 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3732")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_767
			--|#line 3734 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3734 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3734")
end

yyval69 := yyvs17.item (yyvsp17) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp17 := yyvsp17 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_768
			--|#line 3736 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3736 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3736")
end

yyval69 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_769
			--|#line 3738 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3738 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3738")
end

yyval69 := yyvs106.item (yyvsp106) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp106 := yyvsp106 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_770
			--|#line 3740 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3740 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3740")
end

yyval69 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_771
			--|#line 3742 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3742 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3742")
end

yyval69 := yyvs37.item (yyvsp37) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp37 := yyvsp37 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_772
			--|#line 3744 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3744 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3744")
end

yyval69 := yyvs91.item (yyvsp91) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp91 := yyvsp91 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_773
			--|#line 3746 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3746 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3746")
end

yyval69 := yyvs20.item (yyvsp20) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp20 := yyvsp20 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_774
			--|#line 3748 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3748 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3748")
end

yyval69 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_775
			--|#line 3750 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3750 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3750")
end

yyval69 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_776
			--|#line 3752 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3752 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3752")
end

yyval69 := new_once_manifest_string (yyvs2.item (yyvsp2), yyvs15.item (yyvsp15)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp15 := yyvsp15 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_777
			--|#line 3785 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3785 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3785")
end

yyval69 := yyvs101.item (yyvsp101) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp101 := yyvsp101 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_778
			--|#line 3787 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3787 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3787")
end

yyval69 := yyvs121.item (yyvsp121) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp121 := yyvsp121 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_779
			--|#line 3789 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3789 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3789")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_780
			--|#line 3793 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3793 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3793")
end

yyval69 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_781
			--|#line 3795 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3795 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3795")
end

yyval69 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_782
			--|#line 3797 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3797 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3797")
end

			if system_processor.older_ise_version (ise_17_11_0) then
				raise_error
			else
				yyval69 := yyvs101.item (yyvsp101)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp101 := yyvsp101 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_783
			--|#line 3805 "et_eiffel_parser.y"
		local
			yyval69: detachable ET_EXPRESSION
		do
--|#line 3805 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3805")
end

yyval69 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp69 := yyvsp69 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp69 >= yyvsc69 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs69")
		end
		yyvsc69 := yyvsc69 + yyInitial_yyvs_size
		yyvs69 := yyspecial_routines69.aliased_resized_area (yyvs69, yyvsc69)
	end
	yyspecial_routines69.force (yyvs69, yyval69, yyvsp69)
end
		end

	yy_do_action_784
			--|#line 3809 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3809 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3809")
end

yyval36 := yyvs36.item (yyvsp36) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_785
			--|#line 3811 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3811 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3811")
end

yyval36 := yyvs36.item (yyvsp36) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_786
			--|#line 3815 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3815 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3815")
end

			yyval36 := ast_factory.new_bracket_expression (yyvs69.item (yyvsp69), yyvs22.item (yyvsp22), yyvs26.item (yyvsp26))
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp69 := yyvsp69 -1
	yyvsp22 := yyvsp22 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_787
			--|#line 3815 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3815 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3815")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_788
			--|#line 3826 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3826 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3826")
end

			yyval36 := ast_factory.new_bracket_expression (yyvs36.item (yyvsp36 - 1), yyvs22.item (yyvsp22), yyvs26.item (yyvsp26))
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp36 := yyvsp36 -1
	yyvsp22 := yyvsp22 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_789
			--|#line 3826 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3826 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3826")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_790
			--|#line 3839 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3839 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3839")
end

			yyval36 := ast_factory.new_bracket_expression (yyvs69.item (yyvsp69), yyvs22.item (yyvsp22), yyvs26.item (yyvsp26))
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp69 := yyvsp69 -1
	yyvsp22 := yyvsp22 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_791
			--|#line 3839 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3839 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3839")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_792
			--|#line 3850 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3850 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3850")
end

			yyval36 := ast_factory.new_bracket_expression (yyvs36.item (yyvsp36 - 1), yyvs22.item (yyvsp22), yyvs26.item (yyvsp26))
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp36 := yyvsp36 -1
	yyvsp22 := yyvsp22 -1
	yyvsp26 := yyvsp26 -1
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_793
			--|#line 3850 "et_eiffel_parser.y"
		local
			yyval36: detachable ET_BRACKET_EXPRESSION
		do
--|#line 3850 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3850")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp36 := yyvsp36 + 1
	if yyvsp36 >= yyvsc36 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs36")
		end
		yyvsc36 := yyvsc36 + yyInitial_yyvs_size
		yyvs36 := yyspecial_routines36.aliased_resized_area (yyvs36, yyvsc36)
	end
	yyspecial_routines36.force (yyvs36, yyval36, yyvsp36)
end
		end

	yy_do_action_794
			--|#line 3863 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3863 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3863")
end

			if attached yyvs69.item (yyvsp69) as l_expression then
				yyval26 := ast_factory.new_bracket_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval26 /= Void then
					yyval26.put_first (l_expression)
				end
			else
				yyval26 := ast_factory.new_bracket_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_795
			--|#line 3874 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3874 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3874")
end

			yyval26 := ast_factory.new_bracket_arguments (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval26 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval26.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp26 := yyvsp26 + 1
	yyvsp70 := yyvsp70 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp26 >= yyvsc26 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs26")
		end
		yyvsc26 := yyvsc26 + yyInitial_yyvs_size
		yyvs26 := yyspecial_routines26.aliased_resized_area (yyvs26, yyvsc26)
	end
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_796
			--|#line 3882 "et_eiffel_parser.y"
		local
			yyval26: detachable ET_ACTUAL_ARGUMENT_LIST
		do
--|#line 3882 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3882")
end

			yyval26 := yyvs26.item (yyvsp26)
			if yyval26 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval26.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 -1
	yyspecial_routines26.force (yyvs26, yyval26, yyvsp26)
end
		end

	yy_do_action_797
			--|#line 3891 "et_eiffel_parser.y"
		local
			yyval106: detachable ET_PARENTHESIZED_EXPRESSION
		do
--|#line 3891 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3891")
end

			remove_symbol
			remove_counter
		 	yyval106 := ast_factory.new_parenthesized_expression (yyvs5.item (yyvsp5 - 1), yyvs69.item (yyvsp69), yyvs5.item (yyvsp5))
		 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp106 := yyvsp106 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp69 := yyvsp69 -1
	if yyvsp106 >= yyvsc106 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs106")
		end
		yyvsc106 := yyvsc106 + yyInitial_yyvs_size
		yyvs106 := yyspecial_routines106.aliased_resized_area (yyvs106, yyvsc106)
	end
	yyspecial_routines106.force (yyvs106, yyval106, yyvsp106)
end
		end

	yy_do_action_798
			--|#line 3899 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_MANIFEST_ARRAY
		do
--|#line 3899 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3899")
end

yyval101 := ast_factory.new_manifest_array (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp101 := yyvsp101 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp101 >= yyvsc101 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs101")
		end
		yyvsc101 := yyvsc101 + yyInitial_yyvs_size
		yyvs101 := yyspecial_routines101.aliased_resized_area (yyvs101, yyvsc101)
	end
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_799
			--|#line 3901 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_MANIFEST_ARRAY
		do
--|#line 3901 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3901")
end

			yyval101 := yyvs101.item (yyvsp101)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp101 := yyvsp101 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_800
			--|#line 3901 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_MANIFEST_ARRAY
		do
--|#line 3901 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3901")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp101 := yyvsp101 + 1
	if yyvsp101 >= yyvsc101 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs101")
		end
		yyvsc101 := yyvsc101 + yyInitial_yyvs_size
		yyvs101 := yyspecial_routines101.aliased_resized_area (yyvs101, yyvsc101)
	end
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_801
			--|#line 3914 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_MANIFEST_ARRAY
		do
--|#line 3914 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3914")
end

			yyval101 := yyvs101.item (yyvsp101)
			if yyval101 /= Void then
				yyval101.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_802
			--|#line 3923 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_MANIFEST_ARRAY
		do
--|#line 3923 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3923")
end

			if attached yyvs69.item (yyvsp69) as l_expression then
				yyval101 := ast_factory.new_manifest_array (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval101 /= Void then
					yyval101.put_first (l_expression)
				end
			else
				yyval101 := ast_factory.new_manifest_array (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp101 := yyvsp101 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp101 >= yyvsc101 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs101")
		end
		yyvsc101 := yyvsc101 + yyInitial_yyvs_size
		yyvs101 := yyspecial_routines101.aliased_resized_area (yyvs101, yyvsc101)
	end
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_803
			--|#line 3934 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_MANIFEST_ARRAY
		do
--|#line 3934 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3934")
end

			yyval101 := ast_factory.new_manifest_array (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval101 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval101.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp101 := yyvsp101 + 1
	yyvsp70 := yyvsp70 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp101 >= yyvsc101 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs101")
		end
		yyvsc101 := yyvsc101 + yyInitial_yyvs_size
		yyvs101 := yyspecial_routines101.aliased_resized_area (yyvs101, yyvsc101)
	end
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_804
			--|#line 3942 "et_eiffel_parser.y"
		local
			yyval101: detachable ET_MANIFEST_ARRAY
		do
--|#line 3942 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3942")
end

			yyval101 := yyvs101.item (yyvsp101)
			if yyval101 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval101.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 -1
	yyspecial_routines101.force (yyvs101, yyval101, yyvsp101)
end
		end

	yy_do_action_805
			--|#line 3951 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_TUPLE
		do
--|#line 3951 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3951")
end

yyval104 := ast_factory.new_manifest_tuple (yyvs22.item (yyvsp22), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp104 := yyvsp104 + 1
	yyvsp22 := yyvsp22 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp104 >= yyvsc104 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs104")
		end
		yyvsc104 := yyvsc104 + yyInitial_yyvs_size
		yyvs104 := yyspecial_routines104.aliased_resized_area (yyvs104, yyvsc104)
	end
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_806
			--|#line 3953 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_TUPLE
		do
--|#line 3953 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3953")
end

			yyval104 := yyvs104.item (yyvsp104)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp104 := yyvsp104 -1
	yyvsp22 := yyvsp22 -1
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_807
			--|#line 3953 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_TUPLE
		do
--|#line 3953 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3953")
end

			add_symbol (yyvs22.item (yyvsp22))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp104 := yyvsp104 + 1
	if yyvsp104 >= yyvsc104 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs104")
		end
		yyvsc104 := yyvsc104 + yyInitial_yyvs_size
		yyvs104 := yyspecial_routines104.aliased_resized_area (yyvs104, yyvsc104)
	end
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_808
			--|#line 3966 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_TUPLE
		do
--|#line 3966 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3966")
end

			if attached yyvs69.item (yyvsp69) as l_expression then
				yyval104 := ast_factory.new_manifest_tuple (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval104 /= Void then
					yyval104.put_first (l_expression)
				end
			else
				yyval104 := ast_factory.new_manifest_tuple (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp104 := yyvsp104 + 1
	yyvsp69 := yyvsp69 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp104 >= yyvsc104 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs104")
		end
		yyvsc104 := yyvsc104 + yyInitial_yyvs_size
		yyvs104 := yyspecial_routines104.aliased_resized_area (yyvs104, yyvsc104)
	end
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_809
			--|#line 3977 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_TUPLE
		do
--|#line 3977 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3977")
end

			yyval104 := ast_factory.new_manifest_tuple (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval104 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval104.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp104 := yyvsp104 + 1
	yyvsp70 := yyvsp70 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp104 >= yyvsc104 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs104")
		end
		yyvsc104 := yyvsc104 + yyInitial_yyvs_size
		yyvs104 := yyspecial_routines104.aliased_resized_area (yyvs104, yyvsc104)
	end
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_810
			--|#line 3985 "et_eiffel_parser.y"
		local
			yyval104: detachable ET_MANIFEST_TUPLE
		do
--|#line 3985 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3985")
end

			yyval104 := yyvs104.item (yyvsp104)
			if yyval104 /= Void and attached yyvs70.item (yyvsp70) as l_expression then
				yyval104.put_first (l_expression)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp70 := yyvsp70 -1
	yyspecial_routines104.force (yyvs104, yyval104, yyvsp104)
end
		end

	yy_do_action_811
			--|#line 3994 "et_eiffel_parser.y"
		local
			yyval121: detachable ET_STRIP_EXPRESSION
		do
--|#line 3994 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3994")
end

yyval121 := ast_factory.new_strip_expression (yyvs2.item (yyvsp2), yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp121 := yyvsp121 + 1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -2
	if yyvsp121 >= yyvsc121 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs121")
		end
		yyvsc121 := yyvsc121 + yyInitial_yyvs_size
		yyvs121 := yyspecial_routines121.aliased_resized_area (yyvs121, yyvsc121)
	end
	yyspecial_routines121.force (yyvs121, yyval121, yyvsp121)
end
		end

	yy_do_action_812
			--|#line 3996 "et_eiffel_parser.y"
		local
			yyval121: detachable ET_STRIP_EXPRESSION
		do
--|#line 3996 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3996")
end

			yyval121 := yyvs121.item (yyvsp121)
			remove_keyword
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp121 := yyvsp121 -1
	yyvsp2 := yyvsp2 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines121.force (yyvs121, yyval121, yyvsp121)
end
		end

	yy_do_action_813
			--|#line 3996 "et_eiffel_parser.y"
		local
			yyval121: detachable ET_STRIP_EXPRESSION
		do
--|#line 3996 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 3996")
end

			add_keyword (yyvs2.item (yyvsp2))
			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp121 := yyvsp121 + 1
	if yyvsp121 >= yyvsc121 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs121")
		end
		yyvsc121 := yyvsc121 + yyInitial_yyvs_size
		yyvs121 := yyspecial_routines121.aliased_resized_area (yyvs121, yyvsc121)
	end
	yyspecial_routines121.force (yyvs121, yyval121, yyvsp121)
end
		end

	yy_do_action_814
			--|#line 4011 "et_eiffel_parser.y"
		local
			yyval121: detachable ET_STRIP_EXPRESSION
		do
--|#line 4011 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4011")
end

			if attached yyvs76.item (yyvsp76) as l_feature_name then
				yyval121 := ast_factory.new_strip_expression (last_keyword, last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval121 /= Void then
					yyval121.put_first (l_feature_name)
				end
			else
				yyval121 := ast_factory.new_strip_expression (last_keyword, last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp121 := yyvsp121 + 1
	yyvsp76 := yyvsp76 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp121 >= yyvsc121 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs121")
		end
		yyvsc121 := yyvsc121 + yyInitial_yyvs_size
		yyvs121 := yyspecial_routines121.aliased_resized_area (yyvs121, yyvsc121)
	end
	yyspecial_routines121.force (yyvs121, yyval121, yyvsp121)
end
		end

	yy_do_action_815
			--|#line 4022 "et_eiffel_parser.y"
		local
			yyval121: detachable ET_STRIP_EXPRESSION
		do
--|#line 4022 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4022")
end

			yyval121 := ast_factory.new_strip_expression (last_keyword, last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval121 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval121.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp121 := yyvsp121 + 1
	yyvsp77 := yyvsp77 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp121 >= yyvsc121 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs121")
		end
		yyvsc121 := yyvsc121 + yyInitial_yyvs_size
		yyvs121 := yyspecial_routines121.aliased_resized_area (yyvs121, yyvsc121)
	end
	yyspecial_routines121.force (yyvs121, yyval121, yyvsp121)
end
		end

	yy_do_action_816
			--|#line 4030 "et_eiffel_parser.y"
		local
			yyval121: detachable ET_STRIP_EXPRESSION
		do
--|#line 4030 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4030")
end

			yyval121 := yyvs121.item (yyvsp121)
			if yyval121 /= Void and attached yyvs77.item (yyvsp77) as l_feature_name then
				yyval121.put_first (l_feature_name)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp77 := yyvsp77 -1
	yyspecial_routines121.force (yyvs121, yyval121, yyvsp121)
end
		end

	yy_do_action_817
			--|#line 4039 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4039 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4039")
end

yyval49 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp7 := yyvsp7 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_818
			--|#line 4041 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4041 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4041")
end

yyval49 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp9 := yyvsp9 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_819
			--|#line 4043 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4043 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4043")
end

yyval49 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp13 := yyvsp13 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_820
			--|#line 4045 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4045 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4045")
end

yyval49 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp16 := yyvsp16 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_821
			--|#line 4047 "et_eiffel_parser.y"
		local
			yyval49: detachable ET_CONSTANT
		do
--|#line 4047 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4047")
end

yyval49 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp49 := yyvsp49 + 1
	yyvsp15 := yyvsp15 -1
	if yyvsp49 >= yyvsc49 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs49")
		end
		yyvsc49 := yyvsc49 + yyInitial_yyvs_size
		yyvs49 := yyspecial_routines49.aliased_resized_area (yyvs49, yyvsc49)
	end
	yyspecial_routines49.force (yyvs49, yyval49, yyvsp49)
end
		end

	yy_do_action_822
			--|#line 4051 "et_eiffel_parser.y"
		local
			yyval24: detachable ET_ACROSS_EXPRESSION
		do
--|#line 4051 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4051")
end

yyval24 := new_across_some_expression (yyvs24.item (yyvsp24), yyvs100.item (yyvsp100), yyvs48.item (yyvsp48), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs128.item (yyvsp128), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp100 := yyvsp100 -1
	yyvsp48 := yyvsp48 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp128 := yyvsp128 -1
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
		end

	yy_do_action_823
			--|#line 4055 "et_eiffel_parser.y"
		local
			yyval24: detachable ET_ACROSS_EXPRESSION
		do
--|#line 4055 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4055")
end

yyval24 := new_across_all_expression (yyvs24.item (yyvsp24), yyvs100.item (yyvsp100), yyvs48.item (yyvsp48), ast_factory.new_conditional (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69)), yyvs128.item (yyvsp128), yyvs2.item (yyvsp2)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 7
	yyvsp100 := yyvsp100 -1
	yyvsp48 := yyvsp48 -1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp128 := yyvsp128 -1
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
		end

	yy_do_action_824
			--|#line 4059 "et_eiffel_parser.y"
		local
			yyval24: detachable ET_ACROSS_EXPRESSION
		do
--|#line 4059 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4059")
end

yyval24 := new_across_expression_header (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp24 := yyvsp24 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp24 >= yyvsc24 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs24")
		end
		yyvsc24 := yyvsc24 + yyInitial_yyvs_size
		yyvs24 := yyspecial_routines24.aliased_resized_area (yyvs24, yyvsc24)
	end
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
		end

	yy_do_action_825
			--|#line 4061 "et_eiffel_parser.y"
		local
			yyval24: detachable ET_ACROSS_EXPRESSION
		do
--|#line 4061 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4061")
end

yyval24 := new_across_expression_header (yyvs2.item (yyvsp2 - 1), yyvs69.item (yyvsp69), yyvs2.item (yyvsp2), yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp24 := yyvsp24 + 1
	yyvsp2 := yyvsp2 -2
	yyvsp69 := yyvsp69 -1
	yyvsp12 := yyvsp12 -1
	if yyvsp24 >= yyvsc24 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs24")
		end
		yyvsc24 := yyvsc24 + yyInitial_yyvs_size
		yyvs24 := yyspecial_routines24.aliased_resized_area (yyvs24, yyvsc24)
	end
	yyspecial_routines24.force (yyvs24, yyval24, yyvsp24)
end
		end

	yy_do_action_826
			--|#line 4065 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUANTIFIER_EXPRESSION
		do
--|#line 4065 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4065")
end

yyval115 := new_quantifier_expression (yyvs115.item (yyvsp115), yyvs69.item (yyvsp69)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp69 := yyvsp69 -1
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_827
			--|#line 4069 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUANTIFIER_EXPRESSION
		do
--|#line 4069 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4069")
end

yyval115 := new_for_all_quantifier_expression_header (yyvs5.item (yyvsp5 - 2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs69.item (yyvsp69), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp115 := yyvsp115 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp12 := yyvsp12 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_828
			--|#line 4071 "et_eiffel_parser.y"
		local
			yyval115: detachable ET_QUANTIFIER_EXPRESSION
		do
--|#line 4071 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4071")
end

yyval115 := new_there_exists_quantifier_expression_header (yyvs5.item (yyvsp5 - 2), yyvs12.item (yyvsp12), yyvs5.item (yyvsp5 - 1), yyvs69.item (yyvsp69), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp115 := yyvsp115 + 1
	yyvsp5 := yyvsp5 -3
	yyvsp12 := yyvsp12 -1
	yyvsp69 := yyvsp69 -1
	if yyvsp115 >= yyvsc115 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs115")
		end
		yyvsc115 := yyvsc115 + yyInitial_yyvs_size
		yyvs115 := yyspecial_routines115.aliased_resized_area (yyvs115, yyvsc115)
	end
	yyspecial_routines115.force (yyvs115, yyval115, yyvsp115)
end
		end

	yy_do_action_829
			--|#line 4077 "et_eiffel_parser.y"
		local
			yyval37: detachable ET_CALL_AGENT
		do
--|#line 4077 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4077")
end

yyval37 := ast_factory.new_call_agent (yyvs3.item (yyvsp3), Void, yyvs76.item (yyvsp76), yyvs31.item (yyvsp31)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp37 := yyvsp37 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp76 := yyvsp76 -1
	yyvsp31 := yyvsp31 -1
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
		end

	yy_do_action_830
			--|#line 4079 "et_eiffel_parser.y"
		local
			yyval37: detachable ET_CALL_AGENT
		do
--|#line 4079 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4079")
end

yyval37 := ast_factory.new_call_agent (yyvs3.item (yyvsp3), yyvs32.item (yyvsp32), ast_factory.new_dot_feature_name (yyvs5.item (yyvsp5), yyvs76.item (yyvsp76)), yyvs31.item (yyvsp31)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 5
	yyvsp37 := yyvsp37 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp32 := yyvsp32 -1
	yyvsp5 := yyvsp5 -1
	yyvsp76 := yyvsp76 -1
	yyvsp31 := yyvsp31 -1
	if yyvsp37 >= yyvsc37 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs37")
		end
		yyvsc37 := yyvsc37 + yyInitial_yyvs_size
		yyvs37 := yyspecial_routines37.aliased_resized_area (yyvs37, yyvsc37)
	end
	yyspecial_routines37.force (yyvs37, yyval37, yyvsp37)
end
		end

	yy_do_action_831
			--|#line 4083 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4083 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4083")
end

			set_inline_agent_actual_arguments (yyvs91.item (yyvsp91), yyvs31.item (yyvsp31))
			yyval91 := yyvs91.item (yyvsp91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 -1
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_832
			--|#line 4090 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4090 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4090")
end

			yyval91 := ast_factory.new_do_function_inline_agent (yyvs3.item (yyvsp3), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_833
			--|#line 4100 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4100 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4100")
end

			yyval91 := ast_factory.new_do_function_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_834
			--|#line 4106 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4106 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4106")
end

			yyval91 := ast_factory.new_once_function_inline_agent (yyvs3.item (yyvsp3), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp2 := yyvsp2 -2
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_835
			--|#line 4112 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4112 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4112")
end

			yyval91 := ast_factory.new_once_function_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 12
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp2 := yyvsp2 -2
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_836
			--|#line 4118 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4118 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4118")
end

			yyval91 := ast_factory.new_external_function_inline_agent (yyvs3.item (yyvsp3), Void, ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_837
			--|#line 4124 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4124 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4124")
end

			yyval91 := ast_factory.new_external_function_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), ast_factory.new_colon_type (yyvs5.item (yyvsp5), yyvs122.item (yyvsp122)), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp5 := yyvsp5 -1
	yyvsp122 := yyvsp122 -1
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_838
			--|#line 4130 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4130 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4130")
end

			yyval91 := ast_factory.new_do_procedure_inline_agent (yyvs3.item (yyvsp3), Void, yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_839
			--|#line 4136 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4136 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4136")
end

			yyval91 := ast_factory.new_do_procedure_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs47.item (yyvsp47 - 1), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	yyvsp2 := yyvsp2 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_840
			--|#line 4142 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4142 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4142")
end

			yyval91 := ast_factory.new_once_procedure_inline_agent (yyvs3.item (yyvsp3), Void, yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp2 := yyvsp2 -2
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_841
			--|#line 4148 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4148 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4148")
end

			yyval91 := ast_factory.new_once_procedure_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), yyvs112.item (yyvsp112), yyvs99.item (yyvsp99), yyvs103.item (yyvsp103), ast_factory.new_once_compound (yyvs2.item (yyvsp2 - 1), yyvs47.item (yyvsp47 - 1)), yyvs111.item (yyvsp111), yyvs47.item (yyvsp47), yyvs2.item (yyvsp2), Void)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 10
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp112 := yyvsp112 -1
	yyvsp99 := yyvsp99 -1
	yyvsp2 := yyvsp2 -2
	yyvsp103 := yyvsp103 -1
	yyvsp47 := yyvsp47 -2
	yyvsp111 := yyvsp111 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_842
			--|#line 4153 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4153 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4153")
end

			yyval91 := ast_factory.new_external_procedure_inline_agent (yyvs3.item (yyvsp3), Void, yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp1 := yyvsp1 -1
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_843
			--|#line 4159 "et_eiffel_parser.y"
		local
			yyval91: detachable ET_INLINE_AGENT
		do
--|#line 4159 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4159")
end

			yyval91 := ast_factory.new_external_procedure_inline_agent (yyvs3.item (yyvsp3), yyvs80.item (yyvsp80), yyvs112.item (yyvsp112), ast_factory.new_external_language (yyvs2.item (yyvsp2 - 1), yyvs15.item (yyvsp15)), yyvs72.item (yyvsp72), yyvs111.item (yyvsp111), yyvs2.item (yyvsp2), Void)
			register_inline_agent (yyval91)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 8
	yyvsp91 := yyvsp91 + 1
	yyvsp3 := yyvsp3 -1
	yyvsp80 := yyvsp80 -1
	yyvsp112 := yyvsp112 -1
	yyvsp2 := yyvsp2 -2
	yyvsp15 := yyvsp15 -1
	yyvsp72 := yyvsp72 -1
	yyvsp111 := yyvsp111 -1
	if yyvsp91 >= yyvsc91 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs91")
		end
		yyvsc91 := yyvsc91 + yyInitial_yyvs_size
		yyvs91 := yyspecial_routines91.aliased_resized_area (yyvs91, yyvsc91)
	end
	yyspecial_routines91.force (yyvs91, yyval91, yyvsp91)
end
		end

	yy_do_action_844
			--|#line 4167 "et_eiffel_parser.y"
		local
			yyval80: detachable ET_FORMAL_ARGUMENT_LIST
		do
--|#line 4167 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4167")
end

			yyval80 := yyvs80.item (yyvsp80)
			set_start_closure (yyval80)
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines80.force (yyvs80, yyval80, yyvsp80)
end
		end

	yy_do_action_845
			--|#line 4174 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 4174 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4174")
end

set_start_closure (Void) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_action_846
			--|#line 4178 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4178 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4178")
end

yyval32 := new_agent_identifier_target (yyvs12.item (yyvsp12)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp12 := yyvsp12 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_847
			--|#line 4180 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4180 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4180")
end

yyval32 := yyvs106.item (yyvsp106) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp106 := yyvsp106 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_848
			--|#line 4182 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4182 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4182")
end

yyval32 := yyvs17.item (yyvsp17) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp17 := yyvsp17 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_849
			--|#line 4184 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4184 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4184")
end

yyval32 := yyvs10.item (yyvsp10) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp32 := yyvsp32 + 1
	yyvsp10 := yyvsp10 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_850
			--|#line 4186 "et_eiffel_parser.y"
		local
			yyval32: detachable ET_AGENT_TARGET
		do
--|#line 4186 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4186")
end

yyval32 := ast_factory.new_agent_open_target (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp32 := yyvsp32 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	if yyvsp32 >= yyvsc32 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs32")
		end
		yyvsc32 := yyvsc32 + yyInitial_yyvs_size
		yyvs32 := yyspecial_routines32.aliased_resized_area (yyvs32, yyvsc32)
	end
	yyspecial_routines32.force (yyvs32, yyval32, yyvsp32)
end
		end

	yy_do_action_851
			--|#line 4190 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4190 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4190")
end


if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp31 := yyvsp31 + 1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_852
			--|#line 4192 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4192 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4192")
end

yyval31 := ast_factory.new_agent_argument_operands (yyvs5.item (yyvsp5 - 1), yyvs5.item (yyvsp5), 0) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 + 1
	yyvsp5 := yyvsp5 -2
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_853
			--|#line 4194 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4194 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4194")
end

			yyval31 := yyvs31.item (yyvsp31)
			remove_symbol
			remove_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 3
	yyvsp31 := yyvsp31 -1
	yyvsp5 := yyvsp5 -1
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_854
			--|#line 4194 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4194 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4194")
end

			add_symbol (yyvs5.item (yyvsp5))
			add_counter
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp31 := yyvsp31 + 1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_855
			--|#line 4207 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4207 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4207")
end

			if attached yyvs29.item (yyvsp29) as l_agent_actual then
				yyval31 := ast_factory.new_agent_argument_operands (last_symbol, yyvs5.item (yyvsp5), counter_value + 1)
				if yyval31 /= Void then
					yyval31.put_first (l_agent_actual)
				end
			else
				yyval31 := ast_factory.new_agent_argument_operands (last_symbol, yyvs5.item (yyvsp5), counter_value)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 + 1
	yyvsp29 := yyvsp29 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_856
			--|#line 4218 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4218 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4218")
end

			yyval31 := ast_factory.new_agent_argument_operands (last_symbol, yyvs5.item (yyvsp5), counter_value)
			if yyval31 /= Void and attached yyvs30.item (yyvsp30) as l_agent_actual then
				yyval31.put_first (l_agent_actual)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp31 := yyvsp31 + 1
	yyvsp30 := yyvsp30 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp31 >= yyvsc31 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs31")
		end
		yyvsc31 := yyvsc31 + yyInitial_yyvs_size
		yyvs31 := yyspecial_routines31.aliased_resized_area (yyvs31, yyvsc31)
	end
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_857
			--|#line 4226 "et_eiffel_parser.y"
		local
			yyval31: detachable ET_AGENT_ARGUMENT_OPERAND_LIST
		do
--|#line 4226 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4226")
end

			yyval31 := yyvs31.item (yyvsp31)
			if yyval31 /= Void and attached yyvs30.item (yyvsp30) as l_agent_actual then
				yyval31.put_first (l_agent_actual)
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp30 := yyvsp30 -1
	yyspecial_routines31.force (yyvs31, yyval31, yyvsp31)
end
		end

	yy_do_action_858
			--|#line 4235 "et_eiffel_parser.y"
		local
			yyval30: detachable ET_AGENT_ARGUMENT_OPERAND_ITEM
		do
--|#line 4235 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4235")
end

			yyval30 := ast_factory.new_agent_argument_operand_comma (yyvs29.item (yyvsp29), yyvs5.item (yyvsp5))
			if yyval30 /= Void then
				increment_counter
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp30 := yyvsp30 + 1
	yyvsp29 := yyvsp29 -1
	yyvsp5 := yyvsp5 -1
	if yyvsp30 >= yyvsc30 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs30")
		end
		yyvsc30 := yyvsc30 + yyInitial_yyvs_size
		yyvs30 := yyspecial_routines30.aliased_resized_area (yyvs30, yyvsc30)
	end
	yyspecial_routines30.force (yyvs30, yyval30, yyvsp30)
end
		end

	yy_do_action_859
			--|#line 4244 "et_eiffel_parser.y"
		local
			yyval29: detachable ET_AGENT_ARGUMENT_OPERAND
		do
--|#line 4244 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4244")
end

yyval29 := yyvs69.item (yyvsp69) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp29 := yyvsp29 + 1
	yyvsp69 := yyvsp69 -1
	if yyvsp29 >= yyvsc29 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs29")
		end
		yyvsc29 := yyvsc29 + yyInitial_yyvs_size
		yyvs29 := yyspecial_routines29.aliased_resized_area (yyvs29, yyvsc29)
	end
	yyspecial_routines29.force (yyvs29, yyval29, yyvsp29)
end
		end

	yy_do_action_860
			--|#line 4246 "et_eiffel_parser.y"
		local
			yyval29: detachable ET_AGENT_ARGUMENT_OPERAND
		do
--|#line 4246 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4246")
end

yyval29 := yyvs23.item (yyvsp23) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp29 := yyvsp29 + 1
	yyvsp23 := yyvsp23 -1
	if yyvsp29 >= yyvsc29 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs29")
		end
		yyvsc29 := yyvsc29 + yyInitial_yyvs_size
		yyvs29 := yyspecial_routines29.aliased_resized_area (yyvs29, yyvsc29)
	end
	yyspecial_routines29.force (yyvs29, yyval29, yyvsp29)
end
		end

	yy_do_action_861
			--|#line 4248 "et_eiffel_parser.y"
		local
			yyval29: detachable ET_AGENT_ARGUMENT_OPERAND
		do
--|#line 4248 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4248")
end

yyval29 := ast_factory.new_agent_typed_open_argument (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5), yyvs23.item (yyvsp23)) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp29 := yyvsp29 + 1
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyvsp23 := yyvsp23 -1
	if yyvsp29 >= yyvsc29 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs29")
		end
		yyvsc29 := yyvsc29 + yyInitial_yyvs_size
		yyvs29 := yyspecial_routines29.aliased_resized_area (yyvs29, yyvsc29)
	end
	yyspecial_routines29.force (yyvs29, yyval29, yyvsp29)
end
		end

	yy_do_action_862
			--|#line 4254 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4254 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4254")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_863
			--|#line 4256 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4256 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4256")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_864
			--|#line 4260 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4260 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4260")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_865
			--|#line 4262 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4262 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4262")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_866
			--|#line 4264 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4264 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4264")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_867
			--|#line 4266 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4266 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4266")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_868
			--|#line 4268 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4268 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4268")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_869
			--|#line 4270 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4270 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4270")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_870
			--|#line 4272 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4272 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4272")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_871
			--|#line 4274 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4274 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4274")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_872
			--|#line 4276 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4276 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4276")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_873
			--|#line 4278 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4278 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4278")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_874
			--|#line 4280 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4280 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4280")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_875
			--|#line 4282 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4282 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4282")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_876
			--|#line 4284 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4284 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4284")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_877
			--|#line 4286 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4286 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4286")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_878
			--|#line 4288 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4288 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4288")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_879
			--|#line 4290 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4290 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4290")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_880
			--|#line 4292 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4292 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4292")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_881
			--|#line 4294 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4294 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4294")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_882
			--|#line 4296 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4296 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4296")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_883
			--|#line 4298 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4298 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4298")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_884
			--|#line 4300 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4300 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4300")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_885
			--|#line 4302 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4302 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4302")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_886
			--|#line 4304 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4304 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4304")
end

yyval15 := yyvs15.item (yyvsp15) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_887
			--|#line 4306 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4306 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4306")
end

abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp15 := yyvsp15 + 1
	yyvsp6 := yyvsp6 -1
	if yyvsp15 >= yyvsc15 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs15")
		end
		yyvsc15 := yyvsc15 + yyInitial_yyvs_size
		yyvs15 := yyspecial_routines15.aliased_resized_area (yyvs15, yyvsc15)
	end
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_888
			--|#line 4310 "et_eiffel_parser.y"
		local
			yyval15: detachable ET_MANIFEST_STRING
		do
--|#line 4310 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4310")
end

			yyval15 := yyvs15.item (yyvsp15)
			if yyval15 /= Void then
				yyval15.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyspecial_routines15.force (yyvs15, yyval15, yyvsp15)
end
		end

	yy_do_action_889
			--|#line 4319 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4319 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4319")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_890
			--|#line 4321 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4321 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4321")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_891
			--|#line 4325 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4325 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4325")
end

yyval9 := yyvs9.item (yyvsp9) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_892
			--|#line 4327 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4327 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4327")
end

abort 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyvsp9 := yyvsp9 + 1
	yyvsp6 := yyvsp6 -1
	if yyvsp9 >= yyvsc9 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs9")
		end
		yyvsc9 := yyvsc9 + yyInitial_yyvs_size
		yyvs9 := yyspecial_routines9.aliased_resized_area (yyvs9, yyvsc9)
	end
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_893
			--|#line 4331 "et_eiffel_parser.y"
		local
			yyval9: detachable ET_CHARACTER_CONSTANT
		do
--|#line 4331 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4331")
end

			yyval9 := yyvs9.item (yyvsp9)
			if yyval9 /= Void then
				yyval9.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyspecial_routines9.force (yyvs9, yyval9, yyvsp9)
end
		end

	yy_do_action_894
			--|#line 4340 "et_eiffel_parser.y"
		local
			yyval7: detachable ET_BOOLEAN_CONSTANT
		do
--|#line 4340 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4340")
end

yyval7 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines7.force (yyvs7, yyval7, yyvsp7)
end
		end

	yy_do_action_895
			--|#line 4342 "et_eiffel_parser.y"
		local
			yyval7: detachable ET_BOOLEAN_CONSTANT
		do
--|#line 4342 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4342")
end

yyval7 := yyvs7.item (yyvsp7) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines7.force (yyvs7, yyval7, yyvsp7)
end
		end

	yy_do_action_896
			--|#line 4346 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4346 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4346")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_897
			--|#line 4348 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4348 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4348")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_898
			--|#line 4352 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4352 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4352")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_899
			--|#line 4354 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4354 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4354")
end

yyval13 := yyvs13.item (yyvsp13) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_900
			--|#line 4358 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4358 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4358")
end

			yyval13 := yyvs13.item (yyvsp13)
			if yyval13 /= Void then
				yyval13.set_sign (yyvs19.item (yyvsp19))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_901
			--|#line 4365 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4365 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4365")
end

			yyval13 := yyvs13.item (yyvsp13)
			if yyval13 /= Void then
				yyval13.set_sign (yyvs19.item (yyvsp19))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_902
			--|#line 4374 "et_eiffel_parser.y"
		local
			yyval13: detachable ET_INTEGER_CONSTANT
		do
--|#line 4374 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4374")
end

			yyval13 := yyvs13.item (yyvsp13)
			if yyval13 /= Void then
				yyval13.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyspecial_routines13.force (yyvs13, yyval13, yyvsp13)
end
		end

	yy_do_action_903
			--|#line 4383 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4383 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4383")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_904
			--|#line 4385 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4385 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4385")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_905
			--|#line 4389 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4389 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4389")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_906
			--|#line 4391 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4391 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4391")
end

yyval16 := yyvs16.item (yyvsp16) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_907
			--|#line 4395 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4395 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4395")
end

			yyval16 := yyvs16.item (yyvsp16)
			if yyval16 /= Void then
				yyval16.set_sign (yyvs19.item (yyvsp19))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_908
			--|#line 4402 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4402 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4402")
end

			yyval16 := yyvs16.item (yyvsp16)
			if yyval16 /= Void then
				yyval16.set_sign (yyvs19.item (yyvsp19))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 2
	yyvsp19 := yyvsp19 -1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_909
			--|#line 4411 "et_eiffel_parser.y"
		local
			yyval16: detachable ET_REAL_CONSTANT
		do
--|#line 4411 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4411")
end

			yyval16 := yyvs16.item (yyvsp16)
			if yyval16 /= Void then
				yyval16.set_cast_type (ast_factory.new_target_type (yyvs5.item (yyvsp5 - 1), yyvs122.item (yyvsp122), yyvs5.item (yyvsp5)))
			end
		
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 4
	yyvsp5 := yyvsp5 -2
	yyvsp122 := yyvsp122 -1
	yyspecial_routines16.force (yyvs16, yyval16, yyvsp16)
end
		end

	yy_do_action_910
			--|#line 4420 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 4420 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4420")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_911
			--|#line 4422 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 4422 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4422")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_912
			--|#line 4424 "et_eiffel_parser.y"
		local
			yyval12: detachable ET_IDENTIFIER
		do
--|#line 4424 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4424")
end

yyval12 := yyvs12.item (yyvsp12) 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 1
	yyspecial_routines12.force (yyvs12, yyval12, yyvsp12)
end
		end

	yy_do_action_913
			--|#line 4430 "et_eiffel_parser.y"
		local
			yyval1: detachable ANY
		do
--|#line 4430 "et_eiffel_parser.y"
debug ("GEYACC")
	std.error.put_line ("Executing parser user-code from file 'et_eiffel_parser.y' at line 4430")
end

add_counter 
if yy_parsing_status >= yyContinue then
	yyssp := yyssp - 0
	yyvsp1 := yyvsp1 + 1
	if yyvsp1 >= yyvsc1 then
		debug ("GEYACC")
			std.error.put_line ("Resize yyvs1")
		end
		yyvsc1 := yyvsc1 + yyInitial_yyvs_size
		yyvs1 := yyspecial_routines1.aliased_resized_area (yyvs1, yyvsc1)
	end
	yyspecial_routines1.force (yyvs1, yyval1, yyvsp1)
end
		end

	yy_do_error_action (yy_act: INTEGER)
			-- Execute error action.
		do
			if yy_act <= 199 then
				yy_do_error_action_0_199 (yy_act)
			elseif yy_act <= 399 then
				yy_do_error_action_200_399 (yy_act)
			elseif yy_act <= 599 then
				yy_do_error_action_400_599 (yy_act)
			elseif yy_act <= 799 then
				yy_do_error_action_600_799 (yy_act)
			elseif yy_act <= 999 then
				yy_do_error_action_800_999 (yy_act)
			elseif yy_act <= 1199 then
				yy_do_error_action_1000_1199 (yy_act)
			elseif yy_act <= 1399 then
				yy_do_error_action_1200_1399 (yy_act)
			elseif yy_act <= 1599 then
				yy_do_error_action_1400_1599 (yy_act)
			elseif yy_act <= 1799 then
				yy_do_error_action_1600_1799 (yy_act)
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_0_199 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_200_399 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_400_599 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_600_799 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_800_999 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1000_1199 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1200_1399 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1400_1599 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			else
					-- Default action.
				report_error ("parse error")
			end
		end

	yy_do_error_action_1600_1799 (yy_act: INTEGER)
			-- Execute error action.
		do
			inspect yy_act
			when 1760 then
					-- End-of-file expected action.
				report_eof_expected_error
			else
					-- Default action.
				report_error ("parse error")
			end
		end

feature {NONE} -- Table templates

	yytranslate_template: SPECIAL [INTEGER]
			-- Template for `yytranslate'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 376)
			yytranslate_template_1 (an_array)
			yytranslate_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytranslate_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytranslate'.
		do
			yyarray_subcopy (an_array, <<
			    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,  129,    2,    2,  127,    2,    2,    2,
			  122,  123,  115,  136,  125,  135,  128,  108,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,  124,  141,
			  112,  137,  110,  143,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,  142,    2,  126,  114,    2,    2,    2,    2,    2,

			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,  120,    2,  121,  138,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2, yyDummy>>,
			1, 200, 0)
		end

	yytranslate_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytranslate'.
		do
			yyarray_subcopy (an_array, <<
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    1,    2,    3,    4,
			    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
			   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
			   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
			   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,

			   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
			   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
			   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,  107,  109,  111,  113,  116,  117,  118,  119,
			  130,  131,  132,  133,  134,  139,  140, yyDummy>>,
			1, 177, 200)
		end

	yyr1_template: SPECIAL [INTEGER]
			-- Template for `yyr1'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 913)
			yyr1_template_1 (an_array)
			yyr1_template_2 (an_array)
			yyr1_template_3 (an_array)
			yyr1_template_4 (an_array)
			yyr1_template_5 (an_array)
			Result := yyfixed_array (an_array)
		end

	yyr1_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			    0,  394,  394,  185,  395,  395,  396,  184,  397,  287,
			  287,  398,  287,  287,  399,  288,  288,  290,  290,  400,
			  290,  401,  294,  296,  295,  289,  289,  289,  403,  289,
			  404,  291,  293,  293,  292,  292,  299,  299,  297,  297,
			  297,  297,  297,  297,  297,  297,  298,  183,  183,  183,
			  183,  313,  313,  314,  314,  281,  281,  281,  405,  282,
			  282,  280,  279,  279,  279,  279,  279,  279,  279,  279,
			  279,  381,  381,  383,  406,  384,  384,  382,  221,  221,
			  407,  222,  222,  222,  219,  219,  218,  218,  408,  220,
			  220,  220,  223,  223,  223,  223,  223,  223,  223,  223,

			  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
			  223,  223,  223,  223,  224,  224,  224,  224,  224,  224,
			  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
			  224,  224,  224,  224,  224,  224,  213,  213,  212,  212,
			  214,  214,  214,  209,  216,  216,  215,  215,  215,  217,
			  217,  217,  217,  210,  211,  345,  345,  348,  348,  349,
			  349,  411,  351,  351,  412,  347,  347,  347,  347,  347,
			  347,  352,  352,  352,  352,  350,  369,  369,  413,  370,
			  370,  370,  367,  368,  244,  244,  414,  245,  245,  246,
			  246,  415,  243,  243,  243,  416,  243,  267,  267,  267, yyDummy>>,
			1, 200, 0)
		end

	yyr1_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  188,  417,  188,  189,  189,  189,  189,  186,  187,  191,
			  191,  190,  322,  322,  418,  323,  323,  320,  320,  419,
			  321,  321,  318,  318,  420,  319,  319,  317,  317,  317,
			  269,  234,  234,  235,  235,  421,  232,  232,  232,  422,
			  232,  423,  232,  232,  232,  424,  232,  425,  233,  233,
			  233,  270,  227,  227,  228,  426,  229,  229,  229,  226,
			  225,  225,  386,  386,  427,  387,  387,  385,  265,  265,
			  264,  266,  266,  262,  262,  263,  263,  428,  428,  428,
			  428,  361,  361,  361,  361,  361,  361,  355,  355,  355,
			  355,  355,  355,  362,  362,  362,  362,  362,  362,  362,

			  362,  362,  362,  362,  362,  362,  362,  362,  362,  362,
			  362,  362,  362,  362,  362,  362,  356,  356,  356,  356,
			  356,  356,  356,  356,  315,  315,  372,  372,  261,  261,
			  167,  167,  268,  260,  260,  166,  166,  429,  165,  165,
			  165,  165,  165,  165,  165,  165,  165,  165,  165,  165,
			  165,  165,  165,  165,  165,  165,  165,  165,  165,  165,
			  165,  316,  316,  278,  275,  275,  376,  276,  276,  276,
			  276,  276,  276,  272,  271,  273,  274,  330,  330,  330,
			  430,  331,  331,  331,  331,  331,  331,  327,  326,  328,
			  329,  431,  431,  431,  431,  431,  431,  431,  431,  431, yyDummy>>,
			1, 200, 200)
		end

	yyr1_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  431,  431,  431,  432,  354,  354,  354,  354,  354,  433,
			  353,  353,  353,  353,  353,  434,  312,  312,  311,  311,
			  435,  436,  333,  333,  332,  332,  388,  388,  389,  389,
			  193,  193,  377,  377,  378,  378,  378,  378,  378,  378,
			  378,  378,  378,  378,  378,  378,  378,  378,  378,  378,
			  378,  378,  378,  378,  378,  378,  379,  379,  379,  379,
			  379,  379,  379,  379,  379,  379,  379,  379,  379,  379,
			  379,  379,  379,  379,  379,  379,  379,  379,  380,  380,
			  380,  380,  380,  380,  380,  380,  380,  380,  380,  380,
			  380,  380,  380,  380,  380,  380,  380,  380,  380,  380,

			  380,  284,  284,  154,  154,  156,  156,  409,  155,  155,
			  155,  155,  155,  410,  151,  157,  157,  158,  158,  158,
			  159,  159,  159,  159,  159,  159,  152,  153,  325,  325,
			  325,  324,  324,  324,  324,  324,  324,  324,  324,  324,
			  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
			  324,  324,  358,  358,  357,  357,  357,  357,  357,  357,
			  357,  357,  357,  357,  357,  357,  357,  357,  357,  357,
			  357,  357,  357,  194,  203,  195,  196,  197,  198,  199,
			  200,  201,  201,  202,  192,  205,  205,  206,  206,  204,
			  204,  437,  303,  303,  303,  303,  303,  303,  303,  303, yyDummy>>,
			1, 200, 400)
		end

	yyr1_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  303,  303,  303,  303,  303,  303,  303,  303,  303,  303,
			  438,  177,  177,  177,  177,  304,  304,  304,  304,  306,
			  306,  306,  306,  230,  230,  231,  231,  286,  286,  286,
			  286,  241,  242,  242,  240,  285,  285,  238,  239,  239,
			  237,  302,  302,  392,  392,  391,  391,  390,  181,  181,
			  439,  182,  182,  182,  180,  178,  178,  179,  179,  179,
			  179,  147,  147,  371,  207,  207,  236,  342,  342,  342,
			  440,  341,  341,  340,  305,  305,  305,  305,  305,  305,
			  305,  253,  253,  252,  173,  173,  373,  373,  250,  250,
			  249,  249,  249,  249,  249,  249,  249,  249,  248,  248,

			  148,  148,  148,  441,  149,  149,  149,  259,  251,  251,
			  251,  251,  393,  393,  247,  247,  256,  256,  256,  256,
			  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
			  256,  256,  256,  256,  256,  256,  256,  256,  257,  257,
			  257,  257,  257,  257,  258,  258,  258,  258,  258,  258,
			  258,  258,  258,  258,  258,  258,  258,  258,  258,  258,
			  258,  258,  258,  258,  255,  255,  255,  255,  255,  255,
			  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
			  254,  254,  254,  254,  169,  169,  170,  442,  170,  443,
			  171,  444,  171,  445,  150,  150,  150,  346,  335,  335, yyDummy>>,
			1, 200, 600)
		end

	yyr1_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yyr1'.
		do
			yyarray_subcopy (an_array, <<
			  446,  334,  336,  336,  336,  343,  343,  447,  344,  344,
			  344,  374,  374,  448,  375,  375,  375,  208,  208,  208,
			  208,  208,  145,  144,  146,  146,  360,  359,  359,  172,
			  172,  300,  301,  301,  301,  301,  301,  301,  301,  301,
			  301,  301,  301,  301,  277,  449,  164,  164,  164,  164,
			  164,  162,  162,  162,  450,  163,  163,  163,  161,  160,
			  160,  160,  337,  337,  339,  339,  339,  339,  339,  339,
			  339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
			  339,  339,  339,  339,  339,  339,  339,  339,  338,  174,
			  174,  176,  176,  175,  168,  168,  307,  307,  309,  309,

			  310,  310,  308,  363,  363,  365,  365,  366,  366,  364,
			  283,  283,  283,  402, yyDummy>>,
			1, 114, 800)
		end

	yytypes1_template: SPECIAL [INTEGER]
			-- Template for `yytypes1'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 1762)
			yytypes1_template_1 (an_array)
			yytypes1_template_2 (an_array)
			yytypes1_template_3 (an_array)
			yytypes1_template_4 (an_array)
			yytypes1_template_5 (an_array)
			yytypes1_template_6 (an_array)
			yytypes1_template_7 (an_array)
			yytypes1_template_8 (an_array)
			yytypes1_template_9 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytypes1_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    1,    8,    2,    2,   44,   86,   86,   44,   86,   86,
			    2,   44,   44,    2,   86,   87,   87,    1,   86,   87,
			   87,    1,   22,   83,    2,    2,    2,    2,    2,   21,
			   86,   86,   12,   12,   12,   12,   87,   21,   86,   21,
			   86,   19,   19,    5,    6,    6,   16,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   13,    9,    7,    7,    2,    7,    9,    9,    9,   58,
			   12,   87,   88,   89,   90,   13,   13,   13,   13,   15,
			   15,   15,   16,   16,   16,   16,    5,   83,    2,  105,

			    2,    2,    2,    2,   86,   86,    5,   86,   86,   16,
			   13,   16,   13,   23,    5,   12,   12,   12,    2,    2,
			    2,    2,    2,   12,   96,   96,  114,  114,  122,  122,
			   19,   59,   22,    2,  104,    5,    5,   12,   90,    2,
			    2,   81,   82,   83,   12,   15,  108,    1,    2,    2,
			    2,   12,   90,   12,    2,    2,   12,   96,  114,   12,
			    2,    2,   12,   96,   22,   28,   28,    1,   12,    2,
			    2,   12,   96,   12,    2,    2,   12,   96,   12,    2,
			   12,   96,   12,    5,   10,   12,   22,   28,    1,    5,
			    5,   12,    5,    5,  104,    2,   90,   12,   12,    5, yyDummy>>,
			1, 200, 0)
		end

	yytypes1_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    5,   83,    5,   61,    1,    2,  108,  110,   12,   12,
			   12,   28,   12,    2,   12,   96,    5,   10,   12,   28,
			   28,    5,   28,   12,    2,   12,   96,    5,   10,   12,
			   28,    5,    5,   23,    5,   12,   12,   12,    2,    2,
			    2,    2,   27,   27,   27,   28,   28,   12,   12,   96,
			  122,  122,   28,   12,    2,   12,   96,    5,   10,   12,
			   28,    5,   28,   12,    2,   12,   96,    5,   10,   12,
			   28,    5,   28,    5,   10,   12,   28,    5,   28,  122,
			    5,   12,   12,   12,   28,   12,    9,   13,   15,   16,
			   19,  122,   19,   19,    5,    5,    5,    5,    5,    2,

			   20,   17,   16,   14,   13,   11,   10,    5,    4,    3,
			    2,    2,    2,    2,    2,    2,   24,   24,   24,    7,
			   36,   36,   37,    9,    9,   58,   69,   69,   69,   69,
			   69,   69,   69,   69,   69,   69,   69,   69,   70,   12,
			   84,   91,   91,   13,  101,  101,   15,   15,  104,  104,
			  106,  115,  115,   16,  120,  121,    5,    5,    5,   23,
			    5,    5,   12,    2,    2,    2,    2,   54,   12,   96,
			  123,  125,    2,   57,   57,    2,    2,   60,   61,    5,
			   46,   46,  108,   28,    5,   10,   12,   28,    5,  122,
			   12,   28,    5,   10,   12,   28,    5,  122,   12,   12, yyDummy>>,
			1, 200, 200)
		end

	yytypes1_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    2,   12,   12,    2,   12,    5,    5,   28,    5,   12,
			    2,   12,   12,    2,   12,   12,   12,   12,   28,   12,
			   12,   12,   28,   28,    5,   28,    5,    5,   28,    5,
			   10,   12,   28,    5,  122,   12,   28,    5,   10,   12,
			   28,    5,  122,   12,  122,   12,    5,    5,    5,    5,
			    5,   69,   69,   12,   12,   17,   10,   76,   12,  106,
			   12,   12,   12,   12,  122,   69,   69,   69,    5,  101,
			    5,    5,   26,    5,    5,   17,   10,   32,   76,   80,
			   80,   12,  106,    5,    1,   69,    5,   69,    5,    5,
			   15,   69,    5,    2,  100,  100,   22,   22,    5,    5,

			    5,    5,   19,   19,    5,    5,   19,   19,   19,   19,
			   19,   19,   19,   19,   19,   14,   14,   14,   14,   11,
			    5,    5,   22,   22,    5,  104,   26,    5,   31,   69,
			   69,  123,  125,  123,  125,   12,    2,   12,   12,    2,
			   12,  125,   22,   51,   51,    1,   12,    2,   12,   12,
			    2,   12,   12,   12,   12,    2,   53,   22,   51,   51,
			    1,    2,   52,   52,   52,   57,   74,   74,    1,    5,
			   46,   60,   46,   60,   61,   12,  110,  108,  122,   12,
			    5,  122,   12,    5,   28,   12,   12,   28,   28,   12,
			   12,   28,    1,    1,    1,   28,   12,   12,   28,   28, yyDummy>>,
			1, 200, 400)
		end

	yytypes1_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			   12,   12,   28,   28,   28,   28,    5,    5,    5,  122,
			  122,   12,    5,  122,   12,    5,    5,    5,    1,    1,
			    1,    5,    5,    5,    5,    5,   69,   70,  101,    5,
			   26,   12,    5,  122,    5,   31,    5,    2,  112,   78,
			   78,   79,   79,   80,   12,    5,  112,    2,    2,  122,
			    2,    5,  121,  122,    2,  122,    1,    2,   48,   36,
			   36,   69,   69,   69,   69,   69,   69,   69,   69,   69,
			   69,   69,   69,   69,   69,   69,   69,   69,    2,   69,
			    2,   69,   69,   12,   12,   36,   36,    5,   31,    5,
			   52,   52,   52,   52,   51,   12,   12,   51,   51,   12,

			   12,   51,  123,  124,  125,    5,   23,    5,   12,    2,
			    2,    2,    2,   50,   50,   50,   51,   51,   54,   54,
			   12,   12,   96,   51,   12,   12,   51,   51,   12,   12,
			   51,   51,   51,   51,    2,   53,    5,   51,   12,    2,
			   52,   55,   56,   57,   76,    2,   94,   94,    2,   73,
			   73,   74,    5,   46,   60,   60,   77,   12,   60,   60,
			   61,    5,   12,  107,  109,  110,    5,    5,    5,    5,
			   28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
			   28,   28,   28,   28,    1,    1,    1,   21,    5,    5,
			    5,    5,    5,    5,   12,   12,   69,   69,  122,    5, yyDummy>>,
			1, 200, 600)
		end

	yytypes1_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			  101,    5,    5,  101,   26,   69,   70,    5,    5,   76,
			  122,    2,    1,    2,    2,   99,   80,   12,   80,    5,
			   80,    5,   80,    5,    5,  122,    2,   99,   12,   12,
			    5,   12,   76,   77,  121,    5,   69,    5,    2,   69,
			   12,    1,   69,    2,    2,   26,   69,   70,   26,   69,
			   69,   26,   26,   26,   26,   23,    5,   29,   30,   31,
			   69,   51,   51,   51,   51,    5,    5,  125,   12,    2,
			   12,   12,    2,   12,   51,   12,    2,   12,   12,    2,
			   12,   12,   12,   12,   51,   51,   12,   51,    5,    5,
			    5,    5,   51,   51,   51,   51,   51,   53,   76,  117,

			  117,    5,   52,   77,   12,    5,   57,    5,    5,    1,
			   86,   46,   74,    2,   71,   76,   12,  113,  113,  116,
			  116,    1,   45,   45,   46,   12,   60,   60,    5,   60,
			   28,   21,  110,  110,    5,   12,    5,   12,    5,   12,
			    5,   12,   12,   26,    5,    5,    5,   12,    5,    5,
			   26,   26,   31,  112,    1,    1,   99,   15,    2,    2,
			   47,  122,  112,   15,    2,   47,    5,   69,    5,    5,
			    5,  121,    2,   64,    1,    5,   21,   21,    5,    2,
			   69,   12,   69,   69,    5,    5,   26,  122,    5,    5,
			    5,   31,   51,   12,   12,   51,   51,   12,   12,   51, yyDummy>>,
			1, 200, 800)
		end

	yytypes1_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			   51,   12,   12,   51,   51,   12,   12,   51,   51,   51,
			   51,    5,    1,   54,    2,    2,    2,   53,    1,    2,
			   52,    2,    5,  127,  127,    1,    2,   71,  113,  116,
			    5,    5,    2,   80,   80,    2,  113,  116,    5,    1,
			  113,  116,    5,   46,    5,   46,    5,    2,    2,    2,
			    2,    2,   68,   95,   95,   95,  118,   12,   12,   12,
			   12,   69,   26,    2,   99,    1,   12,   97,   97,   98,
			   98,   99,    2,   72,    5,  103,   47,   47,    1,    2,
			  111,   21,    2,   99,   72,  103,  111,  122,    2,   69,
			    2,    2,   63,   64,   12,   21,   21,   21,    5,    2,

			  128,  128,  128,    5,   51,   51,   51,   51,   51,   51,
			   51,   51,    1,   51,   51,   21,    5,   71,    5,  127,
			    5,    1,    1,    5,  113,  116,  113,  116,  122,    5,
			    2,   86,    2,   33,   34,   95,   95,  118,   95,   68,
			   95,   95,    2,   95,   95,   95,   95,   68,   68,   15,
			    2,   47,    5,    5,   99,   99,   99,   99,   15,  111,
			    5,  103,   47,   21,    5,    5,    5,   18,   17,    4,
			    2,    2,    2,    2,    2,    2,    2,    2,   25,   36,
			   36,   36,   38,   39,   47,   47,   62,   69,   69,   69,
			   69,   12,   85,   92,   93,   93,   93,   93,  119,  131, yyDummy>>,
			1, 200, 1000)
		end

	yytypes1_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    2,    1,    2,   47,   47,   15,    2,   47,  111,   47,
			   47,    5,   12,    2,   69,   69,   64,   26,   21,   69,
			   12,    2,    2,   23,    5,  122,  126,  127,    1,    1,
			  113,  116,    2,   35,  122,   86,  105,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   34,   76,   77,   95,   95,  117,  117,  118,   95,   21,
			   46,   67,   68,   95,   95,    2,   95,   72,  103,  111,
			  122,    2,   15,  102,  103,  111,   12,   23,    5,   12,
			    2,    2,    2,    2,   12,   96,  122,  122,    5,   26,

			   69,   69,   69,   47,    5,  103,   59,    1,   47,   47,
			    5,    5,  100,    5,    5,   26,   47,   47,    5,    5,
			    1,    1,   47,    2,   72,  103,  111,    2,  111,    2,
			    2,    2,    5,    5,    5,  127,   44,   76,   21,    5,
			    2,   86,   35,  105,  112,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,   34,
			   95,  118,    2,   67,   68,   95,    2,   95,  111,   47,
			   47,   21,    5,    5,  103,   47,    5,   12,    2,   12,
			   17,   12,    2,   12,   12,  131,   28,   12,    2,   12, yyDummy>>,
			1, 200, 1200)
		end

	yytypes1_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			   12,    2,   12,   12,   12,   12,   28,    5,    5,   12,
			    2,    2,  130,    1,    2,   47,  122,   47,    5,  131,
			    2,    2,   47,    1,  100,   69,   69,    2,  128,   12,
			   12,   47,    5,   69,   69,    1,  111,   47,   47,   47,
			   69,   69,    2,    7,    9,   49,   13,   15,   16,    2,
			   49,   86,  105,    2,   86,  112,    2,    2,   99,   75,
			   76,   77,   68,    2,   95,    2,  111,    2,    2,   69,
			   28,   12,   12,   28,   28,   12,   12,   28,    5,   28,
			   12,   12,   28,   28,   12,   12,   28,   28,   28,   28,
			  131,    5,    5,   12,   12,    2,    2,   47,    2,   43,

			  129,  130,   47,    2,    2,   47,   66,    1,    5,    2,
			  122,    5,   47,   47,    2,    2,   47,   48,   69,    2,
			   26,   26,    2,  111,    2,    2,   21,   21,   21,   21,
			   21,  105,  112,   86,  105,    2,    2,   99,  111,   15,
			    2,   47,   75,    2,   47,    5,   28,   28,   28,   28,
			   12,   28,   28,   28,   28,    5,   12,   26,   47,    2,
			   43,   47,  130,   47,    2,    2,   47,    2,   65,   66,
			    5,    5,   12,    2,    2,   47,   47,   69,   47,  112,
			    2,    2,   99,  105,  112,  111,   15,    2,   47,    2,
			   72,  103,  111,    2,   26,   12,   26,   19,   19,    5, yyDummy>>,
			1, 200, 1400)
		end

	yytypes1_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yytypes1'.
		do
			yyarray_subcopy (an_array, <<
			    9,   40,   41,   42,   43,   12,   13,  120,    2,   69,
			   66,   12,  131,   26,   47,  128,    2,  128,   47,    2,
			    2,    2,   99,  111,   15,    2,    2,   47,   47,  112,
			    2,    2,   99,    2,   72,  103,  111,   21,  111,   47,
			   47,   26,  122,    5,    5,   43,   47,   26,    5,    2,
			    2,    2,  111,   15,    2,   47,    2,   72,   47,  103,
			  111,  111,    2,    2,   99,  111,   15,    2,   47,   21,
			  111,   47,   47,    2,  111,    2,    5,   41,   12,    2,
			   72,  103,  111,   21,  111,   47,   47,   47,  111,   15,
			    2,   47,    2,   72,  103,  111,    2,  111,    2,   21,

			   47,   21,   26,   21,  111,   47,   47,    2,  111,    2,
			    2,    2,   72,  103,  111,   21,  111,   47,   47,   21,
			   47,   21,    2,    2,  111,    2,   21,   47,   21,   21,
			   21,  111,   47,   47,    2,  111,    2,    2,   21,   21,
			   47,   21,    2,    2,  111,    2,   21,   47,   21,   21,
			    2,   21,   21,   47,   21,    2,   21,    2,   21,   21,
			    1,    1,    1, yyDummy>>,
			1, 163, 1600)
		end

	yytypes2_template: SPECIAL [INTEGER]
			-- Template for `yytypes2'
		once
			Result := yyfixed_array (<<
			    1,    1,    1,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
			    2,    2,    2,    2,    2,    2,    2,    3,    4,    5,
			    5,    5,    5,    5,    5,    6,    7,    7,    8,    9,
			   10,   11,   12,   12,   12,   13,   14,   14,   14,   14,
			   14,   15,   15,   15,   15,   15,   15,   15,   15,   15,
			   15,   15,   15,   15,   15,   15,   15,   15,   15,   15,

			   15,   15,   15,   15,   16,   17,   18,   19,   19,   19,
			   19,   19,   19,   19,   19,   19,   20,    6,    6,    2,
			    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
			    5,    5,    5,    5,    5,   19,   19,    5,    5,    5,
			    5,   21,   22,   23, yyDummy>>)
		end

	yydefact_template: SPECIAL [INTEGER]
			-- Template for `yydefact'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 1762)
			yydefact_template_1 (an_array)
			yydefact_template_2 (an_array)
			yydefact_template_3 (an_array)
			yydefact_template_4 (an_array)
			yydefact_template_5 (an_array)
			yydefact_template_6 (an_array)
			yydefact_template_7 (an_array)
			yydefact_template_8 (an_array)
			yydefact_template_9 (an_array)
			Result := yyfixed_array (an_array)
		end

	yydefact_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			   15,   15,   14,   11,    1,   16,   51,    2,  913,  913,
			   52,   55,    3,   53,   13,   19,   21,    0,   10,   28,
			   30,    0,   58,  155,   53,   53,   53,   54,    0,   24,
			  913,  913,  911,  912,  910,    0,   22,   34,  913,   35,
			  913,    0,    0,    0,  887,  892,  905,  864,  883,  882,
			  881,  886,  885,  884,  880,  879,  878,  877,  876,  875,
			  874,  873,  872,  871,  870,  869,  868,  867,  866,  865,
			  898,  891,  894,  895,  625,   39,   40,  890,  889,    0,
			   38,   31,   36,    0,   32,   41,  897,  896,  899,   43,
			  863,  862,   42,  904,  903,  906,   56,    0,    0,  913,

			    0,    0,    0,    0,   18,   20,    0,   27,   29,  908,
			  901,  907,  900,    0,    0,  502,  515,  501,    0,    0,
			    0,    0,    0,  432,  445,    0,  551,  554,    0,  433,
			    0,    0,  807,   44,    0,    0,   46,   38,   37,    0,
			    0,    0,    0,   57,   62,  156,  913,    0,    0,    0,
			    0,   47,   23,  515,    0,    0,  503,    0,  530,  515,
			    0,    0,  503,    0,  507,  446,  516,    0,  515,    0,
			    0,  503,    0,  515,    0,    0,  503,    0,  515,    0,
			  503,    0,  503,    0,  541,  531,  507,  434,    0,    0,
			    0,    0,    0,  805,    0,   45,   33,   64,   63,   59, yyDummy>>,
			1, 200, 0)
		end

	yydefact_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			   61,   60,    0,  252,    0,  209,  158,  161,   50,   49,
			   48,  454,  515,    0,  503,    0,    0,  549,  539,  443,
			  504,    0,  452,  515,    0,  503,    0,    0,  547,  537,
			  441,    0,  517,    0,    0,  911,  912,  910,    0,    0,
			    0,    0,    0,    0,    0,  518,  519,    0,  432,  467,
			    0,    0,  450,  515,    0,  503,    0,    0,  545,  535,
			  439,    0,  448,  515,    0,  503,    0,    0,  543,  533,
			  437,    0,  447,    0,  542,  532,  436,    0,  435,    0,
			  505,  502,  515,  501,  506,  553,  893,  902,  888,  909,
			  626,    0,    0,    0,    0,    0,    0,  366,    0,    0,

			  773,  767,  753,    0,  752,    0,  768,  800,  700,  845,
			    0,    0,    0,    0,    0,    0,  748,  747,  422,  770,
			  742,  745,  771,  783,  774,  746,    0,    0,    0,  766,
			  779,  780,  764,  741,  744,  714,  715,  738,    0,  700,
			  750,  772,  851,  739,  782,  777,  781,  775,  751,  806,
			  769,    0,  749,  740,  765,  778,    0,    0,    0,    0,
			    0,   74,  144,    0,    0,    0,    0,   71,  136,  103,
			   84,   84,  255,  913,  253,  241,  247,  235,  232,    0,
			  210,  164,    0,  455,    0,  550,  540,  444,    0,    0,
			  571,  453,    0,  548,  538,  442,    0,    0,  569,  515, yyDummy>>,
			1, 200, 200)
		end

	yydefact_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			    0,  503,  515,    0,  503,  513,  513,  516,  513,  515,
			    0,  503,  515,    0,  503,  515,  503,  503,  509,  911,
			  912,  910,  522,  521,    0,  456,  508,  514,  451,    0,
			  546,  536,  440,    0,    0,  567,  449,    0,  544,  534,
			  438,    0,    0,  565,    0,  564,    0,  513,  513,  513,
			  623,  754,  755,    0,    0,  710,  709,  708,  332,  711,
			  911,  912,  910,    0,    0,  758,  756,  757,  798,    0,
			  703,    0,  688,  366,    0,  848,  849,    0,  851,  844,
			  404,  846,  847,    0,  404,    0,    0,  760,  813,    0,
			  776,    0,    0,  421,  423,  664,  789,  793,    0,    0,

			    0,    0,    0,    0,  808,  707,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  787,  791,  809,  810,  690,  854,  831,  826,
			    0,   84,   84,   84,   84,  144,    0,  136,  144,    0,
			  136,    0,  507,  145,  104,    0,  144,    0,  136,  144,
			    0,  136,  144,  136,  136,   80,   72,  507,  137,   92,
			    0,   88,   85,   65,   68,    0,  269,  416,    0,  201,
			  239,    0,  245,    0,    0,    0,    0,  160,    0,  572,
			    0,    0,  570,    0,  476,  515,  503,  465,  474,  515,
			  503,  463,    0,    0,    0,  472,  515,  503,  461,  470, yyDummy>>,
			1, 200, 400)
		end

	yydefact_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  515,  503,  459,  469,  458,  457,  513,  513,  513,  526,
			    0,  568,    0,    0,  566,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  743,    0,    0,  799,  701,
			    0,    0,  364,    0,    0,  829,    0,  403,  377,    0,
			    0,    0,    0,  365,  700,    0,  377,    0,    0,    0,
			    0,  811,    0,    0,    0,    0,  424,    0,    0,    0,
			    0,  737,  735,  736,  734,  717,  718,  719,  721,  723,
			  724,  726,  725,  727,  720,  722,  733,  730,    0,  729,
			    0,  728,  716,  700,  700,    0,    0,  852,    0,  797,
			   67,   70,   66,   69,  112,  144,  136,  101,  110,  144,

			  136,   99,    0,    0,   73,  146,    0,    0,  912,    0,
			    0,    0,    0,    0,    0,    0,  147,  148,    0,    0,
			    0,  136,  125,  108,  144,  136,   97,  106,  144,  136,
			   95,  105,   94,   93,   78,    0,  138,  139,    0,   86,
			    0,  256,  257,  254,    0,  415,  417,   15,  276,  271,
			  273,  270,  202,    0,    0,  240,  249,  248,    0,  246,
			  234,  211,  503,  171,  172,  163,    0,    0,    0,    0,
			  477,  466,  475,  464,  511,  524,  512,  525,  510,  523,
			  473,  462,  471,  460,    0,    0,    0,  527,  520,    0,
			    0,    0,    0,    0,  552,  700,    0,    0,    0,    0, yyDummy>>,
			1, 200, 600)
		end

	yydefact_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  801,  802,  803,  804,  702,    0,    0,  700,  850,  851,
			  404,  403,  405,  380,    0,    0,  370,  374,  369,  367,
			  372,  368,  371,  373,    0,  404,    0,    0,  825,  824,
			    0,  762,    0,    0,  812,    0,  913,    0,  395,  391,
			  700,  425,  665,    0,    0,  788,    0,    0,  792,  732,
			  731,  699,  697,  786,  790,  860,    0,    0,    0,  853,
			  859,  113,  102,  111,  100,   77,   75,   76,  144,    0,
			  136,  144,    0,  136,  145,  144,    0,  136,  144,    0,
			  136,  144,  136,  136,  141,  151,    0,  150,  140,  143,
			  513,    0,  137,  109,   98,  107,   96,   79,    0,    0,

			    0,  513,   87,    0,    0,  259,  258,    0,    0,  420,
			    0,  275,  272,    0,  324,  333,  913,  278,  287,  277,
			  281,  274,    0,    0,  200,  207,  238,  250,  251,  244,
			  165,  175,  173,  174,    0,  562,    0,  560,    0,  558,
			    0,  556,  555,  624,  828,  827,    0,  700,  704,  705,
			  706,  689,  830,  377,  406,  407,    0,  328,  667,  913,
			  410,  375,  377,  328,  667,  410,    0,  761,  230,  814,
			  815,  816,    0,    0,    0,    0,  396,  392,  393,  401,
			  397,  700,  428,  428,  794,  795,  796,    0,  858,  855,
			  856,  857,  134,  144,  136,  123,  132,  144,  136,  121, yyDummy>>,
			1, 200, 800)
		end

	yydefact_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  130,  144,  136,  119,  128,  144,  136,  117,  127,  116,
			  115,  513,    0,  153,    0,   81,   82,   83,    0,   90,
			   91,   89,  264,  260,    0,  418,    8,  324,  288,  282,
			    0,    0,  325,  363,  324,   15,  290,  284,    0,    0,
			  280,  279,  203,  206,  204,  205,  208,  219,  224,  178,
			  214,  186,  220,    0,  215,  225,  187,  563,  561,  559,
			  557,  759,  687,    0,    0,  408,  388,    0,    0,  381,
			  382,  379,    0,  410,  670,  913,  586,  573,    0,  409,
			  430,  376,    0,    0,  410,  913,  430,    0,    0,    0,
			    0,    0,  638,  637,  700,  394,  402,  398,  399,    0,

			  429,    0,    0,  743,  135,  124,  133,  122,  131,  120,
			  129,  118,    0,  142,  152,  154,  149,  182,  262,    0,
			  261,  419,    6,    0,  292,  286,  289,  283,  330,    0,
			   15,  155,    0,  337,  334,    0,    0,    0,    0,    0,
			  221,  215,  170,  216,  225,  226,    0,  188,  220,  328,
			  667,  410,  387,    0,  384,  383,  386,  385,  329,    0,
			  668,    0,  410,  609,    0,    0,    0,  608,  767,  700,
			    0,    0,    0,  913,    0,  667,  625,  610,  581,    0,
			  784,  785,    0,  607,  422,  584,  606,    0,    0,    0,
			    0,  712,  599,  600,  591,  592,  594,  593,  913,    0, yyDummy>>,
			1, 200, 1000)
		end

	yydefact_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  409,  411,  913,    0,  431,  328,  667,  410,    0,  410,
			    0,    0,  763,  635,    0,    0,  639,  686,  400,  426,
			  700,  822,  823,  861,  183,    0,    0,  263,    7,   15,
			  291,  285,    0,  293,  330,  155,  404,  361,  361,  361,
			  361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
			  361,  361,  361,  361,  361,  361,  361,  361,  361,  361,
			    0,  227,  228,  218,  223,  179,  180,  177,  213,  196,
			  195,  191,  185,  225,    0,  169,  215,  410,  913,  430,
			  389,  843,    0,    0,  669,  430,    0,    0,    0,  515,
			    0,    0,    0,    0,  478,  490,    0,    0,    0,  688,

			    0,  913,    0,  580,    0,  913,    0,    0,  582,  422,
			    0,    0,    0,    0,    0,  690,    0,    0,    0,    0,
			  412,  413,  579,  839,  410,  913,  430,  842,  430,  838,
			  636,    0,    0,  267,  265,  266,    5,  331,  294,    0,
			   15,  155,   15,  404,  377,  362,  360,  338,  357,  354,
			  359,  358,  356,  353,  351,  355,  352,  350,  349,  348,
			  347,  346,  345,  344,  343,  342,  341,  340,  339,  336,
			  229,  181,  192,    0,    0,    0,  168,  225,    0,  410,
			    0,  390,  673,  671,  672,    0,    0,  515,    0,  503,
			  713,  912,    0,  712,    0,  617,  491,  515,    0,  503, yyDummy>>,
			1, 200, 1200)
		end

	yydefact_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  515,    0,  503,  515,  503,  503,  479,    0,    0,    0,
			    0,    0,    0,    0,  913,  913,    0,    0,    0,  621,
			  913,  611,    0,    0,  664,  596,  595,    0,    0,  700,
			  700,  590,  605,  598,  597,  414,    0,  410,    0,    0,
			  640,  427,  326,  817,  818,  326,  819,  821,  820,  326,
			  326,  155,  404,   15,  155,  377,  410,    0,    0,  194,
			  197,  198,  190,  167,    0,  837,  430,  833,  841,    0,
			  499,  515,  503,  488,  497,  515,  503,  486,    0,  495,
			  515,  503,  484,  493,  515,  503,  482,  492,  481,  480,
			  615,    0,  700,  662,  661,  642,  913,    0,  650,    0,

			  645,  644,  575,  627,  913,    0,    0,    0,    0,  666,
			    0,    0,  588,  576,  613,  612,    0,    0,    0,    0,
			  699,  697,  836,  430,  832,  840,  327,  299,  297,  298,
			  296,  404,  377,  155,  404,  410,    0,    0,    0,  328,
			  667,  410,  199,  166,    0,  663,  500,  489,  498,  487,
			  700,  496,  485,  494,  483,    0,  700,  689,  578,  641,
			    0,  647,  646,  577,  628,  629,    0,    0,  632,  631,
			    0,    0,  700,  614,  913,  428,    0,    0,    0,  377,
			  410,    0,    0,  404,  377,    0,  328,  667,  410,  326,
			  410,  913,  430,  835,  618,  700,  687,    0,    0,    0, yyDummy>>,
			1, 200, 1400)
		end

	yydefact_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yydefact'.
		do
			yyarray_subcopy (an_array, <<
			  658,  651,  655,  652,  649,  659,  657,  660,  630,    0,
			  633,  700,  619,  622,  583,    0,  602,    0,    0,  834,
			  410,    0,    0,    0,  328,  913,  667,  410,  410,  377,
			  410,    0,    0,  326,  410,  913,  430,  320,    0,  410,
			    0,  616,    0,  654,    0,  653,  634,  686,    0,  604,
			  603,  601,    0,  328,  667,  410,  326,  410,  574,  913,
			  430,  430,  410,    0,    0,    0,  328,  667,  410,  321,
			    0,  410,    0,  326,  430,  326,    0,  656,  700,  326,
			  410,  913,  430,  309,    0,  410,    0,    0,    0,  328,
			  667,  410,  326,  410,  913,  430,  326,  430,  326,  322,

			    0,  316,  620,  308,    0,  410,    0,  326,  430,  326,
			  326,  326,  410,  913,  430,  311,    0,  410,    0,  323,
			    0,  317,  326,  326,  430,  326,  313,    0,  301,  295,
			  310,    0,  410,    0,  326,  430,  326,  326,  318,  312,
			    0,  300,  326,  326,  430,  326,  315,    0,  303,  319,
			  326,  305,  314,    0,  302,  326,  304,  326,  307,  306,
			    0,    0,    0, yyDummy>>,
			1, 163, 1600)
		end

	yydefgoto_template: SPECIAL [INTEGER]
			-- Template for `yydefgoto'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 306)
			yydefgoto_template_1 (an_array)
			yydefgoto_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yydefgoto_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yydefgoto'.
		do
			yyarray_subcopy (an_array, <<
			  316,  317,  318, 1178,  526,  804,  845,  242,  243,  244,
			  219,  774,  220,  165,  166,  775,  857,  858,  528,  859,
			  477, 1133, 1134, 1233,  319, 1179,  320,  321,  322, 1182,
			   76,  323,  324, 1183, 1601, 1602, 1603, 1499, 1604,   11,
			   12,    4,  922,  923, 1270,  924,  380,  381, 1076, 1203,
			  960, 1415, 1422, 1505, 1497, 1204, 1184, 1309, 1575, 1628,
			 1185, 1077, 1513,  658, 1445,  713,  714,  715,  558,  559,
			 1113,  543,  544, 1114,  562,  563,  902,  556,  897,  367,
			  719,  741,  742,  373,  374,  743,  325,  131,  377,  755,
			  203,  378, 1186, 1092,  973, 1093, 1568, 1506, 1569, 1271,

			 1052, 1148, 1272,  839,  327,  328,  329,  330,  331,  332,
			  333,  334,  335,  336,  337,  847,  914, 1073,  749,  750,
			  566,  567,  751, 1459,  915, 1262,  756,  639,  640,  641,
			  642, 1033,  643,  480, 1034,  141,  142,   23,  143,  339,
			  123,  340, 1192,    5,    6,   18,   14,   19,   20,   81,
			   15,   16,   36,   82,   83,   84,  341,  342, 1193, 1194,
			 1195, 1196, 1197,   85,  343,   87,   88,  746,  747,   13,
			   28, 1035, 1346, 1263, 1145, 1146, 1140, 1141, 1143, 1144,
			  124,  125, 1067, 1068, 1069, 1070,  815, 1071,  494,  495,
			  344,  345,  628,   89,  346,  347, 1283, 1284, 1075,  348, yyDummy>>,
			1, 200, 0)
		end

	yydefgoto_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yydefgoto'.
		do
			yyarray_subcopy (an_array, <<
			  349,   99,  350,  763,  146,  206,  764,  207,  765, 1080,
			  638,  917,  918,  126,  127,  351,  352,  919,  920,   92,
			  353,   94,   95,  899,  900, 1056, 1267, 1198, 1527,  354,
			  355,  834,  356,  250,  129,  251, 1296,  702,  703,  371,
			  704, 1226, 1023, 1227, 1100, 1101, 1500, 1501, 1412, 1199,
			 1760, 1228, 1229, 1122,    9,    8,   30,   31, 1078,   38,
			   40,   97,  541,  735,  740,  188,  592,  382,  576, 1137,
			 1139, 1374, 1373,  753, 1138, 1135, 1136,  574,  754,  571,
			  758,  573,  565, 1119,  921, 1260,  956,  841,  812, 1201,
			  909, 1025,  656, 1316, 1307, 1560, 1161,  630,  685,  659,

			  686,  660,  469,  194,  652,  484,  688, yyDummy>>,
			1, 107, 200)
		end

	yypact_template: SPECIAL [INTEGER]
			-- Template for `yypact'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 1762)
			yypact_template_1 (an_array)
			yypact_template_2 (an_array)
			yypact_template_3 (an_array)
			yypact_template_4 (an_array)
			yypact_template_5 (an_array)
			yypact_template_6 (an_array)
			yypact_template_7 (an_array)
			yypact_template_8 (an_array)
			yypact_template_9 (an_array)
			Result := yyfixed_array (an_array)
		end

	yypact_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			  126,  253, 2603, 2501, -32768, -32768, 1864, -32768, -32768, -32768,
			 -32768, 1741, -32768,  505, -32768, 1091, -32768, 1052, -32768,  864,
			  673, 2840, 1753,  889, 1865, 1865, 1865, -32768, 1867, -32768,
			 -32768, -32768, -32768, -32768, -32768, 1749, -32768, -32768, -32768, -32768,
			 -32768,  169,  106,  535, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, 1180, -32768, -32768, -32768, -32768,   61,
			 1748, -32768, 1746, 2840, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, 1235, 2941, 2318,

			 1863, 1862, 1857, 1052, -32768, -32768, 2840, -32768, -32768, -32768,
			 -32768, -32768, -32768, 1523, 1495, -32768,  923, -32768, 1394, 1390,
			 1736,  768,  915,  909, -32768, 1740, -32768, 1738, 1742, -32768,
			  768, 1739, 1732, -32768, 1840, 2840, -32768, -32768, -32768, 1052,
			 1052, 1026, 1235, -32768, 1784, -32768, 1643, 1715, 1052, 1052,
			 1052, -32768, -32768,  923, 1726,  906,  909, 1729, -32768,  923,
			 1721,  891,  909, 1728, 1723, -32768, -32768, 1696,  923, 1717,
			  872,  909, 1727,  923, 1701,  863,  909, 1714,  923,  724,
			  909, 1707,  909,  535, 1578, 1576, 1708, -32768, 1686, 1052,
			 7447, 1722,  535, -32768, 6061, -32768, -32768, 1769, 1765, -32768, yyDummy>>,
			1, 200, 0)
		end

	yypact_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, -32768, 1534, 1768,  761, 1685, -32768, 2163, -32768, -32768,
			 -32768, -32768,  923,  689,  909, 1699,  535, 1578, 1576, -32768,
			 -32768, 1052, -32768,  923,  624,  909, 1692,  535, 1578, 1576,
			 -32768, 1052, -32768, 1363, 1325,  773,  711,  680, 1213, 1204,
			 1648,  768, 1686, 1114, 1114, -32768, -32768, 1680,  909, 1677,
			 1662, 1660, -32768,  923,  507,  909, 1656,  535, 1578, 1576,
			 -32768, 1052, -32768,  923,  456,  909, 1654,  535, 1578, 1576,
			 -32768, 1052, -32768,  535, 1578, 1576, -32768, 1052, -32768, 1658,
			 -32768, 1653,   12, 1651, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, 1650, 6061, 6061, 1052, 1052,  370, -32768, 1019, 6061,

			 -32768, 1649, -32768, 6061, -32768, 6061, 1639, 1703,  975,  483,
			 6061, 6166, 1640, 3250, 6061, 1641, -32768, -32768, 1196, -32768,
			  553,  512, -32768, -32768, -32768, -32768, 7087, 1636, 1629, 1628,
			 -32768, -32768, -32768, 1128, 1112, -32768, -32768, -32768, 5954,  399,
			 -32768, -32768, 1349, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 1623, 6061, -32768, -32768, 1622, -32768, 6061, 1534, 1534, 1193,
			 1187, -32768, 1260, 1173, 1120, 1644,  768, 1706, 1258, -32768,
			 1668, 1668, -32768,  511, -32768, 1634, 1401, 1498, -32768, 1666,
			 -32768, 1936, 1715, -32768,  535, 1578, 1576, -32768, 1052, 1613,
			 1426, -32768,  535, 1578, 1576, -32768, 1052, 1608, 1426,  923, yyDummy>>,
			1, 200, 200)
		end

	yypact_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 1577,  909,  923, 1573,  909, -32768, -32768, 1602, -32768,  923,
			 1567,  909,  923, 1560,  909,  923,  909,  909, -32768, 1599,
			 1594, 1589, -32768, -32768,  535, 1563, -32768, -32768, -32768,  535,
			 1578, 1576, -32768, 1052, 1590, 1426, -32768,  535, 1578, 1576,
			 -32768, 1052, 1582, 1426, 1580, 1426, 1572, -32768, -32768, -32768,
			 1569, -32768, -32768, 1574, 1571, -32768, -32768, -32768, -32768, -32768,
			  508,  398,  148, 1568, 1565, -32768, -32768, -32768, -32768, 6061,
			 1562,  768, -32768, 1561,  535, -32768, -32768, 1555, 1349, -32768,
			  103, 3625, -32768, 6061,   91, 2000, 1019, 1676, 1557,  535,
			 -32768, 6603,  535, -32768, -32768, 1105, -32768, -32768, 6061, 6061,

			 6061, 6061, 6061, 6061, -32768, -32768, 6061, 6061, 6061, 6061,
			 6061, 6061, 6061, 6061, 6061, 6061, 6061, 5849, 5733, 6061,
			 1052, 1052, -32768, -32768, -32768, -32768, 3486, 1556, -32768, 7321,
			 7273, 1668, 1668, 1668, 1668, 1260, 1552, 1258, 1260, 1544,
			 1258, 1564, 1546, -32768, -32768,  875, 1260, 1468, 1258, 1260,
			 1417, 1258, 1260, 1258, 1258, 1655, -32768, 1541, -32768, -32768,
			  875, 1646, -32768, -32768, -32768, 1052, -32768, 1633, 1470, 1514,
			 2019, 1052, 1808, 1052,  761, 1508,  768, -32768, 1507, 1426,
			 1491, 1489, 1426, 1437, 1483,  923,  909, 1479, 1473,  923,
			  909, 1472, 1696, 1696, 1696, 1466,  923,  909, 1454, 1451, yyDummy>>,
			1, 200, 400)
		end

	yypact_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			  923,  909, 1449, 1448, 1438, 1422, -32768, -32768, -32768,  446,
			 1439, 1426, 1427, 1424, 1426, 1410, 1408, 1052, 1686, 1686,
			 1686, 1052, 6061, 6061,  535, 6902, 6830, 5628, -32768, -32768,
			 6061, 1416, -32768, 1413, 1052, -32768,  535, 1503,  852, 1052,
			 1052,  374,  305, -32768,  357,  535,  826, 1052, 1052, 1409,
			 1052, -32768, 1052, 1405, 6061, 1403, 5099, 6061,  122, 6061,
			 6061,  642,  642,  642,  642,  530,  530,   62,   62,   62,
			  642,  642,  642,  642,   62,   62, 7366, 7375, 6061, 7375,
			 6061, 2330, -32768,  399,  399, 6061, 6061, -32768, 5204, -32768,
			 -32768, -32768, -32768, -32768, -32768, 1260, 1258, -32768, -32768, 1260,

			 1258, -32768,  587, 1564, -32768, -32768, 1072, 1006,   44, 1000,
			  985, 1093,  768,  875, 1052, 1052, -32768, -32768, 1393, 1389,
			  913, 1258, 1384, -32768, 1260, 1258, -32768, -32768, 1260, 1258,
			 -32768, -32768, -32768, -32768, -32768, 1052, -32768, -32768, 1380, -32768,
			 1052, 1378, 1052, -32768,  930, -32768, -32768,  253, 1382, 1470,
			  181, -32768, -32768, 1052, 1052, -32768, 1052, 1375, 1052, -32768,
			 -32768, -32768,  909,   36,  768, -32768, 1364, 1052, 1355, 1052,
			 1372, 1371, 1368, 1360, -32768, -32768, -32768, -32768, -32768, -32768,
			 1359, 1356, 1354, 1352, 1114, 1114, 1114, -32768, -32768, 1348,
			 1052, 1345, 1052, 1052, -32768,  399, 7228, 7183, 1351, 1052, yyDummy>>,
			1, 200, 600)
		end

	yypact_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, -32768, -32768, -32768, -32768, 7068, 5521,  399, -32768, 1349,
			  785, -32768, 5099,  373, 2941,  645, -32768,  898, -32768, -32768,
			 -32768, -32768, -32768, -32768,  535,  785, 2941,  583, -32768, -32768,
			 5416, -32768,  894,  258, -32768, 2941, 2755, 1330, 1309, 6946,
			  874, 4994, 7321, 6061, 6061, -32768, 7017, 5309, -32768, 7375,
			 2330, 3182, 3043, -32768, -32768, -32768, 1019,  828, 4887, -32768,
			 7321, -32768, -32768, -32768, -32768, -32768, -32768, -32768, 1260,  856,
			 1258, 1260,  759, 1258, 1327, 1260,  746, 1258, 1260,  727,
			 1258, 1260, 1258, 1258, -32768, -32768,  737, -32768, -32768, -32768,
			 -32768, 1564, 1323, -32768, -32768, -32768, -32768, -32768, 1442, 1431,

			  295, -32768, -32768,  291,   64, -32768, -32768, 1322, 1322, -32768,
			 1420, -32768, -32768, 1052,  666, -32768, 6494, -32768, -32768, -32768,
			 -32768,  181,  526,  426, -32768, 1308, -32768, -32768, -32768, -32768,
			 1802, -32768, -32768, -32768, 1052, 1254, 1052, 1254, 1052, 1254,
			 1052, 1254, 1254, -32768, -32768, -32768, 6061,  399, -32768, -32768,
			 -32768, -32768, -32768,  817, 5099, 4994, 1052,  410,  266,  219,
			  303, 1291,  441,  410,  266,  303, 1019, 1425, -32768, -32768,
			 -32768, -32768, 6061, 1415, 1357, 1052, -32768, -32768, 1283, 1270,
			 6936,  767, 6654, 6654, -32768, -32768, -32768, 1301, -32768, -32768,
			 -32768, -32768, 1294, 1260, 1258, 1290, 1288, 1260, 1258, 1287, yyDummy>>,
			1, 200, 800)
		end

	yypact_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 1281, 1260, 1258, 1280, 1277, 1260, 1258, 1269, 1268, 1267,
			 1262, -32768,  875,  234, 1052, -32768, -32768, -32768,  875, -32768,
			 -32768, -32768, 1265, -32768, 1261, 5099, -32768,  265, -32768, -32768,
			  181,  535, -32768, -32768,   66,  253, -32768, -32768, 1052, 1240,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768,  669, 1369,  987,
			  273,  709, 1256, 1366, 1200, 1172, 1362, 1254, 1254, 1254,
			 1254, -32768, -32768, 2941,  560, 4994,  593, 1052, 1052, 1052,
			 1052, -32768, 2941,  303, 1252,  219, -32768, -32768, 2696, 1332,
			  240, -32768, 2941,  500,  303,  219,  240, 1250, 1052, 6275,
			 6061, 6061, 1357, -32768,  399, -32768, -32768, -32768, 1228, 6061,

			 -32768, 1337, 1289, 6787, 1218, 1217, 1216, 1207, 1203, 1202,
			 1191, 1189, 1052, -32768, -32768, -32768, -32768, 1177, -32768,  535,
			 -32768, 4994, 1300,  181, -32768, -32768, -32768, -32768, 1190,  535,
			  253,  889, 7018, 6461, -32768, 1052, 1052, 1052, 1052,  352,
			 -32768, 1200, -32768, -32768, 1172, -32768, 1285, -32768, 1256,  410,
			  266,  303, -32768,  535, -32768, -32768, -32768, -32768, -32768, 1282,
			 -32768, 2941,  303, -32768, 1052,  546,  535, -32768,   67,  766,
			 6061, 6061, 6061, 1065, 1175,  266, 1180, -32768, 1271, 1226,
			  553,  512, 1212, -32768, 1196, -32768, -32768, 1145, 1144, 1128,
			 1112, 4036, -32768, -32768,  382, -32768, -32768, -32768, 1135,  568, yyDummy>>,
			1, 200, 1000)
		end

	yypact_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, 5099,  967, 1249, -32768,  410,  266,  303, 1242,  303,
			 1234, 1123, -32768, -32768, 6229, 6558, -32768, -32768, -32768, 7321,
			  755, -32768, -32768, -32768, -32768,  -16,  535, -32768, -32768,  253,
			 -32768, -32768, 1052, 1429, 1190,  889,  785, 1185, 1185, 1185,
			 1185, 1185, 1185, 1185, 1185, 1185, 1185, 1185, 1185, 1185,
			 1185, 1185, 1185, 1185, 1185, 1185, 1185, 1185, 1185, 1185,
			 1240,  956, 1052, -32768, -32768, -32768, 1052, -32768, -32768, -32768,
			  332,  668, -32768, 1172, 1221, -32768, 1200,  303,  219,  240,
			 1096, -32768,  725, 2941, -32768,  240, 1101,  942,  299,  923,
			  833,  599,  710,  768,  909, -32768, 1094, 1107,  768, 4570,

			 1871, 2339, 6513, -32768,  535,  967,  707, 4782, -32768, 1196,
			 6061, 6061,  849, 1052, 1052, 4173, 2696, 1083, 6061, 6061,
			 5099, 4994, -32768, -32768,  303,  219,  240, -32768,  240, -32768,
			 -32768, 6061, 6061, -32768, -32768, -32768, -32768, -32768, -32768, 6729,
			 6350,  889,  331,  785,  839, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, 1052,  352, 1201, -32768, 1172, 1181,  303,
			 1176, -32768, -32768, -32768, -32768, 1169, 6061,  923,  486,  909,
			 -32768,  923,  435, -32768,  909, 1051, -32768,  923,  365,  909, yyDummy>>,
			1, 200, 1200)
		end

	yypact_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			  923,  193,  909,  923,  909,  909, -32768,  329, 6230, 1049,
			 1052, 1052,  753,  946, 1063,  452, 1042, 1104,  535,  979,
			 1028, -32768, 1102, 4675, 1105, 7321, 7321, 6061, 1087,  399,
			  399, -32768, -32768, 7321, 7321, 4994, 1090,  303, 1086, 1075,
			 7321, 7321,   46, -32768, -32768,   46, -32768, -32768, -32768,   46,
			   46,  889,  785,  253,  889,  830,  303, 2941,  442, -32768,
			  956, 1052, -32768, -32768, 1057, -32768,  240, -32768, -32768, 7138,
			 -32768,  923,  909, -32768, -32768,  923,  909, -32768, 1052, -32768,
			  923,  909, -32768, -32768,  923,  909, -32768, -32768, -32768, -32768,
			  919, 1052,  399, -32768, -32768, -32768, 1028, 1017,  972,  961,

			  946, -32768, -32768, -32768,  967,  953,  133,  896,  842, -32768,
			  806, 1052, -32768, -32768, -32768, -32768,  945,  914, 6467, 6061,
			 3899, 3762, -32768,  240, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768,  785,  520,  889,  785,  303, 2941,  424,  924,  410,
			  266,  303, -32768, -32768,  920, -32768, -32768, -32768, -32768, -32768,
			  399, -32768, -32768, -32768, -32768, 1052,  399, 4440, -32768, -32768,
			  414, -32768, -32768, -32768, -32768, -32768,  903, 6061,  896, -32768,
			 1052,  329,  399, -32768,  195,  859,  160, 6467,  814,  450,
			  303, 2941,  232,  785,  306,  734,  410,  266,  303,   46,
			  303,  219,  240, -32768, -32768,  399, 4310,  738,  717,  535, yyDummy>>,
			1, 200, 1400)
		end

	yypact_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yypact'.
		do
			yyarray_subcopy (an_array, <<
			 -32768,  488,  685,  414, -32768, -32768, -32768, -32768, -32768, 6513,
			 -32768,  399,  439, -32768, -32768,  728, -32768,  712,  677, -32768,
			  303, 2941,  409,  671,  410,  219,  266,  303,  303,  134,
			  303, 2941,  389,   46,  303,  219,  240, -32768,  665,  303,
			  655, -32768,  453, -32768,  414, -32768, -32768, 3348, 1052, -32768,
			 -32768, -32768,  648,  410,  266,  303,   46,  303, -32768,  219,
			  240,  240,  303, 2941,  249,  609,  410,  266,  303, -32768,
			  602,  303,  576,   46,  240,   46,  281, -32768,  399,   46,
			  303,  219,  240, -32768,  550,  303,  531,  447,  404,  410,
			  266,  303,   46,  303,  219,  240,   46,  240,   46, -32768,

			  396, -32768, -32768, -32768,  379,  303,  371,   46,  240,   46,
			   46,   46,  303,  219,  240, -32768,  333,  303,  330, -32768,
			  321, -32768,   46,   46,  240,   46, -32768,  314, -32768, -32768,
			 -32768,  311,  303,  286,   46,  240,   46,   46, -32768, -32768,
			  257, -32768,   46,   46,  240,   46, -32768,  224, -32768, -32768,
			   46, -32768, -32768,  208, -32768,   46, -32768,   46, -32768, -32768,
			  164,  144, -32768, yyDummy>>,
			1, 163, 1600)
		end

	yypgoto_template: SPECIAL [INTEGER]
			-- Template for `yypgoto'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 306)
			yypgoto_template_1 (an_array)
			yypgoto_template_2 (an_array)
			Result := yyfixed_array (an_array)
		end

	yypgoto_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yypgoto'.
		do
			yyarray_subcopy (an_array, <<
			 -32768, -32768, -32768, -32768, -301, 1184, -588, -32768, -32768, -32768,
			  795, -117, -120,  312, -227, -144, -32768, -32768, -450, 1130,
			 -32768, -32768,  714,  739,   28, -32768, -1013, -1015, -32768, -32768,
			 -1245,  -13,  -21, -32768, -32768,  343, -32768, -32768,  367, -32768,
			 -32768,    4, -32768, -32768, -324,  285, -32768, -32768, -1324, -456,
			 -807, -1411,  542,  463, -32768, -32768,  786, -32768, -1427, -32768,
			  647,  206,  466,  536,  615, -32768, -32768, -32768, 1236,  676,
			 -477, 1245,  300, -469, -32768, -315, 1040, -32768, 1041, -500,
			 -32768, -32768, -32768, -32768, -32768, 1210,  214,  754, -32768, -506,
			 -32768, 1365, -32768, -32768, -32768,  836, -32768, -32768,  356, -32768,

			  866, -32768,  547,  847, -1017, -1030, -32768, -32768, -32768, -32768,
			 -1038, -1046, -32768, -246, -284, -173, -823, -925, -32768, -32768,
			 -32768, -32768, 1174,  459, -272, -637, -682, -32768, -32768, -32768,
			 -32768, 1609,  672, -32768, -32768, -32768, -32768, -32768, 1775,   18,
			 1693, -32768, -32768, -32768, -718, 1074, 1142, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768,   40, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -1258,  -17, -189, -32768, -32768, -32768, -32768,
			  982,  881, 6346, -1032,  986, -1114,  984,  765,  980, -1072,
			  -50, 2136, -32768, -32768, -32768, -32768, -629,   65, -32768, -1098,
			 -32768, -619, 1284, -300,   -3,  -19, -32768,  626, -938, 1828, yyDummy>>,
			1, 200, 0)
		end

	yypgoto_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yypgoto'.
		do
			yyarray_subcopy (an_array, <<
			 1570, -1100, -167, -32768, -32768, 1524, -32768, -32768,  438,  883,
			 -470, -801,  992, -32768, 1612, -32768, -32768, -802,  991, -163,
			    1, -180, -32768, -1060, -1064, -32768,  637, -32768,  934, -1352,
			 -32768, 1066, -293,   31, -32768, -32768, -32768, -158, -32768,  801,
			 1199, -32768,  990,  675, -1270, -958, -32768,  385, -32768, -1252,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,    3, -32768,
			 -32768, -32768, -32768, -32768, -32768, 1340, -265, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -793, 1085,  690,
			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

			 -32768, -32768, -32768, -32768, -32768, -32768, -32768, yyDummy>>,
			1, 107, 200)
		end

	yytable_template: SPECIAL [INTEGER]
			-- Template for `yytable'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 7605)
			yytable_template_1 (an_array)
			yytable_template_2 (an_array)
			yytable_template_3 (an_array)
			yytable_template_4 (an_array)
			yytable_template_5 (an_array)
			yytable_template_6 (an_array)
			yytable_template_7 (an_array)
			yytable_template_8 (an_array)
			yytable_template_9 (an_array)
			yytable_template_10 (an_array)
			yytable_template_11 (an_array)
			yytable_template_12 (an_array)
			yytable_template_13 (an_array)
			yytable_template_14 (an_array)
			yytable_template_15 (an_array)
			yytable_template_16 (an_array)
			yytable_template_17 (an_array)
			yytable_template_18 (an_array)
			yytable_template_19 (an_array)
			yytable_template_20 (an_array)
			yytable_template_21 (an_array)
			yytable_template_22 (an_array)
			yytable_template_23 (an_array)
			yytable_template_24 (an_array)
			yytable_template_25 (an_array)
			yytable_template_26 (an_array)
			yytable_template_27 (an_array)
			yytable_template_28 (an_array)
			yytable_template_29 (an_array)
			yytable_template_30 (an_array)
			yytable_template_31 (an_array)
			yytable_template_32 (an_array)
			yytable_template_33 (an_array)
			yytable_template_34 (an_array)
			yytable_template_35 (an_array)
			yytable_template_36 (an_array)
			yytable_template_37 (an_array)
			yytable_template_38 (an_array)
			yytable_template_39 (an_array)
			Result := yyfixed_array (an_array)
		end

	yytable_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   78,  287,   91,  187,   86,    7,  800,  472,   77,  407,
			  289,   17,   21,  490,  646,  833,  483,  827,   90,  955,
			  965,  338,   93,  246,  457, 1102, 1085,  487,  635,  910,
			 1274, 1236, 1190,   17,   17,   35, 1395,  478, 1084,   80,
			 1189,   21, 1428,   21,  370,  718,  451,  452, 1188,   75,
			  245,  570,  572,  465, 1419,  407,  564,  466,  903,  467,
			  718, 1187,   78, 1181,   91, 1180,   86,  759,  716, 1273,
			   77,  284,  848, 1266,  128,  133,  717, 1265, 1021,  145,
			   90, 1446, 1446,  737,   93,   78, 1312,   91, 1561,   86,
			 1027, 1576, 1032,   77, 1444, 1444, 1512,  853,  854,  422,

			  423,  137,  147,   90, 1264, 1334, 1268,   93,  117, 1333,
			  115,   75, 1037, 1036,   78,  144,   91,  249,   86, 1041,
			 1040,  151,   77,  138,  137,  418,  844,  637,  425,  459,
			 -713, -713,   90,  519,   75, 1343,   93,  448,  249,  637,
			  185,  593,  482,  594, 1762, 1504,  152, 1565,    3,  204,
			 1618, 1663,  369,  137,  164, 1490,    2,  197,  198, 1375,
			  144, 1065,  813,   75, 1761,  338,  208,  209,  210,  286,
			 -144,  288, 1512,  218, 1616,  196,  507,  931,  843,  229,
			 1662,  112,  618,  619,  620,  247,  542, 1526,  259,  928,
			 1129, 1117,  249,  269,    1, -691,  833,  275, 1646,  531, yyDummy>>,
			1, 200, 0)
		end

	yytable_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  533,  913, 1266,  132, 1377, 1099, 1265,  285, 1607, -585,
			  111, 1424, 1278,  718,  279,  645,  690,  691,  692,  693,
			  264,  903, 1757,  291, 1277, 1125, 1124,  636, 1127, 1126,
			 1370,  386, 1121, -585, -585,   79,  884, 1305, 1755,  390,
			 -585, 1452,  394,  959,  110,  885,  887,  389,  926,  398,
			  927, 1607,  929,   34,   33,   32, -585, 1151,  397,  986,
			  959,  247,  247, 1464, 1626,  117, 1484,  115, 1325, -501,
			 1190, 1750,  431,  109, -501,    3, 1207, 1202, 1189,  435,
			 1324, 1690,  439,    2, 1625,  913, 1188, -212,  434,  443,
			 -501, 1032, 1607,  744,   91,  445,  627,   79,  442, 1187,

			 1745, 1181, 1606, 1180,  444, 1019, 1617,  369,  369, 1016,
			   90, -212,  453,  454,  458, 1600,  463, 1131, 1079, 1612,
			   79, 1231, 1230, 1631, 1064, 1743,  161,  481, 1742,  464,
			   34,   33,   32, 1083,  813, 1737, 1372,   34,   33,   32,
			  953,  784,  785,  786, 1736, 1606, -193, 1734, 1392,   79,
			   71, 1531, 1630,    3, 1534,  962,   70, 1453, 1600,  952,
			 1116,    2,  809,   34,   33,   32, -193,   34,   33,   32,
			 -193,  462, 1391,  460, -193, 1115,  568,   34,   33,   32,
			  832,  970,  851,  852, -378, 1725, 1606,  473, 1074, 1031,
			 1123, 1013,  254, 1723, -589, -589, -589, -589,   45, 1600, yyDummy>>,
			1, 200, 200)
		end

	yytable_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  959,   34,   33,   32, 1390, -378,  579, -589, 1321,  799,
			 1722, -589, 1235, 1072,  582,  578, 1598, 1597, 1711, -589,
			  959, 1667, -589,  581,  911, -378, -589, -589,  821, -374,
			 -374, -374,  315, 1583, 1390,  959,  287,  117, 1480,  115,
			  456, 1654,   34,   33,   32,  289,   34,   33,   32,  777,
			  779,  611, -193,  959,  627,  609, 1587,  806, 1082,  614,
			  610, 1710,  224,  898, 1504,  211, 1503, 1621,  613,  813,
			  744,  222,  569, -193, 1540,  455,  776,  778,  813,  470,
			  252,  824,  823,   71,  800,  262,   34,   33,   32,   70,
			  272,  369,  297, 1269,  943,  722, 1620,  819,   34,   33,

			   32,  644,  776,  778,  463,  633,  951,  117, 1475,  115,
			  722,  959,  718,  213, 1423, 1341, -589,  649,  718, -515,
			  653,  470,   27,  655,  383, -268,  438, 1435,   34,   33,
			   32,   45, 1206, -268, 1599,  391, -268, 1581,  683,  684,
			  164, -268,  249,  249,  249, 1709,  967, 1044,  813, 1598,
			 1597,   26,   25,  476,   24,   34,   33,   32,  117, 1471,
			  115,  832,  122,  720, 1707,  428, 1580, 1648,  249,  249,
			  249,  959,  788,  122, 1676,  436,  437,  430,  738,   34,
			   33,   32,  121,  458,  120,  119,  118,  787,  475,  757,
			 1698,  757, 1150, 1293,  959, 1292, 1291, 1290,   34,   33, yyDummy>>,
			1, 200, 400)
		end

	yytable_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   32,  519, 1591,  474,  286,  473,  288,  117,  116,  115,
			  247,  247,  247, 1643, 1590,  964, 1696, 1615,  117, 1289,
			  115, 1038, 1451, 1692, 1454, 1012,  175,  429,  898, -502,
			 1210, 1319, 1318,  806, -502,  794, 1018,  514,  513,  795,
			 -695,  777,  779,  508,  507,  506, 1062, 1042, 1401, 1635,
			 -502, 1541,  458,  369,  497,  798,  959,  817,  817,  817,
			  817, 1634, 1679,  722,  114,  828,  829,  810,  831, 1675,
			  458,  117, 1400,  115,  840, 1288,  825,  958,  113, 1673,
			  -26, -698, -189, -217,  -26, 1656,  913,  -26, 1659, 1287,
			  -26, 1651, 1032,  -26,  393,  496,   34,   33,   32, 1657,

			 1061,  -26, -189, -217,  -26,  -26, -189, -217,  866,  -26,
			 -189,  584,  865,  519,  588, 1458, 1681, 1153, 1152,  -26,
			  -26,  595,  -26, -184,  599,  -26, 1650,  603, 1680, 1694,
			 1588,  738,  886,  886, 1038, 1533, 1461,  179,   34,   33,
			   32, 1693, 1649, -184,  392, 1644, 1112, -184, 1633,  514,
			  513, -184, 1713,  458,  264,  508,  507,  506,  904,  385,
			  458,   34,   33,   32, 1712, 1496, 1344, 1495,  916,  376,
			  375,  925,  757,  254,  757, 1627,  757,  503,  502,   34,
			   33,   32,  117, 1403,  115,  935,  224,  937,  473,  800,
			 1031, 1030,  112, 1217,  274,  957,   34,   33,   32,  117, yyDummy>>,
			1, 200, 600)
		end

	yytable_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1005,  115,  247,  247,  247,  408, -501,  963,  939,  384,
			  941,  942, 1390,  110,   39, 1655,  288,  947,  117, 1001,
			  115,  637, -501, 1380, 1461, 1668, 1537, 1418, 1619, 1385,
			  840,  117,  997,  115, 1063,  694,  406, -515,  698,  974,
			  117,  369,  115,  826,  273,  813,  723, 1536, 1383,  727,
			 1382,  458,  731,  164,  813,  961, 1457, 1691,  813,  981,
			  170,  891, 1011, 1261, 1261,  898, 1261,  813, 1299,  814,
			 1438,  -25, 1439, 1455,  463,  -25, 1535,  470,  -25, 1332,
			  813,  -25, 1398,  213,  -25, 1456, 1298,  987,  470,  470,
			 1315, 1098,  -25, 1427, 1099,  -25,  -25,  770,  405, -502,

			  -25,  772,  122, 1582, 1099,  117, 1397,  115,  780, 1567,
			  -25,  -25,  782,  -25,  287, -502,  -25, 1608,  458, 1039,
			   98,  904,  712,  289,  711,  710,  709, 1571,  117,  993,
			  115,  916,  916,  268, 1593,   34,   33,   32, 1589,  916,
			  925,  925,  258, 1574,   34,   33,   32,  462,  708,  460,
			 1622,  989, 1057,  988, 1058, 1632, 1059,  230, 1060, 1573,
			 1337,  228,  722,   34,   33,   32,  260, 1564,  722,  155,
			 1570,  270,  840,  981, 1066,  276,  217,  278,   34,   33,
			   32, -585, 1532,  267,  463,  184, 1498,   34,   33,   32,
			 1261, 1388,  257, 1094,  898,  861,  470, 1087,  978,  863, yyDummy>>,
			1, 200, 800)
		end

	yytable_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1664, -176, 1414, -176,  707,   37,  100,  101,  102,  387,
			 1544,  227,  175, -648,  117, 1387,  115,  969,  706,  968,
			  395, -176,  824,  823,  893, -176,  216,  170,  895, -176,
			  720, 1559,  916,  161,  879,  183,  738,  891,  890, 1447,
			 1447,  326, -587,  840, 1149,  916,  122, 1555,  916,  876,
			  432,  186,  908, 1158,  907,  872,  817,  117,  878,  115,
			  440, 1579, 1128, 1205, 1584,  164,  121, 1578,  120,  119,
			  118, 1543,  117,  875,  115, -585, -585, -585,  117,  871,
			  115,  968,  286,  981,  288, 1066, 1066, 1066, 1066, 1525,
			 -585,  462,  461,  460, -585,  471, 1191,  470,  -17,  155,

			 1524, 1460,  -17, -585, 1522,  -17, 1212, 1511,  -17, -585,
			 -585,  -17,  107, 1629,  108, 1295, 1514, 1220, 1509,  -17,
			  179,  869,  -17,  -17,   34,   33,   32,  -17, 1520, 1521,
			  886, 1519, 1154, 1155, 1156, 1157, 1640,  -17,  -17,  981,
			  -17,  916, 1282,  -17,  117,  868,  115,  175,  114,  657,
			 1225,  200,  199,  458,  458,  458,  458,  485,  532,  534,
			 1234,  491,  113, 1508, 1474,  117,  881,  115,  992,  550,
			 1492,  996,  104,  105, 1406, 1000, 1448, 1448, 1004, 1478,
			 1672, 1008, 1286, 1468, 1280,  326,  421,  420,  419, 1460,
			 1467, 1557,  117,  549,  115, 1465,  587, 1297,  529,  591, yyDummy>>,
			1, 200, 1000)
		end

	yytable_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  170,  932,  933,  530, 1686, 1687,  598, 1043, 1045,  602,
			 1048,  604,  605,  697,  161, 1463,  701, 1432, 1700,  840,
			  155,  493,  547, 1407,  726, 1386, 1706,  730, 1408,  732,
			  733,  175,   29, 1336, 1050, 1376,  539, 1381, 1345, 1718,
			  170, 1720,  536, 1132, 1232,  117,  546,  115, 1329, 1594,
			  458,  799, 1727,  413,  523, 1596, 1327, 1225, 1733,  117,
			  538,  115,  410, 1323, 1282,  117,  535,  115, 1740, -585,
			  522, 1613, 1314, 1313, 1477, 1311,  117,  412,  115, 1747,
			  458, 1162,  140,  139,  458,  117,  409,  115, 1753, 1310,
			 1173, 1209,  130, 1104, 1641, 1304, 1281, 1106, 1047, 1275,

			   -4, 1108, 1224, 1222, 1413, 1110, 1393,   34,   33,   32,
			 1647,  816,  818,  820,  822,  -96,  626, -107,   78,   78,
			   91,   91,   86,   86, 1393,  840,   77,   77,  -98, -109,
			  530, 1429, 1430, -100, 1191, 1416,   90,   90,  840,  981,
			   93,   93, -111, -102, -113,  661,  662,  663,  664,  665,
			  666, 1221,  161,  667,  668,  669,  670,  671,  672,  673,
			  674,  675,  676,  677,  679,  681,  682, 1443, 1443, 1218,
			 1091, 1211,  862, 1200,  403, 1160,  864, 1702, 1051, 1303,
			 1142,  771, -552, -222, 1120,  773, 1118,  286,  -93,  288,
			  155,  458,  781,  -94, -105,  -95,  783,  117,  402,  115, yyDummy>>,
			1, 200, 1200)
		end

	yytable_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  557,  894,  542, -106, 1317,  896,  -97, -108, 1322, -243,
			 -243, 1096,  400,  -99, -110, -243, -101,  175, 1507, -243,
			 -112,  170, 1103, -243, 1095, 1393, -243, 1090, 1493, 1494,
			 1088, -243, 1081, 1046, 1026,  117,  399,  115, 1539,  174,
			  -15,  981, 1022,  169,  264, 1015,  -15, 1014, -114, 1510,
			  976,    3, -126,  981, -243, 1340,  167,  -15,  975,    2,
			  -15,  -15,  117,  173,  115,  -15,  117,  168,  115,  796,
			  797,  527,  946,  940,  626,  -15,  938,  805, -438,  458,
			 -449,  -15, -440,  936, 1379, -451, -442,  287,  748,  117,
			  728,  115,  934,  167, -453,  254, 1550, -444, -455,  167,

			  928,  836,  569,  905,  842,  901,  846,  846,  167, 1556,
			 -103, 1417, -233,  167,  889,  811, -233, 1586,  167,  888,
			 -233,  569,  161, -233,  837,  849,  835,  850, -233, 1572,
			  830, 1437,  846,  846,  808,  860,  793,  807,  792,   78,
			  117,  724,  115,   86,  160,  791,  995,   77, -435,  999,
			  155, -233,  167, 1003, -553,  790, 1007,  930, 1009, 1010,
			  789,  122, 1624,  167, -436,  769, 1339,  117,  159,  115,
			 1338,  224,  154, 1595, -447, -437,  167, -448, 1605,  213,
			 -439,  366,   78,  365,  364,  363,   86,  264, 1611, 1393,
			   77,  122, -450,  167,  254,  117,  153,  115, -441, -452, yyDummy>>,
			1, 200, 1400)
		end

	yytable_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  224, 1396, 1653,  167,  213, -443,  117,  362,  115, -454,
			  768,  366, 1666,  365,  364,  363,  117,  699,  115,  767,
			 1502, 1605,  167,   78,  117,  695,  115,   86,  766,  761,
			 1642,   77,  117,  600,  115,  752,  117,  362,  115,  117,
			  596,  115, -237, -237, 1689,  117,  589,  115, -237,  117,
			  585,  115, -237,  805,  361,  286, -237, -231,  745, -237,
			  739, -231, 1605,  360, -237, -231, 1678,  736, -231,  734,
			 1105,  179,  705, -231, 1107,  179,  561,  359, 1109,  687,
			  651,  650, 1111,  634,  632,  629,  625, -237,  980, -434,
			  982,  983,  624,  360,  846,  623, -231,  621,  622, 1470,

			  617,  616,  545,  615, -528,  860, -529,  359,  560, 1479,
			 1563,  612, 1483,  122,  608, 1487,  117,  552,  115,  607,
			  117,  415,  115,  122,  606,  158,  158, -468,  264,  583,
			  158,  158,  158,  241,  580,  240,  239,  238,  205,  167,
			  575,  555,  167,  241,  254,  240,  239,  238,  224,  167,
			 -696, -693,  167,  213,  569,  167, -694,  521,  283,  282,
			  281,  492,  488,  179,  520,  468,  158, -692,  237,  236,
			  235,  450,  158,  117,  263,  115,  449, -691,  447,  446,
			 1614,  158,  441, 1546,  433,  427,  158, 1548,  426,  117,
			  253,  115, 1551,  117,  223,  115, 1553, 1639,  117,  212, yyDummy>>,
			1, 200, 1600)
		end

	yytable_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  115,  167,  980, -445,  424,  379,  156,  162,  117,  178,
			  115,  171,  176,  180,  182,  234, -242, -242, 1051, 1089,
			  396,  372, -242,  191,  358,  234, -242,  388,  357,  233,
			 -242, 1658,  290, -242,  280,  277, 1050, 1049, -242,  233,
			 1048, 1671,  271,  202, 1047,  158,  158,  214, 1086,  232,
			  158,  158,  158,  225,  195,  261,  231,  221,  193,  192,
			  248, -242,  255,  190,  150, 1685, -530,  265,  189,  149,
			  148,  136,  135,  106,  103,  545, 1411,  560,  545,   96,
			  560,  248,   27,   22,   10, 1562,  545, 1705,  560,  545,
			 1320,  560,  545,  560,  560,  368,  954, 1410, 1024,  971,

			 1717, 1335,  867, 1371, 1029, 1028,  577,  134,  525, 1384,
			 1055,  803,  980, 1276, 1054, 1130, 1053,  201,  479, 1732,
			 1542, 1462, 1147,  912, 1610,  167,  401,  404, 1216,  167,
			 1306,  411,  414,  416,  417,  248,  167, 1214, 1215,  760,
			  167, 1017,  519, 1020, -162, -162, 1219,  518,  517,  516,
			 -162,  515,  906,  874, -162, 1450, 1159,  892, -162, -162,
			 1517, -162, 1558, 1431, 1308, 1516, -162, 1208,  980, 1566,
			 1645,  158,  158, 1342, 1369,  158,  158,  158,  514,  513,
			  512,  511,  510,  509,  508,  507,  506, 1677,  991, -162,
			  950,    0,    0,    0,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 1800)
		end

	yytable_template_11 (an_array: ARRAY [INTEGER])
			-- Fill chunk #11 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,    0,  648,  503,  502,  501,  500,
			  499,  498,  158,    0,    0,  158,    0, 1300, 1301, 1302,
			    0,    0,  158,    0,    0,  158,  647, -236, -236,    0,
			    0,    0,    0, -236, 1279,  545,  560, -236,    0,  545,
			  560, -236,    0,    0, -236, 1285,    0,    0,  545, -236,
			  368,  368,  537,  540,    0,    0,  548,  551,  553,  554,
			    0,  560,    0,    0,  545,  560,    0,    0,  545,  560,
			    0,  519, -236,    0,    0,    0,  518,  517,  516,    0,
			  515,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			 1326,    0, 1328,  586,    0,    0,  590,    0,    0,    0,

			    0,    0,    0,  597,    0,    0,  601,  514,  513,  512,
			  511,  510,  509,  508,  507,  506,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  503,  502,  501,  500,  499,
			  498,    0,    0,    0,    0,    0,    0,    0,  158,    0,
			    0,  158,    0,    0,    0,    0,    0, 1425, 1426,  158,
			 1378,    0,  158,    0,  631, 1433, 1434,    0,  980,    0,
			    0, -159, -159,    0,    0,    0,    0, -159, 1440, 1441,
			    0, -159,    0,    0, 1473, -159,    0,    0, -159,    0,
			    0,    0,    0, -159, 1482,    0,    0, 1486,    0, 1488, yyDummy>>,
			1, 200, 2000)
		end

	yytable_template_12 (an_array: ARRAY [INTEGER])
			-- Fill chunk #12 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1489,    0,    0,    0,    0,    0,    0, 1436,  545,    0,
			  560,  545,    0,  560,    0,  545, -159,  560,  545,    0,
			  560,  545,  560,  560,    0,    0,    0,    0,    0,  696,
			    0,    0,  700, 1469,  368,    0,    0,    0,  721,    0,
			  725,    0,    0,  729,    0,    0,    0,    0,    0,  157,
			  163,    0,    0,  721,  172,  177,  181,    0,    0,    0,
			    0,    0, 1466,    0,    0,    0,    0, 1547,    0,  762,
			  980, 1549,    0,    0, 1518,    0, 1552,    0,    0,    0,
			 1554,    0,  980,    0,    0,  248,  248,  248,    0,    0,
			  215,    0,    0,    0,    0,    0,  226,    0,    0,    0,

			    0,    0,    0,    0,    0,  256,    0,    0,    0,    0,
			  266,  248,  248,  248,    0,    0,    0,    0,  158,  158,
			 1523,  158,  158,  158,    0,    0, -157, -157,    0,    0,
			    0,    0, -157,  545,  560,    0, -157,  545,  560, 1538,
			 -157,  545,  560, -157,    0,  545,  560,    0, -157,    0,
			    0, -643,    0, -643,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, 1577,    0,    0,  157,
			  163, -157,    0,    0,  172,  177,  181,    0,    0, 1528,
			    0,    0,    0, 1529, 1530,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  368,    0,    0,  870, yyDummy>>,
			1, 200, 2200)
		end

	yytable_template_13 (an_array: ARRAY [INTEGER])
			-- Fill chunk #13 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  873,  519,  877,  880,  882,  883,  721,    0,    0,    0,
			  519,    0,    0,    0, 1609,  518,  517,  516, 1585,  515,
			    0,    0,    0,    0, 1592,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  514,  513,  512,
			  511,  510,  509,  508,  507,  506,  514,  513,  512,  511,
			  510,  509,  508,  507,  506,    0,  762,  762,    0,    0,
			    0,    0,    0, 1623,    0,  503,  502,  501,  500,  499,
			  498, 1636,    0, 1638,  503,  502,  501,  500,  499,  498,
			    0,  158,    0,    0,  158,    0,    0,    0,  158,    0,
			    0,  158,    0,    0,    0,  157,  163,    0,    0,  172,

			  177,  181,    0, 1652,    0,    0,    0,    0,   -9,    0,
			 1660, 1661,   -9, 1665,    0,   -9,    0, 1670,   -9,    0,
			    0,   -9, 1674, 1637,    0,    0,    0,    0,    0,   -9,
			    0,    0,   -9,   -9,    0,    0,  215,   -9, 1682,  226,
			 1684,    0,    0,    0,    0, 1688,  256,   -9,   -9,  266,
			   -9, 1695,    0,   -9, 1697,    0,    0,    0,    0,    0,
			    0,    0,  994, 1704,    0,  998,    0, 1669, 1708, 1002,
			    0,    0, 1006,    0, 1714,    0, 1716,    0,    0,    0,
			    0,    0,    0,    0,  368,    0,    0,    0, 1724,    0,
			 1683,    0,    0,    0,    0, 1731,    0,    0,    0,    0, yyDummy>>,
			1, 200, 2400)
		end

	yytable_template_14 (an_array: ARRAY [INTEGER])
			-- Fill chunk #14 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1735,    0,    0,    0,    0,    0,    0, 1699,    0, 1701,
			  -12,    0,    0, 1703,  -12, 1744,    0,  -12,    0,    0,
			  -12,    0,    0,  -12,    0,    0, 1715,    0,    0,  167,
			 1719,  -12, 1721,    0,  -12,  -12,    0,    0,    0,  -12,
			    0, 1726,    0, 1728, 1729, 1730,    0,    0,    0,  -12,
			  -12,    0,  -12,    0,    0,  -12, 1738, 1739,    0, 1741,
			    0,    0,    0,    0,    0,    0,    0,    0, 1746,    0,
			 1748, 1749,  215,    0,    0,  226, 1751, 1752,    0, 1754,
			    0,    0,    0,  256, 1756,    0,  266,    0,    0, 1758,
			    0, 1759,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,    0, 1177,    0, 1176,  721, 1175,    0,    0,    0,
			    0,  721,    0,    0, 1174, 1173,    0, 1172,    0,    0,
			 1171,    0,    0,    0,    0,    0,    0,  167,    0,  313,
			    0,  167,    0,    0,    0,  312,    0,  167,    0,    0,
			  167,    0,    0,  167,    0,    0,    0,    0,    0,    0,
			    0, 1170,    0,  309, 1169,    0,    0,  307,    0,    0,
			    0,    0,   73,   72,    0,   71,  306,  972,   34,   33,
			   32,    0,    0,    0,    0,    0,    0,   69,   68,   67,
			   66,   65,   64,   63,   62,   61,   60,   59,   58,   57,
			   56,   55,   54,   53,   52,   51,   50,   49,   48,   47, yyDummy>>,
			1, 200, 2600)
		end

	yytable_template_15 (an_array: ARRAY [INTEGER])
			-- Fill chunk #15 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0, 1168, 1167,    0,    0,    0,    0,    0,    0,    0,
			    0,  167,  300,   45,   44,  167, 1166,    0,  297,    0,
			  167,    0,    0,  296,  167, 1165,  519,    0,    0, 1164,
			    0,  518,  517,  516,    0,  515,    0, 1163,    0,    0,
			    0,    0,  157,  163,    0,  172,  177,  181,   74,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, 1294,    0,
			    0,    0,  514,  513,  512,  511,  510,  509,  508,  507,
			  506,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  503,  502,  501,  500,  499,  498,    0,    0,    0,  158,

			  158,    0,  158,  158,  158,    0,   73,   72,    0,   71,
			    0,    0,   34,   33,   32,   70,    0,    0,    0,    0,
			    0,   69,   68,   67,   66,   65,   64,   63,   62,   61,
			   60,   59,   58,   57,   56,   55,   54,   53,   52,   51,
			   50,   49,   48,   47,   46,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   45,   44,    0,
			   43,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,   42,   41,    0,    0,    0,
			 1389, 1394,    0, 1399, 1402, 1404, 1405,    0,    0,    0,
			    0, 1409,    0,    0,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 2800)
		end

	yytable_template_16 (an_array: ARRAY [INTEGER])
			-- Fill chunk #16 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  158,    0,    0,    0,  158,  215,    0,    0,  226,    0,
			  158,    0,  256,  158,    0,  266,    0,    0,    0,    0,
			    0,    0,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,
			   51,   50,   49,   48,   47,    0,    0, -682, -682, -682,
			 -682, -682,    0, -682, -682, -682, -682, -682, -682,   44,
			 -682, -682, -682,    0, -682, -682,    0, -682, -682, -682,
			    0, -682, -682, -682,    0, -682, -682,    0,    0,    0,
			 -682, 1472, -682, -682, -682, 1476,    0, -682, -682, -682,
			    0, 1481,    0, -682, 1485, -682,    0,    0, -682, -682,

			 -682, -682,    0,    0, -682, -682,    0,    0,    0, -682,
			 -682,    0, -682, -682, -682, -682, -682, -682, -682, -682,
			 -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
			 -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
			 -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
			 -682, -682, -682, -682, -682, -682, -682, -682, -682, -682,
			 -682, -682, -682, -682,    0, -682, -682,    0, -682, -682,
			 -682,    0, -682, -682, -682, -682, -682, -682, -682, -682,
			 -682, -682, -682, -682, -682, -682, -683, -683, -683, -683,
			 -683,    0, -683, -683, -683, -683, -683, -683,    0, -683, yyDummy>>,
			1, 200, 3000)
		end

	yytable_template_17 (an_array: ARRAY [INTEGER])
			-- Fill chunk #17 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -683, -683,    0, -683, -683,    0, -683, -683, -683,    0,
			 -683, -683, -683,    0, -683, -683,    0,    0,    0, -683,
			    0, -683, -683, -683,    0,    0, -683, -683, -683,    0,
			    0,    0, -683,    0, -683,    0,    0, -683, -683, -683,
			 -683,    0,    0, -683, -683,    0,    0,    0, -683, -683,
			    0, -683, -683, -683, -683, -683, -683, -683, -683, -683,
			 -683, -683, -683, -683, -683, -683, -683, -683, -683, -683,
			 -683, -683, -683, -683, -683, -683, -683, -683, -683, -683,
			 -683, -683, -683, -683, -683, -683, -683, -683, -683, -683,
			 -683, -683, -683, -683, -683, -683, -683, -683, -683, -683,

			 -683, -683, -683,    0, -683, -683,    0, -683, -683, -683,
			    0, -683, -683, -683, -683, -683, -683, -683, -683, -683,
			 -683, -683, -683, -683, -683,    0,    0,    0,    0,    0,
			    0,   69,   68,   67,   66,   65,   64,   63,   62,   61,
			   60,   59,   58,   57,   56,   55,   54,   53,   52,   51,
			   50,   49,   48,   47, -679,    0, -679,    0, -679,    0,
			 -679, -679, -679, -679,    0,    0, -679, -679,   44, -679,
			  489,    0, -679, -679,    0,    0,    0, -679,    0,    0,
			    0, -679,    0,    0,    0, -679,    0, -679, -679,    0,
			    0,    0, -679, -679,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 3200)
		end

	yytable_template_18 (an_array: ARRAY [INTEGER])
			-- Fill chunk #18 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0, -679,    0, -679, -679,    0,    0, -679,
			    0,    0,    0,    0, -679, -679,    0, -679, -679,    0,
			 -679, -679, -679,  157,  163,    0,  172,  177,  181, -679,
			 -679, -679, -679, -679, -679, -679, -679, -679, -679, -679,
			 -679, -679, -679, -679, -679, -679, -679, -679, -679, -679,
			 -679, -679,    0, -679, -679,    0,    0,    0,    0,    0,
			    0,    0,    0,    0, -679, -679, -679,    0, -679,    0,
			 -679,    0,    0,    0,    0, -679,    0, -679,    0,    0,
			    0, -679, -679,    0,    0,    0,    0,    0,    0, -679,
			 -681, -681, -681, -681, -681,    0, -681, -681, -681, -681,

			 -681, -681,    0, -681, -681, -681,    0, -681, -681,    0,
			 -681, -681, -681,    0, -681, -681, -681,    0, -681, -681,
			    0,    0,    0, -681,  215, -681, -681, -681,  226,    0,
			 -681, -681, -681,    0,  256,    0, -681,  266, -681,    0,
			    0, -681, -681, -681, -681,    0,    0, -681, -681,    0,
			    0,    0, -681, -681,    0, -681, -681, -681, -681, -681,
			 -681, -681, -681, -681, -681, -681, -681, -681, -681, -681,
			 -681, -681, -681, -681, -681, -681, -681, -681, -681, -681,
			 -681, -681, -681, -681, -681, -681, -681, -681, -681, -681,
			 -681, -681, -681, -681, -681, -681, -681, -681, -681, -681, yyDummy>>,
			1, 200, 3400)
		end

	yytable_template_19 (an_array: ARRAY [INTEGER])
			-- Fill chunk #19 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -681, -681, -681, -681, -681, -681, -681,    0, -681, -681,
			    0, -681, -681, -681,    0, -681, -681, -681, -681, -681,
			 -681, -681, -681, -681, -681, -681, -681, -681, -681, -332,
			 -332, -332, -332, -332,    0, -332, -332, -332, -332, -332,
			 -332,    0, -332, -332, -332,    0, -332, -332,    0, -332,
			 -332, -332,    0, -332, -332, -332,    0, -332, -332,    0,
			    0,    0, -332,    0, -332, -332, -332,    0,    0, -332,
			 -332, -332,    0,    0,    0, -332,    0, -332,    0,    0,
			 -332, -332, -332, -332,    0,    0, -332, -332,    0,    0,
			    0, -332, -332,    0, -332, -332, -332, -332, -332, -332,

			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332,    0, -332, -332,    0,
			 -332, -332, -332,    0, -332, -332, -332, -332, -332, -332,
			 -332, -332, -332, -332, -332, -332, -332, -332, -676,    0,
			 -676,    0, -676,    0, -676, -676, -676, -676,    0,    0,
			 -676, -676,    0, -676,    0,    0, -676, -676,    0,    0,
			    0, -676,    0,    0,    0, -676,    0,    0,    0, -676, yyDummy>>,
			1, 200, 3600)
		end

	yytable_template_20 (an_array: ARRAY [INTEGER])
			-- Fill chunk #20 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0, -676, -676,    0,    0,    0, -676, -676,    0,    0,
			    0,    0,    0,    0,    0,    0,    0, -676,    0, -676,
			 -676,    0,    0, -676,    0, -685,    0,    0, -676, -676,
			    0, -676, -676,    0, -676, -676, -676,    0,    0,    0,
			    0,    0,    0, -676, -676, -676, -676, -676, -676, -676,
			 -676, -676, -676, -676, -676, -676, -676, -676, -676, -676,
			 -676, -676, -676, -676, -676, -676,    0, -676, -676,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, -676, -676,
			 -676,    0, -676,    0, -676,    0,    0,    0,    0, -676,
			    0, -676,    0,    0,    0, -676, -676,    0,    0,    0,

			    0,    0,    0, -676, -682, -675,    0, -675,    0, -675,
			    0, -675, -675, -675, -675,    0,    0, -675, -675,    0,
			 -675,    0,    0, -675, -675,    0,    0,    0, -675,    0,
			    0,    0, -675,    0,    0,    0, -675,    0, -675, -675,
			    0,    0,    0, -675, -675,    0,    0,    0,    0,    0,
			    0,    0,    0,    0, -675,    0, -675, -675,    0,    0,
			 -675,    0, -684,    0,    0, -675, -675,    0, -675, -675,
			    0, -675, -675, -675,    0,    0,    0,    0,    0,    0,
			 -675, -675, -675, -675, -675, -675, -675, -675, -675, -675,
			 -675, -675, -675, -675, -675, -675, -675, -675, -675, -675, yyDummy>>,
			1, 200, 3800)
		end

	yytable_template_21 (an_array: ARRAY [INTEGER])
			-- Fill chunk #21 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -675, -675, -675,    0, -675, -675,    0,    0,    0,    0,
			    0,    0,    0,    0,    0, -675, -675, -675,    0, -675,
			    0, -675,    0,    0,    0,    0, -675,    0, -675,    0,
			    0,    0, -675, -675,    0,    0,    0,    0,    0,    0,
			 -675, -683, -700,    0, -700,    0, -700,    0, -700, -700,
			 -700, -700,    0,    0, -700, -700,    0, -700,    0,    0,
			 -700, -700,    0,    0,    0, -700,    0,    0,    0, -700,
			    0,    0,    0, -700,    0, -700, -700,    0,    0,    0,
			 -700, -700,    0,    0,    0,    0,    0,    0,    0,    0,
			    0, -700,    0, -700, -700,    0,    0, -700,    0,    0,

			    0,    0, -700, -700,    0, -700, -700,    0, -700, -700,
			 -700,    0,    0,    0,    0,    0,    0, -700, -700, -700,
			 -700, -700, -700, -700, -700, -700, -700, -700, -700, -700,
			 -700, -700, -700, -700, -700, -700, -700, -700, -700, -700,
			    0, -700, -700,    0,    0,    0,    0,    0,    0,    0,
			    0,    0, -700, -700, -700,    0, -700,    0,  470,    0,
			    0,    0,    0, -700, -700, -700,    0,    0,    0, -700,
			 -700,    0,    0,    0,    0,    0,    0, -700, -700, -674,
			    0, -674,    0, -674,    0, -674, -674, -674, -674,    0,
			    0, -674, -674,    0, -674,    0,    0, -674, -674,    0, yyDummy>>,
			1, 200, 4000)
		end

	yytable_template_22 (an_array: ARRAY [INTEGER])
			-- Fill chunk #22 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0, -674,    0,    0,    0, -674,    0,    0,    0,
			 -674,    0, -674, -674,    0,    0,    0, -674, -674,    0,
			    0,    0,    0,    0,    0,    0,    0,    0, -674,    0,
			 -674, -674,    0,    0, -674,    0,    0,    0,    0, -674,
			 -674,    0, -674, -674,    0, -674, -674, -674,    0,    0,
			    0,    0,    0,    0, -674, -674, -674, -674, -674, -674,
			 -674, -674, -674, -674, -674, -674, -674, -674, -674, -674,
			 -674, -674, -674, -674, -674, -674, -674,    0, -674, -674,
			    0,    0,    0,    0,    0,    0,    0,    0,    0, -674,
			 -674, -674,    0, -674,    0, -674,    0,    0,    0,    0,

			 -674,    0, -674,    0,    0,    0, -674, -674,    0,    0,
			    0,    0,    0,    0, -674, -681, -680,    0, -680,    0,
			 -680,    0, -680, -680, -680, -680,    0,    0, -680, -680,
			    0, -680,    0,    0, -680, -680,    0,    0,    0, -680,
			    0,    0,    0, -680,    0,    0,    0, -680,    0, -680,
			 -680,    0,    0,    0, -680, -680,    0,    0,    0,    0,
			    0,    0,    0,    0,    0, -680,    0, -680, -680,    0,
			    0, -680,    0,    0,    0,    0, -680, -680,    0, -680,
			 -680,    0, -680, -680, -680,    0,    0,    0,    0,    0,
			    0, -680, -680, -680, -680, -680, -680, -680, -680, -680, yyDummy>>,
			1, 200, 4200)
		end

	yytable_template_23 (an_array: ARRAY [INTEGER])
			-- Fill chunk #23 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 -680, -680, -680, -680, -680, -680, -680, -680, -680, -680,
			 -680, -680, -680, -680,    0, -680, -680,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -680, -680, -680,    0,
			 -680,    0, -680,    0,    0,    0,    0, -680,    0, -680,
			    0,    0,    0, -680, -680,    0, -678,    0, -678,    0,
			 -678, -680, -678, -678, -678, -678,    0,    0, -678, -678,
			    0, -678,    0,    0, -678, -678,    0,    0,    0, -678,
			    0,    0,    0, -678,    0,    0,    0, -678,    0, -678,
			 -678,    0,    0,    0, -678, -678,    0,    0,    0,    0,
			    0,    0,    0,    0,    0, -678,    0, -678, -678,    0,

			    0, -678,    0,    0,    0,    0, -678, -678,    0, -678,
			 -678,    0, -678, -678, -678,    0,    0,    0,    0,    0,
			    0, -678, -678, -678, -678, -678, -678, -678, -678, -678,
			 -678, -678, -678, -678, -678, -678, -678, -678, -678, -678,
			 -678, -678, -678, -678,    0, -678, -678,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -678, -678, -678,    0,
			 -678,    0, -678,    0,    0,    0,    0, -678,    0, -678,
			    0,    0,    0, -678, -678,    0, -677,    0, -677,    0,
			 -677, -678, -677, -677, -677, -677,    0,    0, -677, -677,
			    0, -677,    0,    0, -677, -677,    0,    0,    0, -677, yyDummy>>,
			1, 200, 4400)
		end

	yytable_template_24 (an_array: ARRAY [INTEGER])
			-- Fill chunk #24 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0, -677,    0,    0,    0, -677,    0, -677,
			 -677,    0,    0,    0, -677, -677,    0,    0,    0,    0,
			    0,    0,    0,    0,    0, -677,    0, -677, -677,    0,
			    0, -677,    0,    0,    0,    0, -677, -677,    0, -677,
			 -677,    0, -677, -677, -677,    0,    0,    0,    0,    0,
			    0, -677, -677, -677, -677, -677, -677, -677, -677, -677,
			 -677, -677, -677, -677, -677, -677, -677, -677, -677, -677,
			 -677, -677, -677, -677,    0, -677, -677,    0,    0,    0,
			    0,    0,  979,   74,    0,    0, -677, -677, -677, 1515,
			 -677,    0, -677,  315,    0,    0,  314, -677,    0, -677,

			    0,    0,    0, -677, -677,    0,    0,    0,  313,    0,
			    0, -677,    0,    0,  312,    0, 1420,    0,    0,    0,
			    0,    0,    0,    0,    0,  311,    0,    0,    0,    0,
			  310,    0,  309,  308,    0,    0,  307,    0,    0,    0,
			    0,   73,   72,    0,   71,  306,  305,   34,   33,   32,
			  304,    0,    0,    0,  303,    0,   69,   68,   67,   66,
			   65,   64,   63,   62,   61,   60,   59,   58,   57,   56,
			   55,   54,   53,   52,   51,   50,   49,   48,   47,  302,
			  301,    0,    0,    0,    0,    0,    0,    0,    0,  838,
			   74,  300,   45,   44,  299,  298, 1421,  297,    0,    0, yyDummy>>,
			1, 200, 4600)
		end

	yytable_template_25 (an_array: ARRAY [INTEGER])
			-- Fill chunk #25 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  315,    0,  296,  314,    0,  295,  294,    0,    0,    0,
			  293,  292,    0,    0,    0,  313,    0,  132,    0,    0,
			    0,  312,    0, 1420,    0,    0,    0,    0,    0,    0,
			    0,    0,  311,    0,    0,    0,    0,  310,    0,  309,
			  308,    0,    0,  307,    0,    0,    0,    0,   73,   72,
			    0,   71,  306,  305,   34,   33,   32,  304,    0,    0,
			    0,  303,    0,   69,   68,   67,   66,   65,   64,   63,
			   62,   61,   60,   59,   58,   57,   56,   55,   54,   53,
			   52,   51,   50,   49,   48,   47,  302,  301,    0,    0,
			    0,    0,    0,    0,    0,   74,    0,    0,  300,   45,

			   44,  299,  298,    0,  297,  315,    0,    0,  314,  296,
			    0,    0,  295,  294,    0,    0,    0,  293,  292,    0,
			  313,    0,    0,    0,  132,    0,  312,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,  311,    0,    0,
			    0,    0,  310,    0,  309,  308,    0,    0,  307,    0,
			    0,    0,    0,   73,   72,    0,   71,  306,  305,   34,
			   33,   32,  304,    0,    0,    0,  303,    0,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,  302,  301,    0,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 4800)
		end

	yytable_template_26 (an_array: ARRAY [INTEGER])
			-- Fill chunk #26 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,  979,   74,  300,   45,   44,  299,  856,    0,  297,
			  990,    0,  315,    0,  296,  314,    0,  295,  294,    0,
			    0,    0,  293,  292,    0,    0,    0,  313,    0,  132,
			  855,    0,    0,  312,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  311,    0,    0,    0,    0,  310,
			    0,  309,  308,    0,    0,  307,    0,    0,    0,    0,
			   73,   72,    0,   71,  306,  305,   34,   33,   32,  304,
			    0,    0,    0,  303,    0,   69,   68,   67,   66,   65,
			   64,   63,   62,   61,   60,   59,   58,   57,   56,   55,
			   54,   53,   52,   51,   50,   49,   48,   47,  302,  301,

			    0,    0,    0,    0,    0,    0,  838,   74,    0,    0,
			  300,   45,   44,  299,  298,    0,  297,  315,    0,    0,
			  314,  296,    0,    0,  295,  294,    0,    0,    0,  293,
			  292,    0,  313,    0,    0,    0,  132,    0,  312,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  311,
			    0,    0,    0,    0,  310,    0,  309,  308,    0,    0,
			  307,    0,    0,    0,    0,   73,   72,    0,   71,  306,
			  305,   34,   33,   32,  304,    0,    0,    0,  303,    0,
			   69,   68,   67,   66,   65,   64,   63,   62,   61,   60,
			   59,   58,   57,   56,   55,   54,   53,   52,   51,   50, yyDummy>>,
			1, 200, 5000)
		end

	yytable_template_27 (an_array: ARRAY [INTEGER])
			-- Fill chunk #27 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   49,   48,   47,  302,  301,    0,    0,    0,    0,    0,
			    0,    0,   74,    0,    0,  300,   45,   44,  299,  298,
			    0,  297,  315,    0,    0,  314,  296,    0,    0,  295,
			  294,    0,    0,    0,  293,  292,    0,  313,    0,    0,
			    0,  132,    0,  312,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,  311,    0,    0,    0,    0,  310,
			    0,  309,  308,    0,    0,  307,    0,    0,    0,    0,
			   73,   72,    0,   71,  306,  305,   34,   33,   32,  304,
			    0,    0,    0,  303,    0,   69,   68,   67,   66,   65,
			   64,   63,   62,   61,   60,   59,   58,   57,   56,   55,

			   54,   53,   52,   51,   50,   49,   48,   47,  302,  301,
			    0,    0,    0,    0,    0,    0,    0,   74,    0,    0,
			  300,   45,   44,  299,  856,    0,  297,  315,    0,    0,
			  314,  296,    0,    0,  295,  294,    0,    0,    0,  293,
			  292,    0,  313,    0,    0,    0,  132,  855,  312,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  311,
			    0,    0,    0,    0,  310,    0,  309,  308,    0,    0,
			  307,    0,    0,    0,    0,   73,   72,    0,   71,  306,
			  305,   34,   33,   32,  304,    0,    0,    0,  303,    0,
			   69,   68,   67,   66,   65,   64,   63,   62,   61,   60, yyDummy>>,
			1, 200, 5200)
		end

	yytable_template_28 (an_array: ARRAY [INTEGER])
			-- Fill chunk #28 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   59,   58,   57,   56,   55,   54,   53,   52,   51,   50,
			   49,   48,   47,  302,  301,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,   74,  300,   45,   44,  299,  298,
			    0,  297,    0,    0,  315,  985,  296,  314,    0,  295,
			  294,    0,    0,    0,  293,  292,    0,    0,    0,  313,
			    0,  132,    0,    0,    0,  312,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  311,    0,    0,    0,
			    0,  310,    0,  309,  308,    0,    0,  307,    0,    0,
			    0,    0,   73,   72,    0,   71,  306,  305,   34,   33,
			   32,  304,    0,    0,    0,  303,    0,   69,   68,   67,

			   66,   65,   64,   63,   62,   61,   60,   59,   58,   57,
			   56,   55,   54,   53,   52,   51,   50,   49,   48,   47,
			  302,  301,    0,    0,    0,    0,    0,    0,    0,   74,
			    0,    0,  300,   45,   44,  299,  966,    0,  297,  315,
			    0,    0,  314,  296,  799,    0,  295,  294,    0,    0,
			    0,  293,  292,    0,  313,    0,    0,    0,  132,    0,
			  312,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  311,    0,    0,    0,    0,  310,    0,  309,  308,
			    0,    0,  307,    0,    0,    0,    0,   73,   72,    0,
			   71,  306,  305,   34,   33,   32,  304,    0,    0,    0, yyDummy>>,
			1, 200, 5400)
		end

	yytable_template_29 (an_array: ARRAY [INTEGER])
			-- Fill chunk #29 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  303,    0,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,
			   51,   50,   49,   48,   47,  302,  301,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,   74,  300,   45,   44,
			  299,  298,    0,  297,  949,    0,  315,    0,  296,  314,
			    0,  295,  294,    0,    0,    0,  293,  292,    0,    0,
			    0,  313,    0,  132,    0,    0,    0,  312,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  311,    0,
			    0,    0,    0,  310,    0,  309,  308,    0,    0,  307,
			  802,    0,    0,    0,   73,   72,    0,   71,  306,  305,

			   34,   33,   32,  304,    0,    0,    0,  303,    0,   69,
			   68,   67,   66,   65,   64,   63,   62,   61,   60,   59,
			   58,   57,   56,   55,   54,   53,   52,   51,   50,   49,
			   48,   47,  302,  301,    0,    0,    0,    0,    0,    0,
			    0,   74,    0,    0,  300,   45,   44,  299,  298,    0,
			  297,  315,    0,    0,  314,  296,    0,    0,  295,  294,
			    0,    0,    0,  293,  292,    0,  313,    0,    0,    0,
			  132,    0,  312,    0,  680,    0,    0,    0,    0,    0,
			    0,    0,    0,  311,    0,    0,    0,    0,  310,    0,
			  309,  308,    0,    0,  307,    0,    0,    0,    0,   73, yyDummy>>,
			1, 200, 5600)
		end

	yytable_template_30 (an_array: ARRAY [INTEGER])
			-- Fill chunk #30 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   72,    0,   71,  306,  305,   34,   33,   32,  304,    0,
			    0,    0,  303,    0,   69,   68,   67,   66,   65,   64,
			   63,   62,   61,   60,   59,   58,   57,   56,   55,   54,
			   53,   52,   51,   50,   49,   48,   47,  302,  301,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  300,
			   45,   44,  299,  298,    0,  297,    0,   74,    0,    0,
			  296,  678,    0,  295,  294,    0,    0,  315,  293,  292,
			  314,    0,    0,    0,    0,  132,    0,    0,    0,    0,
			    0,    0,  313,    0,    0,    0,    0,    0,  312,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  311,

			    0,    0,    0,    0,  310,    0,  309,  308,    0,    0,
			  307,    0,    0,    0,    0,   73,   72,    0,   71,  306,
			  305,   34,   33,   32,  304,    0,    0,    0,  303,    0,
			   69,   68,   67,   66,   65,   64,   63,   62,   61,   60,
			   59,   58,   57,   56,   55,   54,   53,   52,   51,   50,
			   49,   48,   47,  302,  301,    0,    0,    0,    0,    0,
			    0,    0,   74,    0,    0,  300,   45,   44,  299,  298,
			    0,  297,  315,    0,    0,  314,  296,    0,    0,  295,
			  294,    0,    0,    0,  293,  292,    0,  313,    0,    0,
			    0,  132,    0,  312,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 5800)
		end

	yytable_template_31 (an_array: ARRAY [INTEGER])
			-- Fill chunk #31 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,  311,    0,    0,    0,    0,  310,
			    0,  309,  308,    0,    0,  307,    0,    0,    0,    0,
			   73,   72,    0,   71,  306,  305,   34,   33,   32,  304,
			    0,    0,    0,  303,    0,   69,   68,   67,   66,   65,
			   64,   63,   62,   61,   60,   59,   58,   57,   56,   55,
			   54,   53,   52,   51,   50,   49,   48,   47,  302,  301,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,   74,
			  300,   45,   44,  299,  298,    0,  297,    0,    0,  315,
			  524,  296,  314,    0,  295,  294,    0,    0,    0,  293,
			  292,    0,    0,    0,  313,    0,  132,    0,    0,    0,

			  312,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  311,    0,    0,    0,    0,  310,    0,  309,  308,
			    0,    0,  307,    0,    0,    0,    0,   73,   72,    0,
			   71,  306,  305,   34,   33,   32,  304,    0,    0,    0,
			  303,    0,   69,   68,   67,   66,   65,   64,   63,   62,
			   61,   60,   59,   58,   57,   56,   55,   54,   53,   52,
			   51,   50,   49,   48,   47,  302,  301,    0,    0,    0,
			    0,    0,    0,    0,   74,    0,    0,  300,   45,   44,
			  299,  298,    0,  297,  315,    0,    0,  314,  296,    0,
			    0,  295,  294,    0,    0,    0,  293,  292,    0,  313, yyDummy>>,
			1, 200, 6000)
		end

	yytable_template_32 (an_array: ARRAY [INTEGER])
			-- Fill chunk #32 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,  132,    0,  312,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,  311,    0,    0,    0,
			    0,  310,    0,  309,  308,    0,    0,  307,    0,    0,
			    0,    0,   73,   72,    0,   71,  306,  305,   34,   33,
			   32,  304,    0, 1330,    0,  303,    0,   69,   68,   67,
			   66,   65,   64,   63,   62,   61,   60,   59,   58,   57,
			   56,   55,   54,   53,   52,   51,   50,   49,   48,   47,
			  302,  301,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,  300,   45,   44,  299,  486,    0,  297, 1213,
			    0,  307,    0,  296,    0,    0,  295,  294,    0,   71,

			  519,  293,  292,    0,    0,  518,  517,  516,  132,  515,
			    0,   69,   68,   67,   66,   65,   64,   63,   62,   61,
			   60,   59,   58,   57,   56,   55,   54,   53,   52,   51,
			   50,   49,   48,   47,    0,    0,  514,  513,  512,  511,
			  510,  509,  508,  507,  506,    0,  519,   45,   44,    0,
			    0,  518,  517,  516,    0,  515,    0,    0, 1491,    0,
			    0,    0,    0,    0,  503,  502,  501,  500,  499,  498,
			    0,    0,    3,    0,    0,    0,    0,    0,    0,    0,
			    2,    0,  514,  513,  512,  511,  510,  509,  508,  507,
			  506,    0,    0, 1449,    0,    0,    0,    0,    0,    0, yyDummy>>,
			1, 200, 6200)
		end

	yytable_template_33 (an_array: ARRAY [INTEGER])
			-- Fill chunk #33 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  503,  502,  501,  500,  499,  498,   73,   72,    0,   71,
			    0,    0,    0,    0,    0,   70,    0,    0,    0,    0,
			    0,   69,   68,   67,   66,   65,   64,   63,   62,   61,
			   60,   59,   58,   57,   56,   55,   54,   53,   52,   51,
			   50,   49,   48,   47,   46,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,   45,   44,    0,
			   43,    0, -335,    0,    0, -335,    0, -335, -335,    0,
			    0, -335,    0, -335,    0,   42,   41, -335,    0, -335,
			    0, -335, -335, -335,    0, -335, 1574, -335,    0, -335,

			    0,    0,    0, -335,    0, -332,    0, -335, -332,    0,
			 -332, -332,    0,    0, -332,    0, -332,    0,    0,    0,
			 -332,    0, -332,    0, -332, -332, -332,    0, -332,    0,
			 -332,    0, -332, -335, -335, -335, -332,    0,  519,    0,
			 -332,    0,    0,  518,  517,  516,    0,  515,    0,    0,
			    0,    0,    0,    0, 1414,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0, -332, -332, -332,    0,
			    0,    0,    0,    0,  514,  513,  512,  511,  510,  509,
			  508,  507,  506, -335,  519, -335, -335,    0,    0,  518,
			  517,  516,    0,  515,    0,    0,    0,    0,    0, 1331, yyDummy>>,
			1, 200, 6400)
		end

	yytable_template_34 (an_array: ARRAY [INTEGER])
			-- Fill chunk #34 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,  503,  502,  501,  500,  499,  498,    0,    0,
			    0,    0,    0,    0,    0,    0, -332,    0, -332, -332,
			  514,  513,  512,  511,  510,  509,  508,  507,  506,  519,
			    0,    0,    0,    0,  518,  517,  516,    0,  515,    0,
			    0,    0,    0,    0,  654,    0,    0,    0,  503,  502,
			  501,  500,  499,  498,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  514,  513,  512,  511,  510,
			  509,  508,  507,  506,  519,    0,    0,    0,    0,  518,
			  517,  516,    0,  515,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  503,  502,  501,  500,  499,  498, 1099,

			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  514,  513,  512,  511,  510,  509,  508,  507,  506,    0,
			    0,    0,    0,    0,    0,  519,    0,    0,    0,    0,
			  518,  517,  516,    0,  515,    0,    0,    0,  503,  502,
			  501,  500,  499,  498,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  514,  513,  512,  511,  510,  509,  508,  507,  506,
			    0,    0, 1442,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,  503,
			  502,  501,  500,  499,  498,   73,   72,    0,   71,    0, yyDummy>>,
			1, 200, 6600)
		end

	yytable_template_35 (an_array: ARRAY [INTEGER])
			-- Fill chunk #35 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,    0,    0,    0,   70,    0,    0,    0,    0,    0,
			   69,   68,   67,   66,   65,   64,   63,   62,   61,   60,
			   59,   58,   57,   56,   55,   54,   53,   52,   51,   50,
			   49,   48,   47,   46,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,   45,   44,  307,   43,
			    0,    0,    0,    0,    0,    0,   71,    0,    0,    0,
			    0,    0,   70,    0,   42,   41,    0,    0,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,   46,  801,    0,    0,    0,    0,    0,    0,    0,

			    0,  519,    0,    0,   45,   44,  518,  517,  516,    0,
			  515,    0,    0,    0,    0,  799,    0,    0,    0,    0,
			    0,    0,   42,   41,    0,    0,    0,    0,    0,    0,
			 1223,    0,    0,    0,    0,    0,    0,  514,  513,  512,
			  511,  510,  509,  508,  507,  506,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  505,    0,    0,    0,    0,
			    0,    0,    0,  307,    0,  503,  502,  501,  500,  499,
			  498,   71,    0,    0,    0,    0,    0,   70,    0,    0,
			    0,    0,    0,   69,   68,   67,   66,   65,   64,   63,
			   62,   61,   60,   59,   58,   57,   56,   55,   54,   53, yyDummy>>,
			1, 200, 6800)
		end

	yytable_template_36 (an_array: ARRAY [INTEGER])
			-- Fill chunk #36 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			   52,   51,   50,   49,   48,   47,   46,  519,    0,    0,
			    0,    0,  518,  517,  516,    0,  515,  519,    0,   45,
			   44,    0,  518,  517,  516,    0,  515,    0,    0,    0,
			  799,    0,    0,    0,    0,    0,    0,   42,   41,    0,
			    0,    0,    0,  514,  513,  512,  511,  510,  509,  508,
			  507,  506,    0,  514,  513,  512,  511,  510,  509,  508,
			  507,  506,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,  503,  502,  501,  500,  499,  498, 1097,    0,    0,
			    0,  503,  502,  501,  500,  499,  498,  977,  519,    0,
			    0,    0,    0,  518,  517,  516,    0,  515,    0, 1259,

			 1258, 1257, 1256, 1255, 1254, 1253, 1252, 1251, 1250, 1249,
			 1248, 1247, 1246, 1245, 1244, 1243, 1242, 1241, 1240, 1239,
			 1238, 1237,    0,    0,  514,  513,  512,  511,  510,  509,
			  508,  507,  506,    0,    0,    0,    0,    0,    0,  519,
			    0,    0,  505,  984,  518,  517,  516,    0,  515,    0,
			    0,    0,  503,  502,  501,  500,  499,  498,  519,    0,
			    0,    0,    0,  518,  517,  516,    0,  515,    0,    0,
			    0,    0,    0,    0,    0,  514,  513,  512,  511,  510,
			  509,  508,  507,  506,    0,    0,    0,    0,    0,    0,
			    0,  948,    0,  505,  514,  513,  512,  511,  510,  509, yyDummy>>,
			1, 200, 7000)
		end

	yytable_template_37 (an_array: ARRAY [INTEGER])
			-- Fill chunk #37 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			  508,  507,  506,  503,  502,  501,  500,  499,  498,  519,
			    0,    0,  505,  504,  518,  517,  516,    0,  515,    0,
			    0,    0,  503,  502,  501,  500,  499,  498,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  514,  513,  512,  511,  510,
			  509,  508,  507,  506,  519,    0,    0,    0,    0,  518,
			  517,  516,    0,  515,    0,    0,    0,    0,    0,    0,
			 1545,    0,    0,  503,  502,  501,  500,  499,  498,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  514,  513,  512,  511,  510,  509,  508,  507,  506,  519,

			    0,    0,    0,    0,  518,  517,  516,    0,  515,    0,
			    0,    0,    0,    0,    0,  945,    0,    0,  503,  502,
			  501,  500,  499,  498,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,  514,  513,  512,  511,  510,
			  509,  508,  507,  506,  519,    0,    0,    0,    0,  518,
			  517,  516,    0,  515,    0,    0,    0,    0,    0,    0,
			  944,    0,    0,  503,  502,  501,  500,  499,  498,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			  514,  513,  512,  511,  510,  509,  508,  507,  506,    0,
			    0,    0,  519,    0,    0,    0,  689,  518,  517,  516, yyDummy>>,
			1, 200, 7200)
		end

	yytable_template_38 (an_array: ARRAY [INTEGER])
			-- Fill chunk #38 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			    0,  515,    0,    0,    0,    0,    0,    0,  503,  502,
			  501,  500,  499,  498,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,  514,  513,
			  512,  511,  510,  509,  508,  507,  506,  519,    0,    0,
			    0,    0,  518,  517,  516,    0,  519,    0,    0,    0,
			    0,  518,    0,    0,    0,    0,  503,  502,  501,  500,
			  499,  498,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,  514,  513,  512,  511,  510,  509,  508,
			  507,  506,  514,  513,  512,  511,  510,  509,  508,  507,
			  506,    0,    0,    0,    0,    0,    0,    0,    0,    0,

			    0,  503,  502,  501,  500,  499,  498,    0,    0,    0,
			  503,  502,  501,  500,  499,  498,   71,    0,    0,    0,
			    0,    0,   70,    0,    0,    0,    0,    0,   69,   68,
			   67,   66,   65,   64,   63,   62,   61,   60,   59,   58,
			   57,   56,   55,   54,   53,   52,   51,   50,   49,   48,
			   47,   46,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,    0,    0,   45,   44,    0,    0,    0,    0,
			    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
			    0,    0,   42,   41, 1347, 1348, 1349, 1350, 1351, 1352,
			 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362, yyDummy>>,
			1, 200, 7400)
		end

	yytable_template_39 (an_array: ARRAY [INTEGER])
			-- Fill chunk #39 of template for `yytable'.
		do
			yyarray_subcopy (an_array, <<
			 1363, 1364, 1365, 1366, 1367, 1368, yyDummy>>,
			1, 6, 7600)
		end

	yycheck_template: SPECIAL [INTEGER]
			-- Template for `yycheck'
		local
			an_array: ARRAY [INTEGER]
		once
			create an_array.make_filled (0, 0, 7605)
			yycheck_template_1 (an_array)
			yycheck_template_2 (an_array)
			yycheck_template_3 (an_array)
			yycheck_template_4 (an_array)
			yycheck_template_5 (an_array)
			yycheck_template_6 (an_array)
			yycheck_template_7 (an_array)
			yycheck_template_8 (an_array)
			yycheck_template_9 (an_array)
			yycheck_template_10 (an_array)
			yycheck_template_11 (an_array)
			yycheck_template_12 (an_array)
			yycheck_template_13 (an_array)
			yycheck_template_14 (an_array)
			yycheck_template_15 (an_array)
			yycheck_template_16 (an_array)
			yycheck_template_17 (an_array)
			yycheck_template_18 (an_array)
			yycheck_template_19 (an_array)
			yycheck_template_20 (an_array)
			yycheck_template_21 (an_array)
			yycheck_template_22 (an_array)
			yycheck_template_23 (an_array)
			yycheck_template_24 (an_array)
			yycheck_template_25 (an_array)
			yycheck_template_26 (an_array)
			yycheck_template_27 (an_array)
			yycheck_template_28 (an_array)
			yycheck_template_29 (an_array)
			yycheck_template_30 (an_array)
			yycheck_template_31 (an_array)
			yycheck_template_32 (an_array)
			yycheck_template_33 (an_array)
			yycheck_template_34 (an_array)
			yycheck_template_35 (an_array)
			yycheck_template_36 (an_array)
			yycheck_template_37 (an_array)
			yycheck_template_38 (an_array)
			yycheck_template_39 (an_array)
			Result := yyfixed_array (an_array)
		end

	yycheck_template_1 (an_array: ARRAY [INTEGER])
			-- Fill chunk #1 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   21,  190,   21,  123,   21,    1,  625,  308,   21,  236,
			  190,    8,    9,  313,  484,  652,  309,  646,   21,  812,
			  827,  194,   21,  167,  296,  983,  964,  311,  478,  747,
			 1144, 1131, 1078,   30,   31,   17, 1288,  309,  963,   21,
			 1078,   38, 1312,   40,  202,  545,  292,  293, 1078,   21,
			  167,  375,  376,  299, 1306,  282,  371,  303,  740,  305,
			  560, 1078,   83, 1078,   83, 1078,   83,  573,  545, 1141,
			   83,  188,  660, 1137,   43,   14,  545, 1137,   14,   98,
			   83, 1339, 1340,  560,   83,  106, 1184,  106, 1499,  106,
			  913, 1518,   26,  106, 1339, 1340, 1420,  685,  686,  243,

			  244,   83,   99,  106, 1136,  121, 1138,  106,   72,  125,
			   74,   83,  914,  914,  135,   97,  135,  167,  135,  921,
			  921,  103,  135,   83,  106,  242,    4,   36,  248,  296,
			   63,   64,  135,   71,  106, 1235,  135,  125,  188,   36,
			  122,  406,  309,  408,    0,   12,  106,   14,   22,  146,
			 1577,   17,  202,  135,  142, 1407,   30,  139,  140, 1273,
			  142,  954,   28,  135,    0,  338,  148,  149,  150,  190,
			  126,  190, 1496,  155,   14,  135,  114,  141,   56,  161,
			   46,   75,  447,  448,  449,  167,  142,  141,  170,  125,
			  124, 1014,  242,  175,   68,  128,  833,  179, 1609,  357, yyDummy>>,
			1, 200, 0)
		end

	yycheck_template_2 (an_array: ARRAY [INTEGER])
			-- Fill chunk #2 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  358,   20, 1266,  142, 1276,   45, 1266,  189, 1560,   14,
			  104, 1309, 1150,  713,  183,  124,  531,  532,  533,  534,
			   27,  903,   14,  192, 1149, 1027, 1027,  124, 1030, 1030,
			 1262,  213, 1025,   14,   15,   21,  713, 1175,   14,  221,
			   45, 1341,  224,   11,   75,  714,  715,  216,  754,  231,
			  756, 1603,  758,   72,   73,   74,   37, 1064,  227,  847,
			   11,  243,  244, 1377,   32,   72,   73,   74, 1206,  121,
			 1316,   14,  254,  104,  126,   22, 1083,   37, 1316,  261,
			 1205,   32,  264,   30,   52,   20, 1316,   14,  257,  271,
			  142,   26, 1644,  565,  313,  277,  469,   83,  267, 1316,

			   14, 1316, 1560, 1316,  273,   14, 1576,  357,  358,   14,
			  313,   38,  294,  295,  296, 1560,  298, 1035,   15, 1571,
			  106, 1123, 1123,   17,  953,   14,   27,  309,   14,  298,
			   72,   73,   74,  962,   28,   14,    4,   72,   73,   74,
			  810,  606,  607,  608,   14, 1603,   14,   14,   49,  135,
			   69, 1451,   46,   22, 1454,  825,   75,   26, 1603,  809,
			  126,   30,  634,   72,   73,   74,   34,   72,   73,   74,
			   38,   72,   73,   74,   42,  141,  373,   72,   73,   74,
			  652,  123,  683,  684,   11,   14, 1644,  122,  122,  124,
			  125,  891,   27,   14,   12,   13,   14,   15,  117, 1644, yyDummy>>,
			1, 200, 200)
		end

	yycheck_template_3 (an_array: ARRAY [INTEGER])
			-- Fill chunk #3 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   11,   72,   73,   74,  105,   32,  388,   25, 1201,  128,
			   14,   29, 1130,    3,  396,  384,  135,  136,   14,   37,
			   11,   32,   40,  392,  748,   52,   44,   45,  123,   72,
			   73,   74,   18, 1533,  105,   11,  625,   72,   73,   74,
			   70,   32,   72,   73,   74,  625,   72,   73,   74,  593,
			  594,  433,  120,   11,  627,  424,   32,  630,   17,  441,
			  429,   14,   27,  735,   12,  153,   14,   17,  437,   28,
			  742,  159,  120,  141,   32,  105,  593,  594,   28,  122,
			  168,  124,  125,   69, 1103,  173,   72,   73,   74,   75,
			  178,  541,  122,  141,  795,  545,   46,  123,   72,   73,

			   74,  483,  619,  620,  486,  474,  807,   72,   73,   74,
			  560,   11, 1012,   27, 1307, 1233,  134,  486, 1018,  121,
			  489,  122,   17,  492,  212,   14,   70, 1320,   72,   73,
			   74,  117,   32,   22,  120,  223,   25,   17,  520,  521,
			  142,   30,  592,  593,  594,   14,  830,  121,   28,  135,
			  136,   46,   47,   70,   49,   72,   73,   74,   72,   73,
			   74,  833,   27,  545,   14,  253,   46,  128,  618,  619,
			  620,   11,  126,   27,  121,  263,  120,   70,  560,   72,
			   73,   74,   47,  565,   49,   50,   51,  141,  105,  571,
			   14,  573,   32,   47,   11,   49,   50,   51,   72,   73, yyDummy>>,
			1, 200, 400)
		end

	yycheck_template_4 (an_array: ARRAY [INTEGER])
			-- Fill chunk #4 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   74,   71, 1540,  120,  625,  122,  625,   72,   73,   74,
			  592,  593,  594,  125, 1539,   32,   14, 1575,   72,   73,
			   74,  914, 1340,   14, 1342,  890,   27,  120,  900,  121,
			 1086,   63,   64,  806,  126,  617,  901,  107,  108,  621,
			  128,  785,  786,  113,  114,  115,  947,  121,   49, 1587,
			  142, 1458,  634,  703,  142,  624,   11,  639,  640,  641,
			  642, 1586,   14,  713,  129,  647,  648,  636,  650,   14,
			  652,   72,   73,   74,  656,  129,  645,   32,  143,   14,
			    7,  128,   14,   14,   11,   14,   20,   14, 1626,  143,
			   17,   14,   26,   20,   70,  142,   72,   73,   74, 1624,

			  946,   28,   34,   34,   31,   32,   38,   38,  121,   36,
			   42,  399,  125,   71,  402, 1344, 1654,  124,  125,   46,
			   47,  409,   49,   14,  412,   52,   14,  415, 1653, 1667,
			 1537,  713,  714,  715, 1027, 1453, 1373,   27,   72,   73,
			   74, 1666,   14,   34,  120,   60, 1011,   38,   14,  107,
			  108,   42, 1690,  735,   27,  113,  114,  115,  740,   70,
			  742,   72,   73,   74, 1689,   12, 1236,   14,  750,    8,
			    9,  753,  754,   27,  756, 1582,  758,  135,  136,   72,
			   73,   74,   72,   73,   74,  767,   27,  769,  122, 1408,
			  124,  125,   75, 1094,   70,  814,   72,   73,   74,   72, yyDummy>>,
			1, 200, 600)
		end

	yycheck_template_5 (an_array: ARRAY [INTEGER])
			-- Fill chunk #5 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   73,   74,  784,  785,  786,  125,  126,  826,  790,  120,
			  792,  793,  105,   75,  141, 1622,  835,  799,   72,   73,
			   74,   36,  142, 1279, 1461, 1632, 1455,  120,   14, 1285,
			  812,   72,   73,   74,   17,  535,  125,  126,  538,  836,
			   72,  891,   74,   17,  120,   28,  546,   17,  123,  549,
			  125,  833,  552,  142,   28,  824,   17, 1664,   28,  841,
			   27,  124,  125, 1135, 1136, 1137, 1138,   28, 1169,   17,
			 1326,    7, 1328, 1343,  856,   11,   46,  122,   14,  124,
			   28,   17,   49,   27,   20,   46,  120,  856,  122,  122,
			 1191,  124,   28,   44,   45,   31,   32,  585,  125,  126,

			   36,  589,   27, 1532,   45,   72,   73,   74,  596,   13,
			   46,   47,  600,   49, 1103,  142,   52,   14,  900,  916,
			   31,  903,   47, 1103,   49,   50,   51,  121,   72,   73,
			   74,  913,  914,   70,   14,   72,   73,   74,   14,  921,
			  922,  923,   70,   29,   72,   73,   74,   72,   73,   74,
			 1579,  123,  934,  125,  936, 1584,  938,  162,  940,   14,
			 1232,   70, 1012,   72,   73,   74,  171,   14, 1018,   27,
			  128,  176,  954,  955,  956,  180,   70,  182,   72,   73,
			   74,   14, 1452,  120,  966,   70,   40,   72,   73,   74,
			 1262,   49,  120,  975, 1266,  695,  122,  966,  124,  699, yyDummy>>,
			1, 200, 800)
		end

	yycheck_template_6 (an_array: ARRAY [INTEGER])
			-- Fill chunk #6 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			 1629,   14,   41,   16,  129,  141,   24,   25,   26,  214,
			 1466,  120,   27,   41,   72,   73,   74,  123,  143,  125,
			  225,   34,  124,  125,  724,   38,  120,   27,  728,   42,
			 1012,   14, 1014,   27,   49,  120, 1018,  124,  125, 1339,
			 1340,  194,   14, 1025, 1063, 1027,   27,  128, 1030,   49,
			  255,  142,  122, 1072,  124,   49, 1038,   72,   73,   74,
			  265, 1531, 1031, 1082, 1534,  142,   47, 1523,   49,   50,
			   51,   14,   72,   73,   74,   12,   13,   14,   72,   73,
			   74,  125, 1103, 1065, 1103, 1067, 1068, 1069, 1070,   14,
			   25,   72,   73,   74,   29,  120, 1078,  122,    7,   27,

			   14, 1373,   11,   40,   14,   14, 1088,  128,   17,   44,
			   45,   20,   38, 1583,   40, 1165,   14, 1099,   14,   28,
			   27,   49,   31,   32,   72,   73,   74,   36, 1429, 1430,
			 1112,   44, 1067, 1068, 1069, 1070, 1592,   46,   47, 1121,
			   49, 1123, 1161,   52,   72,   73,   74,   27,  129,   44,
			 1119,  125,  126, 1135, 1136, 1137, 1138,  310,  357,  358,
			 1129,  314,  143,  121, 1391,   72,   73,   74,  868,   49,
			  121,  871,   30,   31, 1294,  875, 1339, 1340,  878,  128,
			 1636,  881, 1164,   14, 1153,  338,   72,   73,   74, 1461,
			   14, 1492,   72,   73,   74,   14,  401, 1166,  351,  404, yyDummy>>,
			1, 200, 1000)
		end

	yycheck_template_7 (an_array: ARRAY [INTEGER])
			-- Fill chunk #7 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   27,  763,  764,  356, 1660, 1661,  411,  922,  923,  414,
			   38,  416,  417,  537,   27,   14,  540,  134, 1674, 1201,
			   27,   25,   49,  129,  548,  124, 1682,  551,  121,  553,
			  554,   27,  141, 1229,   34,   14,   49,  141,   53, 1695,
			   27, 1697,   49,    3,   54,   72,   73,   74,   14, 1550,
			 1232,  128, 1708,   49,  142, 1556,   14, 1226, 1714,   72,
			   73,   74,   49,   14, 1283,   72,   73,   74, 1724,  134,
			  142, 1572,  128,  128, 1394,   63,   72,   73,   74, 1735,
			 1262, 1075,   47,   48, 1266,   72,   73,   74, 1744,   63,
			   19, 1085,  112,  993, 1595,  120,   14,  997,   42,   14,

			    0, 1001,  125,   14, 1301, 1005, 1288,   72,   73,   74,
			 1611,  639,  640,  641,  642,  126,  469,  126, 1339, 1340,
			 1339, 1340, 1339, 1340, 1306, 1307, 1339, 1340,  126,  126,
			  483, 1313, 1314,  126, 1316, 1304, 1339, 1340, 1320, 1321,
			 1339, 1340,  126,  126,  126,  498,  499,  500,  501,  502,
			  503,   14,   27,  506,  507,  508,  509,  510,  511,  512,
			  513,  514,  515,  516,  517,  518,  519, 1339, 1340,  141,
			   13,  121,  696,   41,   49,  123,  700, 1678,   16, 1173,
			   14,  586,  128,   14,  123,  590,  121, 1408,  126, 1408,
			   27, 1373,  597,  126,  126,  126,  601,   72,   73,   74, yyDummy>>,
			1, 200, 1200)
		end

	yycheck_template_8 (an_array: ARRAY [INTEGER])
			-- Fill chunk #8 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  142,  725,  142,  126, 1198,  729,  126,  126, 1202,    8,
			    9,  141,   49,  126,  126,   14,  126,   27, 1415,   18,
			  126,   27,  121,   22,  141, 1407,   25,   12, 1410, 1411,
			    5,   30,  141,  125,   14,   72,   73,   74, 1457,   49,
			   11, 1423,  120,   49,   27,   14,   17,    5,  125, 1418,
			  141,   22,  125, 1435,   53,   26,  116,   28,  128,   30,
			   31,   32,   72,   73,   74,   36,   72,   73,   74,  622,
			  623,  122,  121,  128,  627,   46,  128,  630,  126, 1461,
			  126,   52,  126,  128, 1278,  126,  126, 1676,   18,   72,
			   73,   74,  128,  153,  126,   27, 1478,  126,  126,  159,

			  125,  654,  120,  125,  657,  125,  659,  660,  168, 1491,
			  126, 1305,   14,  173,  125,   12,   18, 1536,  178,  126,
			   22,  120,   27,   25,  121,  678,  121,  680,   30, 1511,
			  121, 1325,  685,  686,  121,  688,  128,  121,  128, 1560,
			   72,   73,   74, 1560,   49,  121,  870, 1560,  126,  873,
			   27,   53,  212,  877,  128,  128,  880,  762,  882,  883,
			  121,   27, 1581,  223,  126,  128,  137,   72,   73,   74,
			  141,   27,   49, 1555,  126,  126,  236,  126, 1560,   27,
			  126,   47, 1603,   49,   50,   51, 1603,   27, 1570, 1571,
			 1603,   27,  126,  253,   27,   72,   73,   74,  126,  126, yyDummy>>,
			1, 200, 1400)
		end

	yycheck_template_9 (an_array: ARRAY [INTEGER])
			-- Fill chunk #9 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   27, 1289, 1621,  263,   27,  126,   72,   73,   74,  126,
			  121,   47, 1631,   49,   50,   51,   72,   73,   74,  128,
			 1414, 1603,  282, 1644,   72,   73,   74, 1644,  121,  121,
			 1599, 1644,   72,   73,   74,  121,   72,   73,   74,   72,
			   73,   74,    8,    9, 1663,   72,   73,   74,   14,   72,
			   73,   74,   18,  806,  120, 1676,   22,   14,   25,   25,
			   14,   18, 1644,  129,   30,   22, 1648,  126,   25,   14,
			  994,   27,  126,   30,  998,   27,    8,  143, 1002,  123,
			  123,    5, 1006,  128,  123,  123,  121,   53,  841,  126,
			  843,  844,  124,  129,  847,  124,   53,  128,  124, 1387,

			  128,  121,  362,  121,  128,  858,  128,  143,  368, 1397,
			 1504,  121, 1400,   27,  125, 1403,   72,   73,   74,  125,
			   72,   73,   74,   27,  125,  113,  114,  125,   27,  121,
			  118,  119,  120,   47,  121,   49,   50,   51,   23,  399,
			   74,   35,  402,   47,   27,   49,   50,   51,   27,  409,
			  128,  128,  412,   27,  120,  415,  128,  128,   72,   73,
			   74,  120,  122,   27,  128,   62,  154,  128,   72,   73,
			   74,  121,  160,   72,   73,   74,  125,  128,  125,  121,
			 1574,  169,  128, 1471,  128,  125,  174, 1475,  126,   72,
			   73,   74, 1480,   72,   73,   74, 1484, 1591,   72,   73, yyDummy>>,
			1, 200, 1600)
		end

	yycheck_template_10 (an_array: ARRAY [INTEGER])
			-- Fill chunk #10 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   74,  461,  955,  126,  124,  120,  113,  114,   72,   73,
			   74,  118,  119,  120,  121,  129,    8,    9,   16,  972,
			  128,   53,   14,  130,   59,  129,   18,  128,   59,  143,
			   22, 1625,  110,   25,  126,  128,   34,   35,   30,  143,
			   38, 1635,  128,   59,   42,  233,  234,  154,  965,  126,
			  238,  239,  240,  160,   14,  128,  128,  128,  126,  120,
			  167,   53,  169,  121,    7, 1659,  128,  174,  128,    7,
			    7,  125,  124,  124,    7,  535,    5,  537,  538,  126,
			  540,  188,   17,  142,   20, 1500,  546, 1681,  548,  549,
			 1200,  551,  552,  553,  554,  202,  811,   26,  908,  833,

			 1694, 1226,  703, 1266,  913,  913,  382,   79,  338, 1283,
			  930,  627, 1065, 1148,  930, 1034,  930,  142,  309, 1713,
			 1461, 1374, 1056,  749, 1568,  585,  233,  234, 1092,  589,
			 1176,  238,  239,  240,  241,  242,  596, 1090, 1091,  574,
			  600,  900,   71,  903,    8,    9, 1099,   76,   77,   78,
			   14,   80,  742,  708,   18, 1340, 1073,  721,   22,   23,
			 1424,   25, 1496, 1316, 1178, 1423,   30, 1084, 1121, 1506,
			 1603,  359,  360, 1234, 1260,  363,  364,  365,  107,  108,
			  109,  110,  111,  112,  113,  114,  115, 1644,  858,   53,
			  806,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 1800)
		end

	yycheck_template_11 (an_array: ARRAY [INTEGER])
			-- Fill chunk #11 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   -1,    5,  135,  136,  137,  138,
			  139,  140,  400,   -1,   -1,  403,   -1, 1170, 1171, 1172,
			   -1,   -1,  410,   -1,   -1,  413,   26,    8,    9,   -1,
			   -1,   -1,   -1,   14, 1151,  695,  696,   18,   -1,  699,
			  700,   22,   -1,   -1,   25, 1162,   -1,   -1,  708,   30,
			  357,  358,  359,  360,   -1,   -1,  363,  364,  365,  366,
			   -1,  721,   -1,   -1,  724,  725,   -1,   -1,  728,  729,
			   -1,   71,   53,   -1,   -1,   -1,   76,   77,   78,   -1,
			   80,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			 1207,   -1, 1209,  400,   -1,   -1,  403,   -1,   -1,   -1,

			   -1,   -1,   -1,  410,   -1,   -1,  413,  107,  108,  109,
			  110,  111,  112,  113,  114,  115,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  135,  136,  137,  138,  139,
			  140,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  536,   -1,
			   -1,  539,   -1,   -1,   -1,   -1,   -1, 1310, 1311,  547,
			 1277,   -1,  550,   -1,  471, 1318, 1319,   -1, 1321,   -1,
			   -1,    8,    9,   -1,   -1,   -1,   -1,   14, 1331, 1332,
			   -1,   18,   -1,   -1, 1389,   22,   -1,   -1,   25,   -1,
			   -1,   -1,   -1,   30, 1399,   -1,   -1, 1402,   -1, 1404, yyDummy>>,
			1, 200, 2000)
		end

	yycheck_template_12 (an_array: ARRAY [INTEGER])
			-- Fill chunk #12 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			 1405,   -1,   -1,   -1,   -1,   -1,   -1, 1324,  868,   -1,
			  870,  871,   -1,  873,   -1,  875,   53,  877,  878,   -1,
			  880,  881,  882,  883,   -1,   -1,   -1,   -1,   -1,  536,
			   -1,   -1,  539, 1386,  541,   -1,   -1,   -1,  545,   -1,
			  547,   -1,   -1,  550,   -1,   -1,   -1,   -1,   -1,  113,
			  114,   -1,   -1,  560,  118,  119,  120,   -1,   -1,   -1,
			   -1,   -1, 1379,   -1,   -1,   -1,   -1, 1472,   -1,  576,
			 1423, 1476,   -1,   -1, 1427,   -1, 1481,   -1,   -1,   -1,
			 1485,   -1, 1435,   -1,   -1,  592,  593,  594,   -1,   -1,
			  154,   -1,   -1,   -1,   -1,   -1,  160,   -1,   -1,   -1,

			   -1,   -1,   -1,   -1,   -1,  169,   -1,   -1,   -1,   -1,
			  174,  618,  619,  620,   -1,   -1,   -1,   -1,  706,  707,
			 1437,  709,  710,  711,   -1,   -1,    8,    9,   -1,   -1,
			   -1,   -1,   14,  993,  994,   -1,   18,  997,  998, 1456,
			   22, 1001, 1002,   25,   -1, 1005, 1006,   -1,   30,   -1,
			   -1,   12,   -1,   14,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1, 1519,   -1,   -1,  233,
			  234,   53,   -1,   -1,  238,  239,  240,   -1,   -1, 1445,
			   -1,   -1,   -1, 1449, 1450,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  703,   -1,   -1,  706, yyDummy>>,
			1, 200, 2200)
		end

	yycheck_template_13 (an_array: ARRAY [INTEGER])
			-- Fill chunk #13 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  707,   71,  709,  710,  711,  712,  713,   -1,   -1,   -1,
			   71,   -1,   -1,   -1, 1567,   76,   77,   78, 1535,   80,
			   -1,   -1,   -1,   -1, 1541,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  107,  108,  109,
			  110,  111,  112,  113,  114,  115,  107,  108,  109,  110,
			  111,  112,  113,  114,  115,   -1,  763,  764,   -1,   -1,
			   -1,   -1,   -1, 1580,   -1,  135,  136,  137,  138,  139,
			  140, 1588,   -1, 1590,  135,  136,  137,  138,  139,  140,
			   -1,  869,   -1,   -1,  872,   -1,   -1,   -1,  876,   -1,
			   -1,  879,   -1,   -1,   -1,  359,  360,   -1,   -1,  363,

			  364,  365,   -1, 1620,   -1,   -1,   -1,   -1,    7,   -1,
			 1627, 1628,   11, 1630,   -1,   14,   -1, 1634,   17,   -1,
			   -1,   20, 1639, 1589,   -1,   -1,   -1,   -1,   -1,   28,
			   -1,   -1,   31,   32,   -1,   -1,  400,   36, 1655,  403,
			 1657,   -1,   -1,   -1,   -1, 1662,  410,   46,   47,  413,
			   49, 1668,   -1,   52, 1671,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  869, 1680,   -1,  872,   -1, 1633, 1685,  876,
			   -1,   -1,  879,   -1, 1691,   -1, 1693,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  891,   -1,   -1,   -1, 1705,   -1,
			 1656,   -1,   -1,   -1,   -1, 1712,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 2400)
		end

	yycheck_template_14 (an_array: ARRAY [INTEGER])
			-- Fill chunk #14 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			 1717,   -1,   -1,   -1,   -1,   -1,   -1, 1673,   -1, 1675,
			    7,   -1,   -1, 1679,   11, 1732,   -1,   14,   -1,   -1,
			   17,   -1,   -1,   20,   -1,   -1, 1692,   -1,   -1, 1289,
			 1696,   28, 1698,   -1,   31,   32,   -1,   -1,   -1,   36,
			   -1, 1707,   -1, 1709, 1710, 1711,   -1,   -1,   -1,   46,
			   47,   -1,   49,   -1,   -1,   52, 1722, 1723,   -1, 1725,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1734,   -1,
			 1736, 1737,  536,   -1,   -1,  539, 1742, 1743,   -1, 1745,
			   -1,   -1,   -1,  547, 1750,   -1,  550,   -1,   -1, 1755,
			   -1, 1757,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   -1,   -1,    6,   -1,    8, 1012,   10,   -1,   -1,   -1,
			   -1, 1018,   -1,   -1,   18,   19,   -1,   21,   -1,   -1,
			   24,   -1,   -1,   -1,   -1,   -1,   -1, 1387,   -1,   33,
			   -1, 1391,   -1,   -1,   -1,   39,   -1, 1397,   -1,   -1,
			 1400,   -1,   -1, 1403,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   55,   -1,   57,   58,   -1,   -1,   61,   -1,   -1,
			   -1,   -1,   66,   67,   -1,   69,   70,   12,   72,   73,
			   74,   -1,   -1,   -1,   -1,   -1,   -1,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103, yyDummy>>,
			1, 200, 2600)
		end

	yycheck_template_15 (an_array: ARRAY [INTEGER])
			-- Fill chunk #15 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,  105,  106,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1, 1471,  116,  117,  118, 1475,  120,   -1,  122,   -1,
			 1480,   -1,   -1,  127, 1484,  129,   71,   -1,   -1,  133,
			   -1,   76,   77,   78,   -1,   80,   -1,  141,   -1,   -1,
			   -1,   -1,  706,  707,   -1,  709,  710,  711,    8,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1165,   -1,
			   -1,   -1,  107,  108,  109,  110,  111,  112,  113,  114,
			  115,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  135,  136,  137,  138,  139,  140,   -1,   -1,   -1, 1287,

			 1288,   -1, 1290, 1291, 1292,   -1,   66,   67,   -1,   69,
			   -1,   -1,   72,   73,   74,   75,   -1,   -1,   -1,   -1,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  117,  118,   -1,
			  120,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  135,  136,   -1,   -1,   -1,
			 1287, 1288,   -1, 1290, 1291, 1292, 1293,   -1,   -1,   -1,
			   -1, 1298,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 2800)
		end

	yycheck_template_16 (an_array: ARRAY [INTEGER])
			-- Fill chunk #16 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			 1388,   -1,   -1,   -1, 1392,  869,   -1,   -1,  872,   -1,
			 1398,   -1,  876, 1401,   -1,  879,   -1,   -1,   -1,   -1,
			   -1,   -1,   81,   82,   83,   84,   85,   86,   87,   88,
			   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
			   99,  100,  101,  102,  103,   -1,   -1,    4,    5,    6,
			    7,    8,   -1,   10,   11,   12,   13,   14,   15,  118,
			   17,   18,   19,   -1,   21,   22,   -1,   24,   25,   26,
			   -1,   28,   29,   30,   -1,   32,   33,   -1,   -1,   -1,
			   37, 1388,   39,   40,   41, 1392,   -1,   44,   45,   46,
			   -1, 1398,   -1,   50, 1401,   52,   -1,   -1,   55,   56,

			   57,   58,   -1,   -1,   61,   62,   -1,   -1,   -1,   66,
			   67,   -1,   69,   70,   71,   72,   73,   74,   75,   76,
			   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
			  107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
			  117,  118,  119,  120,   -1,  122,  123,   -1,  125,  126,
			  127,   -1,  129,  130,  131,  132,  133,  134,  135,  136,
			  137,  138,  139,  140,  141,  142,    4,    5,    6,    7,
			    8,   -1,   10,   11,   12,   13,   14,   15,   -1,   17, yyDummy>>,
			1, 200, 3000)
		end

	yycheck_template_17 (an_array: ARRAY [INTEGER])
			-- Fill chunk #17 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   18,   19,   -1,   21,   22,   -1,   24,   25,   26,   -1,
			   28,   29,   30,   -1,   32,   33,   -1,   -1,   -1,   37,
			   -1,   39,   40,   41,   -1,   -1,   44,   45,   46,   -1,
			   -1,   -1,   50,   -1,   52,   -1,   -1,   55,   56,   57,
			   58,   -1,   -1,   61,   62,   -1,   -1,   -1,   66,   67,
			   -1,   69,   70,   71,   72,   73,   74,   75,   76,   77,
			   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
			   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
			  108,  109,  110,  111,  112,  113,  114,  115,  116,  117,

			  118,  119,  120,   -1,  122,  123,   -1,  125,  126,  127,
			   -1,  129,  130,  131,  132,  133,  134,  135,  136,  137,
			  138,  139,  140,  141,  142,   -1,   -1,   -1,   -1,   -1,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,    6,   -1,    8,   -1,   10,   -1,
			   12,   13,   14,   15,   -1,   -1,   18,   19,  118,   21,
			  120,   -1,   24,   25,   -1,   -1,   -1,   29,   -1,   -1,
			   -1,   33,   -1,   -1,   -1,   37,   -1,   39,   40,   -1,
			   -1,   -1,   44,   45,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 3200)
		end

	yycheck_template_18 (an_array: ARRAY [INTEGER])
			-- Fill chunk #18 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,   61,
			   -1,   -1,   -1,   -1,   66,   67,   -1,   69,   70,   -1,
			   72,   73,   74, 1287, 1288,   -1, 1290, 1291, 1292,   81,
			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
			   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
			  102,  103,   -1,  105,  106,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  116,  117,  118,   -1,  120,   -1,
			  122,   -1,   -1,   -1,   -1,  127,   -1,  129,   -1,   -1,
			   -1,  133,  134,   -1,   -1,   -1,   -1,   -1,   -1,  141,
			    4,    5,    6,    7,    8,   -1,   10,   11,   12,   13,

			   14,   15,   -1,   17,   18,   19,   -1,   21,   22,   -1,
			   24,   25,   26,   -1,   28,   29,   30,   -1,   32,   33,
			   -1,   -1,   -1,   37, 1388,   39,   40,   41, 1392,   -1,
			   44,   45,   46,   -1, 1398,   -1,   50, 1401,   52,   -1,
			   -1,   55,   56,   57,   58,   -1,   -1,   61,   62,   -1,
			   -1,   -1,   66,   67,   -1,   69,   70,   71,   72,   73,
			   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
			  104,  105,  106,  107,  108,  109,  110,  111,  112,  113, yyDummy>>,
			1, 200, 3400)
		end

	yycheck_template_19 (an_array: ARRAY [INTEGER])
			-- Fill chunk #19 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  114,  115,  116,  117,  118,  119,  120,   -1,  122,  123,
			   -1,  125,  126,  127,   -1,  129,  130,  131,  132,  133,
			  134,  135,  136,  137,  138,  139,  140,  141,  142,    4,
			    5,    6,    7,    8,   -1,   10,   11,   12,   13,   14,
			   15,   -1,   17,   18,   19,   -1,   21,   22,   -1,   24,
			   25,   26,   -1,   28,   29,   30,   -1,   32,   33,   -1,
			   -1,   -1,   37,   -1,   39,   40,   41,   -1,   -1,   44,
			   45,   46,   -1,   -1,   -1,   50,   -1,   52,   -1,   -1,
			   55,   56,   57,   58,   -1,   -1,   61,   62,   -1,   -1,
			   -1,   66,   67,   -1,   69,   70,   71,   72,   73,   74,

			   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
			  105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
			  115,  116,  117,  118,  119,  120,   -1,  122,  123,   -1,
			  125,  126,  127,   -1,  129,  130,  131,  132,  133,  134,
			  135,  136,  137,  138,  139,  140,  141,  142,    6,   -1,
			    8,   -1,   10,   -1,   12,   13,   14,   15,   -1,   -1,
			   18,   19,   -1,   21,   -1,   -1,   24,   25,   -1,   -1,
			   -1,   29,   -1,   -1,   -1,   33,   -1,   -1,   -1,   37, yyDummy>>,
			1, 200, 3600)
		end

	yycheck_template_20 (an_array: ARRAY [INTEGER])
			-- Fill chunk #20 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   39,   40,   -1,   -1,   -1,   44,   45,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,   57,
			   58,   -1,   -1,   61,   -1,   63,   -1,   -1,   66,   67,
			   -1,   69,   70,   -1,   72,   73,   74,   -1,   -1,   -1,
			   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
			   98,   99,  100,  101,  102,  103,   -1,  105,  106,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  116,  117,
			  118,   -1,  120,   -1,  122,   -1,   -1,   -1,   -1,  127,
			   -1,  129,   -1,   -1,   -1,  133,  134,   -1,   -1,   -1,

			   -1,   -1,   -1,  141,  142,    6,   -1,    8,   -1,   10,
			   -1,   12,   13,   14,   15,   -1,   -1,   18,   19,   -1,
			   21,   -1,   -1,   24,   25,   -1,   -1,   -1,   29,   -1,
			   -1,   -1,   33,   -1,   -1,   -1,   37,   -1,   39,   40,
			   -1,   -1,   -1,   44,   45,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,
			   61,   -1,   63,   -1,   -1,   66,   67,   -1,   69,   70,
			   -1,   72,   73,   74,   -1,   -1,   -1,   -1,   -1,   -1,
			   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
			   91,   92,   93,   94,   95,   96,   97,   98,   99,  100, yyDummy>>,
			1, 200, 3800)
		end

	yycheck_template_21 (an_array: ARRAY [INTEGER])
			-- Fill chunk #21 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  101,  102,  103,   -1,  105,  106,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  116,  117,  118,   -1,  120,
			   -1,  122,   -1,   -1,   -1,   -1,  127,   -1,  129,   -1,
			   -1,   -1,  133,  134,   -1,   -1,   -1,   -1,   -1,   -1,
			  141,  142,    6,   -1,    8,   -1,   10,   -1,   12,   13,
			   14,   15,   -1,   -1,   18,   19,   -1,   21,   -1,   -1,
			   24,   25,   -1,   -1,   -1,   29,   -1,   -1,   -1,   33,
			   -1,   -1,   -1,   37,   -1,   39,   40,   -1,   -1,   -1,
			   44,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   55,   -1,   57,   58,   -1,   -1,   61,   -1,   -1,

			   -1,   -1,   66,   67,   -1,   69,   70,   -1,   72,   73,
			   74,   -1,   -1,   -1,   -1,   -1,   -1,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
			   -1,  105,  106,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  116,  117,  118,   -1,  120,   -1,  122,   -1,
			   -1,   -1,   -1,  127,  128,  129,   -1,   -1,   -1,  133,
			  134,   -1,   -1,   -1,   -1,   -1,   -1,  141,  142,    6,
			   -1,    8,   -1,   10,   -1,   12,   13,   14,   15,   -1,
			   -1,   18,   19,   -1,   21,   -1,   -1,   24,   25,   -1, yyDummy>>,
			1, 200, 4000)
		end

	yycheck_template_22 (an_array: ARRAY [INTEGER])
			-- Fill chunk #22 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   29,   -1,   -1,   -1,   33,   -1,   -1,   -1,
			   37,   -1,   39,   40,   -1,   -1,   -1,   44,   45,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   55,   -1,
			   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,
			   67,   -1,   69,   70,   -1,   72,   73,   74,   -1,   -1,
			   -1,   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   97,   98,   99,  100,  101,  102,  103,   -1,  105,  106,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  116,
			  117,  118,   -1,  120,   -1,  122,   -1,   -1,   -1,   -1,

			  127,   -1,  129,   -1,   -1,   -1,  133,  134,   -1,   -1,
			   -1,   -1,   -1,   -1,  141,  142,    6,   -1,    8,   -1,
			   10,   -1,   12,   13,   14,   15,   -1,   -1,   18,   19,
			   -1,   21,   -1,   -1,   24,   25,   -1,   -1,   -1,   29,
			   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,   -1,   39,
			   40,   -1,   -1,   -1,   44,   45,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,
			   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,
			   70,   -1,   72,   73,   74,   -1,   -1,   -1,   -1,   -1,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89, yyDummy>>,
			1, 200, 4200)
		end

	yycheck_template_23 (an_array: ARRAY [INTEGER])
			-- Fill chunk #23 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,   -1,  105,  106,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  116,  117,  118,   -1,
			  120,   -1,  122,   -1,   -1,   -1,   -1,  127,   -1,  129,
			   -1,   -1,   -1,  133,  134,   -1,    6,   -1,    8,   -1,
			   10,  141,   12,   13,   14,   15,   -1,   -1,   18,   19,
			   -1,   21,   -1,   -1,   24,   25,   -1,   -1,   -1,   29,
			   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,   -1,   39,
			   40,   -1,   -1,   -1,   44,   45,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,

			   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,
			   70,   -1,   72,   73,   74,   -1,   -1,   -1,   -1,   -1,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,   -1,  105,  106,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  116,  117,  118,   -1,
			  120,   -1,  122,   -1,   -1,   -1,   -1,  127,   -1,  129,
			   -1,   -1,   -1,  133,  134,   -1,    6,   -1,    8,   -1,
			   10,  141,   12,   13,   14,   15,   -1,   -1,   18,   19,
			   -1,   21,   -1,   -1,   24,   25,   -1,   -1,   -1,   29, yyDummy>>,
			1, 200, 4400)
		end

	yycheck_template_24 (an_array: ARRAY [INTEGER])
			-- Fill chunk #24 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   33,   -1,   -1,   -1,   37,   -1,   39,
			   40,   -1,   -1,   -1,   44,   45,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,
			   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,
			   70,   -1,   72,   73,   74,   -1,   -1,   -1,   -1,   -1,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,   -1,  105,  106,   -1,   -1,   -1,
			   -1,   -1,    7,    8,   -1,   -1,  116,  117,  118,   14,
			  120,   -1,  122,   18,   -1,   -1,   21,  127,   -1,  129,

			   -1,   -1,   -1,  133,  134,   -1,   -1,   -1,   33,   -1,
			   -1,  141,   -1,   -1,   39,   -1,   41,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,
			   55,   -1,   57,   58,   -1,   -1,   61,   -1,   -1,   -1,
			   -1,   66,   67,   -1,   69,   70,   71,   72,   73,   74,
			   75,   -1,   -1,   -1,   79,   -1,   81,   82,   83,   84,
			   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
			   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
			  105,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    7,
			    8,  116,  117,  118,  119,  120,   14,  122,   -1,   -1, yyDummy>>,
			1, 200, 4600)
		end

	yycheck_template_25 (an_array: ARRAY [INTEGER])
			-- Fill chunk #25 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   18,   -1,  127,   21,   -1,  130,  131,   -1,   -1,   -1,
			  135,  136,   -1,   -1,   -1,   33,   -1,  142,   -1,   -1,
			   -1,   39,   -1,   41,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,   -1,   57,
			   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,   67,
			   -1,   69,   70,   71,   72,   73,   74,   75,   -1,   -1,
			   -1,   79,   -1,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
			   98,   99,  100,  101,  102,  103,  104,  105,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,    8,   -1,   -1,  116,  117,

			  118,  119,  120,   -1,  122,   18,   -1,   -1,   21,  127,
			   -1,   -1,  130,  131,   -1,   -1,   -1,  135,  136,   -1,
			   33,   -1,   -1,   -1,  142,   -1,   39,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,   -1,
			   -1,   -1,   55,   -1,   57,   58,   -1,   -1,   61,   -1,
			   -1,   -1,   -1,   66,   67,   -1,   69,   70,   71,   72,
			   73,   74,   75,   -1,   -1,   -1,   79,   -1,   81,   82,
			   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
			   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
			  103,  104,  105,   -1,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 4800)
		end

	yycheck_template_26 (an_array: ARRAY [INTEGER])
			-- Fill chunk #26 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,    7,    8,  116,  117,  118,  119,  120,   -1,  122,
			  123,   -1,   18,   -1,  127,   21,   -1,  130,  131,   -1,
			   -1,   -1,  135,  136,   -1,   -1,   -1,   33,   -1,  142,
			  143,   -1,   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,
			   -1,   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,
			   66,   67,   -1,   69,   70,   71,   72,   73,   74,   75,
			   -1,   -1,   -1,   79,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,

			   -1,   -1,   -1,   -1,   -1,   -1,    7,    8,   -1,   -1,
			  116,  117,  118,  119,  120,   -1,  122,   18,   -1,   -1,
			   21,  127,   -1,   -1,  130,  131,   -1,   -1,   -1,  135,
			  136,   -1,   33,   -1,   -1,   -1,  142,   -1,   39,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,
			   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,
			   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,   70,
			   71,   72,   73,   74,   75,   -1,   -1,   -1,   79,   -1,
			   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
			   91,   92,   93,   94,   95,   96,   97,   98,   99,  100, yyDummy>>,
			1, 200, 5000)
		end

	yycheck_template_27 (an_array: ARRAY [INTEGER])
			-- Fill chunk #27 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  101,  102,  103,  104,  105,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,    8,   -1,   -1,  116,  117,  118,  119,  120,
			   -1,  122,   18,   -1,   -1,   21,  127,   -1,   -1,  130,
			  131,   -1,   -1,   -1,  135,  136,   -1,   33,   -1,   -1,
			   -1,  142,   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,
			   -1,   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,
			   66,   67,   -1,   69,   70,   71,   72,   73,   74,   75,
			   -1,   -1,   -1,   79,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,

			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,    8,   -1,   -1,
			  116,  117,  118,  119,  120,   -1,  122,   18,   -1,   -1,
			   21,  127,   -1,   -1,  130,  131,   -1,   -1,   -1,  135,
			  136,   -1,   33,   -1,   -1,   -1,  142,  143,   39,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,
			   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,
			   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,   70,
			   71,   72,   73,   74,   75,   -1,   -1,   -1,   79,   -1,
			   81,   82,   83,   84,   85,   86,   87,   88,   89,   90, yyDummy>>,
			1, 200, 5200)
		end

	yycheck_template_28 (an_array: ARRAY [INTEGER])
			-- Fill chunk #28 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
			  101,  102,  103,  104,  105,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,    8,  116,  117,  118,  119,  120,
			   -1,  122,   -1,   -1,   18,  126,  127,   21,   -1,  130,
			  131,   -1,   -1,   -1,  135,  136,   -1,   -1,   -1,   33,
			   -1,  142,   -1,   -1,   -1,   39,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,
			   -1,   55,   -1,   57,   58,   -1,   -1,   61,   -1,   -1,
			   -1,   -1,   66,   67,   -1,   69,   70,   71,   72,   73,
			   74,   75,   -1,   -1,   -1,   79,   -1,   81,   82,   83,

			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
			  104,  105,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    8,
			   -1,   -1,  116,  117,  118,  119,  120,   -1,  122,   18,
			   -1,   -1,   21,  127,  128,   -1,  130,  131,   -1,   -1,
			   -1,  135,  136,   -1,   33,   -1,   -1,   -1,  142,   -1,
			   39,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   50,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,
			   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,
			   69,   70,   71,   72,   73,   74,   75,   -1,   -1,   -1, yyDummy>>,
			1, 200, 5400)
		end

	yycheck_template_29 (an_array: ARRAY [INTEGER])
			-- Fill chunk #29 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   79,   -1,   81,   82,   83,   84,   85,   86,   87,   88,
			   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
			   99,  100,  101,  102,  103,  104,  105,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,    8,  116,  117,  118,
			  119,  120,   -1,  122,  123,   -1,   18,   -1,  127,   21,
			   -1,  130,  131,   -1,   -1,   -1,  135,  136,   -1,   -1,
			   -1,   33,   -1,  142,   -1,   -1,   -1,   39,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,
			   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,   61,
			   62,   -1,   -1,   -1,   66,   67,   -1,   69,   70,   71,

			   72,   73,   74,   75,   -1,   -1,   -1,   79,   -1,   81,
			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
			   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
			  102,  103,  104,  105,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,    8,   -1,   -1,  116,  117,  118,  119,  120,   -1,
			  122,   18,   -1,   -1,   21,  127,   -1,   -1,  130,  131,
			   -1,   -1,   -1,  135,  136,   -1,   33,   -1,   -1,   -1,
			  142,   -1,   39,   -1,   41,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,   -1,
			   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   66, yyDummy>>,
			1, 200, 5600)
		end

	yycheck_template_30 (an_array: ARRAY [INTEGER])
			-- Fill chunk #30 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   67,   -1,   69,   70,   71,   72,   73,   74,   75,   -1,
			   -1,   -1,   79,   -1,   81,   82,   83,   84,   85,   86,
			   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
			   97,   98,   99,  100,  101,  102,  103,  104,  105,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  116,
			  117,  118,  119,  120,   -1,  122,   -1,    8,   -1,   -1,
			  127,   12,   -1,  130,  131,   -1,   -1,   18,  135,  136,
			   21,   -1,   -1,   -1,   -1,  142,   -1,   -1,   -1,   -1,
			   -1,   -1,   33,   -1,   -1,   -1,   -1,   -1,   39,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   50,

			   -1,   -1,   -1,   -1,   55,   -1,   57,   58,   -1,   -1,
			   61,   -1,   -1,   -1,   -1,   66,   67,   -1,   69,   70,
			   71,   72,   73,   74,   75,   -1,   -1,   -1,   79,   -1,
			   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
			   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
			  101,  102,  103,  104,  105,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,    8,   -1,   -1,  116,  117,  118,  119,  120,
			   -1,  122,   18,   -1,   -1,   21,  127,   -1,   -1,  130,
			  131,   -1,   -1,   -1,  135,  136,   -1,   33,   -1,   -1,
			   -1,  142,   -1,   39,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 5800)
		end

	yycheck_template_31 (an_array: ARRAY [INTEGER])
			-- Fill chunk #31 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,   -1,   55,
			   -1,   57,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,
			   66,   67,   -1,   69,   70,   71,   72,   73,   74,   75,
			   -1,   -1,   -1,   79,   -1,   81,   82,   83,   84,   85,
			   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
			   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    8,
			  116,  117,  118,  119,  120,   -1,  122,   -1,   -1,   18,
			  126,  127,   21,   -1,  130,  131,   -1,   -1,   -1,  135,
			  136,   -1,   -1,   -1,   33,   -1,  142,   -1,   -1,   -1,

			   39,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   50,   -1,   -1,   -1,   -1,   55,   -1,   57,   58,
			   -1,   -1,   61,   -1,   -1,   -1,   -1,   66,   67,   -1,
			   69,   70,   71,   72,   73,   74,   75,   -1,   -1,   -1,
			   79,   -1,   81,   82,   83,   84,   85,   86,   87,   88,
			   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
			   99,  100,  101,  102,  103,  104,  105,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,    8,   -1,   -1,  116,  117,  118,
			  119,  120,   -1,  122,   18,   -1,   -1,   21,  127,   -1,
			   -1,  130,  131,   -1,   -1,   -1,  135,  136,   -1,   33, yyDummy>>,
			1, 200, 6000)
		end

	yycheck_template_32 (an_array: ARRAY [INTEGER])
			-- Fill chunk #32 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,  142,   -1,   39,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   50,   -1,   -1,   -1,
			   -1,   55,   -1,   57,   58,   -1,   -1,   61,   -1,   -1,
			   -1,   -1,   66,   67,   -1,   69,   70,   71,   72,   73,
			   74,   75,   -1,   14,   -1,   79,   -1,   81,   82,   83,
			   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
			   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
			  104,  105,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  116,  117,  118,  119,  120,   -1,  122,   14,
			   -1,   61,   -1,  127,   -1,   -1,  130,  131,   -1,   69,

			   71,  135,  136,   -1,   -1,   76,   77,   78,  142,   80,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,   -1,   -1,  107,  108,  109,  110,
			  111,  112,  113,  114,  115,   -1,   71,  117,  118,   -1,
			   -1,   76,   77,   78,   -1,   80,   -1,   -1,  128,   -1,
			   -1,   -1,   -1,   -1,  135,  136,  137,  138,  139,  140,
			   -1,   -1,   22,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   30,   -1,  107,  108,  109,  110,  111,  112,  113,  114,
			  115,   -1,   -1,   43,   -1,   -1,   -1,   -1,   -1,   -1, yyDummy>>,
			1, 200, 6200)
		end

	yycheck_template_33 (an_array: ARRAY [INTEGER])
			-- Fill chunk #33 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  135,  136,  137,  138,  139,  140,   66,   67,   -1,   69,
			   -1,   -1,   -1,   -1,   -1,   75,   -1,   -1,   -1,   -1,
			   -1,   81,   82,   83,   84,   85,   86,   87,   88,   89,
			   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
			  100,  101,  102,  103,  104,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,  117,  118,   -1,
			  120,   -1,   11,   -1,   -1,   14,   -1,   16,   17,   -1,
			   -1,   20,   -1,   22,   -1,  135,  136,   26,   -1,   28,
			   -1,   30,   31,   32,   -1,   34,   29,   36,   -1,   38,

			   -1,   -1,   -1,   42,   -1,   11,   -1,   46,   14,   -1,
			   16,   17,   -1,   -1,   20,   -1,   22,   -1,   -1,   -1,
			   26,   -1,   28,   -1,   30,   31,   32,   -1,   34,   -1,
			   36,   -1,   38,   72,   73,   74,   42,   -1,   71,   -1,
			   46,   -1,   -1,   76,   77,   78,   -1,   80,   -1,   -1,
			   -1,   -1,   -1,   -1,   41,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   72,   73,   74,   -1,
			   -1,   -1,   -1,   -1,  107,  108,  109,  110,  111,  112,
			  113,  114,  115,  122,   71,  124,  125,   -1,   -1,   76,
			   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,   41, yyDummy>>,
			1, 200, 6400)
		end

	yycheck_template_34 (an_array: ARRAY [INTEGER])
			-- Fill chunk #34 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,  135,  136,  137,  138,  139,  140,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  122,   -1,  124,  125,
			  107,  108,  109,  110,  111,  112,  113,  114,  115,   71,
			   -1,   -1,   -1,   -1,   76,   77,   78,   -1,   80,   -1,
			   -1,   -1,   -1,   -1,   41,   -1,   -1,   -1,  135,  136,
			  137,  138,  139,  140,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  107,  108,  109,  110,  111,
			  112,  113,  114,  115,   71,   -1,   -1,   -1,   -1,   76,
			   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  135,  136,  137,  138,  139,  140,   45,

			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  107,  108,  109,  110,  111,  112,  113,  114,  115,   -1,
			   -1,   -1,   -1,   -1,   -1,   71,   -1,   -1,   -1,   -1,
			   76,   77,   78,   -1,   80,   -1,   -1,   -1,  135,  136,
			  137,  138,  139,  140,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,  107,  108,  109,  110,  111,  112,  113,  114,  115,
			   -1,   -1,   43,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  135,
			  136,  137,  138,  139,  140,   66,   67,   -1,   69,   -1, yyDummy>>,
			1, 200, 6600)
		end

	yycheck_template_35 (an_array: ARRAY [INTEGER])
			-- Fill chunk #35 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   -1,   -1,   -1,   75,   -1,   -1,   -1,   -1,   -1,
			   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
			   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
			  101,  102,  103,  104,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,  117,  118,   61,  120,
			   -1,   -1,   -1,   -1,   -1,   -1,   69,   -1,   -1,   -1,
			   -1,   -1,   75,   -1,  135,  136,   -1,   -1,   81,   82,
			   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
			   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
			  103,  104,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   -1,   71,   -1,   -1,  117,  118,   76,   77,   78,   -1,
			   80,   -1,   -1,   -1,   -1,  128,   -1,   -1,   -1,   -1,
			   -1,   -1,  135,  136,   -1,   -1,   -1,   -1,   -1,   -1,
			  143,   -1,   -1,   -1,   -1,   -1,   -1,  107,  108,  109,
			  110,  111,  112,  113,  114,  115,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   61,   -1,  135,  136,  137,  138,  139,
			  140,   69,   -1,   -1,   -1,   -1,   -1,   75,   -1,   -1,
			   -1,   -1,   -1,   81,   82,   83,   84,   85,   86,   87,
			   88,   89,   90,   91,   92,   93,   94,   95,   96,   97, yyDummy>>,
			1, 200, 6800)
		end

	yycheck_template_36 (an_array: ARRAY [INTEGER])
			-- Fill chunk #36 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   98,   99,  100,  101,  102,  103,  104,   71,   -1,   -1,
			   -1,   -1,   76,   77,   78,   -1,   80,   71,   -1,  117,
			  118,   -1,   76,   77,   78,   -1,   80,   -1,   -1,   -1,
			  128,   -1,   -1,   -1,   -1,   -1,   -1,  135,  136,   -1,
			   -1,   -1,   -1,  107,  108,  109,  110,  111,  112,  113,
			  114,  115,   -1,  107,  108,  109,  110,  111,  112,  113,
			  114,  115,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,  135,  136,  137,  138,  139,  140,  141,   -1,   -1,
			   -1,  135,  136,  137,  138,  139,  140,  141,   71,   -1,
			   -1,   -1,   -1,   76,   77,   78,   -1,   80,   -1,   81,

			   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
			   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
			  102,  103,   -1,   -1,  107,  108,  109,  110,  111,  112,
			  113,  114,  115,   -1,   -1,   -1,   -1,   -1,   -1,   71,
			   -1,   -1,  125,  126,   76,   77,   78,   -1,   80,   -1,
			   -1,   -1,  135,  136,  137,  138,  139,  140,   71,   -1,
			   -1,   -1,   -1,   76,   77,   78,   -1,   80,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  107,  108,  109,  110,  111,
			  112,  113,  114,  115,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,  123,   -1,  125,  107,  108,  109,  110,  111,  112, yyDummy>>,
			1, 200, 7000)
		end

	yycheck_template_37 (an_array: ARRAY [INTEGER])
			-- Fill chunk #37 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			  113,  114,  115,  135,  136,  137,  138,  139,  140,   71,
			   -1,   -1,  125,  126,   76,   77,   78,   -1,   80,   -1,
			   -1,   -1,  135,  136,  137,  138,  139,  140,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  107,  108,  109,  110,  111,
			  112,  113,  114,  115,   71,   -1,   -1,   -1,   -1,   76,
			   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,   -1,
			  132,   -1,   -1,  135,  136,  137,  138,  139,  140,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  107,  108,  109,  110,  111,  112,  113,  114,  115,   71,

			   -1,   -1,   -1,   -1,   76,   77,   78,   -1,   80,   -1,
			   -1,   -1,   -1,   -1,   -1,  132,   -1,   -1,  135,  136,
			  137,  138,  139,  140,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,  107,  108,  109,  110,  111,
			  112,  113,  114,  115,   71,   -1,   -1,   -1,   -1,   76,
			   77,   78,   -1,   80,   -1,   -1,   -1,   -1,   -1,   -1,
			  132,   -1,   -1,  135,  136,  137,  138,  139,  140,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			  107,  108,  109,  110,  111,  112,  113,  114,  115,   -1,
			   -1,   -1,   71,   -1,   -1,   -1,  123,   76,   77,   78, yyDummy>>,
			1, 200, 7200)
		end

	yycheck_template_38 (an_array: ARRAY [INTEGER])
			-- Fill chunk #38 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			   -1,   80,   -1,   -1,   -1,   -1,   -1,   -1,  135,  136,
			  137,  138,  139,  140,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  107,  108,
			  109,  110,  111,  112,  113,  114,  115,   71,   -1,   -1,
			   -1,   -1,   76,   77,   78,   -1,   71,   -1,   -1,   -1,
			   -1,   76,   -1,   -1,   -1,   -1,  135,  136,  137,  138,
			  139,  140,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,  107,  108,  109,  110,  111,  112,  113,
			  114,  115,  107,  108,  109,  110,  111,  112,  113,  114,
			  115,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,

			   -1,  135,  136,  137,  138,  139,  140,   -1,   -1,   -1,
			  135,  136,  137,  138,  139,  140,   69,   -1,   -1,   -1,
			   -1,   -1,   75,   -1,   -1,   -1,   -1,   -1,   81,   82,
			   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
			   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
			  103,  104,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,  117,  118,   -1,   -1,   -1,   -1,
			   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
			   -1,   -1,  135,  136, 1238, 1239, 1240, 1241, 1242, 1243,
			 1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253, yyDummy>>,
			1, 200, 7400)
		end

	yycheck_template_39 (an_array: ARRAY [INTEGER])
			-- Fill chunk #39 of template for `yycheck'.
		do
			yyarray_subcopy (an_array, <<
			 1254, 1255, 1256, 1257, 1258, 1259, yyDummy>>,
			1, 6, 7600)
		end

feature {NONE} -- Semantic value stacks

	yyvs1: SPECIAL [detachable ANY]
			-- Stack for semantic values of type detachable ANY

	yyvsc1: INTEGER
			-- Capacity of semantic value stack `yyvs1'

	yyvsp1: INTEGER
			-- Top of semantic value stack `yyvs1'

	yyspecial_routines1: KL_SPECIAL_ROUTINES [detachable ANY]
			-- Routines that ought to be in SPECIAL [detachable ANY]

	yyvs2: SPECIAL [detachable ET_KEYWORD]
			-- Stack for semantic values of type detachable ET_KEYWORD

	yyvsc2: INTEGER
			-- Capacity of semantic value stack `yyvs2'

	yyvsp2: INTEGER
			-- Top of semantic value stack `yyvs2'

	yyspecial_routines2: KL_SPECIAL_ROUTINES [detachable ET_KEYWORD]
			-- Routines that ought to be in SPECIAL [detachable ET_KEYWORD]

	yyvs3: SPECIAL [detachable ET_AGENT_KEYWORD]
			-- Stack for semantic values of type detachable ET_AGENT_KEYWORD

	yyvsc3: INTEGER
			-- Capacity of semantic value stack `yyvs3'

	yyvsp3: INTEGER
			-- Top of semantic value stack `yyvs3'

	yyspecial_routines3: KL_SPECIAL_ROUTINES [detachable ET_AGENT_KEYWORD]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_KEYWORD]

	yyvs4: SPECIAL [detachable ET_PRECURSOR_KEYWORD]
			-- Stack for semantic values of type detachable ET_PRECURSOR_KEYWORD

	yyvsc4: INTEGER
			-- Capacity of semantic value stack `yyvs4'

	yyvsp4: INTEGER
			-- Top of semantic value stack `yyvs4'

	yyspecial_routines4: KL_SPECIAL_ROUTINES [detachable ET_PRECURSOR_KEYWORD]
			-- Routines that ought to be in SPECIAL [detachable ET_PRECURSOR_KEYWORD]

	yyvs5: SPECIAL [detachable ET_SYMBOL]
			-- Stack for semantic values of type detachable ET_SYMBOL

	yyvsc5: INTEGER
			-- Capacity of semantic value stack `yyvs5'

	yyvsp5: INTEGER
			-- Top of semantic value stack `yyvs5'

	yyspecial_routines5: KL_SPECIAL_ROUTINES [detachable ET_SYMBOL]
			-- Routines that ought to be in SPECIAL [detachable ET_SYMBOL]

	yyvs6: SPECIAL [detachable ET_POSITION]
			-- Stack for semantic values of type detachable ET_POSITION

	yyvsc6: INTEGER
			-- Capacity of semantic value stack `yyvs6'

	yyvsp6: INTEGER
			-- Top of semantic value stack `yyvs6'

	yyspecial_routines6: KL_SPECIAL_ROUTINES [detachable ET_POSITION]
			-- Routines that ought to be in SPECIAL [detachable ET_POSITION]

	yyvs7: SPECIAL [detachable ET_BOOLEAN_CONSTANT]
			-- Stack for semantic values of type detachable ET_BOOLEAN_CONSTANT

	yyvsc7: INTEGER
			-- Capacity of semantic value stack `yyvs7'

	yyvsp7: INTEGER
			-- Top of semantic value stack `yyvs7'

	yyspecial_routines7: KL_SPECIAL_ROUTINES [detachable ET_BOOLEAN_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_BOOLEAN_CONSTANT]

	yyvs8: SPECIAL [detachable ET_BREAK]
			-- Stack for semantic values of type detachable ET_BREAK

	yyvsc8: INTEGER
			-- Capacity of semantic value stack `yyvs8'

	yyvsp8: INTEGER
			-- Top of semantic value stack `yyvs8'

	yyspecial_routines8: KL_SPECIAL_ROUTINES [detachable ET_BREAK]
			-- Routines that ought to be in SPECIAL [detachable ET_BREAK]

	yyvs9: SPECIAL [detachable ET_CHARACTER_CONSTANT]
			-- Stack for semantic values of type detachable ET_CHARACTER_CONSTANT

	yyvsc9: INTEGER
			-- Capacity of semantic value stack `yyvs9'

	yyvsp9: INTEGER
			-- Top of semantic value stack `yyvs9'

	yyspecial_routines9: KL_SPECIAL_ROUTINES [detachable ET_CHARACTER_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_CHARACTER_CONSTANT]

	yyvs10: SPECIAL [detachable ET_CURRENT]
			-- Stack for semantic values of type detachable ET_CURRENT

	yyvsc10: INTEGER
			-- Capacity of semantic value stack `yyvs10'

	yyvsp10: INTEGER
			-- Top of semantic value stack `yyvs10'

	yyspecial_routines10: KL_SPECIAL_ROUTINES [detachable ET_CURRENT]
			-- Routines that ought to be in SPECIAL [detachable ET_CURRENT]

	yyvs11: SPECIAL [detachable ET_FREE_OPERATOR]
			-- Stack for semantic values of type detachable ET_FREE_OPERATOR

	yyvsc11: INTEGER
			-- Capacity of semantic value stack `yyvs11'

	yyvsp11: INTEGER
			-- Top of semantic value stack `yyvs11'

	yyspecial_routines11: KL_SPECIAL_ROUTINES [detachable ET_FREE_OPERATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_FREE_OPERATOR]

	yyvs12: SPECIAL [detachable ET_IDENTIFIER]
			-- Stack for semantic values of type detachable ET_IDENTIFIER

	yyvsc12: INTEGER
			-- Capacity of semantic value stack `yyvs12'

	yyvsp12: INTEGER
			-- Top of semantic value stack `yyvs12'

	yyspecial_routines12: KL_SPECIAL_ROUTINES [detachable ET_IDENTIFIER]
			-- Routines that ought to be in SPECIAL [detachable ET_IDENTIFIER]

	yyvs13: SPECIAL [detachable ET_INTEGER_CONSTANT]
			-- Stack for semantic values of type detachable ET_INTEGER_CONSTANT

	yyvsc13: INTEGER
			-- Capacity of semantic value stack `yyvs13'

	yyvsp13: INTEGER
			-- Top of semantic value stack `yyvs13'

	yyspecial_routines13: KL_SPECIAL_ROUTINES [detachable ET_INTEGER_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_INTEGER_CONSTANT]

	yyvs14: SPECIAL [detachable ET_KEYWORD_OPERATOR]
			-- Stack for semantic values of type detachable ET_KEYWORD_OPERATOR

	yyvsc14: INTEGER
			-- Capacity of semantic value stack `yyvs14'

	yyvsp14: INTEGER
			-- Top of semantic value stack `yyvs14'

	yyspecial_routines14: KL_SPECIAL_ROUTINES [detachable ET_KEYWORD_OPERATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_KEYWORD_OPERATOR]

	yyvs15: SPECIAL [detachable ET_MANIFEST_STRING]
			-- Stack for semantic values of type detachable ET_MANIFEST_STRING

	yyvsc15: INTEGER
			-- Capacity of semantic value stack `yyvs15'

	yyvsp15: INTEGER
			-- Top of semantic value stack `yyvs15'

	yyspecial_routines15: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_STRING]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_STRING]

	yyvs16: SPECIAL [detachable ET_REAL_CONSTANT]
			-- Stack for semantic values of type detachable ET_REAL_CONSTANT

	yyvsc16: INTEGER
			-- Capacity of semantic value stack `yyvs16'

	yyvsp16: INTEGER
			-- Top of semantic value stack `yyvs16'

	yyspecial_routines16: KL_SPECIAL_ROUTINES [detachable ET_REAL_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_REAL_CONSTANT]

	yyvs17: SPECIAL [detachable ET_RESULT]
			-- Stack for semantic values of type detachable ET_RESULT

	yyvsc17: INTEGER
			-- Capacity of semantic value stack `yyvs17'

	yyvsp17: INTEGER
			-- Top of semantic value stack `yyvs17'

	yyspecial_routines17: KL_SPECIAL_ROUTINES [detachable ET_RESULT]
			-- Routines that ought to be in SPECIAL [detachable ET_RESULT]

	yyvs18: SPECIAL [detachable ET_RETRY_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_RETRY_INSTRUCTION

	yyvsc18: INTEGER
			-- Capacity of semantic value stack `yyvs18'

	yyvsp18: INTEGER
			-- Top of semantic value stack `yyvs18'

	yyspecial_routines18: KL_SPECIAL_ROUTINES [detachable ET_RETRY_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_RETRY_INSTRUCTION]

	yyvs19: SPECIAL [detachable ET_SYMBOL_OPERATOR]
			-- Stack for semantic values of type detachable ET_SYMBOL_OPERATOR

	yyvsc19: INTEGER
			-- Capacity of semantic value stack `yyvs19'

	yyvsp19: INTEGER
			-- Top of semantic value stack `yyvs19'

	yyspecial_routines19: KL_SPECIAL_ROUTINES [detachable ET_SYMBOL_OPERATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_SYMBOL_OPERATOR]

	yyvs20: SPECIAL [detachable ET_VOID]
			-- Stack for semantic values of type detachable ET_VOID

	yyvsc20: INTEGER
			-- Capacity of semantic value stack `yyvs20'

	yyvsp20: INTEGER
			-- Top of semantic value stack `yyvs20'

	yyspecial_routines20: KL_SPECIAL_ROUTINES [detachable ET_VOID]
			-- Routines that ought to be in SPECIAL [detachable ET_VOID]

	yyvs21: SPECIAL [detachable ET_SEMICOLON_SYMBOL]
			-- Stack for semantic values of type detachable ET_SEMICOLON_SYMBOL

	yyvsc21: INTEGER
			-- Capacity of semantic value stack `yyvs21'

	yyvsp21: INTEGER
			-- Top of semantic value stack `yyvs21'

	yyspecial_routines21: KL_SPECIAL_ROUTINES [detachable ET_SEMICOLON_SYMBOL]
			-- Routines that ought to be in SPECIAL [detachable ET_SEMICOLON_SYMBOL]

	yyvs22: SPECIAL [detachable ET_BRACKET_SYMBOL]
			-- Stack for semantic values of type detachable ET_BRACKET_SYMBOL

	yyvsc22: INTEGER
			-- Capacity of semantic value stack `yyvs22'

	yyvsp22: INTEGER
			-- Top of semantic value stack `yyvs22'

	yyspecial_routines22: KL_SPECIAL_ROUTINES [detachable ET_BRACKET_SYMBOL]
			-- Routines that ought to be in SPECIAL [detachable ET_BRACKET_SYMBOL]

	yyvs23: SPECIAL [detachable ET_QUESTION_MARK_SYMBOL]
			-- Stack for semantic values of type detachable ET_QUESTION_MARK_SYMBOL

	yyvsc23: INTEGER
			-- Capacity of semantic value stack `yyvs23'

	yyvsp23: INTEGER
			-- Top of semantic value stack `yyvs23'

	yyspecial_routines23: KL_SPECIAL_ROUTINES [detachable ET_QUESTION_MARK_SYMBOL]
			-- Routines that ought to be in SPECIAL [detachable ET_QUESTION_MARK_SYMBOL]

	yyvs24: SPECIAL [detachable ET_ACROSS_EXPRESSION]
			-- Stack for semantic values of type detachable ET_ACROSS_EXPRESSION

	yyvsc24: INTEGER
			-- Capacity of semantic value stack `yyvs24'

	yyvsp24: INTEGER
			-- Top of semantic value stack `yyvs24'

	yyspecial_routines24: KL_SPECIAL_ROUTINES [detachable ET_ACROSS_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_ACROSS_EXPRESSION]

	yyvs25: SPECIAL [detachable ET_ACROSS_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_ACROSS_INSTRUCTION

	yyvsc25: INTEGER
			-- Capacity of semantic value stack `yyvs25'

	yyvsp25: INTEGER
			-- Top of semantic value stack `yyvs25'

	yyspecial_routines25: KL_SPECIAL_ROUTINES [detachable ET_ACROSS_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_ACROSS_INSTRUCTION]

	yyvs26: SPECIAL [detachable ET_ACTUAL_ARGUMENT_LIST]
			-- Stack for semantic values of type detachable ET_ACTUAL_ARGUMENT_LIST

	yyvsc26: INTEGER
			-- Capacity of semantic value stack `yyvs26'

	yyvsp26: INTEGER
			-- Top of semantic value stack `yyvs26'

	yyspecial_routines26: KL_SPECIAL_ROUTINES [detachable ET_ACTUAL_ARGUMENT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ACTUAL_ARGUMENT_LIST]

	yyvs27: SPECIAL [detachable ET_ACTUAL_PARAMETER_ITEM]
			-- Stack for semantic values of type detachable ET_ACTUAL_PARAMETER_ITEM

	yyvsc27: INTEGER
			-- Capacity of semantic value stack `yyvs27'

	yyvsp27: INTEGER
			-- Top of semantic value stack `yyvs27'

	yyspecial_routines27: KL_SPECIAL_ROUTINES [detachable ET_ACTUAL_PARAMETER_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_ACTUAL_PARAMETER_ITEM]

	yyvs28: SPECIAL [detachable ET_ACTUAL_PARAMETER_LIST]
			-- Stack for semantic values of type detachable ET_ACTUAL_PARAMETER_LIST

	yyvsc28: INTEGER
			-- Capacity of semantic value stack `yyvs28'

	yyvsp28: INTEGER
			-- Top of semantic value stack `yyvs28'

	yyspecial_routines28: KL_SPECIAL_ROUTINES [detachable ET_ACTUAL_PARAMETER_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ACTUAL_PARAMETER_LIST]

	yyvs29: SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND]
			-- Stack for semantic values of type detachable ET_AGENT_ARGUMENT_OPERAND

	yyvsc29: INTEGER
			-- Capacity of semantic value stack `yyvs29'

	yyvsp29: INTEGER
			-- Top of semantic value stack `yyvs29'

	yyspecial_routines29: KL_SPECIAL_ROUTINES [detachable ET_AGENT_ARGUMENT_OPERAND]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND]

	yyvs30: SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND_ITEM]
			-- Stack for semantic values of type detachable ET_AGENT_ARGUMENT_OPERAND_ITEM

	yyvsc30: INTEGER
			-- Capacity of semantic value stack `yyvs30'

	yyvsp30: INTEGER
			-- Top of semantic value stack `yyvs30'

	yyspecial_routines30: KL_SPECIAL_ROUTINES [detachable ET_AGENT_ARGUMENT_OPERAND_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND_ITEM]

	yyvs31: SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND_LIST]
			-- Stack for semantic values of type detachable ET_AGENT_ARGUMENT_OPERAND_LIST

	yyvsc31: INTEGER
			-- Capacity of semantic value stack `yyvs31'

	yyvsp31: INTEGER
			-- Top of semantic value stack `yyvs31'

	yyspecial_routines31: KL_SPECIAL_ROUTINES [detachable ET_AGENT_ARGUMENT_OPERAND_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_ARGUMENT_OPERAND_LIST]

	yyvs32: SPECIAL [detachable ET_AGENT_TARGET]
			-- Stack for semantic values of type detachable ET_AGENT_TARGET

	yyvsc32: INTEGER
			-- Capacity of semantic value stack `yyvs32'

	yyvsp32: INTEGER
			-- Top of semantic value stack `yyvs32'

	yyspecial_routines32: KL_SPECIAL_ROUTINES [detachable ET_AGENT_TARGET]
			-- Routines that ought to be in SPECIAL [detachable ET_AGENT_TARGET]

	yyvs33: SPECIAL [detachable ET_ALIAS_NAME]
			-- Stack for semantic values of type detachable ET_ALIAS_NAME

	yyvsc33: INTEGER
			-- Capacity of semantic value stack `yyvs33'

	yyvsp33: INTEGER
			-- Top of semantic value stack `yyvs33'

	yyspecial_routines33: KL_SPECIAL_ROUTINES [detachable ET_ALIAS_NAME]
			-- Routines that ought to be in SPECIAL [detachable ET_ALIAS_NAME]

	yyvs34: SPECIAL [detachable ET_ALIAS_NAME_LIST]
			-- Stack for semantic values of type detachable ET_ALIAS_NAME_LIST

	yyvsc34: INTEGER
			-- Capacity of semantic value stack `yyvs34'

	yyvsp34: INTEGER
			-- Top of semantic value stack `yyvs34'

	yyspecial_routines34: KL_SPECIAL_ROUTINES [detachable ET_ALIAS_NAME_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ALIAS_NAME_LIST]

	yyvs35: SPECIAL [detachable ET_ASSIGNER]
			-- Stack for semantic values of type detachable ET_ASSIGNER

	yyvsc35: INTEGER
			-- Capacity of semantic value stack `yyvs35'

	yyvsp35: INTEGER
			-- Top of semantic value stack `yyvs35'

	yyspecial_routines35: KL_SPECIAL_ROUTINES [detachable ET_ASSIGNER]
			-- Routines that ought to be in SPECIAL [detachable ET_ASSIGNER]

	yyvs36: SPECIAL [detachable ET_BRACKET_EXPRESSION]
			-- Stack for semantic values of type detachable ET_BRACKET_EXPRESSION

	yyvsc36: INTEGER
			-- Capacity of semantic value stack `yyvs36'

	yyvsp36: INTEGER
			-- Top of semantic value stack `yyvs36'

	yyspecial_routines36: KL_SPECIAL_ROUTINES [detachable ET_BRACKET_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_BRACKET_EXPRESSION]

	yyvs37: SPECIAL [detachable ET_CALL_AGENT]
			-- Stack for semantic values of type detachable ET_CALL_AGENT

	yyvsc37: INTEGER
			-- Capacity of semantic value stack `yyvs37'

	yyvsp37: INTEGER
			-- Top of semantic value stack `yyvs37'

	yyspecial_routines37: KL_SPECIAL_ROUTINES [detachable ET_CALL_AGENT]
			-- Routines that ought to be in SPECIAL [detachable ET_CALL_AGENT]

	yyvs38: SPECIAL [detachable ET_QUALIFIED_CALL_EXPRESSION]
			-- Stack for semantic values of type detachable ET_QUALIFIED_CALL_EXPRESSION

	yyvsc38: INTEGER
			-- Capacity of semantic value stack `yyvs38'

	yyvsp38: INTEGER
			-- Top of semantic value stack `yyvs38'

	yyspecial_routines38: KL_SPECIAL_ROUTINES [detachable ET_QUALIFIED_CALL_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_QUALIFIED_CALL_EXPRESSION]

	yyvs39: SPECIAL [detachable ET_CHECK_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_CHECK_INSTRUCTION

	yyvsc39: INTEGER
			-- Capacity of semantic value stack `yyvs39'

	yyvsp39: INTEGER
			-- Top of semantic value stack `yyvs39'

	yyspecial_routines39: KL_SPECIAL_ROUTINES [detachable ET_CHECK_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_CHECK_INSTRUCTION]

	yyvs40: SPECIAL [detachable ET_CHOICE]
			-- Stack for semantic values of type detachable ET_CHOICE

	yyvsc40: INTEGER
			-- Capacity of semantic value stack `yyvs40'

	yyvsp40: INTEGER
			-- Top of semantic value stack `yyvs40'

	yyspecial_routines40: KL_SPECIAL_ROUTINES [detachable ET_CHOICE]
			-- Routines that ought to be in SPECIAL [detachable ET_CHOICE]

	yyvs41: SPECIAL [detachable ET_CHOICE_CONSTANT]
			-- Stack for semantic values of type detachable ET_CHOICE_CONSTANT

	yyvsc41: INTEGER
			-- Capacity of semantic value stack `yyvs41'

	yyvsp41: INTEGER
			-- Top of semantic value stack `yyvs41'

	yyspecial_routines41: KL_SPECIAL_ROUTINES [detachable ET_CHOICE_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_CHOICE_CONSTANT]

	yyvs42: SPECIAL [detachable ET_CHOICE_ITEM]
			-- Stack for semantic values of type detachable ET_CHOICE_ITEM

	yyvsc42: INTEGER
			-- Capacity of semantic value stack `yyvs42'

	yyvsp42: INTEGER
			-- Top of semantic value stack `yyvs42'

	yyspecial_routines42: KL_SPECIAL_ROUTINES [detachable ET_CHOICE_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_CHOICE_ITEM]

	yyvs43: SPECIAL [detachable ET_CHOICE_LIST]
			-- Stack for semantic values of type detachable ET_CHOICE_LIST

	yyvsc43: INTEGER
			-- Capacity of semantic value stack `yyvs43'

	yyvsp43: INTEGER
			-- Top of semantic value stack `yyvs43'

	yyspecial_routines43: KL_SPECIAL_ROUTINES [detachable ET_CHOICE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CHOICE_LIST]

	yyvs44: SPECIAL [detachable ET_CLASS]
			-- Stack for semantic values of type detachable ET_CLASS

	yyvsc44: INTEGER
			-- Capacity of semantic value stack `yyvs44'

	yyvsp44: INTEGER
			-- Top of semantic value stack `yyvs44'

	yyspecial_routines44: KL_SPECIAL_ROUTINES [detachable ET_CLASS]
			-- Routines that ought to be in SPECIAL [detachable ET_CLASS]

	yyvs45: SPECIAL [detachable ET_CLIENT_ITEM]
			-- Stack for semantic values of type detachable ET_CLIENT_ITEM

	yyvsc45: INTEGER
			-- Capacity of semantic value stack `yyvs45'

	yyvsp45: INTEGER
			-- Top of semantic value stack `yyvs45'

	yyspecial_routines45: KL_SPECIAL_ROUTINES [detachable ET_CLIENT_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_CLIENT_ITEM]

	yyvs46: SPECIAL [detachable ET_CLIENTS]
			-- Stack for semantic values of type detachable ET_CLIENTS

	yyvsc46: INTEGER
			-- Capacity of semantic value stack `yyvs46'

	yyvsp46: INTEGER
			-- Top of semantic value stack `yyvs46'

	yyspecial_routines46: KL_SPECIAL_ROUTINES [detachable ET_CLIENTS]
			-- Routines that ought to be in SPECIAL [detachable ET_CLIENTS]

	yyvs47: SPECIAL [detachable ET_COMPOUND]
			-- Stack for semantic values of type detachable ET_COMPOUND

	yyvsc47: INTEGER
			-- Capacity of semantic value stack `yyvs47'

	yyvsp47: INTEGER
			-- Top of semantic value stack `yyvs47'

	yyspecial_routines47: KL_SPECIAL_ROUTINES [detachable ET_COMPOUND]
			-- Routines that ought to be in SPECIAL [detachable ET_COMPOUND]

	yyvs48: SPECIAL [detachable ET_CONDITIONAL]
			-- Stack for semantic values of type detachable ET_CONDITIONAL

	yyvsc48: INTEGER
			-- Capacity of semantic value stack `yyvs48'

	yyvsp48: INTEGER
			-- Top of semantic value stack `yyvs48'

	yyspecial_routines48: KL_SPECIAL_ROUTINES [detachable ET_CONDITIONAL]
			-- Routines that ought to be in SPECIAL [detachable ET_CONDITIONAL]

	yyvs49: SPECIAL [detachable ET_CONSTANT]
			-- Stack for semantic values of type detachable ET_CONSTANT

	yyvsc49: INTEGER
			-- Capacity of semantic value stack `yyvs49'

	yyvsp49: INTEGER
			-- Top of semantic value stack `yyvs49'

	yyspecial_routines49: KL_SPECIAL_ROUTINES [detachable ET_CONSTANT]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTANT]

	yyvs50: SPECIAL [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM

	yyvsc50: INTEGER
			-- Capacity of semantic value stack `yyvs50'

	yyvsp50: INTEGER
			-- Top of semantic value stack `yyvs50'

	yyspecial_routines50: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_ITEM]

	yyvs51: SPECIAL [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST

	yyvsc51: INTEGER
			-- Capacity of semantic value stack `yyvs51'

	yyvsp51: INTEGER
			-- Top of semantic value stack `yyvs51'

	yyspecial_routines51: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_ACTUAL_PARAMETER_LIST]

	yyvs52: SPECIAL [detachable ET_CONSTRAINT_CREATOR]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_CREATOR

	yyvsc52: INTEGER
			-- Capacity of semantic value stack `yyvs52'

	yyvsp52: INTEGER
			-- Top of semantic value stack `yyvs52'

	yyspecial_routines52: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_CREATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_CREATOR]

	yyvs53: SPECIAL [detachable ET_CONSTRAINT_RENAME_LIST]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_RENAME_LIST

	yyvsc53: INTEGER
			-- Capacity of semantic value stack `yyvs53'

	yyvsp53: INTEGER
			-- Top of semantic value stack `yyvs53'

	yyspecial_routines53: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_RENAME_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_RENAME_LIST]

	yyvs54: SPECIAL [detachable ET_CONSTRAINT_TYPE]
			-- Stack for semantic values of type detachable ET_CONSTRAINT_TYPE

	yyvsc54: INTEGER
			-- Capacity of semantic value stack `yyvs54'

	yyvsp54: INTEGER
			-- Top of semantic value stack `yyvs54'

	yyspecial_routines54: KL_SPECIAL_ROUTINES [detachable ET_CONSTRAINT_TYPE]
			-- Routines that ought to be in SPECIAL [detachable ET_CONSTRAINT_TYPE]

	yyvs55: SPECIAL [detachable ET_CONVERT_FEATURE]
			-- Stack for semantic values of type detachable ET_CONVERT_FEATURE

	yyvsc55: INTEGER
			-- Capacity of semantic value stack `yyvs55'

	yyvsp55: INTEGER
			-- Top of semantic value stack `yyvs55'

	yyspecial_routines55: KL_SPECIAL_ROUTINES [detachable ET_CONVERT_FEATURE]
			-- Routines that ought to be in SPECIAL [detachable ET_CONVERT_FEATURE]

	yyvs56: SPECIAL [detachable ET_CONVERT_FEATURE_ITEM]
			-- Stack for semantic values of type detachable ET_CONVERT_FEATURE_ITEM

	yyvsc56: INTEGER
			-- Capacity of semantic value stack `yyvs56'

	yyvsp56: INTEGER
			-- Top of semantic value stack `yyvs56'

	yyspecial_routines56: KL_SPECIAL_ROUTINES [detachable ET_CONVERT_FEATURE_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_CONVERT_FEATURE_ITEM]

	yyvs57: SPECIAL [detachable ET_CONVERT_FEATURE_LIST]
			-- Stack for semantic values of type detachable ET_CONVERT_FEATURE_LIST

	yyvsc57: INTEGER
			-- Capacity of semantic value stack `yyvs57'

	yyvsp57: INTEGER
			-- Top of semantic value stack `yyvs57'

	yyspecial_routines57: KL_SPECIAL_ROUTINES [detachable ET_CONVERT_FEATURE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CONVERT_FEATURE_LIST]

	yyvs58: SPECIAL [detachable ET_CREATE_EXPRESSION]
			-- Stack for semantic values of type detachable ET_CREATE_EXPRESSION

	yyvsc58: INTEGER
			-- Capacity of semantic value stack `yyvs58'

	yyvsp58: INTEGER
			-- Top of semantic value stack `yyvs58'

	yyspecial_routines58: KL_SPECIAL_ROUTINES [detachable ET_CREATE_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_CREATE_EXPRESSION]

	yyvs59: SPECIAL [detachable ET_CREATION_REGION]
			-- Stack for semantic values of type detachable ET_CREATION_REGION

	yyvsc59: INTEGER
			-- Capacity of semantic value stack `yyvs59'

	yyvsp59: INTEGER
			-- Top of semantic value stack `yyvs59'

	yyspecial_routines59: KL_SPECIAL_ROUTINES [detachable ET_CREATION_REGION]
			-- Routines that ought to be in SPECIAL [detachable ET_CREATION_REGION]

	yyvs60: SPECIAL [detachable ET_CREATOR]
			-- Stack for semantic values of type detachable ET_CREATOR

	yyvsc60: INTEGER
			-- Capacity of semantic value stack `yyvs60'

	yyvsp60: INTEGER
			-- Top of semantic value stack `yyvs60'

	yyspecial_routines60: KL_SPECIAL_ROUTINES [detachable ET_CREATOR]
			-- Routines that ought to be in SPECIAL [detachable ET_CREATOR]

	yyvs61: SPECIAL [detachable ET_CREATOR_LIST]
			-- Stack for semantic values of type detachable ET_CREATOR_LIST

	yyvsc61: INTEGER
			-- Capacity of semantic value stack `yyvs61'

	yyvsp61: INTEGER
			-- Top of semantic value stack `yyvs61'

	yyspecial_routines61: KL_SPECIAL_ROUTINES [detachable ET_CREATOR_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_CREATOR_LIST]

	yyvs62: SPECIAL [detachable ET_DEBUG_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_DEBUG_INSTRUCTION

	yyvsc62: INTEGER
			-- Capacity of semantic value stack `yyvs62'

	yyvsp62: INTEGER
			-- Top of semantic value stack `yyvs62'

	yyspecial_routines62: KL_SPECIAL_ROUTINES [detachable ET_DEBUG_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_DEBUG_INSTRUCTION]

	yyvs63: SPECIAL [detachable ET_ELSEIF_EXPRESSION]
			-- Stack for semantic values of type detachable ET_ELSEIF_EXPRESSION

	yyvsc63: INTEGER
			-- Capacity of semantic value stack `yyvs63'

	yyvsp63: INTEGER
			-- Top of semantic value stack `yyvs63'

	yyspecial_routines63: KL_SPECIAL_ROUTINES [detachable ET_ELSEIF_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_ELSEIF_EXPRESSION]

	yyvs64: SPECIAL [detachable ET_ELSEIF_EXPRESSION_LIST]
			-- Stack for semantic values of type detachable ET_ELSEIF_EXPRESSION_LIST

	yyvsc64: INTEGER
			-- Capacity of semantic value stack `yyvs64'

	yyvsp64: INTEGER
			-- Top of semantic value stack `yyvs64'

	yyspecial_routines64: KL_SPECIAL_ROUTINES [detachable ET_ELSEIF_EXPRESSION_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ELSEIF_EXPRESSION_LIST]

	yyvs65: SPECIAL [detachable ET_ELSEIF_PART]
			-- Stack for semantic values of type detachable ET_ELSEIF_PART

	yyvsc65: INTEGER
			-- Capacity of semantic value stack `yyvs65'

	yyvsp65: INTEGER
			-- Top of semantic value stack `yyvs65'

	yyspecial_routines65: KL_SPECIAL_ROUTINES [detachable ET_ELSEIF_PART]
			-- Routines that ought to be in SPECIAL [detachable ET_ELSEIF_PART]

	yyvs66: SPECIAL [detachable ET_ELSEIF_PART_LIST]
			-- Stack for semantic values of type detachable ET_ELSEIF_PART_LIST

	yyvsc66: INTEGER
			-- Capacity of semantic value stack `yyvs66'

	yyvsp66: INTEGER
			-- Top of semantic value stack `yyvs66'

	yyspecial_routines66: KL_SPECIAL_ROUTINES [detachable ET_ELSEIF_PART_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_ELSEIF_PART_LIST]

	yyvs67: SPECIAL [detachable ET_EXPORT]
			-- Stack for semantic values of type detachable ET_EXPORT

	yyvsc67: INTEGER
			-- Capacity of semantic value stack `yyvs67'

	yyvsp67: INTEGER
			-- Top of semantic value stack `yyvs67'

	yyspecial_routines67: KL_SPECIAL_ROUTINES [detachable ET_EXPORT]
			-- Routines that ought to be in SPECIAL [detachable ET_EXPORT]

	yyvs68: SPECIAL [detachable ET_EXPORT_LIST]
			-- Stack for semantic values of type detachable ET_EXPORT_LIST

	yyvsc68: INTEGER
			-- Capacity of semantic value stack `yyvs68'

	yyvsp68: INTEGER
			-- Top of semantic value stack `yyvs68'

	yyspecial_routines68: KL_SPECIAL_ROUTINES [detachable ET_EXPORT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_EXPORT_LIST]

	yyvs69: SPECIAL [detachable ET_EXPRESSION]
			-- Stack for semantic values of type detachable ET_EXPRESSION

	yyvsc69: INTEGER
			-- Capacity of semantic value stack `yyvs69'

	yyvsp69: INTEGER
			-- Top of semantic value stack `yyvs69'

	yyspecial_routines69: KL_SPECIAL_ROUTINES [detachable ET_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_EXPRESSION]

	yyvs70: SPECIAL [detachable ET_EXPRESSION_ITEM]
			-- Stack for semantic values of type detachable ET_EXPRESSION_ITEM

	yyvsc70: INTEGER
			-- Capacity of semantic value stack `yyvs70'

	yyvsp70: INTEGER
			-- Top of semantic value stack `yyvs70'

	yyspecial_routines70: KL_SPECIAL_ROUTINES [detachable ET_EXPRESSION_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_EXPRESSION_ITEM]

	yyvs71: SPECIAL [detachable ET_EXTENDED_FEATURE_NAME]
			-- Stack for semantic values of type detachable ET_EXTENDED_FEATURE_NAME

	yyvsc71: INTEGER
			-- Capacity of semantic value stack `yyvs71'

	yyvsp71: INTEGER
			-- Top of semantic value stack `yyvs71'

	yyspecial_routines71: KL_SPECIAL_ROUTINES [detachable ET_EXTENDED_FEATURE_NAME]
			-- Routines that ought to be in SPECIAL [detachable ET_EXTENDED_FEATURE_NAME]

	yyvs72: SPECIAL [detachable ET_EXTERNAL_ALIAS]
			-- Stack for semantic values of type detachable ET_EXTERNAL_ALIAS

	yyvsc72: INTEGER
			-- Capacity of semantic value stack `yyvs72'

	yyvsp72: INTEGER
			-- Top of semantic value stack `yyvs72'

	yyspecial_routines72: KL_SPECIAL_ROUTINES [detachable ET_EXTERNAL_ALIAS]
			-- Routines that ought to be in SPECIAL [detachable ET_EXTERNAL_ALIAS]

	yyvs73: SPECIAL [detachable ET_FEATURE_CLAUSE]
			-- Stack for semantic values of type detachable ET_FEATURE_CLAUSE

	yyvsc73: INTEGER
			-- Capacity of semantic value stack `yyvs73'

	yyvsp73: INTEGER
			-- Top of semantic value stack `yyvs73'

	yyspecial_routines73: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_CLAUSE]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_CLAUSE]

	yyvs74: SPECIAL [detachable ET_FEATURE_CLAUSE_LIST]
			-- Stack for semantic values of type detachable ET_FEATURE_CLAUSE_LIST

	yyvsc74: INTEGER
			-- Capacity of semantic value stack `yyvs74'

	yyvsp74: INTEGER
			-- Top of semantic value stack `yyvs74'

	yyspecial_routines74: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_CLAUSE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_CLAUSE_LIST]

	yyvs75: SPECIAL [detachable ET_FEATURE_EXPORT]
			-- Stack for semantic values of type detachable ET_FEATURE_EXPORT

	yyvsc75: INTEGER
			-- Capacity of semantic value stack `yyvs75'

	yyvsp75: INTEGER
			-- Top of semantic value stack `yyvs75'

	yyspecial_routines75: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_EXPORT]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_EXPORT]

	yyvs76: SPECIAL [detachable ET_FEATURE_NAME]
			-- Stack for semantic values of type detachable ET_FEATURE_NAME

	yyvsc76: INTEGER
			-- Capacity of semantic value stack `yyvs76'

	yyvsp76: INTEGER
			-- Top of semantic value stack `yyvs76'

	yyspecial_routines76: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_NAME]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_NAME]

	yyvs77: SPECIAL [detachable ET_FEATURE_NAME_ITEM]
			-- Stack for semantic values of type detachable ET_FEATURE_NAME_ITEM

	yyvsc77: INTEGER
			-- Capacity of semantic value stack `yyvs77'

	yyvsp77: INTEGER
			-- Top of semantic value stack `yyvs77'

	yyspecial_routines77: KL_SPECIAL_ROUTINES [detachable ET_FEATURE_NAME_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_FEATURE_NAME_ITEM]

	yyvs78: SPECIAL [detachable ET_FORMAL_ARGUMENT]
			-- Stack for semantic values of type detachable ET_FORMAL_ARGUMENT

	yyvsc78: INTEGER
			-- Capacity of semantic value stack `yyvs78'

	yyvsp78: INTEGER
			-- Top of semantic value stack `yyvs78'

	yyspecial_routines78: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_ARGUMENT]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_ARGUMENT]

	yyvs79: SPECIAL [detachable ET_FORMAL_ARGUMENT_ITEM]
			-- Stack for semantic values of type detachable ET_FORMAL_ARGUMENT_ITEM

	yyvsc79: INTEGER
			-- Capacity of semantic value stack `yyvs79'

	yyvsp79: INTEGER
			-- Top of semantic value stack `yyvs79'

	yyspecial_routines79: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_ARGUMENT_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_ARGUMENT_ITEM]

	yyvs80: SPECIAL [detachable ET_FORMAL_ARGUMENT_LIST]
			-- Stack for semantic values of type detachable ET_FORMAL_ARGUMENT_LIST

	yyvsc80: INTEGER
			-- Capacity of semantic value stack `yyvs80'

	yyvsp80: INTEGER
			-- Top of semantic value stack `yyvs80'

	yyspecial_routines80: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_ARGUMENT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_ARGUMENT_LIST]

	yyvs81: SPECIAL [detachable ET_FORMAL_PARAMETER]
			-- Stack for semantic values of type detachable ET_FORMAL_PARAMETER

	yyvsc81: INTEGER
			-- Capacity of semantic value stack `yyvs81'

	yyvsp81: INTEGER
			-- Top of semantic value stack `yyvs81'

	yyspecial_routines81: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_PARAMETER]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_PARAMETER]

	yyvs82: SPECIAL [detachable ET_FORMAL_PARAMETER_ITEM]
			-- Stack for semantic values of type detachable ET_FORMAL_PARAMETER_ITEM

	yyvsc82: INTEGER
			-- Capacity of semantic value stack `yyvs82'

	yyvsp82: INTEGER
			-- Top of semantic value stack `yyvs82'

	yyspecial_routines82: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_PARAMETER_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_PARAMETER_ITEM]

	yyvs83: SPECIAL [detachable ET_FORMAL_PARAMETER_LIST]
			-- Stack for semantic values of type detachable ET_FORMAL_PARAMETER_LIST

	yyvsc83: INTEGER
			-- Capacity of semantic value stack `yyvs83'

	yyvsp83: INTEGER
			-- Top of semantic value stack `yyvs83'

	yyspecial_routines83: KL_SPECIAL_ROUTINES [detachable ET_FORMAL_PARAMETER_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_FORMAL_PARAMETER_LIST]

	yyvs84: SPECIAL [detachable ET_IF_EXPRESSION]
			-- Stack for semantic values of type detachable ET_IF_EXPRESSION

	yyvsc84: INTEGER
			-- Capacity of semantic value stack `yyvs84'

	yyvsp84: INTEGER
			-- Top of semantic value stack `yyvs84'

	yyspecial_routines84: KL_SPECIAL_ROUTINES [detachable ET_IF_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_IF_EXPRESSION]

	yyvs85: SPECIAL [detachable ET_IF_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_IF_INSTRUCTION

	yyvsc85: INTEGER
			-- Capacity of semantic value stack `yyvs85'

	yyvsp85: INTEGER
			-- Top of semantic value stack `yyvs85'

	yyspecial_routines85: KL_SPECIAL_ROUTINES [detachable ET_IF_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_IF_INSTRUCTION]

	yyvs86: SPECIAL [detachable ET_INDEXING_LIST]
			-- Stack for semantic values of type detachable ET_INDEXING_LIST

	yyvsc86: INTEGER
			-- Capacity of semantic value stack `yyvs86'

	yyvsp86: INTEGER
			-- Top of semantic value stack `yyvs86'

	yyspecial_routines86: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_LIST]

	yyvs87: SPECIAL [detachable ET_INDEXING_ITEM]
			-- Stack for semantic values of type detachable ET_INDEXING_ITEM

	yyvsc87: INTEGER
			-- Capacity of semantic value stack `yyvs87'

	yyvsp87: INTEGER
			-- Top of semantic value stack `yyvs87'

	yyspecial_routines87: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_ITEM]

	yyvs88: SPECIAL [detachable ET_INDEXING_TERM]
			-- Stack for semantic values of type detachable ET_INDEXING_TERM

	yyvsc88: INTEGER
			-- Capacity of semantic value stack `yyvs88'

	yyvsp88: INTEGER
			-- Top of semantic value stack `yyvs88'

	yyspecial_routines88: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_TERM]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_TERM]

	yyvs89: SPECIAL [detachable ET_INDEXING_TERM_ITEM]
			-- Stack for semantic values of type detachable ET_INDEXING_TERM_ITEM

	yyvsc89: INTEGER
			-- Capacity of semantic value stack `yyvs89'

	yyvsp89: INTEGER
			-- Top of semantic value stack `yyvs89'

	yyspecial_routines89: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_TERM_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_TERM_ITEM]

	yyvs90: SPECIAL [detachable ET_INDEXING_TERM_LIST]
			-- Stack for semantic values of type detachable ET_INDEXING_TERM_LIST

	yyvsc90: INTEGER
			-- Capacity of semantic value stack `yyvs90'

	yyvsp90: INTEGER
			-- Top of semantic value stack `yyvs90'

	yyspecial_routines90: KL_SPECIAL_ROUTINES [detachable ET_INDEXING_TERM_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_INDEXING_TERM_LIST]

	yyvs91: SPECIAL [detachable ET_INLINE_AGENT]
			-- Stack for semantic values of type detachable ET_INLINE_AGENT

	yyvsc91: INTEGER
			-- Capacity of semantic value stack `yyvs91'

	yyvsp91: INTEGER
			-- Top of semantic value stack `yyvs91'

	yyspecial_routines91: KL_SPECIAL_ROUTINES [detachable ET_INLINE_AGENT]
			-- Routines that ought to be in SPECIAL [detachable ET_INLINE_AGENT]

	yyvs92: SPECIAL [detachable ET_INSPECT_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_INSPECT_INSTRUCTION

	yyvsc92: INTEGER
			-- Capacity of semantic value stack `yyvs92'

	yyvsp92: INTEGER
			-- Top of semantic value stack `yyvs92'

	yyspecial_routines92: KL_SPECIAL_ROUTINES [detachable ET_INSPECT_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_INSPECT_INSTRUCTION]

	yyvs93: SPECIAL [detachable ET_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_INSTRUCTION

	yyvsc93: INTEGER
			-- Capacity of semantic value stack `yyvs93'

	yyvsp93: INTEGER
			-- Top of semantic value stack `yyvs93'

	yyspecial_routines93: KL_SPECIAL_ROUTINES [detachable ET_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_INSTRUCTION]

	yyvs94: SPECIAL [detachable ET_INVARIANTS]
			-- Stack for semantic values of type detachable ET_INVARIANTS

	yyvsc94: INTEGER
			-- Capacity of semantic value stack `yyvs94'

	yyvsp94: INTEGER
			-- Top of semantic value stack `yyvs94'

	yyspecial_routines94: KL_SPECIAL_ROUTINES [detachable ET_INVARIANTS]
			-- Routines that ought to be in SPECIAL [detachable ET_INVARIANTS]

	yyvs95: SPECIAL [detachable ET_KEYWORD_FEATURE_NAME_LIST]
			-- Stack for semantic values of type detachable ET_KEYWORD_FEATURE_NAME_LIST

	yyvsc95: INTEGER
			-- Capacity of semantic value stack `yyvs95'

	yyvsp95: INTEGER
			-- Top of semantic value stack `yyvs95'

	yyspecial_routines95: KL_SPECIAL_ROUTINES [detachable ET_KEYWORD_FEATURE_NAME_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_KEYWORD_FEATURE_NAME_LIST]

	yyvs96: SPECIAL [detachable ET_LIKE_TYPE]
			-- Stack for semantic values of type detachable ET_LIKE_TYPE

	yyvsc96: INTEGER
			-- Capacity of semantic value stack `yyvs96'

	yyvsp96: INTEGER
			-- Top of semantic value stack `yyvs96'

	yyspecial_routines96: KL_SPECIAL_ROUTINES [detachable ET_LIKE_TYPE]
			-- Routines that ought to be in SPECIAL [detachable ET_LIKE_TYPE]

	yyvs97: SPECIAL [detachable ET_LOCAL_VARIABLE]
			-- Stack for semantic values of type detachable ET_LOCAL_VARIABLE

	yyvsc97: INTEGER
			-- Capacity of semantic value stack `yyvs97'

	yyvsp97: INTEGER
			-- Top of semantic value stack `yyvs97'

	yyspecial_routines97: KL_SPECIAL_ROUTINES [detachable ET_LOCAL_VARIABLE]
			-- Routines that ought to be in SPECIAL [detachable ET_LOCAL_VARIABLE]

	yyvs98: SPECIAL [detachable ET_LOCAL_VARIABLE_ITEM]
			-- Stack for semantic values of type detachable ET_LOCAL_VARIABLE_ITEM

	yyvsc98: INTEGER
			-- Capacity of semantic value stack `yyvs98'

	yyvsp98: INTEGER
			-- Top of semantic value stack `yyvs98'

	yyspecial_routines98: KL_SPECIAL_ROUTINES [detachable ET_LOCAL_VARIABLE_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_LOCAL_VARIABLE_ITEM]

	yyvs99: SPECIAL [detachable ET_LOCAL_VARIABLE_LIST]
			-- Stack for semantic values of type detachable ET_LOCAL_VARIABLE_LIST

	yyvsc99: INTEGER
			-- Capacity of semantic value stack `yyvs99'

	yyvsp99: INTEGER
			-- Top of semantic value stack `yyvs99'

	yyspecial_routines99: KL_SPECIAL_ROUTINES [detachable ET_LOCAL_VARIABLE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_LOCAL_VARIABLE_LIST]

	yyvs100: SPECIAL [detachable ET_LOOP_INVARIANTS]
			-- Stack for semantic values of type detachable ET_LOOP_INVARIANTS

	yyvsc100: INTEGER
			-- Capacity of semantic value stack `yyvs100'

	yyvsp100: INTEGER
			-- Top of semantic value stack `yyvs100'

	yyspecial_routines100: KL_SPECIAL_ROUTINES [detachable ET_LOOP_INVARIANTS]
			-- Routines that ought to be in SPECIAL [detachable ET_LOOP_INVARIANTS]

	yyvs101: SPECIAL [detachable ET_MANIFEST_ARRAY]
			-- Stack for semantic values of type detachable ET_MANIFEST_ARRAY

	yyvsc101: INTEGER
			-- Capacity of semantic value stack `yyvs101'

	yyvsp101: INTEGER
			-- Top of semantic value stack `yyvs101'

	yyspecial_routines101: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_ARRAY]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_ARRAY]

	yyvs102: SPECIAL [detachable ET_MANIFEST_STRING_ITEM]
			-- Stack for semantic values of type detachable ET_MANIFEST_STRING_ITEM

	yyvsc102: INTEGER
			-- Capacity of semantic value stack `yyvs102'

	yyvsp102: INTEGER
			-- Top of semantic value stack `yyvs102'

	yyspecial_routines102: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_STRING_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_STRING_ITEM]

	yyvs103: SPECIAL [detachable ET_MANIFEST_STRING_LIST]
			-- Stack for semantic values of type detachable ET_MANIFEST_STRING_LIST

	yyvsc103: INTEGER
			-- Capacity of semantic value stack `yyvs103'

	yyvsp103: INTEGER
			-- Top of semantic value stack `yyvs103'

	yyspecial_routines103: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_STRING_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_STRING_LIST]

	yyvs104: SPECIAL [detachable ET_MANIFEST_TUPLE]
			-- Stack for semantic values of type detachable ET_MANIFEST_TUPLE

	yyvsc104: INTEGER
			-- Capacity of semantic value stack `yyvs104'

	yyvsp104: INTEGER
			-- Top of semantic value stack `yyvs104'

	yyspecial_routines104: KL_SPECIAL_ROUTINES [detachable ET_MANIFEST_TUPLE]
			-- Routines that ought to be in SPECIAL [detachable ET_MANIFEST_TUPLE]

	yyvs105: SPECIAL [detachable ET_OBSOLETE]
			-- Stack for semantic values of type detachable ET_OBSOLETE

	yyvsc105: INTEGER
			-- Capacity of semantic value stack `yyvs105'

	yyvsp105: INTEGER
			-- Top of semantic value stack `yyvs105'

	yyspecial_routines105: KL_SPECIAL_ROUTINES [detachable ET_OBSOLETE]
			-- Routines that ought to be in SPECIAL [detachable ET_OBSOLETE]

	yyvs106: SPECIAL [detachable ET_PARENTHESIZED_EXPRESSION]
			-- Stack for semantic values of type detachable ET_PARENTHESIZED_EXPRESSION

	yyvsc106: INTEGER
			-- Capacity of semantic value stack `yyvs106'

	yyvsp106: INTEGER
			-- Top of semantic value stack `yyvs106'

	yyspecial_routines106: KL_SPECIAL_ROUTINES [detachable ET_PARENTHESIZED_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENTHESIZED_EXPRESSION]

	yyvs107: SPECIAL [detachable ET_PARENT]
			-- Stack for semantic values of type detachable ET_PARENT

	yyvsc107: INTEGER
			-- Capacity of semantic value stack `yyvs107'

	yyvsp107: INTEGER
			-- Top of semantic value stack `yyvs107'

	yyspecial_routines107: KL_SPECIAL_ROUTINES [detachable ET_PARENT]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENT]

	yyvs108: SPECIAL [detachable ET_PARENT_CLAUSE_LIST]
			-- Stack for semantic values of type detachable ET_PARENT_CLAUSE_LIST

	yyvsc108: INTEGER
			-- Capacity of semantic value stack `yyvs108'

	yyvsp108: INTEGER
			-- Top of semantic value stack `yyvs108'

	yyspecial_routines108: KL_SPECIAL_ROUTINES [detachable ET_PARENT_CLAUSE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENT_CLAUSE_LIST]

	yyvs109: SPECIAL [detachable ET_PARENT_ITEM]
			-- Stack for semantic values of type detachable ET_PARENT_ITEM

	yyvsc109: INTEGER
			-- Capacity of semantic value stack `yyvs109'

	yyvsp109: INTEGER
			-- Top of semantic value stack `yyvs109'

	yyspecial_routines109: KL_SPECIAL_ROUTINES [detachable ET_PARENT_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENT_ITEM]

	yyvs110: SPECIAL [detachable ET_PARENT_LIST]
			-- Stack for semantic values of type detachable ET_PARENT_LIST

	yyvsc110: INTEGER
			-- Capacity of semantic value stack `yyvs110'

	yyvsp110: INTEGER
			-- Top of semantic value stack `yyvs110'

	yyspecial_routines110: KL_SPECIAL_ROUTINES [detachable ET_PARENT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_PARENT_LIST]

	yyvs111: SPECIAL [detachable ET_POSTCONDITIONS]
			-- Stack for semantic values of type detachable ET_POSTCONDITIONS

	yyvsc111: INTEGER
			-- Capacity of semantic value stack `yyvs111'

	yyvsp111: INTEGER
			-- Top of semantic value stack `yyvs111'

	yyspecial_routines111: KL_SPECIAL_ROUTINES [detachable ET_POSTCONDITIONS]
			-- Routines that ought to be in SPECIAL [detachable ET_POSTCONDITIONS]

	yyvs112: SPECIAL [detachable ET_PRECONDITIONS]
			-- Stack for semantic values of type detachable ET_PRECONDITIONS

	yyvsc112: INTEGER
			-- Capacity of semantic value stack `yyvs112'

	yyvsp112: INTEGER
			-- Top of semantic value stack `yyvs112'

	yyspecial_routines112: KL_SPECIAL_ROUTINES [detachable ET_PRECONDITIONS]
			-- Routines that ought to be in SPECIAL [detachable ET_PRECONDITIONS]

	yyvs113: SPECIAL [detachable ET_PROCEDURE]
			-- Stack for semantic values of type detachable ET_PROCEDURE

	yyvsc113: INTEGER
			-- Capacity of semantic value stack `yyvs113'

	yyvsp113: INTEGER
			-- Top of semantic value stack `yyvs113'

	yyspecial_routines113: KL_SPECIAL_ROUTINES [detachable ET_PROCEDURE]
			-- Routines that ought to be in SPECIAL [detachable ET_PROCEDURE]

	yyvs114: SPECIAL [detachable ET_QUALIFIED_LIKE_IDENTIFIER]
			-- Stack for semantic values of type detachable ET_QUALIFIED_LIKE_IDENTIFIER

	yyvsc114: INTEGER
			-- Capacity of semantic value stack `yyvs114'

	yyvsp114: INTEGER
			-- Top of semantic value stack `yyvs114'

	yyspecial_routines114: KL_SPECIAL_ROUTINES [detachable ET_QUALIFIED_LIKE_IDENTIFIER]
			-- Routines that ought to be in SPECIAL [detachable ET_QUALIFIED_LIKE_IDENTIFIER]

	yyvs115: SPECIAL [detachable ET_QUANTIFIER_EXPRESSION]
			-- Stack for semantic values of type detachable ET_QUANTIFIER_EXPRESSION

	yyvsc115: INTEGER
			-- Capacity of semantic value stack `yyvs115'

	yyvsp115: INTEGER
			-- Top of semantic value stack `yyvs115'

	yyspecial_routines115: KL_SPECIAL_ROUTINES [detachable ET_QUANTIFIER_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_QUANTIFIER_EXPRESSION]

	yyvs116: SPECIAL [detachable ET_QUERY]
			-- Stack for semantic values of type detachable ET_QUERY

	yyvsc116: INTEGER
			-- Capacity of semantic value stack `yyvs116'

	yyvsp116: INTEGER
			-- Top of semantic value stack `yyvs116'

	yyspecial_routines116: KL_SPECIAL_ROUTINES [detachable ET_QUERY]
			-- Routines that ought to be in SPECIAL [detachable ET_QUERY]

	yyvs117: SPECIAL [detachable ET_RENAME_ITEM]
			-- Stack for semantic values of type detachable ET_RENAME_ITEM

	yyvsc117: INTEGER
			-- Capacity of semantic value stack `yyvs117'

	yyvsp117: INTEGER
			-- Top of semantic value stack `yyvs117'

	yyspecial_routines117: KL_SPECIAL_ROUTINES [detachable ET_RENAME_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_RENAME_ITEM]

	yyvs118: SPECIAL [detachable ET_RENAME_LIST]
			-- Stack for semantic values of type detachable ET_RENAME_LIST

	yyvsc118: INTEGER
			-- Capacity of semantic value stack `yyvs118'

	yyvsp118: INTEGER
			-- Top of semantic value stack `yyvs118'

	yyspecial_routines118: KL_SPECIAL_ROUTINES [detachable ET_RENAME_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_RENAME_LIST]

	yyvs119: SPECIAL [detachable ET_REPEAT_INSTRUCTION]
			-- Stack for semantic values of type detachable ET_REPEAT_INSTRUCTION

	yyvsc119: INTEGER
			-- Capacity of semantic value stack `yyvs119'

	yyvsp119: INTEGER
			-- Top of semantic value stack `yyvs119'

	yyspecial_routines119: KL_SPECIAL_ROUTINES [detachable ET_REPEAT_INSTRUCTION]
			-- Routines that ought to be in SPECIAL [detachable ET_REPEAT_INSTRUCTION]

	yyvs120: SPECIAL [detachable ET_STATIC_CALL_EXPRESSION]
			-- Stack for semantic values of type detachable ET_STATIC_CALL_EXPRESSION

	yyvsc120: INTEGER
			-- Capacity of semantic value stack `yyvs120'

	yyvsp120: INTEGER
			-- Top of semantic value stack `yyvs120'

	yyspecial_routines120: KL_SPECIAL_ROUTINES [detachable ET_STATIC_CALL_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_STATIC_CALL_EXPRESSION]

	yyvs121: SPECIAL [detachable ET_STRIP_EXPRESSION]
			-- Stack for semantic values of type detachable ET_STRIP_EXPRESSION

	yyvsc121: INTEGER
			-- Capacity of semantic value stack `yyvs121'

	yyvsp121: INTEGER
			-- Top of semantic value stack `yyvs121'

	yyspecial_routines121: KL_SPECIAL_ROUTINES [detachable ET_STRIP_EXPRESSION]
			-- Routines that ought to be in SPECIAL [detachable ET_STRIP_EXPRESSION]

	yyvs122: SPECIAL [detachable ET_TYPE]
			-- Stack for semantic values of type detachable ET_TYPE

	yyvsc122: INTEGER
			-- Capacity of semantic value stack `yyvs122'

	yyvsp122: INTEGER
			-- Top of semantic value stack `yyvs122'

	yyspecial_routines122: KL_SPECIAL_ROUTINES [detachable ET_TYPE]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE]

	yyvs123: SPECIAL [detachable ET_TYPE_CONSTRAINT]
			-- Stack for semantic values of type detachable ET_TYPE_CONSTRAINT

	yyvsc123: INTEGER
			-- Capacity of semantic value stack `yyvs123'

	yyvsp123: INTEGER
			-- Top of semantic value stack `yyvs123'

	yyspecial_routines123: KL_SPECIAL_ROUTINES [detachable ET_TYPE_CONSTRAINT]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_CONSTRAINT]

	yyvs124: SPECIAL [detachable ET_TYPE_CONSTRAINT_ITEM]
			-- Stack for semantic values of type detachable ET_TYPE_CONSTRAINT_ITEM

	yyvsc124: INTEGER
			-- Capacity of semantic value stack `yyvs124'

	yyvsp124: INTEGER
			-- Top of semantic value stack `yyvs124'

	yyspecial_routines124: KL_SPECIAL_ROUTINES [detachable ET_TYPE_CONSTRAINT_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_CONSTRAINT_ITEM]

	yyvs125: SPECIAL [detachable ET_TYPE_CONSTRAINT_LIST]
			-- Stack for semantic values of type detachable ET_TYPE_CONSTRAINT_LIST

	yyvsc125: INTEGER
			-- Capacity of semantic value stack `yyvs125'

	yyvsp125: INTEGER
			-- Top of semantic value stack `yyvs125'

	yyspecial_routines125: KL_SPECIAL_ROUTINES [detachable ET_TYPE_CONSTRAINT_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_CONSTRAINT_LIST]

	yyvs126: SPECIAL [detachable ET_TYPE_ITEM]
			-- Stack for semantic values of type detachable ET_TYPE_ITEM

	yyvsc126: INTEGER
			-- Capacity of semantic value stack `yyvs126'

	yyvsp126: INTEGER
			-- Top of semantic value stack `yyvs126'

	yyspecial_routines126: KL_SPECIAL_ROUTINES [detachable ET_TYPE_ITEM]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_ITEM]

	yyvs127: SPECIAL [detachable ET_TYPE_LIST]
			-- Stack for semantic values of type detachable ET_TYPE_LIST

	yyvsc127: INTEGER
			-- Capacity of semantic value stack `yyvs127'

	yyvsp127: INTEGER
			-- Top of semantic value stack `yyvs127'

	yyspecial_routines127: KL_SPECIAL_ROUTINES [detachable ET_TYPE_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_TYPE_LIST]

	yyvs128: SPECIAL [detachable ET_VARIANT]
			-- Stack for semantic values of type detachable ET_VARIANT

	yyvsc128: INTEGER
			-- Capacity of semantic value stack `yyvs128'

	yyvsp128: INTEGER
			-- Top of semantic value stack `yyvs128'

	yyspecial_routines128: KL_SPECIAL_ROUTINES [detachable ET_VARIANT]
			-- Routines that ought to be in SPECIAL [detachable ET_VARIANT]

	yyvs129: SPECIAL [detachable ET_WHEN_PART]
			-- Stack for semantic values of type detachable ET_WHEN_PART

	yyvsc129: INTEGER
			-- Capacity of semantic value stack `yyvs129'

	yyvsp129: INTEGER
			-- Top of semantic value stack `yyvs129'

	yyspecial_routines129: KL_SPECIAL_ROUTINES [detachable ET_WHEN_PART]
			-- Routines that ought to be in SPECIAL [detachable ET_WHEN_PART]

	yyvs130: SPECIAL [detachable ET_WHEN_PART_LIST]
			-- Stack for semantic values of type detachable ET_WHEN_PART_LIST

	yyvsc130: INTEGER
			-- Capacity of semantic value stack `yyvs130'

	yyvsp130: INTEGER
			-- Top of semantic value stack `yyvs130'

	yyspecial_routines130: KL_SPECIAL_ROUTINES [detachable ET_WHEN_PART_LIST]
			-- Routines that ought to be in SPECIAL [detachable ET_WHEN_PART_LIST]

	yyvs131: SPECIAL [detachable ET_WRITABLE]
			-- Stack for semantic values of type detachable ET_WRITABLE

	yyvsc131: INTEGER
			-- Capacity of semantic value stack `yyvs131'

	yyvsp131: INTEGER
			-- Top of semantic value stack `yyvs131'

	yyspecial_routines131: KL_SPECIAL_ROUTINES [detachable ET_WRITABLE]
			-- Routines that ought to be in SPECIAL [detachable ET_WRITABLE]

feature {NONE} -- Constants

	yyFinal: INTEGER = 1762
			-- Termination state id

	yyFlag: INTEGER = -32768
			-- Most negative INTEGER

	yyNtbase: INTEGER = 144
			-- Number of tokens

	yyLast: INTEGER = 7605
			-- Upper bound of `yytable' and `yycheck'

	yyMax_token: INTEGER = 376
			-- Maximum token id
			-- (upper bound of `yytranslate'.)

	yyNsyms: INTEGER = 451
			-- Number of symbols
			-- (terminal and nonterminal)

feature -- User-defined features



feature -- Access

	system_processor: ET_SYSTEM_PROCESSOR
			-- System processor currently used

end
